#####################################
#	LineGraph 1.46a			#
#	for YaBB SP 1 - 1.3.1		#
#	by Carsten				#
#####################################

$graphheight = 100;	# Here you can change the graph height
$canvaswidth = 330;	# Here you can change the total graph width
$gralign = "center";	# Here you can align the graph 'left', 'right' or 'center'
$yams_inst = 0;		# Set to 1 if you have YaMS 4.0 or later, else 0
$view_statusbar = 1;	# Set to 0 to hide the Status Bar
$own_page = 0;		# Set to 1 to view graphs on it's own page

my(@lgvalue, $linegrper, $grafdeg, $nowyr, $nowmd, $lnowmd, $nowda, $totgrposts, $totgrtposts, $totgrtpposts, $thetotgrposts);
my($oldgrafdate, $grdate, $mtime, $oldestgraf, $check1, $check2, $check3, $thisuser);

sub LineGraph {
$thisuser = $_[0];
if($own_page) {
$yymain .= qq~
        <td align="left">
		&nbsp;
	  </td>
        <td align="left">
		<font size="2"><a href="$cgi;action=sellinegraf2;username=$thisuser">$lgrftxt{'07'}</a></font>
	  </td>
	</tr><tr>
	~;
}
else {
	&LineGraph2;
}
}

sub LineGraph2 {

if($own_page) {
	$thisuser = $INFO{'username'};
	fopen(FILE, "$memberdir/$INFO{'username'}.dat");
	@memsettings=<FILE>;
	fclose(FILE);
	chomp @memsettings;
}

if($FORM{'linegrmode'} == 1) { $linegrper = 1; $check1 = "selected" }
elsif($FORM{'linegrmode'} == 2) { $linegrper = 2; $check2 = "selected" }
elsif($FORM{'linegrmode'} == 3) { $linegrper = 3; $check3 = "selected" }
elsif($FORM{'linegrmode'} == 4) { $linegrper = 4; $check4 = "selected" }
elsif($FORM{'linegrmode'} == 5) { $linegrper = 5; $check5 = "selected" }
elsif($FORM{'linegrmode'} == 6) { $linegrper = 6; $check6 = "selected" }
else {
	if($own_page) { $linegrper = 1; $check1 = "selected"; }
	else { $linegrper = 0; $check0 = "selected"; }
}

if ($yyCatsLoaded ne 1) {
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
}

$total_posts = 0;
foreach $curcat (@categories) {
	chomp $curcat;
	fopen(FILE, "$boardsdir/$curcat.cat");
		@thiscurcat = <FILE>;
		chomp @thiscurcat;
	fclose(FILE);
	foreach $curboard (@thiscurcat) {
		chomp $curboard;
		( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);
		$total_posts += $messagecount;
	}
}


if($linegrper != 0) {
	&usersyearposts($thisuser);
	$totgrposts = $totgrposts + $totgrtposts;
	$thetotgrposts = "$totgrtposts $txt{'330'} $txt{'763'} $totgrposts $txt{'86'} ";
}
else { $thetotgrposts = "$txt{'330'} $txt{'763'} $txt{'86'}" }

@lgvalue = reverse @lgvalue;
$valnum = @lgvalue;
$valuenum = $valnum - 1;

$graphwidth = $canvaswidth - $valnum;

$valwidth = int($graphwidth/$valuenum);
$graphwidth = ($valuenum * $valwidth) + $valnum;

$totwidth = ($valnum * $valwidth) + $valnum;
$graphleft = int($valwidth / 2);

if($total_posts > 0) {

if($view_statusbar) {

if($yams_inst) {
	fopen(FILE, "$vardir/barcolor.dat");
	@grpbar=<FILE>;
	fclose(FILE);
	chomp(@grpbar);
}

if(!-e "$sourcedir/MemberGroups.pl") {
	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	chomp @membergroups;

	if($total_posts > 0 && $total_posts < $JrPostNum) {
		$posgrwidth[0] = $canvaswidth - 1;
		$grpcount = 1;
	}
	elsif($total_posts >= $JrPostNum && $total_posts < $FullPostNum) {
		$posgrwidth[0] = int((($canvaswidth * $JrPostNum) / $total_posts)) - 1;
		$posgrwidth[1] = int((($canvaswidth * ($total_posts - $JrPostNum)) / $total_posts)) - 1;
		$grpcount = 2;
	}
	elsif($total_posts >= $FullPostNum && $total_posts < $SrPostNum) {
		$posgrwidth[0] = int((($canvaswidth * $JrPostNum) / $total_posts)) - 1;
		$posgrwidth[1] = int((($canvaswidth * ($FullPostNum - $JrPostNum)) / $total_posts)) - 1;
		$posgrwidth[2] = int((($canvaswidth * ($total_posts - $FullPostNum)) / $total_posts)) - 1;
		$grpcount = 3;
	}
	elsif($total_posts >= $SrPostNum && $total_posts < $GodPostNum) {
		$posgrwidth[0] = int((($canvaswidth * $JrPostNum) / $total_posts)) - 1;
		$posgrwidth[1] = int((($canvaswidth * ($FullPostNum - $JrPostNum)) / $total_posts)) - 1;
		$posgrwidth[2] = int((($canvaswidth * ($SrPostNum - $FullPostNum)) / $total_posts)) - 1;
		$posgrwidth[3] = int((($canvaswidth * ($total_posts - $SrPostNum)) / $total_posts)) - 1;
		$grpcount = 4;
	}
	elsif($total_posts >= $GodPostNum) {
		$posgrwidth[0] = int((($canvaswidth * $JrPostNum) / $total_posts)) - 1;
		$posgrwidth[1] = int((($canvaswidth * ($FullPostNum - $JrPostNum)) / $total_posts)) - 1;
		$posgrwidth[2] = int((($canvaswidth * ($SrPostNum - $FullPostNum)) / $total_posts)) - 1;
		$posgrwidth[3] = int((($canvaswidth * ($GodPostNum - $SrPostNum)) / $total_posts)) - 1;
		$posgrwidth[4] = int((($canvaswidth * ($total_posts - $GodPostNum)) / $total_posts)) - 1;
		$grpcount = 5;
	}
	$alttext[0] = $membergroups[2];
	$alttext[1] = $membergroups[3];
	$alttext[2] = $membergroups[4];
	$alttext[3] = $membergroups[5];
	$alttext[4] = $membergroups[6];
	if($yams_inst) {
		$posbar[0] = $stfaultbar;
		$posbar[1] = $grpbar[0];
		$posbar[2] = $grpbar[1];
		$posbar[3] = $grpbar[2];
		$posbar[4] = $grpbar[3];
		$theurl = $barsurl;
	}
	else {
		$posbar[0] = "bar";
		$posbar[1] = "bar";
		$posbar[2] = "bar";
		$posbar[3] = "bar";
		$posbar[4] = "bar";
		$theurl = $imagesdir;
	}
}
else {
	$i = 0;
	$memstatcount = "0";
	$posgramm[$i] = 0;
	$alttext[$i] = $MemStatNewbie;
	if($yams_inst) { $posbar[$i] = $stfaultbar; } else { $posbar[$i] = "bar"; }
	$i++;
	while($MemStat[$memstatcount]) {
		if($MemPostNum[$memstatcount] ne "x") {
			$posgramm[$i] = $MemPostNum[$memstatcount];
			$alttext[$i] = $MemStat[$memstatcount];
			if($yams_inst) { $posbar[$i] = $grpbar[$memstatcount]; } else { $posbar[$i] = "bar"; }
			$i++;
		}
		$memstatcount++;
	}
	$posgramm[$i] = 99999999;
	$grpcount = @posgramm;

	$posgrwidth[0] = $canvaswidth - 1;

	for($i=1;$i<$grpcount;$i++) {
		if($total_posts >= $posgramm[$i] && $total_posts < $posgramm[$i+1]) {
			$posgrwidth[0] = int((($canvaswidth * $posgramm[1]) / $total_posts) + 0.5) - 1;
			for($z=1;$z<$i;$z++) {
				$posgrwidth[$z] = int((($canvaswidth * ($posgramm[$z+1] - $posgramm[$z])) / $total_posts) + 0.5) - 1;
			}
			$posgrwidth[$i] = int((($canvaswidth * ($total_posts - $posgramm[$i])) / $total_posts) + 0.5) - 1;
		}
	}

	$grpcount = @posgrwidth;

	if($yams_inst) {
		$theurl = $barsurl;
	}
	else {
		$theurl = $imagesdir;
	}
}
$posgraphwidth = 0;
$cellcount = 0;
for($i=0;$i<$grpcount;$i++) { if($posgrwidth[$i] > 0) { $posgraphwidth += ($posgrwidth[$i] + 1); $cellcount++; } }
$errow_pos = int((($memsettings[6] * $posgraphwidth) / $total_posts)) - 4;
}

$postsperct = $memsettings[6] / $total_posts * 100;
$postspct = sprintf("%.2f", $postsperct);

if($own_page) {
	$grftable_width = $canvaswidth + 60;
	$graph_header .= qq(
	<table align="center" border="0" width="$grftable_width" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
	    <tr>
	    <td bgcolor="$color{'windowbg'}" class="windowbg" width="100%">
	    <table border=0 cellspacing="0" cellpadding="4" width="100%">
		<tr>
		<td class="titlebg" colspan="2" bgcolor="$color{'titlebg'}">
			<img src="$imagesdir/profile.gif" alt="" border="0" align="absmiddle"> <font size=2 class="text1" color="$color{'titletext'}"><B>$lgrftxt{'07'}: $memsettings[1]</b></font>
		</td>
		</tr><tr>
	        <td><font size=2><b>$txt{'86'}: </b></font></td>
      	  <td><font size=2>$memsettings[6]</font></td>
	      </tr><tr>
	);
	$graph_footer .= qq(
		</tr>
	    </table>
	    </td>
	    </tr>
	</table>
	<p align=center><a href="$cgi;action=viewprofile;username=$thisuser"><font size=2><b>$txt{'92'} $memsettings[1]</b></font></a></p></font>
	);
	$yymain .= qq~$graph_header~;
}

$yymain .= qq~
        <td align="left">
		&nbsp;
	  </td>
        <td align="left">
		<font size="2">$postspct$lgrftxt{'06'}</font>
	  </td>
	</tr><tr>
	~;
	if($view_statusbar) {
	$yymain .= qq~
        <td colspan="2" align="$gralign">
		<table border="0" align="$gralign" cellspacing="0" cellpadding="0">
		<tr><td>
		<div style="position: relative; top: 0px; left: 0px; width: $posgraphwidth; height: 23px;">
		<table height="23" border="0" align="center" cellspacing="1" cellpadding="0"><tr>
		<td colspan="$cellcount" style="padding: 0px; margin: 0px; border-width: 0px;">
			<img src="$imagesdir/pos_errow.gif" style="position: absolute; left: $errow_pos; top: 5;" width="11" height="8" alt="$postspct$lgrftxt{'06'}" border="0">
		</td>
		</tr><tr>
		~;
		for($i=0;$i<$grpcount;$i++) {
			if($posgrwidth[$i] > 0) {
			$yymain .= qq~
				<td align="left" style="padding: 0px; margin: 0px; border-width: 0px;">
					<img src="$theurl/$posbar[$i].gif" width="$posgrwidth[$i]" height="10" alt="$alttext[$i]" border="0">
				</td>
			~;
			}
		}
		$yymain .= qq~
		</tr></table>
		</div>
		</td></tr>
		</table>
	  </td>
	</tr><tr>
~;
	}
}
if($own_page) {
	$yymain .= qq~
			<form method="post" action="$cgi;action=sellinegraf2;username=$thisuser">
	~;
}
else {
	$yymain .= qq~
			<form method="post" action="$cgi;action=sellinegraf;username=$thisuser#lngrf">
	~;
}
$yymain .= qq~
        <td align="center" colspan="2"><font size=1>$thetotgrposts $lgrftxt{'01'} </font>
		<select name="linegrmode" style="font-size: 9px" onChange="submit(); return true">
			<option value="" $check0></option>
			<option value="1" $check1>$lgrftxt{'02'}</option>
			<option value="4" $check4>$lgrftxt{'02'} $lgrftxt{'05'}</option>
			<option value="2" $check2>$lgrftxt{'03'}</option>
			<option value="5" $check5>$lgrftxt{'03'} $lgrftxt{'05'}</option>
			<option value="3" $check3>$lgrftxt{'04'}</option>
			<option value="6" $check6>$lgrftxt{'04'} $lgrftxt{'05'}</option>
		</select>
	  </td>
			</form>
~;

if($linegrper != 0) {

$maxgraph = 0;
$topicpgrvalue = 0;
$topicgrvalue = 0;

for($i=0;$i<$valnum;$i++) {
	($labl[$i],$lablmd[$i],$grvalue[$i],$tgrvalue[$i]) = split(/\|/,$lgvalue[$i]);
	if($linegrper == 4 || $linegrper == 5 || $linegrper == 6) {
		$topicgrvalue = $topicgrvalue + $tgrvalue[$i];
		$togrvalue[$i] = $topicgrvalue;
		$topicpgrvalue = $topicpgrvalue + $grvalue[$i] + $tgrvalue[$i];
		$tpgrvalue[$i] = $topicpgrvalue;
	}
	else {
		$tpgrvalue[$i] = $grvalue[$i] + $tgrvalue[$i];
		if($tpgrvalue[$i] > $maxgraph) { $maxgraph = $tpgrvalue[$i] }
	}
}
for($i=0;$i<$valnum;$i++) {
	if($linegrper == 4 || $linegrper == 5 || $linegrper == 6) {
		$maxgraph = $totgrposts;
		$tgrvalue[$i] = $togrvalue[$i];
	}
	if($grvalue[$i] > 0) { $grvalue[$i] = int((($grvalue[$i] * $graphheight) / $maxgraph) + 0.5) }
	if($tgrvalue[$i] > 0) { $tgrvalue[$i] = int((($tgrvalue[$i] * $graphheight) / $maxgraph) + 0.5) }
	if($tpgrvalue[$i] > 0) { $tpgrvalue[$i] = int((($tpgrvalue[$i] * $graphheight) / $maxgraph) + 0.5) }
}

$cvgraphheight = $graphheight + 2;
$yymain .= qq~
      </tr><tr>
        <td colspan="2" align="$gralign">
<SCRIPT LANGUAGE="JavaScript1.1">
<!--
  img1 = new Image();
  img1.src = "$imagesdir/tplinedot.gif";
  img2 = new Image();
  img2.src = "$imagesdir/tlinedot.gif";
  img3 = new Image();
  img3.src = "$imagesdir/linedot.gif";
  img4 = new Image();
  img4.src = "$imagesdir/tolinedot.gif";
// -->
</SCRIPT>
<table border="0" align="$gralign" cellspacing="0" cellpadding="0">
<tr><td>
<div style="position: relative; top: 0; left: $graphleft; width: $graphwidth; height: $cvgraphheight; z-index: 1;">
<table height="$cvgraphheight" width="$graphwidth" border="0" align="center" cellspacing="1" cellpadding="0" bgcolor="#AAAAAA"><tr>
~;
$m = 0;
$zb = 2;
for($i=0;$i<$valuenum;$i++) {
	my($dotcorr, $tdotcorr, $tpdotcorr, $dothigh, $tdothigh, $tpdothigh, $dothi, $tdothi);

	$yax1 = $grvalue[$i];
	$yax2 = $grvalue[$i+1];
	$grv = ($yax2 - $yax1) / $valwidth;
	$dothi = abs($grv);
	$dothigh = int($dothi);
	if($dothigh == 0) { $dothigh = 1; }
	$dotcorr = $dothigh - 1;
	if($yax1 == 0 && $yax2 == 0) { $dotcorr = 1; }

	$tyax1 = $tgrvalue[$i];
	$tyax2 = $tgrvalue[$i+1];
	$tgrv = ($tyax2 - $tyax1) / $valwidth;
	$tdothi = abs($tgrv);
	$tdothigh = int($tdothi);
	if($tdothigh == 0) { $tdothigh = 1; }
	$tdotcorr = $tdothigh - 1;
	if($tyax1 == 0 && $tyax2 == 0) { $tdotcorr = 1; }

	$tpyax1 = $tpgrvalue[$i];
	$tpyax2 = $tpgrvalue[$i+1];
	$tpgrv = ($tpyax2 - $tpyax1) / $valwidth;

	$yymain .= qq~<td height="$graphheight" width="$valwidth" bgcolor="#EEEEEE" style="padding: 0px; margin: 0px; border-width: 0px;">~;
	for($x=0;$x<$valwidth;$x++) {
		$px = $x;
		if($x == 0) { $px = 0.1; }
		$yax = int(($graphheight - $yax1 - ($px * $grv)) - $dotcorr) + 1;
		$tyax = int(($graphheight - $tyax1 - ($px * $tgrv)) - $tdotcorr) + 1;
		$tpyax = int($graphheight - $tpyax1 - ($x * $tpgrv)) + 1;
		$tpdothigh = $graphheight - $tpyax + 1;
		$todothigh = $graphheight - $tyax + 1;
		$xax = $m * ($valwidth + 1) + $x + 1;
		$yymain .= qq~ <img src="$imagesdir/tplinedot.gif" style="position: absolute; left: $xax; top: $tpyax; z-index: $zb" height="$tpdothigh" width="1" border="0" alt="">~;
		$zb++;
		$yymain .= qq~<img src="$imagesdir/linedot.gif" style="position: absolute; left: $xax; top: $tpyax; z-index: $zb" height="$dothigh" width="1" border="0" alt="">~;
		$zb++;
		$yymain .= qq~<img src="$imagesdir/tolinedot.gif" style="position: absolute; left: $xax; top: $tyax; z-index: $zb" height="$todothigh" width="1" border="0" alt="">~;
		$zb++;
		$yymain .= qq~<img src="$imagesdir/tlinedot.gif" style="position: absolute; left: $xax; top: $tyax; z-index: $zb" height="$tdothigh" width="1" border="0" alt="">~;
		$zb++;
	}
	$yymain .= qq~</td>~;
	$m++;
}
$yymain .= qq~</tr></table></div>
<table width="$totwidth" border="0" align="left" cellspacing="1" cellpadding="0"><tr>~;
$pgrafvalue = 0;
$tgrafvalue = 0;
for($i=0;$i<$valnum;$i++) {
	($graflabl_a,$graflabl_b,$grafvalue,$tografvalue) = split(/\|/,$lgvalue[$i]);
	if($linegrper == 4 || $linegrper == 5 || $linegrper == 6) {
		$pgrafvalue = $pgrafvalue + $tografvalue + $grafvalue;
		$tgrafvalue = $tgrafvalue + $tografvalue;
	}
	else {
		$pgrafvalue = 0;
		$tgrafvalue = 0;
		$pgrafvalue = $tografvalue + $grafvalue;
		$tgrafvalue = $tografvalue;
	}
	$yymain .= qq~<td align="center" valign="top" width="$valwidth"><font size="1" style="font-size: 10px">$graflabl_a</font><br><font size="1" style="font-size: 10px">$graflabl_b</font> <br><font size="1" style="font-size: 8px" color="#339033">$pgrafvalue</font><br><font size="1" style="font-size: 8px" color="#ff3333">($tgrafvalue)</font></td>~;
}
$yymain .= qq~
</tr></table>
</td></tr>
</table>
</td><tr>
<td colspan="2" align="center" valign="middle"><font size="1" style="font-size: 10px">$txt{'330'} <img src="$imagesdir/tlinedot.gif" height="1" width="$valwidth" border="0" alt="" align="absmiddle"> &nbsp; $txt{'86'} <img src="$imagesdir/linedot.gif" height="1" width="$valwidth" border="0" alt="" align="absmiddle"></font></td>
</tr>
</td>
~;
}
if($own_page) {
	$yymain .= qq~$graph_footer~;
	$yytitle = "$lgrftxt{'07'} $memsettings[1]";
	&template;
	exit;
}
}


sub usersyearposts {
my(@grmessages, @theuserdate, @linegrdates, $display, @categories, %cat, $numfound, $tnumfound, $curcat, %catname, %catboards, $curboard, @threads, @boardinfo, $i, $c, @messages, $tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mns, $board);
$theuser = $_[0];
@categories = ();
fopen(FILE, "$vardir/cat.txt");
@categories = <FILE>;
fclose(FILE);

$grafdeg = 0;
if($linegrper == 1 ||$linegrper == 4) { $peri = 14; $grafdeg = 1209600; &GraphDate; }
elsif($linegrper == 2 ||$linegrper == 5) { $peri = 98; $grafdeg = 8467200; &GraphDate; }
elsif($linegrper == 3 ||$linegrper == 6) { $peri = 12; $grafdeg = 29030400; &GraphDate; $nowda = "01"; }
$oldgrafdate = "$nowmd/$nowda/$nowyr $txt{'107'} 00:00:00";
$oldestgraf = stringtotime($oldgrafdate);

foreach $curcat (@categories) {
	chomp $curcat;
	fopen(FILE, "$boardsdir/$curcat.cat");
	@catboards = <FILE>;
	fclose(FILE);
	foreach $curboard (@catboards) {
		chomp $curboard;
		fopen(FILE, "$boardsdir/$curboard.txt");
		@threads = <FILE>;
		fclose(FILE);
		threadcheck: for ($i = 0; $i < @threads; $i++) {
			chomp $threads[$i];
			($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
			fopen(FILE, "$datadir/$tnum.txt") || next;
			@messages = <FILE>;
			fclose(FILE);
			@grmessages = reverse @messages;
			for ($c = 0; $c < @messages; $c++) {
				$tc = $c + 1;
				chomp $grmessages[$c];
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$grmessages[$c]);
				$mtime = stringtotime($mdate);
				if( $mtime <= $oldestgraf ) { next threadcheck }
				if ($theuser eq $musername) {
					$theyear = substr($mdate,6,2);
					$themont = substr($mdate,0,2);
					$theday = substr($mdate,3,2);
					if($linegrper == 3 || $linegrper == 6) { 
						if($tc < @messages) { $theuserdate[$numfound] = "$theyear|$themont"; $numfound++; }
						elsif($tc == @messages) { $theusertdate[$tnumfound] = "$theyear|$themont"; $tnumfound++; }
					}
					else {
						if($tc < @messages) { $theuserdate[$numfound] = "$theyear|$themont|$theday"; $numfound++; }
						elsif($tc == @messages) { $theusertdate[$tnumfound] = "$theyear|$themont|$theday"; $tnumfound++; }
					}
				}
			}
		}
	}
}

@linegrdates = sort{lc($b) cmp lc($a)} (@theuserdate);
@linegrtdates = sort{lc($b) cmp lc($a)} (@theusertdate);

$grafdeg = 0;
$wchecknr = 0;
$wchecktnr = 0;
&GraphDate;
$weekdg = 0;
$x = 0;
$i = 0;
$t = 0;
$totgrposts = 0;
$totgrtposts = 0;
for($z=0;$z<$peri;$z++) {
	$checknr = 0;
	$checktnr = 0;
	while($linegrdates[$i] eq $grdate) { $checknr++; $i++; }
	$totgrposts = $totgrposts + $checknr;
	while($linegrtdates[$t] eq $grdate) { $checktnr++; $t++; }
	$totgrtposts = $totgrtposts + $checktnr;
	if($linegrper == 1 || $linegrper == 4) {
		$labelmd1 = substr($months[$lnowmd],0,3);
		$lgvalue[$z] = "$nowda|$labelmd1|$checknr|$checktnr";
		$grafdeg = $grafdeg + 86400;
		&GraphDate;
	}
	elsif($linegrper == 2 || $linegrper == 5) { 
		$wchecknr = $wchecknr + $checknr;
		$wchecktnr = $wchecktnr + $checktnr;
		$weekdg++;
		if($weekdg == 1) { $lablday2 = $nowda; $lablmd2 = $lnowmd; }
		if($weekdg == 7) {
			$labelmd2 = substr($months[$lablmd2],0,3);
			$lgvalue[$x] = "$lablday2|$labelmd2|$wchecknr|$wchecktnr";
			$weekdg = 0;
			$wchecknr = 0;
			$wchecktnr = 0;
			$x++;
		}
		$grafdeg = $grafdeg + 86400;
		&GraphDate;
	}
	elsif($linegrper == 3 || $linegrper == 6) {
		$nowmd = $nowmd - 1;
		$lablyear = substr($months[$nowmd],0,3);
		$lgvalue[$z] = "$lablyear|$nowyr|$checknr|$checktnr";
		if($nowmd < 1) { $nowmd = 12; $nowyr--; $nowyr = "0$nowyr" if ($nowyr < 10); }
		$nowmd = "0$nowmd" if ($nowmd < 10);
		$grdate = "$nowyr|$nowmd";
	}
}

}


sub GraphDate {
	($sec,$min,$hour,$nowda,$lnowmd,$year,$wday,$yday,$isdst) = localtime(time - $grafdeg + (3600*$timeoffset));
	$nowmd = $lnowmd+1;
	$nowyr = ($year % 100);
	$nowmd = "0$nowmd" if ($nowmd < 10);
	$nowda = "0$nowda" if ($nowda < 10);
	$nowyr = "0$nowyr" if ($nowyr < 10);
	if($linegrper == 3 || $linegrper == 6) {
		$grdate = "$nowyr|$nowmd";
	}
	else {
		$grdate = "$nowyr|$nowmd|$nowda";
	}
}

1;