###############################################################################
# Notify.pl                                                                   #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.4                                        #
# Released:       December 2001; Updated November 25, 2004                    #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

$notifyplver = "1 Gold - SP 1.4";
# --- Added for Notify Plus 2.2 --- #
require "$sourcedir/NotifyPlus.pl";
# --- /Added for Notify Plus 2.2 --- #


# --- Deleted for Notify Plus 2.2 --- #
#sub Notify {
#	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
#	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }

# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
sub Notify {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error("$txt{'138'}"); }

	# When email of Guest not entered yet ...
	if($username eq "Guest") {

		if ($FORM{'guest_email'} eq "") {

			$yymain .= qq~
			<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
			<tr>
			    <td class="titlebg" bgcolor="$color{'titlebg'}">
					<font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font>
				</td>
			</tr>
			<tr>
		    	<td class="windowbg" bgcolor="$color{'windowbg'}">
					<font size=2>
					<form action="$cgi;action=notify;thread=$INFO{'thread'};start=$INFO{'start'}" method="post" name="notifyForm">
						$notify_txt{'14'}
						<input type="text" name="guest_email" size="25" maxlength="30">
						<br>
						<b><a href="javascript:document.notifyForm.submit();">$notify_txt{'15'}</a> - <a href="javascript:history.go(-1)">$txt{'250'}</a></b>
					</form>
			    	</font>
				</td>
			</tr>
			</table>
~;

			$yytitle = "$txt{'125'}";
			&template;
			exit;
		}
		else {
			# Check email
			&fatal_error("$txt{'76'}") if($FORM{'guest_email'} eq '');
			&fatal_error($txt{'243'}) if($FORM{'guest_email'} !~ /^[0-9A-Za-z@\._\-]+$/);
			&fatal_error("$txt{'500'}") if(($FORM{'guest_email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'guest_email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));

			# Not email-address of member ?
			fopen(FILE, "$memberdir/memberlist.txt");
			@memberlist = <FILE>;
			fclose(FILE);
			for ($a = 0; $a < @memberlist; $a++) {
				chomp $memberlist[$a];
				if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {

					# Load users and check email
					if( !$yyUDLoaded{$memberlist[$a]} && -e("$memberdir/$memberlist[$a].dat") ) {
						# If user is not in memory, s/he must be loaded.
						&LoadUser($memberlist[$a]);
						if($userprofile{$memberlist[$a]}->[2] eq $FORM{'guest_email'}) { &fatal_error("$notify_txt{'16'}"); }
					}
					fclose(FILE2);
				}
			}

			# Email-address OK !
			$settings[2] = $FORM{'guest_email'};
		}
	}
# --- /Added for Notify Plus 2.2 --- #


	# Check, if User already gets a notification
	fopen(FILE, "$datadir/$INFO{'thread'}.mail");
	@mails = <FILE>;
	fclose(FILE);

	$isonlist = 0;
# --- Deleted for Notify Plus 2.2 --- #
#	foreach $curmail (@mails) {
#		$curmail =~ s/[\n\r]//g;
#		if($settings[2] eq "$curmail") { $isonlist = 1; }
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	foreach $record (@mails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);
		if($settings[2] eq $email) { $isonlist = 1; }
	}
# --- /Added for Notify Plus 2.2 --- #


	if ($isonlist){
	$yymain .= qq~
<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
<!--- Deleted for Notify Plus 2.2 --->
<!---     $txt{'212'}<br> --->
<!---     <b><a href="$cgi;action=notify3;thread=$INFO{'thread'};start=$INFO{'start'}">$txt{'163'}</a> - <a href="$cgi;action=display;num=$INFO{'thread'};start=$INFO{'start'}">$txt{'164'}</a></b> --->
<!--- /Deleted for Notify Plus 2.2 --->

<!--- Added for Notify Plus 2.2 --->
    $txt{'212'}<br>

    <b><a href="$cgi;action=notify3;thread=$INFO{'thread'};start=$INFO{'start'};guest_email=$FORM{'guest_email'}">$txt{'163'}</a> - <a href="$cgi;action=display;num=$INFO{'thread'};start=$INFO{'start'}">$txt{'164'}</a></b>
<!--- /Added for Notify Plus 2.2 --->

    </font></td>
  </tr>
</table>
~;
	} else
	{
	$yymain .= qq~
<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
<!--- Deleted for Notify Plus 2.2 --->
<!---    $txt{'126'}<br> --->
<!---    <b><a href="$cgi;action=notify2;thread=$INFO{'thread'};start=$INFO{'start'}">$txt{'163'}</a> - <a href="$cgi;action=display;num=$INFO{'thread'};start=$INFO{'start'}">$txt{'164'}</a></b> --->
<!--- /Deleted for Notify Plus 2.2 --->

<!--- Added for Notify Plus 2.2--->
	<form action="$cgi;action=notify2;thread=$INFO{'thread'};start=$INFO{'start'}" method="post" name="notifyForm">
	    $txt{'126'}<br>
		<input name="guest_email" type="hidden" value="$FORM{'guest_email'}">
~;

		# When Guest
		if($username eq "Guest") {

			$yymain .= qq~
			<font size=1>$notify_txt{'1'}</font>
			<input type="radio" name="notifyformat" value="HTML" checked><font size=1>$notify_txt{'2'}</font>
			<input type="radio" name="notifyformat" value="Plain"><font size=1>$notify_txt{'3'}</font><br>
~;
		}
		$yymain .= qq~
		<b><a href="javascript:document.notifyForm.submit();">$txt{'163'}</a> - <a href="javascript:history.go(-1)">$txt{'164'}</a></b>
	</form>
<!--- /Added for Notify Plus 2.2 --->

    </font></td>
  </tr>
</table>
~;
	}
	$yytitle = "$txt{'125'}";
	&template;
	exit;
}

# --- Deleted for Notify Plus 2.2 --- #
#sub Notify2 {
#	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
#	if($username eq 'Guest') { &fatal_error($txt{'138'}); }
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
sub Notify2 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }

	# Get parameter 
	local($who) = @_;
	
	# When notify Guest: fill guest_email !
	if ($who eq 'Guest') { $FORM{'guest_email'} = $FORM{'email'}; }
	
	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error($txt{'138'}); }
	if($username eq 'Guest') { $settings[2] = $FORM{'guest_email'}; }
# --- /Added for Notify Plus 2.2 --- #

	$thread = $INFO{'thread'};
	$start = $INFO{'start'} ne '' ? $INFO{'start'} : 9999999;
	fopen(FILE, "$datadir/$thread.mail");
	@mails = <FILE>;
	fclose(FILE);
	fopen(FILE, ">$datadir/$thread.mail", 1) || &fatal_error("$txt{'23'} $thread.mail");
# --- Deleted for Notify Plus 2.2 --- #
#	print FILE "$settings[2]\n";	
#	foreach $curmail (@mails) {
#		$curmail =~ s/[\n\r]//g;
#		if($settings[2] ne $curmail) { print FILE "$curmail\n"; }
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #

	# When Guest
	if($username eq "Guest") {
		print FILE "$settings[2]|$FORM{'notifyformat'}\n";
	}
	# When Member
	else {
		print FILE "$settings[2]|$INFO{'username'}\n";
	}

	foreach $record (@mails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);
		if($settings[2] ne $email) { print FILE "$record\n"; }
	}
# --- /Added for Notify Plus 2.2 --- #

	fclose(FILE);
	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start~;
	&redirectexit;
}

# --- Deleted for Notify Plus 2.2 --- #
#sub Notify3 {
#	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
#	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
sub Notify3 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error($txt{'138'}); }
	if($username eq 'Guest') { $settings[2] = $INFO{'guest_email'}; }
# --- /Added for Notify Plus 2.2 --- #

	$thread = $INFO{'thread'};
	$start = $INFO{'start'} ne '' ? $INFO{'start'} : 9999999;
	fopen(FILE, "$datadir/$thread.mail");
	@mails = <FILE>;
	fclose(FILE);
# --- Deleted for Notify Plus 2.2 --- #
#	fopen(FILE, ">$datadir/$thread.mail", 1) || &fatal_error("$txt{'23'} $thread.mail");
#	foreach $curmail (@mails) {
#		$curmail =~ s/[\n\r]//g;
#		if($settings[2] ne "$curmail") { print FILE "$curmail\n"; }
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	fopen(FILE, ">$datadir/$thread.mail", 1) || &fatal_error("$txt{'23'} $thread.mail");
	foreach $record (@mails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);
		if($settings[2] ne $email) { print FILE "$record\n"; }
	}
# --- /Added for Notify Plus 2.2 --- #

	fclose(FILE);
	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start~;
	&redirectexit;
}

# --- Deleted for Notify Plus 2.2 --- #
#sub Notify4 {
#	if($username eq "Guest") { &fatal_error("$txt{'138'}"); }
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
sub Notify4 {
	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error("$txt{'138'}"); }
	if($username eq 'Guest') { $settings[2] = $FORM{'guest_email'}; }
# --- /Added for Notify Plus 2.2 --- #

	my( $variable, $dummy, $dummy2, $threadno, @mails, $curmail );

	foreach $variable (keys %FORM) {
	 	$dummy = $FORM{$variable};
# --- Deleted for Notify Plus 2.2 --- #
#		($dummy2,$threadno) = split(/-/,$variable);
#		if ($dummy2 eq "thread") {
#
#			fopen(FILE, "$datadir/$threadno.mail");
#			@mails = <FILE>;
#			fclose(FILE);
#
#			fopen(FILE, ">$datadir/$threadno.mail") || &fatal_error("$txt{'23'} $threadno.mail");
#			foreach $curmail (@mails) {
#				$curmail =~ s/[\n\r]//g;
#				if($settings[2] ne $curmail) { print FILE "$curmail\n"; }
#			}
#			fclose(FILE);

# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
		($dummy2,$board_threadno) = split(/-/,$variable);


		# Board-level ?
		if ($dummy2 eq "board") {


			fopen(FILE, "$boardsdir/$board_threadno.mail");
			@mails = <FILE>;
			fclose(FILE);

			fopen(FILE, ">$boardsdir/$board_threadno.mail") || &fatal_error("$txt{'23'} $board_threadno.mail");
			foreach $record (@mails) {

				chomp($record);
				($email, $format) = split(/\|/, $record);
				chomp($email);
				if($settings[2] ne $email) { print FILE "$record\n"; }
			}
			fclose(FILE);
		}

		# Thread-level ?
		else {

			fopen(FILE, "$datadir/$board_threadno.mail");
			@mails = <FILE>;
			fclose(FILE);

			fopen(FILE, ">$datadir/$board_threadno.mail") || &fatal_error("$txt{'23'} $board_threadno.mail");
			foreach $record (@mails) {

				chomp($record);
				($email, $format) = split(/\|/, $record);
				chomp($email);
				if($settings[2] ne $email) { print FILE "$record\n"; }
			}
			fclose(FILE);

# --- /Added for Notify Plus 2.2 --- #


		}

	}
	&ShowNotifications;
}

# --- Deleted for Notify Plus 2.2 --- #
#sub ShowNotifications {
#	if($username eq "Guest") { &error("$txt{'138'}"); }
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #	
sub Notify5 {

	$settings[2] = $FORM{'guest_email'};
	my( $variable, $field, $threadno, @mails, $curmail );

	# Read all Formfields
	foreach $variable (keys %FORM) {

		($field,$threadno) = split(/-/,$variable);

		# When thread activated: Delete
		if ($field eq "thread") {

			fopen(FILE, "$datadir/$threadno.mail");
			@mails = <FILE>;
			fclose(FILE);
	
			fopen(FILE, ">$datadir/$threadno.mail") || &fatal_error("$txt{'23'} $threadno.mail");
			foreach $record (@mails) {
	
				chomp($record);
				($email, $format) = split(/\|/, $record);
				chomp($email);
				if($settings[2] ne $email) { print FILE "$record\n"; }
			}
			fclose(FILE);
		}
	}
	&ShowGuestNotification;
}

sub ShowNotifications {
	if ($username eq "Guest") {
	

		if ($FORM{'guest_email'} eq "") { 

			$yymain .= qq~
			<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
			<tr>
			    <td class="titlebg" bgcolor="$color{'titlebg'}">
					<font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font>
				</td>
			</tr>
			<tr>
		    	<td class="windowbg" bgcolor="$color{'windowbg'}">
					<font size=2>
					<form action="$cgi;action=shownotify" method="post" name="notifyForm">
						$notify_txt{'14'}
						<input type="text" name="guest_email" size="25" maxlength="30">
						<p>
						<b><a href="javascript:document.notifyForm.submit();">$notify_txt{'15'}</a> - <a href="javascript:history.go(-1)">$txt{'250'}</a></b>
					</form>
			    	</font>
				</td>
			</tr>
			</table>
~;

			$yytitle = "$txt{'125'}";
			&template;
			exit;
		}
		else {
			fopen(FILE, "$memberdir/memberlist.txt");
			@memberlist = <FILE>;
			fclose(FILE);
			for ($a = 0; $a < @memberlist; $a++) {
				chomp $memberlist[$a];
				if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
		
					# Load users and check email
					if( !$yyUDLoaded{$memberlist[$a]} && -e("$memberdir/$memberlist[$a].dat") ) {
						# If user is not in memory, s/he must be loaded.
						&LoadUser($memberlist[$a]);
						if($userprofile{$memberlist[$a]}->[2] eq $FORM{'guest_email'}) { &fatal_error("$notify_txt{'16'}"); }
					}
					fclose(FILE2);
				}
			}	
			
			# Password is not from a Member	
			$settings[2] = $FORM{'guest_email'};
		}
	}
# --- /Added for Notify Plus 2.2 --- #
		

	my(@dirdata,@datdata,$filename,$entry,@entries,$mnum,$dummy,$msub,$mname,$memail,$mdate,$musername,$micon,$mattach,$mip,$mmessage,@messages,@found_number,@found_subject,@found_date,@found_username);
# --- Added for Notify Plus 2.2 --- #

	my(@found_format);

	# Load Censor List
	&LoadCensorList;

	# Read required data for ALL members !
	&ReadAllMembers;

	# -----------------------------------------------------------------------------
	# BOARD-level
	# -----------------------------------------------------------------------------
	# Boardlevel is only for Members
	if($username ne "Guest") {

		# Read all .mail-Files and search for username
		opendir (DIRECTORY,"$boardsdir");
		@dirdata = readdir(DIRECTORY);
		closedir (DIRECTORY);
		@datdata = grep(/mail/,@dirdata);

		foreach $filename (@datdata) {

			fopen(FILE, "$boardsdir/$filename");
			@entries = <FILE>;
			fclose(FILE);

			foreach $record (@entries) {

				chomp($record);
				($email, $format) = split(/\|/, $record);

				chomp($email);
				if ($email eq $settings[2]) {

					# Read User Data
					$user_to_read =	$user_Array{"$email"};
					&ReadUserData($user_to_read);					

					# Push text from language-file !
					if ($user_format eq "HTML") { push(@found_boardformat,$notify_txt{'2'}); }
					elsif ($user_format eq "HTML-Attach") { push(@found_boardformat,$notify_txt{'45'}); }				
					else { push(@found_boardformat,$notify_txt{'3'}); }

					($boardid, $dummy) = split(/\./,$filename);
					fopen(FILE, "$boardsdir/$boardid.dat");
					@boarddata = <FILE>;
					fclose(FILE);

					push(@found_boardname,@boarddata[0]);
					push(@found_boardid,$boardid);
				}
			# End foreach record
			}
		# End foreach filename
		}
	# End if not Guest
	}
	# -----------------------------------------------------------------------------
	# THREAD-level
	# -----------------------------------------------------------------------------

# --- /Added for Notify Plus 2.2 --- #


	# Read all .mail-Files and search for username
	opendir (DIRECTORY,"$datadir");
	@dirdata = readdir(DIRECTORY);
	closedir (DIRECTORY);
	@datdata = grep(/mail/,@dirdata);

# --- Deleted for Notify Plus 2.2 --- #
#	# Load Censor List
#	&LoadCensorList;
# --- /Deleted for Notify Plus 2.2 --- #

	
	foreach $filename (@datdata) {
		fopen(FILE, "$datadir/$filename");
		@entries = <FILE>;
		fclose(FILE);
# --- Deleted for Notify Plus 2.2 --- #
#	        foreach $entry (@entries) {
#	        	$entry =~ s/[\n\r]//g;

#	        	if ($entry eq $settings[2]) {
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	        foreach $record (@entries) {

	        	chomp($record);
	        	($email, $format) = split(/\|/, $record);

	        	chomp($email);
	        	chomp($format);

	        	# When a Guest
	        	if ($username eq 'Guest') {
	        	   $user_format = $format;
	        	}
	        	# When a Member
	        	else {

	        	   # Read User Data
	        	   $user_to_read = $user_Array{"$email"};
	        	   &ReadUserData($user_to_read);					
	        	}

	        	if ($email eq $settings[2]) {

	        	   # Push text from Language-file
	        	   if ($user_format eq "HTML") { push(@found_format,$notify_txt{'2'}); }
	        	   elsif ($user_format eq "HTML-Attach") { push(@found_format,$notify_txt{'45'}); }
	        	   else { push(@found_format,$notify_txt{'3'}); }

# --- /Added for Notify Plus 2.2 --- #

				($mnum, $dummy) = split(/\./,$filename);
				fopen(FILE, "$datadir/$mnum.txt");
				@messages = <FILE>;
				fclose(FILE);
				($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip,  $mmessage) = split(/\|/,$messages[0]);
				push(@found_number,$mnum);
				push(@found_subject,$msub);
				push(@found_date,$mdate);
				push(@found_username,$musername);
				push(@found_name,$mname);
			}
		}
	}

	# Display all Entries
	$yymain .= qq~
<table border=0 width=100% cellspacing=1 cellpadding=6 bgcolor="$color{'bordercolor'}" class="bordercolor">
 <tr>
  <td bgcolor="$color{'titlebg'}" class="titlebg">
   <font size=2 color="$color{'titletext'}"><b>$txt{'418'}</b></font>
  </td>
 </tr><tr>
  <td bgcolor="$color{'windowbg'}" class="windowbg">
   <font size=2>
    <br>
~;


# --- Added for Notify Plus 2.2 --- #

	# -----------------------------------------------------------------------------
	# Show Notified Boards
	# -----------------------------------------------------------------------------
	# Only for Members !
	if ($username ne 'Guest') {

		# No Boards selected ?
		if (@found_boardname==0) {
			$yymain .= qq~ <font size=2><b>$notify_txt{'43'}</b></font><br>\n ~;
			$yymain .= qq~ $notify_txt{'42'}<br><br> ~;
		}
		else {
			$yymain .= qq~<form action="$cgi;action=notify4" method=post> ~;
			$yymain .= qq~ <input name="guest_email" type="hidden" value="$FORM{'guest_email'}"> ~;

			$yymain .= qq~ <table>\n ~;
			$yymain .= qq~ <tr><td colspan=2><font size=2><b>$notify_txt{'43'}</b></font></td></tr> ~;

			$counter=0;
			foreach $entry (@found_boardname) {
				$yymain .= qq~ <tr><td><font size=2> ~;
				$yymain .= qq~ <input type=checkbox name="board-$found_boardid[$counter]" value="1"></font></td> ~;
				$yymain .= qq~ <td><font size=2><b><i>$found_boardname[$counter]</i></b> </font></td></tr> ~;
				$yymain .= qq~ <tr><td></td> ~;
				$yymain .= qq~ <td><font size="1">$notify_txt{'1'} $found_boardformat[$counter]</font></td></tr> ~;

				$counter++;
			}

			$yymain .= qq~ </table>\n ~;
			$yymain .= qq~ <p>\n ~;
		}
	}
	# -----------------------------------------------------------------------------
	# Show Notified Threads
	# -----------------------------------------------------------------------------
	# No Threads selected ?
# --- /Added for Notify Plus 2.2 --- #

# --- Deleted for Notify Plus 2.2 --- #
#	i	if (@found_number==0) {
#		$yymain .= "$txt{'414'}<br><br>&nbsp;";
#	} else {
#		foreach (@censored) {
#		($tmpa,$tmpb) = @{$_};
#		$found_subject[$counter] =~ s~\Q$tmpa\E~$tmpb~gi;
#		}
#		$yymain .= qq~<form action="$cgi;action=notify4" method=post>
#<table>
#  <tr>
#      <td colspan=2><font size=2>$txt{'415'}:</font><br>&nbsp;</td></tr>
#~;
#		$counter=0;
#		foreach $entry (@found_number) {
#			&FormatUserName($found_username[$counter]);
#			$yymain .= "<tr><td><font size=2>";
#			$yymain .= qq~<input type=checkbox name="thread-$found_number[$counter]" value="1"></font></td>~;
#			$yymain .= qq~<td><font size=2><b><i>$found_subject[$counter]</i></b> $txt{'525'} <a href="$scripturl?board=;action=viewprofile;username=$useraccount{$found_username[$counter]}">$found_name[$counter]</a></font></td></tr>\n~;
#			$counter++;
#		}
#		$yymain .= "<tr><td colspan=2><br><font size=2>$txt{'416'}</font><br>&nbsp;</td></tr>\n";
#		$yymain .= qq~<tr><td>&nbsp;</td><td><input type=reset value="$txt{'278'}">&nbsp;&nbsp;&nbsp;<input type=submit value="$txt{'417'}"></td></tr>~;
#		$yymain .= "</table></form><br>&nbsp;\n";
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #

	if (@found_number==0) {
		$yymain .= qq~ <font size=2><b>$txt{'415'}:</b></font><br>\n ~;
		$yymain .= qq~ $txt{'414'}<br><br>&nbsp; ~;
	} else {
		foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$found_subject[$counter] =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Only when no boards with Notification
		if (@found_boardname==0 || $username eq "Guest") {
			$yymain .= qq~ <form action="$cgi;action=notify4" method=post> ~;
			$yymain .= qq~ <input name="guest_email" type="hidden" value="$FORM{'guest_email'}"> ~;
		}

		$yymain .= qq~ <table>\n ~;
		$yymain .= qq~ <tr><td colspan=2><font size=2><b>$txt{'415'}:</b></font></td></tr> ~;
		$counter=0;
		foreach $entry (@found_number) {
			&FormatUserName($found_username[$counter]);
			$yymain .= qq~ <tr><td><font size=2> ~;
			$yymain .= qq~ <input type=checkbox name="thread-$found_number[$counter]" value="1"></font></td> ~;
			$yymain .= qq~ <td><font size=2><b><i>$found_subject[$counter]</i></b> $txt{'525'} <a href="$scripturl?board=;action=viewprofile;username=$useraccount{$found_username[$counter]}">$found_name[$counter]</a></font></td></tr>\n ~;
			$yymain .= qq~ <td></td> ~;
			$yymain .= qq~ <td><font size="1">$notify_txt{'1'} $found_format[$counter]</font></td></tr> ~;

			$counter++;
		}
		$yymain .= qq~</table>\n ~;
	}


	# Show buttons when it gives a notification !
	if (@found_boardname != 0 || @found_number != 0) {
		$yymain .= qq~ <p>\n ~;

		$yymain .= qq~ <font size=2>$notify_txt{'44'}</font><br>&nbsp;\n ~;
		$yymain .= qq~ <br>\n ~;
		$yymain .= qq~ <input type=reset value="$txt{'278'}">&nbsp;&nbsp;&nbsp;<input type=submit value="$txt{'417'}"> ~;
	}

	$yymain .= qq~ </form><br>&nbsp;\n ~;

# --- /Added for Notify Plus 2.2 --- #

	$yymain .= qq~
   </font>
  </td>
 </tr>
</table>
~;
	$yytitle = "$txt{'417'}";
	&template;
	exit;
}

# --- Added for Notify Plus 2.2 --- #

sub replace_notifications {
	my ($old_email, $new_email, @maildir, $filename, $content, $content_old) = (shift, shift);

	opendir (DIRECTORY,"$datadir");
	@maildir = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);

	foreach $filename (@maildir) {
		$content = '';

		fopen(MYFILE, "+<$datadir/$filename") || &fatal_error("$txt{'23'} $filename");
		while (<MYFILE>) { $content .= $_; }
		$content_old = $content;

		$content =~ s/$old_email/$new_email/ig;

		if (length($content) > 0) {
			if ($content ne $content_old) {
				truncate(MYFILE,0);
				seek(MYFILE,0,0);
				print MYFILE $content;
				fclose(MYFILE);
			}
			else {
				fclose(MYFILE);
			}
		}
		else {
			fclose(MYFILE);
			unlink("$datadir/$filename");
		}
	}
}

sub NotifyBoard {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error("$txt{'138'}"); }

	# When email of Guest not entered yet ...
	if($username eq "Guest") {

		if ($FORM{'guest_email'} eq "") {

			$yymain .= qq~
			<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
			<tr>
			    <td class="titlebg" bgcolor="$color{'titlebg'}">
					<font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font>
				</td>
			</tr>
			<tr>
		    	<td class="windowbg" bgcolor="$color{'windowbg'}">
					<font size=2>
					<form action="$cgi;action=notifyboard" method="post" name="notifyForm">
						$notify_txt{'14'}
						<input type="text" name="guest_email" size="25" maxlength="30">
						<br>
						<b><a href="javascript:document.notifyForm.submit();">$notify_txt{'15'}</a> - <a href="javascript:history.go(-1)">$txt{'250'}</a></b>


					</form>
			    	</font>
				</td>
			</tr>
			</table>
~;

			$yytitle = "$txt{'125'}";
			&template;
			exit;
		}
		else {
			# Check email
			&fatal_error("$txt{'76'}") if($FORM{'guest_email'} eq '');
			&fatal_error($txt{'243'}) if($FORM{'guest_email'} !~ /^[0-9A-Za-z@\._\-]+$/);
			&fatal_error("$txt{'500'}") if(($FORM{'guest_email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'guest_email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));

			# Not email-address of member ?
			fopen(FILE, "$memberdir/memberlist.txt");
			@memberlist = <FILE>;
			fclose(FILE);
			for ($a = 0; $a < @memberlist; $a++) {
				chomp $memberlist[$a];
				if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {

					# Load users and check email
					if( !$yyUDLoaded{$memberlist[$a]} && -e("$memberdir/$memberlist[$a].dat") ) {
						# If user is not in memory, s/he must be loaded.
						&LoadUser($memberlist[$a]);
						if($userprofile{$memberlist[$a]}->[2] eq $FORM{'guest_email'}) { &fatal_error("$notify_txt{'16'}"); }
					}
					fclose(FILE2);
				}
			}

			# Email-address OK !
			$settings[2] = $FORM{'guest_email'};
		}
	}

	# Check, if User already gets a notification
	@mails = ();
	if (-e("$boardsdir/$INFO{'board'}.mail")) {
		fopen(FILE, "$boardsdir/$INFO{'board'}.mail");
		@mails = <FILE>;
		fclose(FILE);
	}

	$isonlist = 0;

	foreach $record (@mails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);
		if($settings[2] eq $email) { $isonlist = 1; }
	}

	if ($isonlist){

	$yymain .= qq~
<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    $notify_txt{'40'}<br>
    <b><a href="$cgi;action=notifyboard3;guest_email=$FORM{'guest_email'}">$txt{'163'}</a> - <a href="$cgi">$txt{'164'}</a></b>
    </font></td>
  </tr>
</table>
~;


	} else
	{

	$yymain .= qq~
<table border=0 width=100% cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'125'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
	<form action="$cgi;action=notifyboard2" method="post" name="notifyForm">
	    $notify_txt{'41'}<br>
		<input name="guest_email" type="hidden" value="$FORM{'guest_email'}">
		<b><a href="javascript:document.notifyForm.submit();">$txt{'163'}</a> - <a href="javascript:history.go(-1)">$txt{'164'}</a></b>
	</form>
    </font></td>
  </tr>
</table>
~;

	}

	$yytitle = "$txt{'125'}";
	&template;
	exit;
}

sub NotifyBoard2 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }

	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error($txt{'138'}); }
	if($username eq 'Guest') { $settings[2] = $FORM{'guest_email'}; }

	$board = $INFO{'board'};

	@mails = ();

	if (-e("$boardsdir/$board.mail")) {
		fopen(FILE, "$boardsdir/$board.mail");
		@mails = <FILE>;
		fclose(FILE);
	}
	fopen(FILE, ">$boardsdir/$board.mail", 1) || &fatal_error("$txt{'23'} $board.mail");

	print FILE "$settings[2]|$INFO{'username'}\n";

	foreach $record (@mails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);
		if($settings[2] ne $email) { print FILE "$record\n"; }
	}

	fclose(FILE);
	$yySetLocation = qq~$cgi~;
	&redirectexit;
}

sub NotifyBoard3 {
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	if($username eq 'Guest' && $enable_notification_guest == 0) { &fatal_error($txt{'138'}); }

	if($username eq 'Guest') { $settings[2] = $INFO{'guest_email'}; }

	$board = $INFO{'board'};
	fopen(FILE, "$boardsdir/$board.mail");
	@mails = <FILE>;
	fclose(FILE);
	fopen(FILE, ">$boardsdir/$board.mail", 1) || &fatal_error("$txt{'23'} $board.mail");

	foreach $record (@mails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);
		if($settings[2] ne $email) { print FILE "$record\n"; }
	}

	fclose(FILE);
	$yySetLocation = qq~$cgi~;
	&redirectexit;
}

# --- /Added for Notify Plus 2.2 --- #
sub remove_notifications {
	my (@deademails, @maildir, $filename, $content, $content_old) = (@_);

	opendir (DIRECTORY,"$datadir");
	@maildir = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);

	foreach $filename (@maildir) {
		$content = '';

		fopen(MYFILE, "+<$datadir/$filename") || &fatal_error("$txt{'23'} $filename");
		while (<MYFILE>) { $content .= $_; }
		$content_old = $content;

		foreach (@deademails) { $content =~ s/$_(?:\r\n|\r|\n)//ig; }

		if (length($content) > 0) {
			if ($content ne $content_old) {
				truncate(MYFILE,0);
				seek(MYFILE,0,0);
				print MYFILE $content;
				fclose(MYFILE);
				$done .= "$filename\n";
			}
			else {
				fclose(MYFILE);
			}
		}
		else {
			fclose(MYFILE);
			unlink("$datadir/$filename");
		}
	}
}

sub replace_notifications {
	my ($old_email, $new_email, @maildir, $filename, $content, $content_old) = (shift, shift);

	opendir (DIRECTORY,"$datadir");
	@maildir = grep {/\.mail$/} readdir(DIRECTORY);
	closedir (DIRECTORY);

	foreach $filename (@maildir) {
		$content = '';

		fopen(MYFILE, "+<$datadir/$filename") || &fatal_error("$txt{'23'} $filename");
		while (<MYFILE>) { $content .= $_; }
		$content_old = $content;

		$content =~ s/$old_email/$new_email/ig;

		if (length($content) > 0) {
			if ($content ne $content_old) {
				truncate(MYFILE,0);
				seek(MYFILE,0,0);
				print MYFILE $content;
				fclose(MYFILE);
			}
			else {
				fclose(MYFILE);
			}
		}
		else {
			fclose(MYFILE);
			unlink("$datadir/$filename");
		}
	}
}

1;
