###############################################################################
#Post.pl                                                                     #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.4                                        #
# Released:       December 2001; Updated November 25, 2004                    #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

$postplver = "1 Gold - SP 1.4";
# --- Added for Notify Plus 2.2 --- #
require "$sourcedir/NotifyPlus.pl";
# --- /Added for Notify Plus 2.2 --- #


sub Post {
	if($username eq 'Guest' && $enable_guestposting == 0) { &fatal_error($txt{'165'}); }
	if( $currentboard eq '' ) { &fatal_error($txt{'1'}); }
	my( $subtitle, $x, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $msubject, $mattach, $mip, $mmessage, $mns, $quotestart);
	my $quotemsg = $INFO{'quote'};
	$threadid = $INFO{'num'};

	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
	if( $mstate == 1 ) { &fatal_error($txt{'90'}); }

	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	$curcat = $cat;
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$cat = <FILE>;
	fclose(FILE);
	$pollthread = 0;
	$polltxt{'1a'} =~ tr/+/ /;
	$polltxt{'2a'} =~ tr/+/ /;
	if ($INFO{'title'} eq $polltxt{'1a'}) { $pollthread = 1; }
	elsif ($INFO{'title'} eq $polltxt{'2a'}) { $pollthread = 2; }
	if ($pollthread == 2 && $useraddpoll == 0) { &fatal_error($txt{'1'}); }

# --- Deleted for Notify Plus 2.2 --- #
#	$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
#   <tr>
#      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
#     <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
#   </tr>
#~;
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Notification enabled ?
	if ($enable_notification == 1) {

		# Notification enabled for guests ?
		if ($username ne 'Guest' || $enable_notification_guest == 1) {

			$notification = <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><font size=2><input type=checkbox name="notify" value="x"></font>
~;

			# When Guest
			if ($username eq 'Guest') {

				$notification .= <<"~;";

	<font size=1>$notify_txt{'1'}</font>
	<input type="radio" name="notifyformat" value="HTML" checked><font size=1>$notify_txt{'2'}</font>
	<input type="radio" name="notifyformat" value="Plain"><font size=1>$notify_txt{'3'}</font>
~;
			}
			# When Member
			else {

				$notification .= <<"~;";

	<font size=1>$txt{'750'}</font>
~;
			}

			$notification .= <<"~;";
	</td>
</tr>
~;
		}
	}
# --- /Added for Notify Plus 2.2 --- #


	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><font size="2"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></font></td>
      </tr>~ : qq~~;

	$sub = "";
	$settofield="subject";
	if( $threadid ne '' ) {
		fopen(FILE, "$datadir/$threadid.txt") || &fatal_error("201 $txt{'106'}: $txt{'23'} $threadid.txt");
		@messages = <FILE>;
		fclose(FILE);
	$message =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;

		if($quotemsg ne '') {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns) = split(/\|/,$messages[$quotemsg]);
			$message=$mmessage;
			$message =~ s~<br>~\n~g;
			$message =~ s~\n{0,1}\[quote([^\]]*)\](.*?)\[/quote\]\n{0,1}~\n~isg;
			$message =~ s~\n*\[/*quote([^\]]*)\]\n*~~ig;

			$mname ||= $musername || $txt{'470'};
			$quotestart = int( $quotemsg / $maxmessagedisplay ) * $maxmessagedisplay;
			$message = qq~[quote author=$mname link=board=$currentboard;num=$threadid;start=$quotestart#$quotemsg date=$mdate\]$message\[/quote\]\n~;
			$msubject =~ s/\bre:\s+//ig;
			if ($mns eq "NS") {$nscheck="checked";}
		}
		else {
			($msubject, $mname, $memail, $mdate, $musername, $micon, $mattache, $mip, $mmessage, $mns) = split(/\|/,$messages[0]);
			$msubject =~ s/\bre:\s+//ig;
		}
		$sub = "Re: $msubject";
		$settofield="message";
	}
	if ($pollthread && $username eq "Guest") {$guest_vote = 1;}
	if ($pollthread == 2) {
		$settofield="question";
		$sub = "$msubject";
	} else {
		if (!$enable_notification || $username eq 'Guest') {$notification = ""} else { $notification = qq~<tr>
                <td><font size="2"><b>$txt{'131'}:</b></font></td>
                <td><input type="checkbox" name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
              </tr>~;}
	}
	if(!$sub) { $subtitle = "<i>$txt{'33'}</i>"; }
	else { $subtitle = "<i>$sub</i>"; }
	$yymain .= qq~
<table  width="90%" align="center" cellpadding=0 cellspacing=0>
  <tr>
    <td valign="bottom" colspan="2">
    <font size="2" class="nav"><B><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <img src="$imagesdir/tline.gif" border="0" alt=""><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$scripturl#$curcat" class="nav">$cat</a><br>
    <img src="$imagesdir/tline2.gif" border="0" alt=""><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    <a href="$cgi" class="nav">$boardname</a><br>
    <img src="$imagesdir/tline3.gif" border="0" alt=""><img src="$imagesdir/open.gif" border="0" alt="">&nbsp;&nbsp;
    $INFO{'title'} ( $subtitle )</B></font></td>
  </tr>
</table>
~;
	$submittxt = "$txt{'105'}";
	$destination = "post2";
	$icon = "xx";
	$is_preview = 0;
	$post = "post";
	$preview = "preview";
	$yytitle = "$INFO{'title'}";
	&Postpage;
	if ($pollthread != 2) { &doshowthread; }
	&template;
	exit;
}

sub Postpage {
	my $extra;
	if ($is_preview) {$txt{'507'}=$txt{'771'};}
	$message =~ s~<\/~\&lt\;/~isg;
	$message =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;
	if($post eq "imsend") {
		if(!$INFO{'to'}) { $INFO{'to'} = $FORM{'to'};}
		if($INFO{'to'}) {$settofield="message";} else {$settofield="to";}
		$idinfo = "$INFO{'id'}";
if(!$INFO{'adminim'}) {
		$extra = qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'150'}</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
	<input type=text name="to" value="$INFO{'to'}" size="20" maxlength="50" tabindex="2">
	<font size="1">$txt{'748'}</font></td>
      </tr>
	~;
} else { $extra = qq~$adminim~; }

	}
	else {
	 $extra = qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'71'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}">
        <select name="icon" onChange="showimage()">
         <option value="xx"$ic1>$txt{'281'}
         <option value="thumbup"$ic2>$txt{'282'}
         <option value="thumbdown"$ic3>$txt{'283'}
         <option value="exclamation"$ic4>$txt{'284'}
         <option value="question"$ic5>$txt{'285'}
         <option value="lamp"$ic6>$txt{'286'}
         <option value="smiley"$ic7>$txt{'287'}
         <option value="angry"$ic8>$txt{'288'}
         <option value="cheesy"$ic9>$txt{'289'}
         <option value="laugh"$ic10>$txt{'290'}
         <option value="sad"$ic11>$txt{'291'}
         <option value="wink"$ic12>$txt{'292'}
        </select>
        <img src="$imagesdir/$icon.gif" name="icons" border="0" hspace="15" alt="$icon" title="$icon"></td>
      </tr>
	 ~;
	if ($realname eq '' && $threadid ne '') {$settofield="name";}
	}
	$yymain .= qq~

<table border="0" width="90%" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">~;
if($INFO{'adminim'} || $INFO{'action'} eq "imgroups") {
$yymain .= qq~<form action="$cgi;action=imgroups" method="post" name="postmodify" onSubmit="return submitproc()">~;
} else {
$yymain .= qq~<form action="$cgi;action=$destination" method="post" name="postmodify" onSubmit="return submitproc()">~;
}
$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
    <input type="hidden" name="threadid" value="$threadid">
    <input type=hidden name="postid" value="$postid">
<!--- Added for Notify Plus 2.2 --->
~;

# Add extra Fields when not Guest
if ($username ne 'Guest') {

	$yymain .= qq~
	<input type="hidden" name="name" value="$realname">
	<input type="hidden" name="email" value="$realemail">
~;

}

$yymain .= qq~
<!--- /Added for Notify Plus 2.2 --->

    <input type=hidden name="info" value="$idinfo">
    <table class="titlebg" bgcolor="$color{'titlebg'}" width="100%">
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}"><font size="2" class="text1" color="$color{'titletext'}"><b>$yytitle</b></font></td>
      </tr>
    </table>
    </td>
  </tr>~;
	if ($pollthread != 2 || ($pollthread == 2 && $username eq 'Guest')) { $yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">~;
		if ($pollthread == 2 ) {$extra = "";} else { $yymain .= qq~
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'70'}:</b></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><input type=text name="subject" value="$sub" size="40" maxlength="50" tabindex="1"></font></td>
      </tr>
~;
		}
		$yymain .= qq~
$name_field
$email_field
$extra
    </table>
    </td>
   </tr>
~;
	}

## [Poll Mod Options] ##
	if ($pollthread) {
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		if ($guest_vote) {$gvchecked = " checked";}
		if ($hide_results) {$hrchecked = " checked";}
		if ($multi_choice) {$mcchecked = " checked";}
		$yymain .= qq~
        <tr>
          <td bgcolor="$color{'windowbg2'}" class="windowbg2">
            <input type="hidden" name="pollthread" value="$pollthread">
            <table width="100%" cellpadding="3" cellspacing="0" border="0">
              <tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'6'}:</b></font></td>
                <td align="left"><input type="text" size="40" name="question" value="$poll_question" maxlength="$maxpq"></td>
              </tr><tr>
                <td width="23%" align="left">&nbsp;</td>
                <td align="left">
                  <table cellpadding="0" cellspacing="0" border="0">~;

		for(my $i = 1; $i <= $numpolloptions; $i++) {
			$yymain .= qq~
                    <tr>
                      <td align="right"> &nbsp; <font size="2">$polltxt{'7'} $i: &nbsp;</font></td>
                      <td align="left"><input type="text" size="25" maxlength="$maxpo" name="option$i" value="$options[$i]"></td>
                    </tr>~;
		}
		$yymain .= qq~
                  </table>
                </td>~;

		if ($maxpc > 0) {
			$yymain .= qq~
             </tr><tr>
                <td valign=top class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$polltxt{'59'}:</b></font></td>
                <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><textarea name="poll_comment" rows="3" cols="60" wrap="soft" onkeyup="if (document.postmodify.poll_comment.value.length > $maxpc) {document.postmodify.poll_comment.value = document.postmodify.poll_comment.value.substring(0,$maxpc)}">$poll_comment</textarea></font></td>~;
		}

		$yymain .= qq~
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'32'}</b></font></td>
                <td align="left"><input type="checkbox" name="guest_vote" value="1"$gvchecked> <font size="1">$polltxt{'54'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'26'}</b></font></td>
                <td align="left"><input type="checkbox" name="hide_results" value="1"$hrchecked> <font size="1">$polltxt{'55'}</font></td>
              </tr><tr>
                <td width="23%" align="left"><font size="2"><b>$polltxt{'58'}</b></font></td>
                <td align="left"><input type="checkbox" name="multi_choice" value="1"$mcchecked> <font size="1">$polltxt{'56'}</font></td>
              </tr>

            </table>
          </td>
        </tr>~;
	}
	if ($pollthread != 2) { # if not adding a poll to an existing thread, display standard post page inputs

## [/Poll Mod Options] ##

if($enable_ubbc && $showyabbcbutt) {
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg2'}" class="windowbg2">
      <tr>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="23%"><font size=2><b>$txt{'252'}:</b></font></td>
        <td valign=middle class="windowbg2" bgcolor="$color{'windowbg2'}">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          HAND = "onmouseover=this.style.cursor='hand'";
          document.write("<img src='$imagesdir/bold.gif' onclick='bold();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'253'}' title='$txt{'253'}' border='0'>");
          document.write("<img src='$imagesdir/italicize.gif' onclick='italicize();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'254'}' title='$txt{'254'}' border='0'>");
          document.write("<img src='$imagesdir/underline.gif' onclick='underline();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'255'}' title='$txt{'255'}' border='0'>");
          document.write("<img src='$imagesdir/strike.gif' onclick='strike();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'441'}' title='$txt{'441'}' border='0'>");
          document.write("<img src='$imagesdir/glow.gif' onclick='glow();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'442'}' title='$txt{'442'}' border='0'>");
          document.write("<img src='$imagesdir/shadow.gif' onclick='shadow();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'443'}' title='$txt{'443'}' border='0'>");
          document.write("<img src='$imagesdir/move.gif' onclick='move();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'439'}' title='$txt{'439'}' border='0'>");
          document.write("<img src='$imagesdir/pre.gif' onclick='pre();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'444'}' title='$txt{'444'}' border='0'>");
          document.write("<img src='$imagesdir/left.gif' onclick='left();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'445'}' title='$txt{'445'}' border='0'>");
          document.write("<img src='$imagesdir/center.gif' onclick='center();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'256'}' title='$txt{'256'}' border='0'>");
          document.write("<img src='$imagesdir/right.gif' onclick='right();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'446'}' title='$txt{'446'}' border='0'>");
          document.write("<img src='$imagesdir/hr.gif' onclick='hr();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'531'}' title='$txt{'531'}' border='0'>");
          document.write("<img src='$imagesdir/size.gif' onclick='size();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'532'}' title='$txt{'532'}' border='0'>");
          document.write("<img src='$imagesdir/face.gif' onclick='font();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'533'}' title='$txt{'533'}'' border='0'>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        <select name="color" onChange="showcolor(this.options[this.selectedIndex].value)">
         <option value="Black" selected>$txt{'262'}</option>
         <option value="Red">$txt{'263'}</option>
         <option value="Yellow">$txt{'264'}</option>
         <option value="Pink">$txt{'265'}</option>
         <option value="Green">$txt{'266'}</option>
         <option value="Orange">$txt{'267'}</option>
         <option value="Purple">$txt{'268'}</option>
         <option value="Blue">$txt{'269'}</option>
         <option value="Beige">$txt{'270'}</option>
         <option value="Brown">$txt{'271'}</option>
         <option value="Teal">$txt{'272'}</option>
         <option value="Navy">$txt{'273'}</option>
         <option value="Maroon">$txt{'274'}</option>
         <option value="LimeGreen">$txt{'275'}</option>
        </select>
        <br>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<img src='$imagesdir/flash.gif' onclick='flash();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'433'}' title='$txt{'433'}' border='0'>");
          document.write("<img src='$imagesdir/url.gif' onclick='hyperlink();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'257'}' title='$txt{'257'}' border='0'>");
          document.write("<img src='$imagesdir/ftp.gif' onclick='ftp();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'434'}' title='$txt{'434'}' border='0'>");
          document.write("<img src='$imagesdir/img.gif' onclick='image();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'435'}' title='$txt{'435'}' border='0'>");
          document.write("<img src='$imagesdir/email2.gif' onclick='emai1();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'258'}' title='$txt{'258'}' border='0'>");
          document.write("<img src='$imagesdir/table.gif' onclick='table();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'436'}' title='$txt{'436'}' border='0'>");
          document.write("<img src='$imagesdir/tr.gif' onclick='trow();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'437'}' title='$txt{'437'}' border='0'>");
          document.write("<img src='$imagesdir/td.gif' onclick='tcol();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'449'}' title='$txt{'449'}' border='0'>");
          document.write("<img src='$imagesdir/sup.gif' onclick='superscript();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'447'}' title='$txt{'447'}' border='0'>");
          document.write("<img src='$imagesdir/sub.gif' onclick='subscript();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'448'}' title='$txt{'448'}' border='0'>");
          document.write("<img src='$imagesdir/tele.gif' onclick='teletype();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'440'}' title='$txt{'440'}' border='0'>");
          document.write("<img src='$imagesdir/code.gif' onclick='showcode();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'259'}' title='$txt{'259'}' border='0'>");
          document.write("<img src='$imagesdir/quote2.gif' onclick='quote();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'260'}' title='$txt{'260'}' border='0'>");
          document.write("<img src='$imagesdir/list.gif' onclick='list();' "+HAND+" align='bottom' width='23' height='22' alt='$txt{'261'}' title='$txt{'261'}' border='0'>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
      <tr>
        <td bgcolor="$color{'bordercolor'}" colspan="2" class="bordercolor">
        <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
~;
}
### Add More Smilies 3.0 - Smiley List ###
	if ($SmilieURL[0] eq "") {&LoadSmilies;}

	$showmore = ""; 
	$smilie_list = "";
	$smilie_more = "";
	$smilie_block = "";
	$smilie_url_array = "";
	for( my $i = 0; $i < @SmilieURL; $i++ ) {
		if ($SmilieURL[$i] =~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$smiliesurl/$SmilieURL[$i]~;}
		($tmpCode, $dummy) = split (/\s+/, $SmilieCode[$i]); 
		$tmpCode =~ s/'/&#39;/g;
		if ($SmilieOption[$i] % 2 == 1) { $smilie_list .= qq~
                    document.write("<img src='$tmpurl' onclick='javascript:AddText(" + '" $tmpCode"' + ")' align='bottom' alt='$SmilieDescription[$i]' border='0' style='cursor:hand'> ");~;
		}
		if (($SmilieOption[$i] / 2) % 2 == 1) {$smilie_block .= qq~
                    document.write("<option value=" + '" $tmpCode"' + ">$SmilieDescription[$i]</option>");~;
			$smilie_url_array .= qq~"$tmpurl", ~;
		}
		if (($SmilieOption[$i] / 4) % 2 == 1) {$showmore = 1;}
	}
	$smilie_url_array .= qq~""~;

	if ($showmore == 1 && ($show_smilie_block != 1 || $smilie_block eq "")) {$smilie_more = qq~
                    document.write('<a href="$scripturl?action=smilieindex" target="_blank" onclick="' + "javascript: window.open('$scripturl?action=smilieindex', 'list', 'width=100,height=100,left=0,top=0,scrollbars=yes'); return false" + '">$smi_txt{'8'}</a>');~;
	}

	if ($smilie_list ne "" || $smilie_more ne "" ) {$yymain .= qq~
              <tr>
                <td width="23%"><font size="2"><b>$txt{'297'}:</b></font></td>
                <td valign="middle">
                  <script language="JavaScript1.2" type="text/javascript">
                  <!--
                  if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {$smilie_list$smilie_more
                  }
                  else { document.write("<font size='1'>$txt{'215'}</font>"); }
                  //-->
                  </script>
                  <noscript>
                    <font size="1">$txt{'215'}</font>
                  </noscript>
                </td>
              </tr>~;
	}
### Add More Smilies 3.0 - Smiley List ###

		$yymain .= qq~
              <tr>
                <td valign="top" width="23%"><font size=2><b>$txt{'72'}:</b></font>
                  <br><br><br>~;

### Add More Smilies 3.0 - Smiley Block ###
	if ($show_smilie_block == 1 && $smilie_block ne "") {$yymain .= qq~
               <script language="JavaScript1.2" type="text/javascript">
               <!--
               smilieurl = new Array($smilie_url_array)
               smiliecode = new Array($smilie_code_array)

               if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {

                 document.write('<table border="0" cellpadding="3" callspacing="0" bgcolor="" style="border-style:solid; border-width:1px; border-color:silver" align="center"><tr>');
                 document.write('<td height="20" width="120" align="center" valign="top"><select name="smiliextra_list" onchange="document.images.smiliextra_image.src= smilieurl[document.postmodify.smiliextra_list.selectedIndex]" style="width:120px; font-size:7pt">');$smilie_block
                 document.write('</select></td>');
                 document.write('</tr><tr>');
                 document.write('<td height="70" align="center" valign="middle" style="height:70px"><img name="smiliextra_image" src="'+smilieurl[0]+'" alt="" border="0" onclick="javascript:AddText(document.postmodify.smiliextra_list.options[document.postmodify.smiliextra_list.selectedIndex].value)" style="cursor:hand"></td>');
                 document.write('</tr><tr>');
                 document.write('<td height="15" align="center" valign="middle"><font size="1"><a href="$scripturl?action=smilieindex" target="_blank" onclick="' + "javascript: window.open('$scripturl?action=smilieindex', 'list', 'width=100,height=100,left=0,top=0,scrollbars=yes'); return false" + '">$smi_txt{'9'}</a></font></td>');
                 document.write('</tr></table>');
               }

               //-->
               </script>~;
	}
### Add More Smilies 3.0 - Smiley Block ###

		$yymain .= qq~
               </td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">
        <textarea name="message" rows="12" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" tabindex="4">$message</textarea>
        </font><BR><BR></td>
      </tr>
    </table>
    </td>
  </tr><tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table width="100%" cellpadding="3" cellspacing="0" bgcolor="$color{'windowbg'}" class="windowbg">
$notification
$lastmod
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="23%"><font size=2><b>$txt{'276'}:</b></font><BR><BR></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}"><input type=checkbox name="ns" value="NS"$nscheck> <font size="1"> $txt{'277'}</font><BR><BR></td>
      </tr>
    </table>
    </td>
  </tr>~;
	}
	$yymain .= qq~
  <tr>
    <td bgcolor="$color{'bordercolor'}" class="bordercolor">
    <table class="titlebg" bgcolor="$color{'titlebg'}" align="center" width="100%">
      <tr>
        <td align="center" class="titlebg" bgcolor="$color{'titlebg'}">
        <font size="1" class="text1" color="$color{'titletext'}">$txt{'329'}</font><br>
		<input type="submit" name="$post" value="$submittxt" accesskey="s" tabindex="5">
~;
unless ($pollthread == 2) {$yymain .= qq~		<input type="submit" name="$preview" value="$txt{'507'}" accesskey="p">~;}
unless ($is_preview){$yymain .= qq~       <input type="reset" value="$txt{'278'}" accesskey="r">~;}

$yymain.=qq~
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
</form>
<script language="JavaScript"> <!--
   document.postmodify.$settofield.focus();
//--> </script>
~;
}

sub Preview {
	$poll_question = $FORM{'question'};
	$numpolloptions ||= 8;
	for(my $i = 1; $i <= $numpolloptions; $i++) {$options[$i] = $FORM{"option$i"};}
	$guest_vote = $FORM{'guest_vote'};
	$hide_results = $FORM{'hide_results'};
	$multi_choice = $FORM{'multi_choice'};
	$poll_comment = $FORM{'poll_comment'};
	$pollthread =  $FORM{'pollthread'} || 0;

	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$sub = $FORM{'subject'};
	$FORM{'message'} =~ s~\r~~g;
	$mess = $FORM{'message'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	$notify = $FORM{'notify'};
	$postid = $FORM{'postid'};
	if (length($sub) > 50) { $sub = substr($sub,0,50); }
	$sub =~ s/[\r\n]//g;
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1$2~g;
	&ToHTML($message);
	$message =~ s/\t/ \&nbsp; \&nbsp; \&nbsp;/g;
	$message =~ s/\n/<br>/g;
	$message =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;
	&CheckIcon;

	if($icon eq "xx") { $ic1 = " selected"; }
	elsif($icon eq "thumbup") { $ic2 = " selected"; }
	elsif($icon eq "thumbdown") { $ic3 = " selected"; }
	elsif($icon eq "exclamation") { $ic4 = " selected"; }
	elsif($icon eq "question") { $ic5 = " selected"; }
	elsif($icon eq "lamp") { $ic6 = " selected"; }
	elsif($icon eq "smiley") { $ic7 = " selected"; }
	elsif($icon eq "angry") { $ic8 = " selected"; }
	elsif($icon eq "cheesy") { $ic9 = " selected"; }
	elsif($icon eq "laugh") { $ic10 = " selected"; }
	elsif($icon eq "sad") { $ic11 = " selected"; }
	elsif($icon eq "wink") { $ic12 = " selected"; }

	$name_field = $realname eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'44'}:</b></font></td>
    <td class="windowbg"><input type=text name="name" size=25 value="$FORM{'name'}" maxlength="25" tabindex="2"></td>
      </tr>~ : qq~~;

	$email_field = $realemail eq '' ? qq~      <tr>
    <td class="windowbg"><font size=2><b>$txt{'69'}:</b></font></td>
    <td class="windowbg"><input type=text name="email" size=25 value="$FORM{'email'}" maxlength="40" tabindex="3"></td>
      </tr>~ : qq~~;
	if ($FORM{'notify'} eq "x") {$notify = " checked";}
	if ($FORM{'ns'} eq 'NS') {$nscheck = " checked";}

	if ($username eq 'Guest') {
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("202 $txt{'106'}: $txt{'23'} memberlist.txt");
		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'100'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'100'}); }
		}
		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("203 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("204 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) {
			chomp $reservecfg[$a];
		}
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;
		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
	}
	&wrap;
	$displayname = $settings[1];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;
	if( $FORM{'previewmodify'} ) {
		$submittxt = "$txt{'10'}";
		$is_preview = 1;
		$post = "postmodify";
		$preview = "previewmodify";
		$destination = 'modify2';
		$submittxt = $txt{'10'};
	}
	elsif( $FORM{'previewim'} ) {
		$submittxt = "$txt{'148'}";
		$destination = "imsend2";
		$is_preview = 1;
		$post = "imsend";
		$preview = "previewim";
		$submittxt = $txt{'148'};
	}
	else {
		$notification = ! $enable_notification || $username eq 'Guest' ? '' : <<"~;";
    <tr>
      <td class="windowbg"><font size=2><b>$txt{'131'}:</b></font></td>
      <td class="windowbg"><input type=checkbox name="notify" value="x"$notify> <font size="1">$txt{'750'}</font></td>
    </tr>
~;
		$destination = 'post2';
		$submittxt = $txt{'105'};
		$is_preview = 1;
		$post = "post";
		$preview = "preview";
	}

	if($INFO{'action'} eq "imgroups") { $destination = "imgroups"; }


	$csubject = $sub;
	&LoadCensorList;	# Load Censor List
	$csubject =~ s/\Q$tmpa\E/$tmpb/gi;
	$message =~ s/\Q$tmpa\E/$tmpb/gi;

	$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript" src="$ubbcjspath"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
<table border=0 width="90%" cellspacing=1 cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}"><font size=2 class="text1" color="$color{'titletext'}">
    <img src="$imagesdir/$icon.gif" name="icons" border=0> $csubject</font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><BR>$message<BR><BR></font></td>
  </tr>
</table>
<BR>
~;
	$message = $mess; 
	$yytitle = "$txt{'507'} - $csubject";
	$settofield="message";
	&Postpage;
	&template;
	exit;
}

sub Post2 {
	if($username eq 'Guest' && $enable_guestposting == 0) {	&fatal_error($txt{'165'}); }
	my( $email, $subject, $ns, $threadid, $notify, @memberlist, $a, $realname, $membername, $testname, @reserve, @reservecfg, $matchword, $matchcase, $matchuser, $matchname, $namecheck, $reserved, $reservecheck, $newthreadid, @messages, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $start, $pageindex, $tempname );

	# If poster is a Guest then evaluate the legality of name and email
	if(!$settings[2]) {
		$FORM{'name'} =~ s/\A\s+//;
		$FORM{'name'} =~ s/\s+\Z//;
		&fatal_error($txt{'75'}) unless ($FORM{'name'} ne '' && $FORM{'name'} ne '_' && $FORM{'name'} ne ' ');
		&fatal_error($txt{'568'}) if(length($FORM{'name'}) > 25);
		&fatal_error("$txt{'76'}") if($FORM{'email'} eq '');
		&fatal_error("$txt{'240'} $txt{'69'} $txt{'241'}") if($FORM{'email'} !~ /[\w\-\.\+]+\@[\w\-\.\+]+\.(\w{2,4}$)/);
		&fatal_error("$txt{'500'}") if(($FORM{'email'} =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)|(\.$)/) || ($FORM{'email'} !~ /^.+@\[?(\w|[-.])+\.[a-zA-Z]{2,4}|[0-9]{1,4}\]?$/));
	}

	# Get the form values
	$name = $FORM{'name'};
	$email = $FORM{'email'};
	$subject = $FORM{'subject'};
	$message = $FORM{'message'};
 	$icon = $FORM{'icon'};
	$ns = $FORM{'ns'};
	$threadid = $FORM{'threadid'};
	if( $threadid =~ /\D/ ) { &fatal_error($txt{'337'}); }
	$notify = $FORM{'notify'};
		$message =~ s/([\000-\x09\x0b\x0c\x0e-\x1f\x7f])/\x0d/g;

	if($name && $email) {
		&ToHTML($name);
		$email =~ s/\|//g;
		&ToHTML($email);
		$tempname = $name;	# hold it temporarily so we can put the _'s back later
		$name =~ s/\_/ /g;
	}

	&fatal_error($txt{'75'}) unless($username || $name);
	&fatal_error($txt{'76'}) unless($settings[2] || $email);
	$pollthread = $FORM{'pollthread'} || 0;
	if ($pollthread != 2) {	# If user is NOT adding a Poll to an existing thread
	&fatal_error($txt{'77'}) unless($subject && $subject !~ m~\A[\s_.,]+\Z~);
	&fatal_error($txt{'78'}) unless($message);
	if (length($message)>$MaxMessLen) { &fatal_error($txt{'499'}); }

	if( $FORM{'preview'} ) { &Preview; }
	&spam_protection;

	if (length($subject) > 50) { $subject = substr($subject,0,50); }
	$subject =~ s/[\r\n]//g;
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($message);
	$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$message =~ s~\n~<br>~g;
	&CheckIcon;

	if(-e("$datadir/.txt")) { unlink("$datadir/.txt"); }

	} # end if

	if ($username ne 'Guest') {
		# If not guest, get name and email.
		$name = $settings[1];
		$email = $settings[2];
	} else {
		# If user is Guest, then make sure the chosen name
		# is not reserved or used by a member.
		fopen(FILE, "$memberdir/memberlist.txt") || &fatal_error("206 $txt{'106'}: $txt{'23'} $memberlist.txt");

		@memberlist = <FILE>;
		fclose(FILE);
		$testname = lc $name;
		for ($a = 0; $a < @memberlist; $a++) {
			chomp $memberlist[$a];
			$membername = lc $memberlist[$a];
			if( fopen(FILE2, "$memberdir/$memberlist[$a].dat") ) {
				$tmpa = <FILE2>;
				$realname = <FILE2>;
				fclose(FILE2);
				chomp $realname;
				$realname = lc $realname;
				if ($realname eq $testname || $membername eq $testname) { &fatal_error($txt{'473'}); }
			}
			elsif( $testname eq $membername ) { &fatal_error($txt{'473'}); }
		}

		fopen(FILE, "$vardir/reserve.txt") || &fatal_error("207 $txt{'106'}: $txt{'23'} reserve.txt");
		@reserve = <FILE>;
		fclose(FILE);
		fopen(FILE, "$vardir/reservecfg.txt") || &fatal_error("208 $txt{'106'}: $txt{'23'} reservecfg.txt");
		@reservecfg = <FILE>;
		fclose(FILE);
		for( $a = 0; $a < @reservecfg; $a++ ) { chomp $reservecfg[$a]; }
		$matchword = $reservecfg[0] eq 'checked';
		$matchcase = $reservecfg[1] eq 'checked';
		$matchuser = $reservecfg[2] eq 'checked';
		$matchname = $reservecfg[3] eq 'checked';
		$namecheck = $matchcase eq 'checked' ? $name : lc $name;

		foreach $reserved (@reserve) {
			chomp $reserved;
			$reservecheck = $matchcase ? $reserved : lc $reserved;
			if ($matchname) {
				if ($matchword) {
					if ($namecheck eq $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
				else {
					if ($namecheck =~ $reservecheck) { &fatal_error("$txt{'244'} $reserved"); }
				}
			}
		}
		$name = $tempname; # put the name back (with any _'s) now that we've checked it
	}


## [Poll Mod] ##
	my @poll_data;
	if ($pollthread) {	
		$maxpq ||= 60;
		$maxpo ||= 50;
		$maxpc ||= 0;
		$numpolloptions ||= 8;

		$numcount = 0;
		if ( length($FORM{"question"} ) > $maxpq) { &fatal_error("$polltxt{'40'} $polltxt{'34a'} $maxpq $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($FORM{"question"});
		$guest_vote = $FORM{'guest_vote'} || 0;
		$hide_results = $FORM{'hide_results'} || 0;
		$multi_choice = $FORM{'multi_choice'} || 0;
		$poll_comment = $FORM{'poll_comment'} || "";
		if ( length($poll_comment ) > $maxpc) { &fatal_error("$polltxt{'57'} $polltxt{'34a'} $maxpc $polltxt{'34b'} $polltxt{'36'}"); }
		&ToHTML($poll_comment);
		$poll_comment =~ s~\n~<br>~g;
		$poll_comment =~ s~\r~~g;
		push @poll_data, qq~$FORM{"question"}|0|$username|$name|$email|$date|$guest_vote|$hide_results|$multi_choice|||$poll_comment\n~;

		for ($i = 1; $i <= $numpolloptions; $i++){
			if ($FORM{"option$i"}) {
				if (length($FORM{"option$i"}) > $maxpo) { &fatal_error("$polltxt{'7'} $i  $polltxt{'34a'} $maxpo $polltxt{'34b'} $polltxt{'36'}"); }
				&ToHTML($FORM{"option$i"});
				$numcount++;
				push @poll_data, qq~0|$FORM{"option$i"}\n~;
			}
		}
		unless ($FORM{"question"}) { &fatal_error("$polltxt{'37'}"); }
		if ($numcount < 2) { &fatal_error("$polltxt{'38'}"); }
	}
## [/Poll Mod] ##

	# If no thread specified, this is a new thread.
	# Find a valid random ID for it.
	if($threadid eq '') {
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid="$newthreadid$i";
		}
	}
	else { $newthreadid = ''; }

	if($newthreadid) {
		# This is a new thread. Save it.
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("210 $txt{'106'}: $txt{'23'} $currentboard.txt");
			seek FILE, 0, 0;
			my @buffer = <FILE>;
			truncate FILE, 0;
			seek FILE, 0, 0;
			print FILE qq~$newthreadid|$subject|$name|$email|$date|0|$username|$icon|0\n~;
			print FILE @buffer;
		fclose(FILE);
		fopen(FILE, ">$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|\n~;
		fclose(FILE);
		$mreplies = 0;

		fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
		@mailcheck = <FILE>;
		fclose(FILE);
		chomp($mailcheck[6]);
		if($mailcheck[6] eq "1") {
		# Mail webmaster about new post
		$mailsub = "$not{'1'} \n\n $not{'2'} $mailcheck[0] $not{'6'} $subject. \n $not{'3'} \n $cgi&action=display&num=$newthreadid";
		$board = $INFO{'board'};
		&sendmail( $webmaster_email, "$not{'5'}: $subject", $mailsub);
		}
		if ($pollthread) { # Save Poll data for new thread
			fopen (POLL, ">$datadir/$newthreadid.poll");
			print POLL @poll_data;
			fclose (POLL);
		}
	} else {
		# This is an old thread. Save it.
		if ($pollthread) { # Save new Poll data
			fopen (POLL, ">$datadir/$threadid.poll");
			print POLL @poll_data;
			fclose (POLL);
			$yySetLocation = qq~$cgi;action=display;num=$threadid~;
			&redirectexit;
		} else { # or save new reply data
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/,$yyThreadLine);
		if( $mstate == 1 ) { &fatal_error($txt{'90'}); }
		++$mreplies;
		fopen(FILE, "+<$boardsdir/$currentboard.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $currentboard.txt");
			seek FILE, 0, 0;
			my @buffer = <FILE>;
			truncate FILE, 0;
			for ($a = 0; $a < @buffer; $a++) {
				if ( $buffer[$a] =~ m~\A$mnum\|~o ) { $buffer[$a] = ""; last; }
			}
			seek FILE, 0, 0;
			print FILE qq~$mnum|$msub|$mname|$memail|$date|$mreplies|$musername|$micon|$mstate\n~;
			print FILE @buffer;
		fclose(FILE);
		fopen(FILE, ">>$datadir/$threadid.txt") || &fatal_error("212 $txt{'106'}: $txt{'23'} $threadid.txt");
		print FILE qq~$subject|$name|$email|$date|$username|$icon|0|$user_ip|$message|$ns|\n~;
		fclose(FILE);
		} # end else

	}

	if($username ne 'Guest') {
		# Increment post count for the member.
		$settings[6] =~ s/[\n\r]//g;
		++$settings[6];
		fopen(FILE, ">$memberdir/$username.dat") || &fatal_error("213 $txt{'106'}: $txt{'23'} $username.dat");
		foreach (@settings) {
			print FILE qq~$_\n~;
		}
		fclose(FILE);
            &WriteLastOnline($username, "x", $date, "x"); 
# Advanced System eMails Mod
            if ($settings[6] == $JrPostNum + 1 && $settings[7] eq "") {
                   &advsendmail3(9,$email,$username,"") }
            elsif ($settings[6] == $FullPostNum + 1 && $settings[7] eq "") {
                   &advsendmail3(10,$email,$username,"") }
            elsif ($settings[6] == $SrPostNum + 1 && $settings[7] eq "") {
                   &advsendmail3(11,$email,$username,"")}
            elsif ($settings[6] == $GodPostNum + 1 && $settings[7] eq "") {
                   &advsendmail3(12,$email,$username,"")};
# End Advanced System eMails Mod

	}

	# The thread ID, regardless of whether it's a new thread or not.
	$thread = $newthreadid || $threadid;

# --- Added for Notify Plus 2.2 --- #
	# Write new Post for Mailinglist
	if ($enable_mailinglist == 1) {

		# Check if thread ID is already written in New posts File before
		$idfound = 0;
		fopen(FILE, "$vardir/newposts.txt");
		@newposts = <FILE>;
		fclose (FILE);

		foreach $newpost (@newposts) {

			chomp($newpost);
			local($board, $newpostid, $date) = split(/\|/, $newpost);
				if ($thread eq $newpostid) { $idfound =1; }
		}

		# Write thread ID in New posts File, when not written before
		if ($idfound == 0) {
			fopen(FILE, ">>$vardir/newposts.txt");
			print FILE "$currentboard|$thread|$date\n";
			fclose (FILE);
		}
	}
# --- /Added for Notify Plus 2.2 --- #

	# Update totals for this board.
	&doaddition;

	# Mark thread as read for the member.
	&dumplog($currentboard,$date);

	# Let's figure out what page number to show
	$start = 0;
	$pageindex = int($mreplies / $maxmessagedisplay);
	$start = $pageindex * $maxmessagedisplay;

# --- Deleted for Notify Plus 2.2 --- #
#	# Notify any members who have notification turned on for this thread.
#	if(-e("$datadir/$thread.mail")) { &NotifyUsers; }
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Notify any members who have notification turned on for this thread.
	if(-e("$datadir/$thread.mail")) { &NotifyUsers('thread'); }

	# Notify any members who have notification turned on for the board this thread is in.
	elsif ($enable_notification_board && -e("$boardsdir/$currentboard.mail")) {
		&NotifyUsers('board');
	}
# --- /Added for Notify Plus 2.2 --- #


# --- Deleted for Notify Plus 2.2 --- #
#	if($notify) {
#		$INFO{'thread'} = $thread;
#		$INFO{'start'} = $start;
#		require "$sourcedir/Notify.pl";

#		&Notify2;
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	if( $notify ) {
		$INFO{'thread'} = $thread;
		$INFO{'start'} = $start;
		require "$sourcedir/Notify.pl";
		
		# When guest
		if ($username eq 'Guest') {
			&Notify2("Guest");
		}
		# When Member
		else {
			&Notify2();
		}
	}	
# --- /Added for Notify Plus 2.2 --- #

	$yySetLocation = qq~$cgi;action=display;num=$thread;start=$start#$mreplies~;
	&redirectexit;
}

sub NotifyUsers {
# --- Added for Notify Plus 2.2 --- #

	# Type of posting
	local($post_type) = @_;
# --- /Added for Notify Plus 2.2 --- #

	$subject = $FORM{'subject'};

# --- Deleted for Notify Plus 2.2 --- #
#	fopen(FILE, "$datadir/$thread.mail") || return 0;
#	@mails = <FILE>;
#	fclose(FILE);
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Read Board-file
	@boardmails = ();
	if ($enable_notification_board && -e("$boardsdir/$currentboard.mail")) {
		fopen(FILE, "$boardsdir/$currentboard.mail") || return 0;
		@boardmails = <FILE>;
		fclose(FILE);
	}

	# Read Thread-file
	@threadmails = ();
	if(-e("$datadir/$thread.mail")) {
		fopen(FILE, "$datadir/$thread.mail") || return 0;
		@threadmails = <FILE>;
		fclose(FILE);
	}

	# Join both array's
	%usedemail = ();
	@mails = ();

	# Board-mails
	foreach $record (@boardmails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);

		# Push email & format
		push(@mails, $record);

		# Save used email-address
		$usedemail{"$email"} = $email;
	}

	# Thread-mails

	foreach $record (@threadmails) {

		chomp($record);
		($email, $format) = split(/\|/, $record);
		chomp($email);

		if ($usedemail{"$email"} ne $email) {
			push(@mails, $record);
		}
	}
# --- /Added for Notify Plus 2.2 --- #

# --- Deleted for Notify Plus 2.2  --- #
#	foreach $curmail (@mails) {
#		chomp $curmail;
#		if ($curmail ne $settings[2]) {
#			&sendmail($curmail,"$txt{'127'}\:  $subject","$txt{'128'}, $subject, $txt{'129'} $cgi;action=display;num=$thread\n\n$txt{'130'}");
#		}
#	}
# --- /Deleted for Notify Plus 2.2 --- #

# --- Added for Notify Plus 2.2 --- #
	# Send the topic

	&NP_SendTopic($post_type);
# --- /Added for Notify Plus 2.2 --- #

	return 1;
}

sub doshowthread {
	my( $line, $trash, $tempname, $tempdate, $temppost );

	&LoadCensorList;	# Load Censor List

	if (@messages) {
		$yymain .= qq~
	<BR><BR>
	<table cellspacing=1 cellpadding=0 width="90%" align="center" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr><td>
	<table class="windowbg" cellspacing="1" cellpadding="2" width="100%" align=center bgcolor="$color{'windowbg'}">
	<tr><td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font size="2" class="text1" color="$color{'titletext'}">
~;
$showall = "$cutts{'3'} <a href=$cgi;action=post;num=$threadid;title=Post+reply;start=$INFO{'start'};showall=yes>$cutts{'4'}</a> $cutts{'5'} ";
if ($INFO{'showall'} ne '' || $cutamount eq "all"){
	$origcutamount = $cutamount;
	$cutamount = 'all';
	$showall = "$cutts{'3'} <a href=$cgi;action=post;num=$threadid;title=Post+reply;start=$INFO{'start'}>$cutts{'4'}</a> $cutts{'6'} ";
}
$yymain .= qq~	
<b>$txt{'468'} - $cutts{'2'} $cutamount $showall</b>
	</font></td></tr>~;
if ($tsreverse == 1){
@messages = reverse(@messages);
}
if ($INFO{'showall'} ne '' || $cutamount eq "all"){
	$cutamount = 1000;
}
for ($amounter; $amounter ne $cutamount; $amounter++){

			($trash, $tempname, $trash, $tempdate, $trash, $trash, $trash, $trash, $message, $ns) = split(/\|/,$messages[$amounter]);
			$tempdate = &timeformat($tempdate);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$message =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			my @words = split(/\s/,$message);
			&wrap;
			$displayname = $tempname;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
unless ($message eq ''){

			$yymain .= qq~

<tr><td align=left class="catbg">
<font size="1">$txt{'279'}: $tempname</font></td>
<td class="catbg" align=right>
<font size="1">$txt{'280'}: $tempdate</font></td>
</tr>
<tr><td class="windowbg2" colspan=2 bgcolor="$color{'windowbg2'}">
<font size="1">$message</font>
</td></tr>~;
		}}
		$yymain .= "</table></td></tr></table>\n";
	}
	else { $yymain .= "<!--no summary-->"; }
}

sub doaddition {
	fopen(FILE2, "$datadir/$thread.data");
	$tempinfo = <FILE2>;
	fclose(FILE2);

	($views, $lastposter) = split(/\|/,$tempinfo);

	my( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid ) = &BoardCountGet($currentboard);
	++$messagecount;
	unless( $FORM{'threadid'} ) {
		++$threadcount;
	}
	$myname = $username eq 'Guest' ? qq~Guest-$name~ : $username;
	&BoardCountSet( $currentboard, $threadcount, $messagecount, $date, $myname, $thread );

	fopen(FILE2, "+>$datadir/$thread.data");
	print FILE2 "$views|$myname";
	fclose(FILE2);
}

1;