###############################################################################
# plugin/language.pl                                                          #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# YaBB Plugin: Let's you choose a language                                    #
# Software Version: YaBB 1 Gold - SP1 - Language Plugin                       #
# =========================================================================== #
# Software Distributed by:    http://www.skijumpinglibrary.com                #
# =========================================================================== #
# Copyright (c) 2000-2001 FTT Corporation - All Rights Reserved               #
# Software by: FTT Corporation                                                #
###############################################################################
$lngver = "Beta for sp1.3./1.3.1.";
$languageplver = "1";
$languageplver =~ s/b/ beta /g;
$lnginfo = "<center><font size=1>Advanced Language Control System $languageplver ($lngver)<BR>Originally done by <a href=\"mailto:webmaster\@skijumpinglibrary.com\">niGhTHAwCK</a>!<BR>Testing and SP1 modifications by <a href=\"mailto:flashmedia\@angelabode.net\">Hiryu</a>!<br>
Modified for sp1.3. and sp1.3.1 by Alexik<font size=1></center>";


require "$yabb_fullpath/Sources/cookie.lib";
require "$vardir/language.txt";
if (!$languageip)
{
	if ($ENV{'HTTP_X_FORWARDED_FOR'} && $ENV{'HTTP_X_FORWARDED_FOR'} ne "127.0.0.1") {$languageip = $ENV{'HTTP_X_FORWARDED_FOR'};}
	elsif (!$languageip && $ENV{'HTTP_CLIENT_IP'} && $ENV{'HTTP_CLIENT_IP'} ne "127.0.0.1") {$languageip = $ENV{'HTTP_CLIENT_IP'};}
	elsif (!$languageip && $ENV{'X_CLIENT_IP'} && $ENV{'X_CLIENT_IP'} ne "127.0.0.1") {$languageip = $ENV{'X_CLIENT_IP'};}
	else {$languageip = $ENV{'REMOTE_ADDR'};}
}
$lngdefault = $language;
$lngerror = "0";
&openlngnewsfile;
&openlngagreementfile;
&openlngtemplatefile;
&startlanguage;

# Begin startlanguage
sub startlanguage {
my ($name, $value, $lngpair, @lngpairs);
if($ENV{QUERY_STRING} =~ m~;~) { @lngpairs = split(/;/, $ENV{QUERY_STRING}); }
else { @lngpairs = split(/&/, $ENV{QUERY_STRING}); }
foreach $lngpair (@lngpairs) {
	  ($name,$value) = split(/=/, $lngpair);
	  $name =~ tr/+/ /;
	  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	  $value =~ tr/+/ /;
	  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	  $value =~ s/<!--(.|\n)*-->//g;
	  $query{$name} = $value;
}
if ($query{'language'} ne "") {
&savelanguage;
} else {
&getlanguage;
}
}
# End startlanguage

# Begin getlanguage sub
sub getlanguage {
my ($lngname, $lngvalue, $lngdesc, $lngline);
open(lngLL,"$vardir/language.lst") || die "$langtxt{'59'} $vardir/language.lst, Error : $!\n"; 
@lngxlanguages = <lngLL>;
close(lngLL);
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
$lnglanguage{$lngname} = $lngvalue;
$lnglanguagecode{$lngvalue} = $lngname;
}
if (&GetCookies('lngYaBBLanguage')) {
	$language = $lnglanguage{$Cookies{'lngYaBBLanguage'}};
	$languagecode = $Cookies{'lngYaBBLanguage'};
} else {
	$language = $lngdefault;
	$languagecode = "default";
}
if ($language eq "") {
	$language = $lngdefault;
	$languagecode = "default";
}
&languageclick2;
&endgetlanguage;
}
# End getlanguage sub

# Begin savelanguage sub
sub savelanguage {
my ($lngname, $lngvalue, $lngdesc, $lngline);
&SetCookieExpDate('Sun, 17-Jan-2038 00:00:00 GMT');
&SetCookies('lngYaBBLanguage',$query{'language'});
&openlngfile;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
$lnglanguage{$lngname} = $lngvalue;
}
$language = $lnglanguage{$query{'language'}};
$languagecode = $query{'language'};
if ($language eq "") {
	$language = $lngdefault;
	$languagecode = "default";
}
&languageclick;
}
# End savelanguage sub

# Begin endgetlanguage sub
sub endgetlanguage {
my ($curlanguage, $lngxmembers);
if ($langset{"cookiemem"} ne "0") {
require "$sourcedir/Load.pl";
&LoadCookie;
if ($username ne "Guest") {
open(lngLL,"$memberdir/$username.lng");
$lngxmembers = <lngLL>;
close(lngLL);
($curlanguage) = split(/;/, $lngxmembers);
if ($curlanguage) { if ($curlanguage ne "cookie") { $language = $curlanguage; $languagecode = $lnglanguagecode{"$curlanguage"}; } else { $langset{"cookiemem"} = "4"; }} else { $language = $lngdefault; $languagecode = "default"; }
if ($languagecode eq "") {
$languagecode = "default";
}
}
}
}
# Begin endgetlanguage sub

# Begin getlangprofile sub
sub getlangprofile {
my ($sellang, $line, @contents, $extension, $name);
if ($langset{"cookiemem"} ne "0") {
$yymain .= qq~
<tr><td colspan="2">
<hr width="100%" size="1" class="hr">
</td></tr>
<tr>
     <td width="320"><font size=2><b>$langtxt{'50'}</b><BR><BR></td>
     <td><select name="langprofile">
~;
$sellang = "selected";
if ($langset{"cookiemem"} eq "2") {
$yymain .= qq~<option value="cookie">$langtxt{'76'}\n~;
} elsif ($langset{"cookiemem"} eq "4") {
$yymain .= qq~<option value="cookie" selected>$langtxt{'76'}\n~;
$sellang = "";
}
opendir(DIR, "$boarddir") || die "$txt{'230'} ($boarddir) :: $!";
@contents = readdir(DIR);
closedir(DIR);
foreach $line (@contents){
	($name, $extension) = split (/\./, $line);
	if ($extension eq "lng"){
		if ($language eq $line) {
			$yymain .= "    <option value=\"$line\" $sellang> - $name\n";
		} else {
			$yymain .= "    <option value=\"$line\"> - $name\n";	
		}
	}
}
$yymain .= qq~
</select><BR><BR></td>
</tr>
~;
}
}
# End getlangprofile sub

# Begin savelangprofile sub
sub savelangprofile {
if ($langset{"cookiemem"} ne "0") {
open(lngLL,">$memberdir/$username.lng") || die "$langtxt{'77'} $memberdir/$username.lng, Error : $!\n";
		print lngLL "$FORM{'langprofile'}";
close(lngLL);
}
}
# End savelangprofile sub

# Begin LanguagePanel sub
sub LanguagePanel {
my ($lngname, $lngvalue, $lngdesc, $lngline, $curls_ic, $curls_cookiemem0, $curls_cookiemem1, $curls_cookiemem2, $curls_go, @contents, $name, $extension, $line);
	&is_admin;
	$yytitle = $langtxt{'04'};
$yymain .= qq~
<table border=0 width="100%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
if ($lngerror eq "1") {
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/exclamation.gif">&nbsp;$langtxt{'08'}</font></b></td>
</tr>
<tr>
<td class="catbg" bgcolor="$color{'catbg'}" colspan="4" height=22><b><font size=2>$lngerrormsg</font></b></td>
</tr>
~;
}
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/language.gif">&nbsp;$langtxt{'09'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>$langtxt{'10'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>$langtxt{'11'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>$langtxt{'12'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="10%" height=22><b><font size=2>$txt{'17'}</font></b></td>
</TR>
~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($lngname eq "default") {
$yymain .= qq~
<form action="$cgi;action=languagepanel2" method="POST">
<input type="hidden" name="what" value="change">
<input type="hidden" name="code" value="$lngname">
<TR>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='30%' align=center><font size=2>default</font></TD>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='30%' align=center><font size=2>$lngdefault</font></TD>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='30%' align=center><font size=2><input type="Text" name="desc" value="$lngdesc"></font></TD>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='10%' align=center><input type='submit' value='$langtxt{'13'}'></TD>
</TR>
</form>
~;
}
}
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($lngname ne "default") {
$yymain .= qq~
<form action="$cgi;action=languagepanel2" method="POST">
<input type="hidden" name="what" value="delete">
<input type="hidden" name="code" value="$lngname">
<TR>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='30%' align=center><font size=2>$lngname</font></TD>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='30%' align=center><font size=2>$lngvalue</font></TD>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='30%' align=center><font size=2>$lngdesc</font></TD>
	<td class='windowbg2' bgcolor=$color{'windowbg2'} width='10%' align=center><input type='submit' value='$txt{'31'}'></TD>
</TR>
</form>
~;
}
}
if ($langset{"ic"} eq "1") { $curls_ic = "checked"; }
if ($langset{"go"} eq "1") { $curls_go = "checked"; }
if ($langset{"cookiemem"} eq "0") { $curls_cookiemem0 = "checked"; }
if ($langset{"cookiemem"} eq "1") { $curls_cookiemem1 = "checked"; }
if ($langset{"cookiemem"} eq "2") { $curls_cookiemem2 = "checked"; }
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/language.gif">&nbsp;$langtxt{'14'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>Language Code</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>Language File</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>Description</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="10%" height=22><b><font size=2>Add</font></b></td>
</TR>
<form action="$cgi;action=languagepanel2" method="POST">
<input type="hidden" name="what" value="add">
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center><input type="text" name="code"></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center><select name="file">
~;
opendir(DIR, "$boarddir") || die "$txt{'230'} ($boarddir) :: $!";
@contents = readdir(DIR);
closedir(DIR);
foreach $line (@contents){
	($name, $extension) = split (/\./, $line);
	if ($extension eq "lng"){
		$yymain .= "    <option value=\"$line\">$line\n";
	}
}
$yymain .= qq~
</select></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center><input type="text" name="desc"></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="10%" height=22 align=center><font size=2><input type='submit' value='$langtxt{'15'}'></font></td>
</TR>
</form>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/language.gif">&nbsp;$langtxt{'04'}</font></b></td>
</tr>
<form action="$cgi;action=languagepanel2" method="POST">
<input type="hidden" name="what" value="settings">
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=left colspan="2"><font size=2>$langtxt{'17'}</font></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center colspan="2"><input type="Checkbox" name="ic" $curls_ic></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=left colspan="2"><font size=2>$langtxt{'18'}</font></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center colspan="2"><input type="Checkbox" name="go" $curls_go></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=left colspan="2"><font size=2>$langtxt{'73'}<BR>$langtxt{'74'}<BR>$langtxt{'75'}</font></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center colspan="2"><input type="Radio" name="cookiemem" value="0" $curls_cookiemem0><BR><input type="Radio" name="cookiemem" value="1" $curls_cookiemem1><BR><input type="Radio" name="cookiemem" value="2" $curls_cookiemem2></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center colspan="4"><input type="submit" value="$txt{'10'}">&nbsp;&nbsp;&nbsp;<input type="reset" value="$txt{'278'}"></td>
</TR>
</form>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/language.gif">&nbsp;$langtxt{'19'}</font></b></td>
</tr>
<tr>
<td class="catbg" bgcolor="$color{'catbg'}" colspan="4" height=22><b><font size=2>$langtxt{'20'}</font></b></td>
</tr>
<tr>
<td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="4" height=22><font size=2>
$langtxt{'21'}
</font></td>
</tr>
<tr>
<td class="catbg" bgcolor="$color{'catbg'}" colspan="4" height=22><b><font size=2>$langtxt{'22'}</font></b></td>
</tr>
<tr>
<td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="4" height=22><font size=2>
$langtxt{'23'}
</font></td>
</tr>
<tr>
<td class="catbg" bgcolor="$color{'catbg'}" colspan="4" height=22><b><font size=2>$langtxt{'24'}</font></b></td>
</tr>
<tr>
<td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="4" height=22><font size=2>
$langtxt{'25'}
</font></td>
</tr>
</form>
</TABLE>
</form>
$lnginfo
~;
&template;
exit;
}
# End LanguagePanel sub

# Begin LanguagePanel2 sub
sub LanguagePanel2 {
my ($lngline, $lngname, $lngfound, $lngoutput);
&is_admin;
if ($FORM{'what'} eq "delete") {
$lngfound = "0";
$lngerrormsg = "$FORM{'code'} $langtxt{'26'}";
$lngoutput = "";
foreach $lngline (@lngxlanguages) {
($lngname) = split(/=/, $lngline);
if ($lngname ne "\n") {
if ($FORM{'code'} ne $lngname) {
$lngoutput .= $lngline;
} else {
$lngfound = "1";
$lngerrormsg = "$FORM{'code'} $langtxt{'27'}";
}
}
}
if ($lngfound eq "1") {
open(lngLL,">$vardir/language.lst") || die "$langtxt{'33'} $vardir/language.lst, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}
$lngerror = "1";
} elsif ($FORM{'what'} eq "add") {
$lngfound = "0";
$lngerrormsg = "$FORM{'code'} $langtxt{'29'}";
foreach $lngline (@lngxlanguages) {
($lngname) = split(/=/, $lngline);
if ($FORM{'code'} eq $lngname) {
$lngfound = "1";
$lngerrormsg = "$FORM{'code'} $langtxt{'30'}";
}
}
if ($FORM{'desc'} eq "") {
$lngfound = "1";
$lngerrormsg = $langtxt{'31'};
}
if ($FORM{'code'} eq "") {
$lngfound = "1";
$lngerrormsg = $langtxt{'32'};
}
if ($lngfound eq "0") {
$lngoutput = "\n$FORM{'code'}=$FORM{'file'}=$FORM{'desc'};";
open(lngLL,">>$vardir/language.lst") || die "$langtxt{'33'} $vardir/language.lst, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
&openlngfile;
$lngoutput = "";
foreach $lngline (@lngxlanguages) {
($lngname) = split(/=/, $lngline);
if ($lngname ne "\n") {
$lngoutput .= $lngline;
}
open(lngLL,">$vardir/language.lst") || die "$langtxt{'33'} $vardir/language.lst, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}
}
$lngerror = "1";
} elsif ($FORM{'what'} eq "change") {
if ($FORM{'desc'} eq "") {
$lngerror = "1";
$lngerrormsg = $langtxt{'31'};
} else {
############### Delete Default ###############
$lngfound = "0";
$lngoutput = "";
foreach $lngline (@lngxlanguages) {
($lngname) = split(/=/, $lngline);
if ($lngname ne "\n") {
if ($lngname ne "default") {
$lngoutput .= $lngline;
} else {
$lngfound = "1";
}
}
}
if ($lngfound eq "1") {
open(lngLL,">$vardir/language.lst") || die "$langtxt{'33'} $vardir/language.lst, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}
############### Delete Default ###############
################ Add Default #################
$lngfound = "0";
$lngerrormsg = $langtxt{'34'};
&openlngfile;
foreach $lngline (@lngxlanguages) {
($lngname) = split(/=/, $lngline);
if ($lngname eq "default") {
$lngfound = "1";
$lngerrormsg = $langtxt{'35'};
}
}
if ($lngfound eq "0") {
$lngoutputlang = join('',@lngxlanguages);
$lngoutput = "default==$FORM{'desc'};\n".$lngoutputlang;
open(lngLL,">$vardir/language.lst") || die "$langtxt{'33'} $vardir/language.lst, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
&openlngfile;
$lngoutput = "";
foreach $lngline (@lngxlanguages) {
($lngname) = split(/=/, $lngline);
if ($lngname ne "\n") {
$lngoutput .= $lngline;
}
open(lngLL,">$vardir/language.lst") || die "$langtxt{'33'} $vardir/language.lst, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}

}
$lngerror = "1";
################ Add Default #################
}
} elsif ($FORM{'what'} eq "settings") {
if ($FORM{'go'} eq "") {$FORM{'go'} = "0";} else {$FORM{'go'} = "1";}
if ($FORM{'ic'} eq "") {$FORM{'ic'} = "0";} else {$FORM{'ic'} = "1";}
$lngoutput = qq~
\$langset{"go"} = $FORM{'go'};
\$langset{"ic"} = $FORM{'ic'};
\$langset{"cookiemem"} = $FORM{'cookiemem'};
1;
~;
open(lngLL,">$vardir/language.txt") || die "$langtxt{'36'} $vardir/language.txt, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}
&openlngfile;
&LanguagePanel;
}
# End LanguagePanel2 sub

# Begin translateagreement sub
sub translateagreement {
my ($lngname, $lngvalue, $lngdesc, $lngline, $lngcur);
	&is_admin;
	$yytitle = "$langtxt{'02'}";
$yymain .= qq~
<table border=0 width="60%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'02'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$langtxt{'39'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="60%" height=22><b><font size=2>$langtxt{'40'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$txt{'17'}</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2>on</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="60%" height=22 align=center><b><font size=2>$langtxt{'43'}</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2><a href="$cgi;action=modagreement">$langtxt{'44'}</a></font></b></td>
</TR>
~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($lngagreement{$lngname} eq "on") {
$lngcur = "on";
} else {
$lngcur = "default";
}
if ($lngname ne "default") {
$yymain .= qq~
<form action="$cgi;action=translateagreement2" method="POST">
<input type="hidden" name="code" value="$lngname">
<input type="hidden" name="desc" value="$lngdesc">
<input type="hidden" name="enabled" value="$lngagreement{$lngname}">
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2>$lngcur</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="60%" height=22 align=center><b><font size=2>$lngdesc</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2><input type='submit' value='$txt{'17'}'></font></b></td>
</TR>
</form>
~;
}
}
$yymain .= qq~
</table>
$lnginfo
~;
&template;
exit;
}
# End translateagreement sub

# Begin translateagreement2 sub
sub translateagreement2 {
my ($lngchecked1, $lngchecked2, $curagreement);
	&is_admin;
	$yytitle = "$langtxt{'02'}";
&openlngagreementfile;
if ($FORM{'enabled'} eq "on") {
$lngchecked1 = "";
$lngchecked2 = "checked";
} else {
$lngchecked1 = "checked";
$lngchecked2 = "";
}
$yymain .= qq~
<form action="$cgi;action=translateagreement3" method="POST">
<input type="hidden" name="code" value="$FORM{'code'}">
<input type="hidden" name="desc" value="$FORM{'desc'}">
<table border=0 width="100%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="1" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$txt{'764'}: $FORM{'desc'}</font></b></td>
</tr>
<tr>
    <td class="windowbg" bgcolor="$color{'catbg'}"><BR><font size="1">$txt{'765'}</font><BR><BR></td>
</tr>
<tr>
    <td class="catbg" bgcolor="$color{'windowbg'}"><BR><font size="1">
	<input type="radio" name="what" value="" $lngchecked1>$langtxt{'46'} $langtxt{'43'} (default)<BR>
	<input type="radio" name="what" value="on" $lngchecked2>$langtxt{'46'} $langtxt{'47'} (on)
	</font><BR><BR></td>
</tr>
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><BR>
    <font size=2>
    <textarea rows=30 cols=95 wrap=virtual name="agreement" style="width:98%">
~;
&getlngagreement;
	foreach $curagreement (@lngxcuragreement) {
		$curagreement =~ s/[\n\r]//g;
		if( $curagreement =~ m~\A\s*\Z~ ) { next; }
		$yymain .=qq~$curagreement\n~;
	}
$yymain .= qq~
</textarea><br><input type="submit" value="$txt{'10'}"></font><BR></td>
</tr>
</table></form>$lnginfo
~;
&template;
exit;
}
# End translateagreement2 sub

# Begin translateagreement3 sub
sub translateagreement3 {
my ($lngoutput, $lngfound, $lngline, $lnglang);
&is_admin;
open(lngLL,">$vardir/agreement_$FORM{'code'}.txt") || die "$langtxt{'48'} $vardir/agreement_$FORM{'code'}.txt, Error : $!\n";
		print lngLL "$FORM{'agreement'}";
close(lngLL);
$lngoutput = "";
$lngfound = "0";
foreach $lngline (@lngx) {
($lnglang) = split(/=/, $lngline);
if ($lnglang eq $FORM{'code'}) {
$lngoutput .= "$FORM{'code'}=$FORM{'what'};\n";
$lngfound = "1";
} else {
$lngoutput .= $lngline;
}
}
if ($lngfound eq "0") {
$lngoutput .= "$FORM{'code'}=$FORM{'what'};\n";
}
open(lngLL,">$vardir/agreementlanguage.txt") || die "$langtxt{'49'} $vardir/language.txt, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
&openlngagreementfile;
&translateagreement;
}
# End translateagreement3 sub

# Begin translatetemplate sub
sub translatetemplate {
my ($lngname, $lngvalue, $lngdesc, $lngline, $lngcur);
	&is_admin;
	$yytitle = "$langtxt{'06'}";
$yymain .= qq~
<table border=0 width="60%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'06'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$langtxt{'39'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="60%" height=22><b><font size=2>$langtxt{'40'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$txt{'17'}</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2>On</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="60%" height=22 align=center><b><font size=2>$langtxt{'52'}</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2><a href="$cgi;action=modtemp">$langtxt{'44'}</a></font></b></td>
</TR>
~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($lngtemplate{$lngname} eq "on") {
$lngcur = "On";
} else {
$lngcur = "Default";
}
if ($lngname ne "default") {
$yymain .= qq~
<form action="$cgi;action=translatetemplate2" method="POST">
<input type="hidden" name="code" value="$lngname">
<input type="hidden" name="desc" value="$lngdesc">
<input type="hidden" name="enabled" value="$lngtemplate{$lngname}">
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2>$lngcur</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="60%" height=22 align=center><b><font size=2>$lngdesc</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2><input type='submit' value='$txt{'17'}'></font></b></td>
</TR>
</form>
~;
}
}
$yymain .= qq~
</table>
$lnginfo
~;
&template;
exit;
}
# End translatetemplate sub

# Begin translatetemplate2 sub
sub translatetemplate2 {
my ($lngchecked1, $lngchecked2, $curtemplate);
	&is_admin;
	$yytitle = "$langtxt{'06'}";
&openlngtemplatefile;
if ($FORM{'enabled'} eq "on") {
$lngchecked1 = "";
$lngchecked2 = "checked";
} else {
$lngchecked1 = "checked";
$lngchecked2 = "";
}
$yymain .= qq~
<form action="$cgi;action=translatetemplate3" method="POST">
<input type="hidden" name="code" value="$FORM{'code'}">
<input type="hidden" name="desc" value="$FORM{'desc'}">
<table border=0 width="100%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="1" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$txt{'216'}: $FORM{'desc'}</font></b></td>
</tr>
<tr>
    <td class="windowbg" bgcolor="$color{'catbg'}"><BR><font size="1">$txt{'682'}<br>$langtxt{'16'}</font><BR><BR></td>
</tr>
<tr>
    <td class="catbg" bgcolor="$color{'windowbg'}"><BR><font size="1">
	<input type="radio" name="what" value="" $lngchecked1>$langtxt{'46'} $langtxt{'52'} (default)<BR>
	<input type="radio" name="what" value="on" $lngchecked2>$langtxt{'46'} $langtxt{'53'} (on)
	</font><BR><BR></td>
</tr>
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><BR>
    <font size=2>
    <textarea rows=30 cols=95 wrap=virtual name="template" style="width:98%">
~;
&getlngtemplate;
	foreach $curtemplate (@lngxcurtemplate) {
		$curtemplate =~ s/[\n\r]//g;
		if( $curtemplate =~ m~\A\s*\Z~ ) { next; }
		$yymain .=qq~$curtemplate\n~;
	}
$yymain .= qq~
</textarea><br><input type="submit" value="$txt{'10'}"></font><BR></td>
</tr>
</table></form>$lnginfo
~;
&template;
exit;
}
# End translatetemplate2 sub

# Begin translatetemplate3 sub
sub translatetemplate3 {
my ($lngoutput, $lngfound, $lngline, $lnglang);
&is_admin;
open(lngLL,">template_$FORM{'code'}.html") || die "$langtxt{'54'} $vardir/template_$FORM{'code'}.txt, Error : $!\n";
		print lngLL "$FORM{'template'}";
close(lngLL);
$lngoutput = "";
$lngfound = "0";
foreach $lngline (@lngx) {
($lnglang) = split(/=/, $lngline);
if ($lnglang eq $FORM{'code'}) {
$lngoutput .= "$FORM{'code'}=$FORM{'what'};\n";
$lngfound = "1";
} else {
$lngoutput .= $lngline;
}
}
if ($lngfound eq "0") {
$lngoutput .= "$FORM{'code'}=$FORM{'what'};\n";
}
open(lngLL,">$vardir/templatelanguage.txt") || die "$langtxt{'55'} $vardir/templatelanguage.txt, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
&openlngtemplatefile;
&translatetemplate;
}
# End translatetemplate3 sub

# Begin translatenews sub
sub translatenews {
my ($lngcur2, $lngcur, $lngcur3, $lngname, $lngvalue, $lngdesc, $lngline);
	&is_admin;
	$yytitle = "$langtxt{'01'}";
if ($shownewsfader eq "1") {
$lngcur2 = "On";
} else {
$lngcur2 = "Off";
}
if ($enable_news eq "1") {
$lngcur3 = "On";
} else {
$lngcur3 = "Off";
}
$yymain .= qq~
<table border=0 width="80%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'01'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="15%" height=22><b><font size=2>$langtxt{'78'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="15%" height=22><b><font size=2>$langtxt{'79'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="50%" height=22><b><font size=2>$langtxt{'40'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$txt{'17'}</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="15%" height=22 align=center><b><font size=2>$lngcur3</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="15%" height=22 align=center><b><font size=2>$lngcur2</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="50%" height=22 align=center><b><font size=2>$langtxt{'07'}</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2><a href="$cgi;action=editnews">$langtxt{'44'}</a></font></b></td>
</TR>
~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($lngnews{$lngname} eq "on") {
$lngcur = "On";
} elsif ($lngnews{$lngname} eq "off") {
$lngcur = "Off";
} else {
$lngcur = "Default";
}
if ($lngnews2{$lngname} eq "on") {
$lngcur2 = "On";
} elsif ($lngnews2{$lngname} eq "off") {
$lngcur2 = "Off";
} else {
$lngcur2 = "Default";
}
if ($lngname ne "default") {
$yymain .= qq~
<form action="$cgi;action=translatenews2" method="POST">
<input type="hidden" name="code" value="$lngname">
<input type="hidden" name="desc" value="$lngdesc">
<input type="hidden" name="enabled" value="$lngnews{$lngname}">
<input type="hidden" name="enabled2" value="$lngnews2{$lngname}">
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="15%" height=22 align=center><b><font size=2>$lngcur2</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="15%" height=22 align=center><b><font size=2>$lngcur</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="50%" height=22 align=center><b><font size=2>$lngdesc</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2><input type='submit' value='$txt{'17'}'></font></b></td>
</TR>
</form>
~;
}
}
$yymain .= qq~
</table>
$lnginfo
~;
&template;
exit;
}
# End translatenews sub

# Begin translatenews2 sub
sub translatenews2 {
my ($lngchecked1, $lngchecked2, $lngchecked3, $lngchecked4, $lngchecked5, $lngchecked6, $curnews);
	&is_admin;
	$yytitle = "$langtxt{'01'}";
&openlngnewsfile;
if ($FORM{'enabled'} eq "on") {
$lngchecked1 = "";
$lngchecked2 = "checked";
$lngchecked3 = "";
} elsif ($FORM{'enabled'} eq "off") {
$lngchecked1 = "";
$lngchecked2 = "";
$lngchecked3 = "checked";
} else {
$lngchecked1 = "checked";
$lngchecked2 = "";
$lngchecked3 = "";
}
if ($FORM{'enabled2'} eq "on") {
$lngchecked4 = "";
$lngchecked5 = "checked";
$lngchecked6 = "";
} elsif ($FORM{'enabled2'} eq "off") {
$lngchecked4 = "";
$lngchecked5 = "";
$lngchecked6 = "checked";
} else {
$lngchecked4 = "checked";
$lngchecked5 = "";
$lngchecked6 = "";
}
$yymain .= qq~
<form action="$cgi;action=translatenews3" method="POST">
<input type="hidden" name="code" value="$FORM{'code'}">
<input type="hidden" name="desc" value="$FORM{'desc'}">
<table border=0 width="70%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="1" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$txt{'7'}: $FORM{'desc'}</font></b></td>
</tr>
<tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><BR><font size="1">$txt{'670'}</font><BR><BR></td>
</tr>
<tr>
    <td class="catbg" bgcolor="$color{'catbg'}"><font size="1">$langtxt{'78'}:</td>
</tr>
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1">
	<input type="radio" name="what2" value="off" $lngchecked6>$langtxt{'37'} (off)<BR>
	<input type="radio" name="what2" value="" $lngchecked4>$langtxt{'46'} $langtxt{'38'} (default)<BR>
	<input type="radio" name="what2" value="on" $lngchecked5>$langtxt{'46'} $langtxt{'41'} (on)
	</font></td>
</tr>
<tr>
    <td class="catbg" bgcolor="$color{'catbg'}"><font size="1">$langtxt{'79'}:</td>
</tr>
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="1">
	<input type="radio" name="what" value="off" $lngchecked3>$langtxt{'37'} (off)<BR>
	<input type="radio" name="what" value="" $lngchecked1>$langtxt{'46'} $langtxt{'38'} (default)<BR>
	<input type="radio" name="what" value="on" $lngchecked2>$langtxt{'46'} $langtxt{'41'} (on)
	</font></td>
</tr>
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><BR>
    <font size=2>
    <textarea cols=70 rows=8 name="news">
~;
&getlngnews;
	foreach $curnews (@lngxcurnews) {
		$curnews =~ s/[\n\r]//g;
		if( $curnews =~ m~\A\s*\Z~ ) { next; }
		$yymain .=qq~$curnews\n~;
	}
$yymain .= qq~
</textarea><br><input type="submit" value="$txt{'10'}"></font><BR></td>
</tr>
</table></form>$lnginfo
~;
&template;
exit;
}
# End translatenews2 sub

# Begin translatenews3 sub
sub translatenews3 {
my ($lnglang, $lngoutput, $lngfound, $lngline);
&is_admin;
open(lngLL,">$vardir/news_$FORM{'code'}.txt") || die "$langtxt{'42'} $vardir/news_$FORM{'code'}.txt, Error : $!\n";
		print lngLL "$FORM{'news'}";
close(lngLL);
$lngoutput = "";
$lngfound = "0";
foreach $lngline (@lngxnews) {
($lnglang) = split(/=/, $lngline);
if ($lnglang eq $FORM{'code'}) {
$lngoutput .= "$FORM{'code'}=$FORM{'what2'}=$FORM{'what'};\n";
$lngfound = "1";
} else {
$lngoutput .= $lngline;
}
}
if ($lngfound eq "0") {
$lngoutput .= "$FORM{'code'}=$FORM{'what2'}=$FORM{'what'};\n";
}
open(lngLL,">$vardir/newslanguage.txt") || die "$langtxt{'45'} $vardir/newslanguage.txt, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
&openlngnewsfile;
&translatenews;
}
# End translatenews3 sub

# Begin getlngnewsfader sub
sub getlngnewsfader {
if ($lngnews{$languagecode} eq "on") {
$lngnewsfile = "news_".$languagecode;
} else {
$lngnewsfile = "news";
}
}
# End getlngnewsfader sub

# Begin getlngenablenews sub
sub getlngenablenews {
if ($lngnews{$languagecode} eq "off") {
$enable_news2 = 0;
} elsif ($lngnews{$languagecode} eq "on") {
$enable_news2 = 1;
} else {
if ($languagecode eq "default") {
$enable_news2 = $shownewsfader;
} else {
$enable_news2 = 1;
}
}
}

sub getlngenablenews2 {
if ($lngnews2{$languagecode} eq "off") {
$enable_news2 = 0;
} elsif ($lngnews2{$languagecode} eq "on") {
$enable_news2 = 1;
} else {
if ($languagecode eq "default") {
$enable_news2 = $enable_news;
} else {
$enable_news2 = 1;
}
}
}
# End getlngenablenews sub

# Begin getyylangmenu sub
sub getyylangmenu {
$yylangmenu = "";
$yylangdd = "";
if ($langset{"cookiemem"} eq "0" or $langset{"cookiemem"} eq "4") {
&getyylangmenu2;
} elsif ($langset{"cookiemem"} eq "2") {
if ($username eq "Guest") {
&getyylangmenu2;
}
}
}

sub getyylangmenu2 {
#########################################
$yylangdd = qq~<form action="$cgi" method="GET">~;
if ($langset{"go"} eq "0") {
$yylangdd .= qq~<select name="language" onChange="if(this.options[this.selectedIndex].value) window.location.href='$cgi;language=' + this.options[this.selectedIndex].value;">~;
} else {
$yylangdd .= qq~<select name="language">~;
}
$yylangdd .= qq~<option value="">$langtxt{'50'}</option>~;
$yylangdd .= qq~<option value="">-----------------------------</option>~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($languagecode eq $lngname) {
$yylangdd .= qq~<option value="$lngname" selected>=>&nbsp;$lngdesc</option>~;
$yylangmenu .= qq~[$lngdesc]&nbsp;~;
} else {
$yylangdd .= qq~<option value="$lngname">&nbsp;&nbsp;-&nbsp;$lngdesc</option>~;
$yylangmenu .= qq~[<a href="$cgi;action=;language=$lngname">$lngdesc</a>]&nbsp;~;
}
}
if ($langset{"go"} eq "1") {
$yylangdd .= qq~</select>&nbsp;<input type="submit" value="GO"></form>~;
} else {
$yylangdd .= qq~</select></form>~;
}
#########################################
}
# End getyylangmenu sub

# Begin getlangmenu sub
sub getlangmenu {
$langdd = "";
if ($langset{"cookiemem"} eq "0" or $langset{"cookiemem"} eq "4") {
&getlangmenu2;
} elsif ($langset{"cookiemem"} eq "2") {
if ($username eq "Guest") {
&getlangmenu2;
}
}
}

sub getlangmenu2 {
if ($langset{"ic"} eq "1") {
$langdd = qq~
<tr>
<form action="$cgi" method="GET">
<td valign="top" align="left" width="100%" colspan="2"><img src="$imagesdir/language.gif">
<font size="1">$langtxt{'50'}</font>&nbsp;
~;
if ($langset{"go"} eq "0") {
$langdd .= qq~<select name="language" onChange="if(this.options[this.selectedIndex].value) window.location.href='$cgi;language=' + this.options[this.selectedIndex].value;">~;
} else {
$langdd .= qq~<select name="language">~;
}
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($languagecode eq $lngname) {
$langdd .= qq~<option value="$lngname" selected>=>&nbsp;$lngdesc</option>~;
} else {
$langdd .= qq~<option value="$lngname">&nbsp;&nbsp;-&nbsp;$lngdesc</option>~;
}
}
if ($langset{"go"} eq "1") {
$langdd .= qq~</select>&nbsp;<input type="submit" value="$langtxt{'44'}"></td></form></tr>~;
} else {
$langdd .= qq~</select></td></form></tr>~;
}
} else {
$langdd = "";
}
}
# End getlangmenu sub

# Begin languagelog sub
sub languagelog {
my ($lngname, $lngvalue, $lngusage, $lngip, $lngline, $lngtotusage, $lngcurlog, $lngdesc, $lngcurlog2, $lngcurlog3);
&openlnglogfile;
	&is_admin;
	$yytitle = "$langtxt{'05'}";
$yymain .= qq~
<table border=0 width="70%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$lngtotusage = 0;
foreach $lngline (@lngxlog) {
($lngname, $lngvalue, $lngusage, $lngip) = split(/=/, $lngline);
($lngip) = split(/;/, $lngip);
$lnglog{$lngname} = $lngvalue;
$lnglog2{$lngname} = $lngusage;
$lnglog3{$lngname} = $lngip;
$lngtotusage = $lngtotusage+$lngusage*1;
}
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="4" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'51'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>$langtxt{'40'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$txt{'691'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="20%" height=22><b><font size=2>$langtxt{'56'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="30%" height=22><b><font size=2>$langtxt{'57'}</font></b></td>
</TR>
~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
if ($lnglog{$lngname} eq "") {
$lngcurlog = "0";
} else {
$lngcurlog = $lnglog{$lngname};
}
if ($lnglog2{$lngname} eq "") {
$lngcurlog2 = "0";
} else {
$lngcurlog2 = substr($lnglog2{$lngname}/$lngtotusage*100,0,3);
if (substr($lngcurlog2,2,1) eq ".") {
$lngcurlog2 = substr($lngcurlog2,0,2);
}
}
if ($lnglog3{$lngname} eq "") {
$lngcurlog3 = "0";
} else {
$lngcurlog3 = $lnglog3{$lngname};
}
$yymain .= qq~
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center><b><font size=2>$lngdesc</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2>$lngcurlog</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><b><font size=2>$lngcurlog2\%</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="30%" height=22 align=center><b><font size=2>$lngcurlog3</font></b></td>
</TR>
~;
}
$yymain .= qq~
<form action="$cgi;action=languagelog2" method="POST">
<input type="hidden" name="what" value="reset">
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="60%" height=22 colspan="4" align=center><b><input type="submit" value="$txt{'278'}"></b></td>
</TR>
</form>
</table>
$lnginfo
~;
&template;
exit;
}
# End languagelog sub

# Begin languagelog2 sub
sub languagelog2 {
	&is_admin;
if ($FORM{'what'} eq "reset") {
open(lngLL,">$vardir/language.log") || die "$langtxt{'58'} $vardir/language.log, Error : $!\n";
		print lngLL "";
close(lngLL);
}
&languagelog;
}
# End languagelog2 sub

# Begin goyylangdd sub
sub goyylangdd {
$yymain .=qq~ Location: $cgi;action=language=$FORM{'code'}\n\n ~;
}
# End goyylangdd sub

# Begin languageclick2 sub
sub languageclick2 {
my ($lngoutput, $lngfound, $lnglang, $lngclick, $lngusage, $lngip, $lngline);
&openlnglogfile;
$lngoutput = "";
$lngfound = "0";
foreach $lngline (@lngxlog) {
($lnglang,$lngclick,$lngusage,$lngip) = split(/=/, $lngline);
($lngip) = split(/;/, $lngip);
if ($lnglang eq $languagecode) {
if ($languageip ne $lngip) {
$lngusage = $lngusage + 1;
}
$lngoutput .= "$languagecode=$lngclick=$lngusage=$lngip;\n";
$lngfound = "1";
} else {
$lngoutput .= $lngline;
}
}
if ($lngfound eq "0") {
$lngfound = "1";
$lngoutput .= "$languagecode=1=1=$languageip;\n";
}
if ($lngfound eq "1") {
open(lngLL,">$vardir/language.log") || die "$langtxt{'58'} $vardir/language.log, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}
}
# End languageclick2 sub

# Begin languageclick sub
sub languageclick {
my ($lngoutput, $lngfound, $lngline, $lnglang, $lngclick, $lngusage, $lngip);
&openlnglogfile;
$lngoutput = "";
$lngfound = "0";
foreach $lngline (@lngxlog) {
($lnglang,$lngclick,$lngusage,$lngip) = split(/=/, $lngline);
($lngip) = split(/;/, $lngip);
$lngclick = $lngclick + 1;
$lngusage = $lngusage + 1;
if ($lnglang eq $languagecode) {
$lngoutput .= "$languagecode=$lngclick=$lngusage=$lngip;\n";
$lngfound = "1";
} else {
$lngoutput .= $lngline;
}
}
if ($lngfound eq "0") {
$lngoutput .= "$languagecode=1=1=$languageip;\n";
}
open(lngLL,">$vardir/language.log") || die "$langtxt{'58'} $vardir/language.log, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
}
# End languageclick sub

# Begin openlngfile sub
sub openlngfile {
open(lngLL,"$vardir/language.lst") || die "$langtxt{'59'} $vardir/language.lst, Error : $!\n"; 
@lngxlanguages = <lngLL>;
close(lngLL);
}
# End openlngfile sub

# Begin openlnglogfile sub
sub openlnglogfile {
open(lngLL,"$vardir/language.log") || die "$langtxt{'60'}e $vardir/language.log, Error : $!\n"; 
@lngxlog = <lngLL>;
close(lngLL);
}
# End openlnglogfile sub

# Begin openlngagreementfile sub
sub openlngagreementfile {
my ($lngline, $lnglang, $lngenabled);
open(lngLL,"$vardir/agreementlanguage.txt") || die "$langtxt{'61'} $vardir/agreementlanguage.txt, Error : $!\n"; 
@lngxagree = <lngLL>;
close(lngLL);
foreach $lngline (@lngxagree) {
($lnglang, $lngenabled) = split(/=/, $lngline);
($lngenabled) = split(/;/, $lngenabled);
$lngagreement{$lnglang} = $lngenabled;
}
}
# End openlngagreementfile sub

# Begin openlngtemplatefile sub
sub openlngtemplatefile {
my ($lngline, $lnglang, $lngenabled);
open(lngLL,"$vardir/templatelanguage.txt") || die "$langtxt{'62'} $vardir/templatelanguage.txt, Error : $!\n"; 
@lngxtemp = <lngLL>;
close(lngLL);
foreach $lngline (@lngxtemp) {
($lnglang, $lngenabled) = split(/=/, $lngline);
($lngenabled) = split(/;/, $lngenabled);
$lngtemplate{$lnglang} = $lngenabled;
}
}
# End openlngtemplatefile sub

# Begin openlngnewsfile sub
sub openlngnewsfile {
my ($lngline, $lnglang, $lngenabled, $lngenabled2);
open(lngLL,"$vardir/newslanguage.txt") || die "$langtxt{'63'} $vardir/newslanguage.txt, Error : $!\n"; 
@lngxnews = <lngLL>;
close(lngLL);
foreach $lngline (@lngxnews) {
($lnglang, $lngenabled, $lngenabled2) = split(/=/, $lngline);
($lngenabled2) = split(/;/, $lngenabled2);
$lngnews{$lnglang} = $lngenabled2;
$lngnews2{$lnglang} = $lngenabled;
}
}
# End openlngnewsfile sub

# Begin openlngboardfile sub
sub openlngboardfile {
my ($lngline, $lnglang, $lngenabled);
open(lngLL,"$vardir/boardlanguage.txt") || die "$langtxt{'64'} $vardir/boardlanguage.txt, Error : $!\n"; 
@lngxboard = <lngLL>;
close(lngLL);
foreach $lngline (@lngxboard) {
($lnglang, $lngenabled) = split(/=/, $lngline);
($lngenabled) = split(/;/, $lngenabled);
$lngboard{$lnglang} = $lngenabled;
}
}
# End openlngboardfile sub

# Begin getlngagreement sub
sub getlngagreement {
open(lngLL,"$vardir/agreement_$FORM{'code'}.txt");
@lngxcuragreement = <lngLL>;
close(lngLL);
}
# End getlngagreement sub

# Begin getlngtemplate sub
sub getlngtemplate {
open(lngLL,"template_$FORM{'code'}.html");
@lngxcurtemplate = <lngLL>;
close(lngLL);
}
# End getlngtemplate sub

# Begin getlngagreementfile sub
sub getlngagreementfile {
if ($lngagreement{$languagecode} eq "on") {
$lngagreementfile = "agreement_$languagecode";
} else {
$lngagreementfile = "agreement";
}
}
# End getlngagreementfiles sub

# Begin getlngtemplatefile sub
sub getlngtemplatefile {
if ($lngtemplate{$languagecode} eq "on") {
$lngtemplatefile = "template_$languagecode";
} else {
$lngtemplatefile = "template";
}
}
# End getlngtemplatefile sub

# Begin getlngnews sub
sub getlngnews {
open(lngLL,"$vardir/news_$FORM{'code'}.txt");
@lngxcurnews = <lngLL>;
close(lngLL);
}
# End getlngnews sub

# Begin translateboards sub
sub translateboards {
	&is_admin;
if ($FORM{'what'} eq "edit") { &translateboards2; }
elsif ($FORM{'what'} eq "edit2") { &translateboards3; }
else {
	$yytitle = "$langtxt{'03'}";
$yymain .= qq~
<table border=0 width="70%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'03'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" width="45%" height=22><b><font size=2>$langtxt{'65'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="45%" height=22><b><font size=2>$langtxt{'66'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" width="10%" height=22><b><font size=2>$txt{'17'}</font></b></td>
</TR>
~;
my( @categories, @catboards, @curcataccess, $curcat, $curcatname, $curcataccess, $curboard, $curboardname);
fopen(FILE, "$vardir/cat.txt");
@categories = <FILE>;
fclose(FILE);
foreach $curcat (@categories) {
	chomp $curcat;
	fopen(CATFILE, "$boardsdir/$curcat.cat");
	$curcatname = <CATFILE>;
	$curcataccess = <CATFILE>;
	@catboards = <CATFILE>;
	fclose(CATFILE);
	chomp $curcatname;
	chomp $curcataccess;
	foreach $curboard (@catboards) {
	chomp $curboard;
	fopen(BOARDFILE, "$boardsdir/$curboard.dat");
	$curboardname = <BOARDFILE>;
	$curboardinfo = <BOARDFILE>;
	fclose(BOARDFILE);
$yymain .= qq~
<TR>
<form action="$cgi;action=translateboards" method="POST">
<input type="hidden" name="what" value="edit">
<input type="hidden" name="board" value="$curboard">
<input type="hidden" name="cat" value="$curcat">
<input type="hidden" name="catname" value="$curcatname">
<input type="hidden" name="boardname" value="$curboardname">
<input type="hidden" name="boardinfo" value="$curboardinfo">
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="45%" height=22 align=center><b><font size=2>$curcat</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="45%" height=22 align=center><b><font size=2>$curboard</font></b></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="10%" height=22 align=center><b><font size=2><input type="submit" value="$txt{'17'}"></font></b></td>
</form>
</TR>
~;
	}
}
$yymain .= qq~
</table>
$lnginfo
~;
&template;
exit;
}
}
# End translateboards sub

# Begin translateboards2 sub
sub translateboards2 {
my ($lngname, $lngvalue, $lngdesc, $lngline, $lngcurlngboard, $lngcur);
&openlngboardfile;
	$yytitle = "$langtxt{'03'}";
$yymain .= qq~
<table border=0 width="70%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'03'} - $FORM{'cat'} - $FORM{'board'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" colspan="3" height=22><b><font size=2>$langtxt{'67'} (<a href="$cgi;action=manageboards">$txt{'17'}</a>):</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" colspan="3" height=22><font size=2>
	<b>$langtxt{'65'}:</b> $FORM{'catname'}<BR>
	<b>$langtxt{'66'}:</b> $FORM{'boardname'}<BR>
	</font></td>
</TR>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" colspan="3" height=22><b><font size=2>$langtxt{'68'} (<a href="$cgi;action=manageboards">$txt{'17'}</a>):</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" colspan="3" height=22><font size=2>
	$FORM{'boardinfo'}<BR>
	</font></td>
</TR>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'69'}:</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" height=22 width="20%"><b><font size=2>$langtxt{'39'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" height=22 width="60%"><b><font size=2>$langtxt{'40'}</font></b></td>
	<td class="catbg" bgcolor="$color{'catbg'}" height=22 width="20%"><b><font size=2>$txt{'17'}</font></b></td>
</TR>
~;
foreach $lngline (@lngxlanguages) {
($lngname, $lngvalue, $lngdesc) = split(/=/, $lngline);
($lngdesc) = split(/;/, $lngdesc);
$lngcurlngboard = $FORM{'board'}."_".$lngname;
if ($lngboard{$lngcurlngboard} eq "on") {
$lngcur = "On";
} else {
$lngcur = "Default";
}
$yymain .= qq~
<TR>
<form action="$cgi;action=translateboards" method="POST">
<input type="hidden" name="what" value="edit2">
<input type="hidden" name="board" value="$FORM{'board'}">
<input type="hidden" name="cat" value="$FORM{'cat'}">
<input type="hidden" name="catname" value="$FORM{'catname'}">
<input type="hidden" name="boardname" value="$FORM{'boardname'}">
<input type="hidden" name="boardinfo" value="$FORM{'boardinfo'}">
<input type="hidden" name="code" value="$lngname">
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><font size=2>$lngcur</font></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="60%" height=22 align=center><font size=2>$lngdesc</font></td>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" width="20%" height=22 align=center><font size=2><input type="submit" value="$txt{'17'}"></font></td>
</form>
</TR>
~;
}
$yymain .= qq~
</table>
$lnginfo
~;
&template;
exit;
}
# End translateboards2 sub

# Begin translateboards3 sub
sub translateboards3 {
my ($lngcurlngboard, $lngcur, $lngcur2, $lngline, @lngxboarddesc);
&openlngboardfile;
	$yytitle = "$langtxt{'03'}";
$lngcurlngboard = $FORM{'board'}."_".$FORM{'code'};
if ($lngboard{$lngcurlngboard} eq "on") {
$lngcur = "";
$lngcur2 = "Checked";
} else {
$lngcur = "Checked";
$lngcur2 = "";
}
$yymain .= qq~
<form action="$cgi;action=translateboards4" method="POST">
<input type="hidden" name="what" value="edit3">
<input type="hidden" name="board" value="$FORM{'board'}">
<input type="hidden" name="code" value="$FORM{'code'}">
<table border=0 width="70%" cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align=center>
~;
$yymain .= qq~
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'03'} - $FORM{'cat'} - $FORM{'board'}</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" colspan="3" height=22><b><font size=2>$langtxt{'67'} (<a href="$cgi;action=manageboards">$txt{'17'}</a>):</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" colspan="3" height=22><font size=2>
	<b>$langtxt{'65'}:</b> $FORM{'catname'}<BR>
	<b>$langtxt{'66'}:</b> $FORM{'boardname'}<BR>
	</font></td>
</TR>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" colspan="3" height=22><b><font size=2>$langtxt{'68'} (<a href="$cgi;action=manageboards">$txt{'17'}</a>):</font></b></td>
</TR>
<TR>
	<td class='windowbg2' bgcolor="$color{'windowbg2'}" colspan="3" height=22><font size=2>
	$FORM{'boardinfo'}<BR>
	</font></td>
</TR>
<tr>
<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="3" height=22><b><font size=2 class="text1" color="$color{'titletext'}">&nbsp<img src="$imagesdir/xx.gif">&nbsp;$langtxt{'69'}:</font></b></td>
</tr>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" height=22><b><font size=2>$langtxt{'39'}:</font></b></td>
</TR>
<TR>
	<td class="windowbg2" bgcolor="$color{'windowbg2'}" height=22><font size=2>
	<input type="radio" name="status" value="" $lngcur>$langtxt{'46'} $langtxt{'68'} (default)<BR>
	<input type="radio" name="status" value="on" $lngcur2>$langtxt{'46'} $langtxt{'70'} (on)<BR>
	</font></td>
</TR>
<TR>
	<td class="catbg" bgcolor="$color{'catbg'}" height=22><b><font size=2>$langtxt{'70'}:</font></b></td>
</TR>
<tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><BR>
    <font size=2>
    <textarea cols=70 rows=8 name="desc">
~;
open(lngLL,"$boardsdir/$FORM{'board'}.$FORM{'code'}");
@lngxboarddesc = <lngLL>;
close(lngLL);
	foreach $lngline (@lngxboarddesc) {
		$lngline =~ s/[\n\r]//g;
		if( $lngline =~ m~\A\s*\Z~ ) { next; }
		$yymain .=qq~$lngline\n~;
	}
$yymain .= qq~
</textarea><br><input type="submit" value="$txt{'10'}"></font><BR></td>
</tr>
</table></form>
$lnginfo
~;
&template;
exit;
}
# End translateboards3 sub

# Begin translateboards4 sub
sub translateboards4 {
my ($lngoutput, $lngfound, $lngline, $lnglang);
if ($FORM{'what'} eq "edit3") {
&openlngboardfile;
	&is_admin;
$FORM{'desc'} =~ s/\n/ /g;
open(lngLL,">$boardsdir/$FORM{'board'}.$FORM{'code'}") || die "$langtxt{'71'} $boardsdir/$FORM{'board'}.$FORM{'code'}, Error : $!\n";
		print lngLL "$FORM{'desc'}";
close(lngLL);
$lngoutput = "";
$lngfound = "0";
foreach $lngline (@lngxboard) {
($lnglang) = split(/=/, $lngline);
if ($lnglang eq $FORM{'code'}) {
$lngoutput .= "$FORM{'board'}"."_"."$FORM{'code'}=$FORM{'status'};\n";
$lngfound = "1";
} else {
$lngoutput .= $lngline;
}
}
if ($lngfound eq "0") {
$lngoutput .= "$FORM{'board'}"."_"."$FORM{'code'}=$FORM{'status'};\n";
}
open(lngLL,">$vardir/boardlanguage.txt") || die "$langtxt{'72'} $vardir/boardlanguage.txt, Error : $!\n";
		print lngLL "$lngoutput";
close(lngLL);
&translateboards;
} else {
&translateboards;
}
}
# End translateboards4 sub

# Begin getlngboard sub
sub getlngboard {
&openlngboardfile;
$lngcurlngboard = $curboard."_".$languagecode;
if ($lngboard{$lngcurlngboard} eq "on") {
fopen(lngLL,"$boardsdir/$curboard.$languagecode");
$curboarddescr = <lngLL>;
fclose(lngLL);
chomp $curboarddescr;
}
}
# End getlngboard sub

# Begin getlngboard2 sub
sub getlngboard2($currentboard) {
fopen(lngLL,"$boardsdir/$currentboard.$languagecode");
$bdescrip = <lngLL>;
fclose(lngLL);
chomp $bdescrip;
return $bdescrip;
}
# End getlngboard2 sub

1;
