###############################################################################
# AdminEdit.pl                                                                #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.4                                        #
# Released:       December 2001; Updated November 25, 2004                    #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

$admineditplver = "1 Gold - SP 1.4";
# --- Added for Notify Plus 2.2 --- #
require "$sourcedir/NotifyPlus.pl";
# --- /Added for Notify Plus 2.2 --- #


sub EditNews {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_news != 1 ) { &fatal_error("$txt{'1'}"); }
	my($line);
	$yymain .= qq~
<form action="$cgi;action=editnews2" method="POST">
<table border="0" width="70%" cellspacing="1" cellpadding="3" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'7'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><BR><font size="1">$txt{'670'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><BR>
    <font size=2>
    <textarea cols=70 rows=8 name="news">
~;
	fopen(FILE, "$vardir/news.txt");
	while($line = <FILE>) { chomp $line; $yymain .= qq~$line~; }
	fclose(FILE);
	$yymain .= qq~
</textarea><br><input type="submit" value="$txt{'10'}"></font><BR></td>
  </tr>
</table>
</form>
~;
	$yytitle = "$txt{'7'}";
	&template;
	exit;
}

sub EditNews2 {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_news != 1 ) { &fatal_error("$txt{'1'}"); }
	fopen(FILE, ">$vardir/news.txt", 1);
	chomp $FORM{'news'};
	print FILE "$FORM{'news'}";
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
	&redirectexit;
}

sub EditMemberGroups {
	&is_admin;
	my(@lines, $mgroups, $i);
	fopen(FILE, "$vardir/membergroups.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 7; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$mgroups .= "$lines[$i]\n";
	}
	$yymain .= qq~
<table border="0" width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/guest.gif" alt="" border="0">
    <font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'8'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>
    <form action="$cgi;action=modmemgr2" method="POST">
    <table border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="right"><font size=2><b>$txt{'11'}:</b></font></td>
        <td><input type=text name="admin" size=30 value="$lines[0]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'12'}:</b></font></td>
        <td><input type=text name="moderator" size=30 value="$lines[1]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'569'}:</b></font></td>
        <td><input type=text name="newbie" size=30 value="$lines[2]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'13'}:</b></font></td>
        <td><input type=text name="junior" size=30 value="$lines[3]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'14'}:</b></font></td>
        <td><input type=text name="full" size=30 value="$lines[4]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'15'}:</b></font></td>
        <td><input type=text name="senior" size=30 value="$lines[5]"></td>
      </tr><tr>
        <td align="right"><font size=2><b>$txt{'570'}:</b></font></td>
        <td><input type=text name="god" size=30 value="$lines[6]"></td>
      </tr><tr>
        <td align="right"><font size=2><B>$txt{'16'}:</b></font></td>
        <td><textarea name="additional" cols=30 rows=5>$mgroups</textarea><BR>
        <center><input type="submit" value="$txt{'10'}"></center></td>
      </tr>
    </table>
    </form>
    </font></td>
  </tr>
</table>
~;
	$yytitle = $txt{'8'};
	&template;
	exit;
}

sub EditMemberGroups2 {
	&is_admin;
	my $additional = $FORM{'additional'};
	while( $groups = each(%FORM) ) {
		$FORM{$groups} =~ tr/\n//d;
		$FORM{$groups} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/membergroups.txt", 1);
	print FILE "$FORM{'admin'}\n";
	print FILE "$FORM{'moderator'}\n";
	print FILE "$FORM{'newbie'}\n";
	print FILE "$FORM{'junior'}\n";
	print FILE "$FORM{'full'}\n";
	print FILE "$FORM{'senior'}\n";
	print FILE "$FORM{'god'}\n";
	print FILE "$additional";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

sub SetMembermap {
	&is_admin;
	my(@lines, $cnmaps, $i);
	fopen(FILE, "$vardir/continent.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$cnmaps .= "$lines[$i]\n";
	}

	my(@lines, $countr, $i);
	fopen(FILE, "$vardir/country.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$countr .= "$lines[$i]\n";
	}

	my(@lines, $stat, $i);
	fopen(FILE, "$vardir/state.txt");
	@lines = <FILE>;
	fclose(FILE);
	foreach $i (@lines) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	for( $i = 0; $i < @lines; ++$i ) {
		if( $lines[$i] =~ m~\A\s+\Z~ ) { next; }
		$stat .= "$lines[$i]\n";
	}

	$yymain .= qq~
<table border="0" width="600" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4">
  <tr>
    <td colspan="2" class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/map.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$maptxt{'08'}</font></td>
  </tr>
<tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=setmembmap2" method="POST">
    <table align="center" border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="left"><font size=2><B>$maptxt{'09'}:</b></font></td>
	</tr><tr>
        <td align="center"><textarea name="maps" cols=30 rows=10>$cnmaps</textarea><BR>
        <input type=submit value="$txt{'10'}"></td>
      </tr>
    </table>
    </form>
    </td>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=setcountry2" method="POST">
    <table align="center" border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="left"><font size=2><B>$maptxt{'10'}:</b></font></td>
	</tr><tr>
        <td align="center"><textarea name="country" cols=30 rows=10>$countr</textarea><BR>
        <input type=submit value="$txt{'10'}"></td>
      </tr>
    </table>
    </form>
    </td>
  </tr>
  <tr>
    <td colspan="2" class="windowbg" bgcolor="$color{'windowbg'}">
    <form action="$cgi;action=setstate2" method="POST">
    <table align="center" border="0" cellpadding="1" cellspacing="0">
      <tr>
        <td align="left">
          <font size=2><B>$maptxt{'19'}:</b></font><br>
          <font size=2>$maptxt{'20'}</font>
        </td>
	</tr><tr>
        <td align="center"><textarea name="states" cols=40 rows=10>$stat</textarea><BR>
        <input type=submit value="$txt{'10'}"></td>
      </tr>
    </table>
    </form>
    </td>
  </tr>
</table>
~;
	$yytitle = $maptxt{'08'};
	&template;
	exit;
}

sub SetMembermap2 {
	&is_admin;
	my $maps = $FORM{'maps'};
	while( $conts = each(%FORM) ) {
		$FORM{$conts} =~ tr/\n//d;
		$FORM{$conts} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/continent.txt", 1);
	print FILE "$maps";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetCountry2 {
	&is_admin;
	my $country = $FORM{'country'};
	while( $contr = each(%FORM) ) {
		$FORM{$contr} =~ tr/\n//d;
		$FORM{$contr} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/country.txt", 1);
	print FILE "$country";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetState2 {
	&is_admin;
	my $states = $FORM{'states'};
	while( $sstate = each(%FORM) ) {
		$FORM{$sstate} =~ tr/\n//d;
		$FORM{$sstate} =~ tr/\r//d;
	}
	fopen(FILE, ">$vardir/state.txt", 1);
	print FILE "$states";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=setmembmap~;
	&redirectexit;
}

sub SetCensor {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_censor != 1 ) { &fatal_error("$txt{'1'}"); }
	my( @censored, $i );
	fopen(FILE, "$vardir/censor.txt");
	@censored = <FILE>;
	fclose(FILE);
	foreach $i (@censored) {
		$i =~ tr/\r//d;
		$i =~ tr/\n//d;
	}
	$yymain .= qq~
<table border="0" width="300" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/ban.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'135'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size=2>
    <form action="$cgi;action=setcensor2" method="POST">
    $txt{'136'}<br>
    <textarea cols=55 rows=15 name="censored">
~;
	foreach $i (@censored) {
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		$yymain .= "$i\n";
	}
	$yymain .= qq~
</textarea><br><BR>
    <input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'135'}";
	&template;
	exit;
}

sub SetCensor2 {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_censor != 1 ) { &fatal_error("$txt{'1'}"); }
	$FORM{'censored'} =~ tr/\r//d;
	$FORM{'censored'} =~ s~\A[\s\n]+~~;
	$FORM{'censored'} =~ s~[\s\n]+\Z~~;
	$FORM{'censored'} =~ s~\n\s*\n~\n~g;
	my @lines = split( /\n/, $FORM{'censored'} );
	fopen(FILE, ">$vardir/censor.txt", 1);
	foreach my $i (@lines) {
		$i =~ tr/\n//d;
		unless( $i && $i =~ m~.+\=.+~ ) { next; }
		print FILE "$i\n";
	}
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
	&redirectexit;
}

sub SetReserve {
	my( @reserved, @reservecfg, $i );
	&is_admin;
	fopen(FILE, "$vardir/reserve.txt");
	@reserved = <FILE>;
	fclose(FILE);
	fopen(FILE, "$vardir/reservecfg.txt");
	@reservecfg = <FILE>;
	fclose(FILE);
	for(my $i = 0; $i < @reservecfg; $i++) { chomp $reservecfg[$i]; }

	$yymain .= qq~
<table border=0 cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" align="center" cellpadding="4" width="580">
  <tr>
    <td bgcolor="$color{'titlebg'}" class="titlebg">
    <img src="$imagesdir/profile.gif" alt="" border="0">
    <font size="2" class="text1" color="$color{'titletext'}"><b>$txt{'341'}</b></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg'}" class="windowbg">
    <font size="1"><BR>$txt{'699'}<BR><BR></font></td>
  </tr><tr>
    <td bgcolor="$color{'windowbg2'}" class="windowbg2"><font size=2>
    <form action="$cgi;action=setreserve2" method="POST">
    <center>$txt{'342'}<br>
    <textarea cols=30 rows=6 name="reserved">
~;
	foreach $i (@reserved) {
		chomp $i;
		$i =~ s~\t~~g;
		if( $i !~ m~\A[\S|\s]*[\n\r]*\Z~) { next; }
		$yymain .= "$i\n";
	}
	$yymain .= qq~</textarea></center><br>
	<font size=2><input type=checkbox name="matchword" value="checked" $reservecfg[0]></font>
	<font size=2>$txt{'726'}</font><br>
	<font size=2><input type=checkbox name="matchcase" value="checked" $reservecfg[1]></font>
	<font size=2>$txt{'727'}</font><br>
	<font size=2><input type=checkbox name="matchuser" value="checked" $reservecfg[2]></font>
	<font size=2>$txt{'728'}</font><br>
	<font size=2><input type=checkbox name="matchname" value="checked" $reservecfg[3]></font>
	<font size=2>$txt{'729'}</font><br>
	<center><input type=submit value="$txt{'10'}"></center></form></font></td>
</tr>
</table>
~;
	$yytitle = "$txt{'341'}";
	&template;
	exit;
}

sub SetReserve2 {
	&is_admin;
	$FORM{'reserved'} =~ tr/\r//d;
	$FORM{'reserved'} =~ s~\A[\s\n]+~~;
	$FORM{'reserved'} =~ s~[\s\n]+\Z~~;
	$FORM{'reserved'} =~ s~\n\s*\n~\n~g;
	fopen(FILE, ">$vardir/reserve.txt", 1);
	my $matchword = $FORM{'matchword'} eq 'checked' ? 'checked' : '';
	my $matchcase = $FORM{'matchcase'} eq 'checked' ? 'checked' : '';
	my $matchuser = $FORM{'matchuser'} eq 'checked' ? 'checked' : '';
	my $matchname = $FORM{'matchname'} eq 'checked' ? 'checked' : '';
	print FILE $FORM{'reserved'};
	fclose(FILE);
	fopen(FILE, "+>$vardir/reservecfg.txt");
	print FILE "$matchword\n";
	print FILE "$matchcase\n";
	print FILE "$matchuser\n";
	print FILE "$matchname\n";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

sub AddTemplate {
	&is_admin;
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'216'}</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <BR><form action="$cgi;action=modtemp2" method="POST"><input name="templatefile" id="templatefile" value=".html"> <input type=submit value="$txt{'10'}"><br>
    <textarea rows=30 cols=95 wrap=virtual name="template" style="width:98%"></textarea>
    </form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'216'}";
	&template;
	exit;
}
sub ModifyTemplate {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_edittemp != 1 ) { &fatal_error("$txt{'1'}"); }
	my( $fulltemplate, $line );
	### User Templates ###
	if($FORM{'templatefile'}) { $templatefile = $FORM{'templatefile'} }
	else { $templatefile = "$defaulttemplate"; }
	opendir(TMPLDIR, $templatesdir);
	@templates = readdir(TMPLDIR);
	closedir(TMPLDIR);
	$templs = "";
	foreach $file(sort @templates) {
	    ($name, $ext) = split(/\./, $file);
	    $selected = '';
	    if($ext eq 'html' || $ext eq 'htm') {
		if($file eq $templatefile) { $selected = ' selected'; }
		$templs .= qq~<option value="$file"$selected>$name</option>\n~;
	    }
	}
	fopen(FILE, "$templatesdir/$templatefile");
#	fopen(FILE, "$boarddir/template.html");
	###/User Templates ###
	while( $line = <FILE> ) {
		$line =~ s~[\r\n]~~g;
		&FromHTML;
		$fulltemplate .= qq~$line\n~;
	}
	fclose(FILE);
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'216'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size="1">$txt{'682'}</font><BR><BR>
      <font size="1">$templs{'3'}</font>
      <form action="$scripturl?action=modtemp" method="post">
      <input type="submit" value="$txt{'216'}" style="width:200px;">
      <select name="templatefile" id="templatefile" size="1">
      $templs</select>
      </form>
      <form action="$scripturl?action=deletetemp" method="post">
      <input type="submit" value="Template $txt{'154'}" style="width:200px;">
      <select name="templatefile" id="templatefile" size="1">
      $templs</select>
      </form>
      <form action="$scripturl?action=modtempadd" method="post">
      <input type="submit" value="$templs{'4'}" style="width:200px;">
      </form>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <BR><form action="$cgi;action=modtemp2" method="POST"><input name="templatefile" type="hidden" id="templatefile" value="$templatefile"> <input type=submit value="$txt{'10'}"><br>
    <textarea rows=30 cols=95 wrap=virtual name="template" style="width:98%">$fulltemplate</textarea>
    </form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'216'}";
	&template;
	exit;
}

sub DelTemplate {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_edittemp != 1 ) { &fatal_error("$txt{'1'}"); }
	if($FORM{'templatefile'}) { $templatefile = $FORM{'templatefile'}; }
	### User Templates ###
	unlink("$templatesdir/$templatefile");
	###/User Templates ###

	$yymain .= qq~<b>$templatefile</b> $langtxt{'27'}!!!<br><br>- <a href="$cgi;action=modtemp">$txt{'216'}</a>~;
	$yytitle = "$txt{'216'}";
	&template;
	exit;
}

sub ModifyTemplate2 {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $allowgmod_edittemp != 1 ) { &fatal_error("$txt{'1'}"); }
	$FORM{'template'} =~ tr/\r//d;
	$FORM{'template'} =~ s~\A\n~~;
	$FORM{'template'} =~ s~\n\Z~~;
	### User Templates ###
	if($FORM{'templatefile'}) { $templatefile = $FORM{'templatefile'}; }
	else { $templatefile = "$defaulttemplate"; }
	fopen(FILE, ">$templatesdir/$templatefile");
      chmod (0666, "$templatesdir/$templatefile");
#	fopen(FILE, ">$boarddir/template.html");
	###/User Templates ###

	print FILE $FORM{'template'};
	fclose(FILE);
	if ($settings[7] eq 'Global Moderator') {
	$yySetLocation = qq~$cgi\;action=moderate~;
	} else {
	$yySetLocation = qq~$cgi\;action=admin~;
	}
	&redirectexit;
}

sub ModifyAgreement {
	&is_admin;
	my( $fullagreement, $line );
	fopen(FILE, "$vardir/agreement.txt");
	while( $line = <FILE> ) {
		$line =~ tr/[\r\n]//d;
		&FromHTML($line);
		$fullagreement .= qq~$line\n~;
	}
	fclose(FILE);
	$yymain .= qq~
<table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}">
    <img src="$imagesdir/xx.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'764'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}">
    <BR><font size="1">$txt{'765'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>
    <form action="$cgi;action=modagreement2" method="POST"><BR>
    <textarea rows=30 cols=95 wrap=virtual name="agreement" style="width:98%">$fullagreement</textarea>
    <br><BR><input type=submit value="$txt{'10'}"></form></font></td>
  </tr>
</table>
~;
	$yytitle = "$txt{'764'}";
	&template;
	exit;
}

sub ModifyAgreement2 {
	&is_admin;
	$FORM{'agreement'} =~ tr/\r//d;
	$FORM{'agreement'} =~ s~\A\n~~;
	$FORM{'agreement'} =~ s~\n\Z~~;
	fopen(FILE, ">$vardir/agreement.txt");
	print FILE $FORM{'agreement'};
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

# Advanced System eMails Mod
sub EmailControlCenter {
	&is_admin;
	my( $advemailstemplates, @subjlist, @bodylist );
	fopen(FILE, "$vardir/advemails.txt");
	@EMAILTEMPL = <FILE>;
	fclose(FILE);
     
      @subjlist[0] = substr(@EMAILTEMPL[0],0,index(@EMAILTEMPL[0],'|'));
      @bodylist[0] = substr(@EMAILTEMPL[0],index(@EMAILTEMPL[0],'|')+1,length(@EMAILTEMPL[0]));
      
      @subjlist[1] = substr(@EMAILTEMPL[1],0,index(@EMAILTEMPL[1],'|'));
      @bodylist[1] = substr(@EMAILTEMPL[1],index(@EMAILTEMPL[1],'|')+1,length(@EMAILTEMPL[1]));

      @subjlist[2] = substr(@EMAILTEMPL[2],0,index(@EMAILTEMPL[2],'|'));
      @bodylist[2] = substr(@EMAILTEMPL[2],index(@EMAILTEMPL[2],'|')+1,length(@EMAILTEMPL[2]));

      @subjlist[3] = substr(@EMAILTEMPL[3],0,index(@EMAILTEMPL[3],'|'));
      @bodylist[3] = substr(@EMAILTEMPL[3],index(@EMAILTEMPL[3],'|')+1,length(@EMAILTEMPL[3]));

      @subjlist[4] = substr(@EMAILTEMPL[4],0,index(@EMAILTEMPL[4],'|'));
      @bodylist[4] = substr(@EMAILTEMPL[4],index(@EMAILTEMPL[4],'|')+1,length(@EMAILTEMPL[4]));

      @subjlist[5] = substr(@EMAILTEMPL[5],0,index(@EMAILTEMPL[5],'|'));
      @bodylist[5] = substr(@EMAILTEMPL[5],index(@EMAILTEMPL[5],'|')+1,length(@EMAILTEMPL[5]));

      @subjlist[6] = substr(@EMAILTEMPL[6],0,index(@EMAILTEMPL[6],'|'));
      @bodylist[6] = substr(@EMAILTEMPL[6],index(@EMAILTEMPL[6],'|')+1,length(@EMAILTEMPL[6]));

      @subjlist[7] = substr(@EMAILTEMPL[7],0,index(@EMAILTEMPL[7],'|'));
      @bodylist[7] = substr(@EMAILTEMPL[7],index(@EMAILTEMPL[7],'|')+1,length(@EMAILTEMPL[7]));

      @subjlist[8] = substr(@EMAILTEMPL[8],0,index(@EMAILTEMPL[8],'|'));
      @bodylist[8] = substr(@EMAILTEMPL[8],index(@EMAILTEMPL[8],'|')+1,length(@EMAILTEMPL[8]));

      @subjlist[9] = substr(@EMAILTEMPL[9],0,index(@EMAILTEMPL[9],'|'));
      @bodylist[9] = substr(@EMAILTEMPL[9],index(@EMAILTEMPL[9],'|')+1,length(@EMAILTEMPL[9]));

      @subjlist[10] = substr(@EMAILTEMPL[10],0,index(@EMAILTEMPL[10],'|'));
      @bodylist[10] = substr(@EMAILTEMPL[10],index(@EMAILTEMPL[10],'|')+1,length(@EMAILTEMPL[10]));

      @subjlist[11] = substr(@EMAILTEMPL[11],0,index(@EMAILTEMPL[11],'|'));
      @bodylist[11] = substr(@EMAILTEMPL[11],index(@EMAILTEMPL[11],'|')+1,length(@EMAILTEMPL[11]));

      @subjlist[12] = substr(@EMAILTEMPL[12],0,index(@EMAILTEMPL[12],'|'));
      @bodylist[12] = substr(@EMAILTEMPL[12],index(@EMAILTEMPL[12],'|')+1,length(@EMAILTEMPL[12]));

      @subjlist[13] = substr(@EMAILTEMPL[13],0,index(@EMAILTEMPL[13],'|'));
      @bodylist[13] = substr(@EMAILTEMPL[13],index(@EMAILTEMPL[13],'|')+1,length(@EMAILTEMPL[13]));

      @subjlist[14] = substr(@EMAILTEMPL[14],0,index(@EMAILTEMPL[14],'|'));
      @bodylist[14] = substr(@EMAILTEMPL[14],index(@EMAILTEMPL[14],'|')+1,length(@EMAILTEMPL[14]));

      @subjlist[15] = substr(@EMAILTEMPL[15],0,index(@EMAILTEMPL[15],'|'));
      @bodylist[15] = substr(@EMAILTEMPL[15],index(@EMAILTEMPL[15],'|')+1,length(@EMAILTEMPL[15]));

      @subjlist[16] = substr(@EMAILTEMPL[16],0,index(@EMAILTEMPL[16],'|'));
      @bodylist[16] = substr(@EMAILTEMPL[16],index(@EMAILTEMPL[16],'|')+1,length(@EMAILTEMPL[16]));

      if (length(@subjlist[0]) == 0) {@subjlist[0] = "[subject]" ;};
      if (length(@bodylist[0]) < 2) {@bodylist[0] = "$txt{'247'}\n\n$txt{'128'}, [subject], $txt{'129'} [threadurl]\n\n$txt{'130'}"; };

      if (length(@subjlist[1]) == 0) {@subjlist[1] = "$advemailtxt{'10'} ([subject])" ;};
      if (length(@bodylist[1]) < 2) {@bodylist[1] = "$txt{'247'} [name]\n\n[sender] $advemailtxt{'11'}\n\n[message]\n\n$txt{'130'}"; };

      if (length(@subjlist[2]) == 0) {@subjlist[2] = "$txt{'700'} [mbname]" ;};
      if (length(@bodylist[2]) < 2) {@bodylist[2] = "$txt{'248'} [username]!\n\n$txt{'719'} [username] $txt{'492'} [password]\n\n$txt{'701'}\n\n[profile]\n\n$txt{'130'}"; };

      if (length(@subjlist[3]) == 0) {@subjlist[3] = "$txt{'700'} [mbname]" ;};
      if (length(@bodylist[3]) < 2) {@bodylist[3] = "$txt{'248'} [username]!\n\n$txt{'719'} [username], $txt{'492'} [password]\n\n$txt{'701'}\n\n[profile]\n\n$txt{'130'}"; };

      if (length(@subjlist[4]) == 0) {@subjlist[4] = "$txt{'700'} [mbname]" ;};
      if (length(@bodylist[4]) < 2) {@bodylist[4] = "$txt{'711'} [name],\n\n$txt{'719'} [username], $txt{'492'} [password]\n\n$txt{'130'}"; };

      if (length(@subjlist[5]) == 0) {@subjlist[5] = "$txt{'700'} [mbname]" ;};
      if (length(@bodylist[5]) < 2) {@bodylist[5] = "$txt{'733'} [password] $txt{'734'} [username].\n\n$txt{'701'} [profile]\n\n$txt{'130'}"; };

      if (length(@subjlist[6]) == 0) {@subjlist[6] = "$txt{'118'}:  [subject] ($txt{'318'} [sender])" ;};
      if (length(@bodylist[6]) < 2) {@bodylist[6] = "$txt{'711'} [recipient],\n\n$txt{'712'}: [subject], $txt{'30'} [mbname]. $txt{'713'}:\n\n[topicurl]\n\n\n$txt{'714'},\n[sender]"; };

      @bodylist[0] =~ s~\\n~\n~g;
      @bodylist[1] =~ s~\\n~\n~g;
      @bodylist[2] =~ s~\\n~\n~g;
      @bodylist[3] =~ s~\\n~\n~g;
      @bodylist[4] =~ s~\\n~\n~g;
      @bodylist[5] =~ s~\\n~\n~g;
      @bodylist[6] =~ s~\\n~\n~g;
      @bodylist[7] =~ s~\\n~\n~g;
      @bodylist[8] =~ s~\\n~\n~g;
      @bodylist[9] =~ s~\\n~\n~g;
      @bodylist[10] =~ s~\\n~\n~g;
      @bodylist[11] =~ s~\\n~\n~g;
      @bodylist[12] =~ s~\\n~\n~g;
      @bodylist[13] =~ s~\\n~\n~g;
      @bodylist[14] =~ s~\\n~\n~g;
      @bodylist[15] =~ s~\\n~\n~g;
      @bodylist[16] =~ s~\\n~\n~g;

	$yymain .= qq~
  <form action="$cgi;action=advemail2" method="POST"><BR>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'titlebg'}" height="24" class="titlebg" align="center"><font size=3 class="text1" color="$color{'titletext'}"><B>$advemailtxt{'1'}</B></font></td></tr> 
 </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'3'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'13'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj1" SIZE="50" value="@subjlist[1]"><br> 
            <B>$txt{'69'}:</B><br>
        <input type="hidden" name="subj0" value="@subjlist[0]">
        <input type="hidden" name="body0" value="@bodylist[0]">
            <textarea rows=10 cols=95 wrap=virtual name="body1" style="width:98%">@bodylist[1]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'4'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'14'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj2" SIZE="50" value="@subjlist[2]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body2" style="width:98%">@bodylist[2]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'5'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'14'} <p>$advemailtxt{'15'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj3" SIZE="50" value="@subjlist[3]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body3" style="width:98%">@bodylist[3]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'6'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'14'} <p>$advemailtxt{'15'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj4" SIZE="50" value="@subjlist[4]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body4" style="width:98%">@bodylist[4]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'7'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'14'} <p>$advemailtxt{'15'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj5" SIZE="50" value="@subjlist[5]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body5" style="width:98%">@bodylist[5]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'8'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'17'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj6" SIZE="50" value="@subjlist[6]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body6" style="width:98%">@bodylist[6]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'9'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'16'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj7" SIZE="50" value="@subjlist[7]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body7" style="width:98%">@bodylist[7]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'18'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'32'} $advemailtxt{'19'}<p>$advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj8" SIZE="50" value="@subjlist[8]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body8" style="width:98%">@bodylist[8]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'21'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'22'} $advemailtxt{'19'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj9" SIZE="50" value="@subjlist[9]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body9" style="width:98%">@bodylist[9]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'23'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'24'} $advemailtxt{'19'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj10" SIZE="50" value="@subjlist[10]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body10" style="width:98%">@bodylist[10]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'25'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'26'} $advemailtxt{'19'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj11" SIZE="50" value="@subjlist[11]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body11" style="width:98%">@bodylist[11]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'27'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'28'} $advemailtxt{'19'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj12" SIZE="50" value="@subjlist[12]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body12" style="width:98%">@bodylist[12]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'29'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'31'} $advemailtxt{'38'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj13" SIZE="50" value="@subjlist[13]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body13" style="width:98%">@bodylist[13]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">


  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'30'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'31'} $advemailtxt{'38'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj14" SIZE="50" value="@subjlist[14]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body14" style="width:98%">@bodylist[14]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'36'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'37'} $advemailtxt{'38'}<p> $advemailtxt{'20'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj16" SIZE="50" value="@subjlist[16]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body16" style="width:98%">@bodylist[16]</textarea>
     </td>
  </tr>
  </table>
 <p>
  <table border=0 width="100%" cellspacing=1 bgcolor="$color{'bordercolor'}" class="bordercolor" cellpadding="4">
  <tr><td bgcolor="$color{'catbg'}" height="24" class="catbg"><img src="$imagesdir/email.gif" alt=""> <font size="2"><B>$advemailtxt{'34'}</B></font></td></tr>
  <tr><td bgcolor="$color{'windowbg2'}" height="24" class="windowbg2"><font size="1">$advemailtxt{'35'}</font><p>
            <B>$txt{'319'}:</B>&nbsp;&nbsp;&nbsp;<input type="text" NAME="subj15" SIZE="50" value="@subjlist[15]"><br> 
            <B>$txt{'69'}:</B><br>
            <textarea rows=10 cols=95 wrap=virtual name="body15" style="width:98%">@bodylist[15]</textarea>
     </td>
  </tr>
  </table>
 <p>

  <table border=0 width="100%" cellspacing=1>
  <tr><td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><input type=submit value="$txt{'10'}"></td></tr>
  </table>
  </form>
~;
	$yytitle = $advemailtxt{'1'};
	&template;
	exit;
}

sub EmailControlCenter3 {
    $_[0] =~ tr/\r//d; $_[0] =~ s~\A\n~~; $_[0] =~ s~\n\Z~~; $_[0] =~ s/\|/ /g;
    $_[1] =~ s/\cM//g; 
    $_[1] =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
    $_[1] =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
    $_[1] =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
    $_[1] =~ s~\t~ \     ~g;
    $_[1] =~ s~\n~\\n~g;
}
sub EmailControlCenter2 {

	&is_admin;
      EmailControlCenter3($FORM{'subj0'},$FORM{'body0'});
      EmailControlCenter3($FORM{'subj1'},$FORM{'body1'});
      EmailControlCenter3($FORM{'subj2'},$FORM{'body2'});
      EmailControlCenter3($FORM{'subj3'},$FORM{'body3'});
      EmailControlCenter3($FORM{'subj4'},$FORM{'body4'});
      EmailControlCenter3($FORM{'subj5'},$FORM{'body5'});
      EmailControlCenter3($FORM{'subj6'},$FORM{'body6'});
      EmailControlCenter3($FORM{'subj7'},$FORM{'body7'});
      EmailControlCenter3($FORM{'subj8'},$FORM{'body8'});
      EmailControlCenter3($FORM{'subj9'},$FORM{'body9'});
      EmailControlCenter3($FORM{'subj10'},$FORM{'body10'});
      EmailControlCenter3($FORM{'subj11'},$FORM{'body11'});
      EmailControlCenter3($FORM{'subj12'},$FORM{'body12'});
      EmailControlCenter3($FORM{'subj13'},$FORM{'body13'});
      EmailControlCenter3($FORM{'subj14'},$FORM{'body14'});
      EmailControlCenter3($FORM{'subj15'},$FORM{'body15'});
      EmailControlCenter3($FORM{'subj16'},$FORM{'body16'});

	fopen(FILE, ">$vardir/advemails.txt");
      print FILE $FORM{'subj0'}; print FILE "|"; print FILE $FORM{'body0'}; print FILE "\n";
      print FILE $FORM{'subj1'}; print FILE "|"; print FILE $FORM{'body1'}; print FILE "\n";
      print FILE $FORM{'subj2'}; print FILE "|"; print FILE $FORM{'body2'}; print FILE "\n";
      print FILE $FORM{'subj3'}; print FILE "|"; print FILE $FORM{'body3'}; print FILE "\n";
      print FILE $FORM{'subj4'}; print FILE "|"; print FILE $FORM{'body4'}; print FILE "\n";
      print FILE $FORM{'subj5'}; print FILE "|"; print FILE $FORM{'body5'}; print FILE "\n";
      print FILE $FORM{'subj6'}; print FILE "|"; print FILE $FORM{'body6'}; print FILE "\n";
      print FILE $FORM{'subj7'}; print FILE "|"; print FILE $FORM{'body7'}; print FILE "\n";
      print FILE $FORM{'subj8'}; print FILE "|"; print FILE $FORM{'body8'}; print FILE "\n";
      print FILE $FORM{'subj9'}; print FILE "|"; print FILE $FORM{'body9'}; print FILE "\n";
      print FILE $FORM{'subj10'}; print FILE "|"; print FILE $FORM{'body10'}; print FILE "\n";
      print FILE $FORM{'subj11'}; print FILE "|"; print FILE $FORM{'body11'}; print FILE "\n";
      print FILE $FORM{'subj12'}; print FILE "|"; print FILE $FORM{'body12'}; print FILE "\n";
      print FILE $FORM{'subj13'}; print FILE "|"; print FILE $FORM{'body13'}; print FILE "\n";
      print FILE $FORM{'subj14'}; print FILE "|"; print FILE $FORM{'body14'}; print FILE "\n";
      print FILE $FORM{'subj15'}; print FILE "|"; print FILE $FORM{'body15'}; print FILE "\n";
      print FILE $FORM{'subj16'}; print FILE "|"; print FILE $FORM{'body16'}; print FILE "\n";
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}
# End Advanced System eMails Mod
sub ModifySettings {
	&is_admin;
	my($topposterchecked);
	if($imspam eq "off") {$imspam = "";}
	my($mainchecked, $guestaccchecked, $forcechecked, $blankchecked, $agreechecked, $mailpasschecked, $newpasschecked, $welchecked);
	my($menuchecked, $ubbcchecked, $aluchecked, $cpchecked, $pbchecked, $insertchecked, $newschecked, $gpchecked, $notifchecked);
	my ($uapchecked, $upchecked);
	my($ahmchecked, $slmchecked, $srbarchecked, $smbarchecked, $smreadchecked, $smodchecked, $supicchecked, $sutextchecked, $sgichecked);
	my($snfchecked, $fls1, $fls2, $fls3, $utfchecked, $truncchecked, $mts1, $mts2, $mts3, $tsl6, $tsl5, $tsl4, $tsl3, $tsl2, $tsl1);
     my($tsrchecked);
	my($sviewmailcolm, $sviewicqcolm, $sviewwwwcolm, $sviewimcolm, $sviewyimcolm, $sviewaimcolm, $sviewmsncolm, $sviewregcolm, $bmd1, $bmd2, $defml1, $defml2, $defml3, $defml4);
	my($sviewnumbcolm, $sviewipcolm, $sguest_allow, $sviewnumb, $smailpic, $smailtxt, $swwwpic, $swwwtxt, $simpic, $simtxt, $sicqpic, $sicqtxt, $syimpic, $syimtxt, $saimpic, $saimtxt);
	my($sviewgendcolm, $sgendpic, $sgendtxt, $senablebuddy, $mxbar1, $mxbar2, $mxbar3);
	my($smapguest_allow, $sview_flag, $sview_text, $sview_state, $smapsort_name, $smapsort_country, $smapsort_index, $sreq_location, $sview_mapgender);
	my($sred_pin, $sgreen_pin, $sblue_pin);
     my($mdadchecked, $mdglchecked, $mdmochecked);
	my($gmodchecked, $disprealinfochecked, $hideadminchecked, $hidegmodchecked, $hidemodchecked);
	my($gmodedittemplate, $gmodeditcat, $gmodban, $gmodmaint, $gmodeditprof);

	# figure out what to print
	if ($rul_users_display eq '') { $rul_users_display = 5; }
	if ($rul_avatar_width eq '') { $rul_avatar_width = 0; }
	if ($rul_avatar_height eq '') { $rul_avatar_height = 0; }
	if ($rul_rowspan eq '') { $rul_rowspan = 6; }
	if ($rul_show_avatars) { $rul_show_avatars_checked = ' checked'; }
	if ($rul_show_time) { $rul_show_time_checked = ' checked'; }
	if ($rul_avatar_link == 2)    { $rul_avatar_link_selected2 = ' selected'; }
	elsif ($rul_avatar_link == 1) { $rul_avatar_link_selected1 = ' selected'; }
	else                          { $rul_avatar_link_selected0 = ' selected'; }
	
	if ($mdadmin) { $mdadchecked = ' checked'; }
	if ($mdglobal) { $mdglchecked = ' checked'; }
	if ($mdmod) { $mdmochecked = ' checked'; }
	if ($tsreverse) { $tsrchecked = ' checked'; }
	if ($maintenance) { $mainchecked = ' checked'; }
	if ($show_topposter) { $topposterchecked = ' checked'; }
	if ($guestaccess == 0) { $guestaccchecked = ' checked'; }
	if($RegAgree) { $agreechecked = " checked"; }
	if($emailpassword) { $mailpasschecked = " checked"; }
	if($emailnewpass) { $newpasschecked = " checked"; }
	if($emailwelcome) { $welchecked = " checked"; }
	if ($MenuType) { $menuchecked = ' checked'; }
	if ($allow_mod) { $gmodchecked = ' checked'; }
	if ($disprealinfo) { $disprealinfochecked = ' checked'; }
	if ($hideadmin) { $hideadminchecked = ' checked'; }
	if ($hidegmod) { $hidegmodchecked = ' checked'; }
	if ($hidemod) { $hidemodchecked = ' checked'; }
	if ($showgmod_info) {$gmodshowstats = ' checked'; }
	if ($allowgmod_censor) {$gmodshowcensor = ' checked'; }
	if ($allowgmod_edittemp) {$gmodedittemplate = ' checked'; }
	if ($allowgmod_editcat) {$gmodeditcat = ' checked'; }
	if ($allowgmod_ban) {$gmodban = ' checked'; }
	if ($allowgmod_news) {$gmodnews = ' checked'; }
	if ($allowgmod_maint) {$gmodmaint = ' checked'; }
	if ($allowgmod_editprof) {$gmodeditprof = ' checked'; }
	if ($enable_ubbc) { $ubbcchecked = ' checked'; }
	if ($show_smilie_block) { $showblockchecked = " checked"; }
	if ($autolinkurls) { $aluchecked = ' checked'; }
	if ($curposlinks) { $cpchecked = ' checked'; }
	if ($profilebutton) { $pbchecked = ' checked'; }
	if ($enable_news) { $newschecked = "checked" }
	if ($enable_guestposting) { $gpchecked = "checked" }
	if ($enable_notification) { $notifchecked = "checked" }
# --- Added for Notify Plus 2.2 --- #
	if ($enable_notification_board) { $notifyboardchecked = "checked" }
	if ($enable_mark_board) { $markboardchecked = "checked" }
	if ($enable_mark_thread) { $markthreadchecked = "checked" }
	if ($enable_notification_guest) { $notifyguestchecked = "checked" }
	if ($enable_mailinglist) { $mailinglistchecked = "checked" }
	if ($autosend eq "") { $autosend = "EmailReminder" }
	if ($autosend_frequency eq "") { $autosend_frequency = "Never" }
# --- /Added for Notify Plus 2.2 --- #

	if ($allow_hide_email) { $ahmchecked = "checked" }
	if ($showlatestmember) { $slmchecked = "checked" }
	if ($Show_RecentBar) { $srbarchecked = "checked" }
	## WHOSON MOD START ##
	if ($Show_OnlineBar || $Show_OnlineBar eq "") { $onlbarchecked = "checked" }
	if ($Show_MostUsers) { $smuchecked = "checked" }
	if ($Show_WhosOn) { $swochecked = "checked" }
	if ($onlopt) { $whoon = "checked" }
	if ($adminwho) { $admindisplay = "checked" }
	## WHOSON MOD END ##
	if ($showmarkread) { $smreadchecked = "checked" }
	if ($ss_advanced) { $ssadvchecked = ' checked'; }
	if ($showmodify) { $smodchecked = "checked" }
	if ($ShowBDescrip) { $bdescripchecked = "checked" }
	if ($showuserpic) { $supicchecked = "checked" }
	if ($showusertext) { $sutextchecked = "checked" }
	if ($enable_mailsounds) {$senablemailsounds = 'checked' }
	if ($enable_mailpopup) {$senablemailpopup = 'checked' }
	if ($enable_imlimit) {$senableimlimit = 'checked' }
	if ($send_welcomeim) {$send_welcomeimchecked = 'checked' }
	if ($enable_buddies) {$enable_buddieschecked = 'checked' }
	if ($popup_on) {$popup_onchecked = 'checked' }
	if ($showgenderimage) { $sgichecked = "checked" }
	if ($shownewsfader) { $snfchecked = "checked" }
	if ($showyabbcbutt) { $syabbcchecked = "checked" }
	$maxpq ||= 60;
	$maxpo ||= 50;
	$maxpc ||= 0;
	$numpolloptions ||= 8;
	if ($useraddpoll) { $uapchecked = " checked" }
	if ($ubbcpolls) { $upchecked = " checked" }
	if ($allowpics) { $allowpicschecked = "checked" }
	if ($showallgroups) { $showallgroupschecked = "checked" }
	if (!$OnlineLogTime) { $OnlineLogTime = "15" }
	if ($view_state) { $sview_state = "checked" }
	if ($mapsort_index) { $smapsort_index = "checked" }
	if ($mapsort eq "name") { $smapsort_name = 'checked' } else { $smapsort_country = 'checked' }
	if ($mapguest_allow) { $smapguest_allow = "checked" }
	if ($view_flag) { $sview_flag = "checked" }
	if ($view_text) { $sview_text = "checked" }
	if ($req_location) { $sreq_location = "checked" }
	if ($view_mapgender) { $sview_mapgender = "checked" }
	if ($mappin eq "rpin") { $sred_pin = 'checked' } elsif ($mappin eq "gpin") { $sgreen_pin = 'checked' } else { $sblue_pin = 'checked' }
	if ($use_flock == 0) { $fls1 = " selected" } elsif ($use_flock == 1) { $fls2 = " selected" } elsif ($use_flock == 2) { $fls3 = " selected" }
	if ($adminview == 0) { $am1 = " selected" } elsif ($adminview == 1) { $am2 = " selected" } elsif ($adminview == 2) { $am3 = " selected" } elsif ($adminview == 3) { $am4 = " selected" }
	if ($gmodview == 0) { $gm1 = " selected" } elsif ($gmodview == 1) { $gm2 = " selected" } elsif ($gmodview == 2) { $gm3 = " selected" } elsif ($gmodview == 3) { $gm4 = " selected" }
	if ($modview == 0) { $m1 = " selected" } elsif ($modview == 1) { $m2 = " selected" } elsif ($modview == 2) { $m3 = " selected" } elsif ($modview == 3) { $m4 = " selected" }
	$utfchecked = $usetempfile ? ' checked' : '';
	$truncchecked = $faketruncation ? ' checked' : '';
	if ($mailtype == 0) { $mts1 = ' selected'; } elsif ($mailtype == 1) { $mts2 = ' selected'; } elsif( $mailtype == 2 ) { $mts3 = ' selected'; }
	if ($timeselected == 6) { $tsl6 = " selected" } elsif ($timeselected == 5) { $tsl5 = " selected" } elsif ($timeselected == 4) { $tsl4 = " selected" } elsif ($timeselected == 3) { $tsl3 = " selected" } elsif ($timeselected == 2) { $tsl2 = " selected" } else { $tsl1 = " selected" }
	if ($barmaxdepend == 0) { $bmd1 = 'checked'; } else { $bmd2 = 'checked'; }
	if ($defaultml == 0) { $defml1 = ' selected'; } elsif ($defaultml == 1) { $defml2 = ' selected'; } elsif( $defaultml == 2 ) { $defml3 = ' selected'; } elsif( $defaultml == 3 ) { $defml4 = ' selected'; }
	if ($maxbar == $membtxt{'02b'}) { $mxbar1 = ' selected'; } elsif ($maxbar == $membtxt{'02c'}) { $mxbar2 = ' selected'; } elsif( $maxbar == $membtxt{'02d'}) { $mxbar3 = ' selected'; } else { $mxbar1 = ' selected'; }
	if ($view_mailcolm) { $sviewmailcolm = 'checked' }
	if ($view_icqcolm) { $sviewicqcolm = 'checked' }
	if ($view_wwwcolm) { $sviewwwwcolm = 'checked' }
	if ($view_imcolm) { $sviewimcolm = 'checked' }
	if ($view_yimcolm) { $sviewyimcolm = 'checked' }
	if ($view_aimcolm) { $sviewaimcolm = 'checked' }
	if ($view_msncolm) { $sviewmsncolm = 'checked' }
	if ($view_regdate) { $sviewregcolm = 'checked' }
	if ($view_numbcolm) { $sviewnumbcolm = 'checked' }
	if ($enable_buddylist) { $senablebuddy = 'checked' }
	if ($view_numb) { $sviewnumb = 'checked' }
	if ($view_ipcolm) { $sviewipcolm = 'checked' }
	if ($view_gendcolm) { $sviewgendcolm = 'checked' }
	if ($guest_allow) { $sguest_allow = 'checked' }
	if ($gendcol eq "pic") { $sgendpic = 'checked' } else { $sgendtxt = 'checked' }
	if ($mailcol eq "pic") { $smailpic = 'checked' } else { $smailtxt = 'checked' }
	if ($wwwcol eq "pic") { $swwwpic = 'checked' } else { $swwwtxt = 'checked' }
	if ($imcol eq "pic") { $simpic = 'checked' } else { $simtxt = 'checked' }
	if ($icqcol eq "pic") { $sicqpic = 'checked' } else { $sicqtxt = 'checked' }
	if ($yimcol eq "pic") { $syimpic = 'checked' } else { $syimtxt = 'checked' }
	if ($aimcol eq "pic") { $saimpic = 'checked' } else { $saimtxt = 'checked' }
	$imtext =~ s/\&\&/\n/g;
	$imtext =~ s/\&lt;/</g;
	$imtext =~ s/\&gt;/>/g;
	$imsubject =~ s/\&\&/\n/g;
	$imsubject =~ s/\&lt;/</g;
	$imsubject =~ s/\&gt;/>/g;

	$yymain .= qq~
<!-- YaBBSERVER ON -->
<form action="$cgi;action=modsettings2" name="modsettings" method="POST">
<input type="hidden" name="kategorie" value="$kategorie">
<input type="hidden" name="boarddir" size="30" value="$boarddir">
<input type="hidden" name="datadir" size="30" value="$datadir">
<input type="hidden" name="memberdir" size="30" value="$memberdir">
<input type="hidden" name="boardsdir" size="30" value="$boardsdir">
<input type="hidden" name="sourcedir" size="30" value="$sourcedir">
<input type="hidden" name="vardir" size="30" value="$vardir">
<input type="hidden" name="templatesdir" id="templatesdir" size="30" value="$templatesdir">
<input type="hidden" name="facesdir" size="30" value="$facesdir">
<input type="hidden" name="soundsdir" size="30" value="$soundsdir">
<input type="hidden" name="soundsurl" size="45" value="$soundsurl">
<input type="hidden" name="facesurl" size="45" value="$facesurl">
<input type="hidden" name="smiliesdir" size="30" value="$smiliesdir">
<input type="hidden" name="smiliesurl" size="45" value="$smiliesurl">
<input type="hidden" name="imagesdir" size="45" value="$imagesdir">
<input type="hidden" name="barsdir" size="30" value="$barsdir">
<input type="hidden" name="barsurl" size="45" value="$barsurl">
<input type="hidden" name="faderpath" size="45" value="$faderpath">
<input type="hidden" name="ubbcjspath" size="45" value="$ubbcjspath">
<input type="hidden" name="helpfile" size="45" value="$helpfile">
<input type="hidden" name="imagesurl" size="35" value="$imagesurl">
<input type="hidden" name="mailprog" size="20" value="$mailprog">
<input type="hidden" name="smtp_server" size="20" value="$smtp_server">
<!-- YaBBSERVER END -->
<table width="90%" border="0" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
  <td>
  <table border="0" cellspacing="0" cellpadding="4" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan=2>
    <img src="$imagesdir/preferences.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'222'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=2><BR><font size="1">$txt{'347'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'350'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="mbname" size="35" value="$mbname"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'351'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="boardurl" size="45" value="$boardurl" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'349'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="language">
~;
opendir(DIR, "$boarddir") || die "$txt{'230'} ($yabb_fullpath/language) :: $!";
@contents = readdir(DIR);
closedir(DIR);
foreach $line (@contents){
	($name, $extension) = split (/\./, $line);
	if ($extension eq "lng"){
		$selected = "";
		if ($line eq $language) { $selected = " selected" }
		$yymain .= "    <option value=\"$line\"$selected>$name\n";
	}
}
$yymain .= qq~
</select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">Standard $templs{'2'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="defaulttemplate">
~;
opendir(DIR, "$templatesdir") || die "$txt{'230'} ($templatesdir) :: $!";
@contents = readdir(DIR);
closedir(DIR);
foreach $line (@contents){
	($name, $extension) = split (/\./, $line);
	if($extension eq 'html' || $extension eq 'htm') {
		$selected = "";
		if ($line eq $defaulttemplate) { $selected = " selected" }
		$yymain .= "    <option value=\"$line\"$selected>$name\n";
	}
}
$yymain .= qq~
</select></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'348'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="maintenance"$mainchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'348Text'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text size="45" name="maintenancetext" value="$maintenancetext"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'632'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="guestaccess"$guestaccchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'380'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_guestposting" $gpchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'432'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cookielength" size="5" value="$Cookie_Length"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'352'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cookieusername" size="20" value="$cookieusername"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'353'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cookiepassword" size="20" value="$cookiepassword"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'584'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="regagree"$agreechecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'702'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailpassword"$mailpasschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'639'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailnewpass"$newpasschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'619'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="emailwelcome"$welchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
<!-- ANFANG Ausgeblendet fr Serverversion
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'354'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="mailprog" size="20" value="$mailprog"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'407'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="smtp_server" size="20" value="$smtp_server"></td>
  </tr><tr>
ENDE Ausgeblendet fr Serverversion -->
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'355'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="webmaster_email" size="35" value="$webmaster_email"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'404'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="mailtype" size=1>
    <option value="0"$mts1>$txt{'405'}
<!-- ANFANG Ausgeblendet fr Serverversion
    <option value="1"$mts2>$txt{'406'}
    <option value="2"$mts3>Net::SMTP
ENDE Ausgeblendet fr Serverversion -->
    </select></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
<!-- ANFANG Ausgeblendet fr Serverversion
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'356'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="boarddir" size="30" value="$boarddir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'357'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="datadir" size="30" value="$datadir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'358'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="memberdir" size="30" value="$memberdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'359'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="boardsdir" size="30" value="$boardsdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'360'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="sourcedir" size="30" value="$sourcedir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'361'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="vardir" size="30" value="$vardir" readonly></td>
  </tr><tr>
  <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$templs{'1'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="templatesdir" id="templatesdir" size="30" value="$templatesdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'362'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="facesdir" size="30" value="$facesdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'25'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="soundsdir" size="30" value="$soundsdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'26'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="soundsurl" size="45" value="$soundsurl" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'423'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="facesurl" size="45" value="$facesurl" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$smi_txt{'2'}</font><br><font size="1">$smi_txt{'4'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="smiliesdir" size="30" value="$smiliesdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$smi_txt{'3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="smiliesurl" size="45" value="$smiliesurl" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'363'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="imagesdir" size="45" value="$imagesdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'41'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="barsdir" size="30" value="$barsdir" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'42'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="barsurl" size="45" value="$barsurl" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'390'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="faderpath" size="45" value="$faderpath" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'506'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="ubbcjspath" size="45" value="$ubbcjspath" readonly></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'364'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="helpfile" size="45" value="$helpfile" readonly></td>
  </tr><tr>
ENDE Ausgeblendet fr Serverversion -->
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"><b><font size="1">$txt{'784'}</font></b></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'365'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="titlebg" size="10" value="$color{'titlebg'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'366'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="titletext" size="10" value="$color{'titletext'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'367'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="windowbg" size="10" value="$color{'windowbg'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'368'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="windowbg2" size="10" value="$color{'windowbg2'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'640'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="windowbg3" size="10" value="$color{'windowbg3'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'369'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="catbg" size="10" value="$color{'catbg'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'370'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="bordercolor" size="10" value="$color{'bordercolor'}"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'389'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="fadertext" size="10" value="$color{'fadertext'}"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$tsreverse{'1'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="tsreverse" value="1"$tsrchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$cutts{'1'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="cutamount" size="10" value="$cutamount"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'521'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="menutype"$menuchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'522'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="curposlinks"$cpchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'523'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="profilebutton"$pbchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$toppostertxt{'2'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="show_topposter" $topposterchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'382'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showlatestmember" $slmchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'387'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="shownewsfader" $snfchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'388'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="fadertime" size="5" value="$fadertime"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'509'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showrecentbar" $srbarchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'618'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmarkread" $smreadchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'623a'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="ss_advanced"$ssadvchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'732'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showbdescrip" $bdescripchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'383'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmodify" $smodchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'384'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showuserpic" $supicchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'385'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showusertext" $sutextchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'386'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showgenderimage" $sgichecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'740'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showyabbcbutt" $syabbcchecked></td>
  </tr><tr>
  <!-- WHOSON MOD START -->
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$mosttxt{'04'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showonlinebar" $onlbarchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$mosttxt{'05'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showmostusers" $smuchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'101'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showwhoson" $swochecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'102'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><INPUT TYPE=checkbox name="onlopt" $whoon></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'104'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="adminwho" $admindisplay></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$who{'110'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="whotime" size="5" value="$whotime"></td>
  </tr><tr>
  <!-- WHOSON MOD END -->
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'587'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="timeselect" size=1>
    <option value="1"$tsl1>$txt{'480'}
    <option value="5"$tsl5>$txt{'484'}
    <option value="4"$tsl4>$txt{'483'}
    <option value="2"$tsl2>$txt{'481'}
    <option value="3"$tsl3>$txt{'482'}
    <option value="6"$tsl6>$txt{'485'}
    </select>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'371'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeoffset" size="5" value="$timeoffset"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$smi_txt{'5'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="show_smilie_block" value="1"$showblockchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'378'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_ubbc"$ubbcchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'524'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="autolinkurls"$aluchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'379'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_news" $newschecked></td>
  </tr><tr>
<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$mdintxt{'1'}</font><br><font size=-2>$mdintxt{'2'}</font></td> 
<td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mdadmin" value="1"$mdadchecked>&nbsp;<input type=checkbox name="mdglobal" value="1"$mdglchecked>&nbsp;<input type=checkbox name="mdmod" value="1"$mdmochecked></td> 
</tr><tr> 
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'498'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxmesslen" size="5" value="$MaxMessLen"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'28'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="numpolloptions" size="5" value="$numpolloptions"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'61'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpq" size="5" value="$maxpq"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'62'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpo" size="5" value="$maxpo"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'63'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="text" name="maxpc" size="5" value="$maxpc"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'29'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="useraddpoll"$uapchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$polltxt{'60'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="ubbcpolls"$upchecked></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$matxt{'5'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="adminview" size=1>
    <option value="0"$am1>$matxt{'1'}
    <option value="1"$am2>$matxt{'2'}
    <option value="2"$am3>$matxt{'3'}
    <option value="3"$am4>$matxt{'4'}
    </select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$matxt{'6'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="gmodview" size=1>
    <option value="0"$gm1>$matxt{'1'}
    <option value="1"$gm2>$matxt{'2'}
    <option value="2"$gm3>$matxt{'3'}
    <option value="3"$gm4>$matxt{'4'}
    </select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$matxt{'7'}:</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="modview" size=1>
    <option value="0"$m1>$matxt{'1'}
    <option value="1"$m2>$matxt{'2'}
    <option value="2"$m3>$matxt{'3'}
    <option value="3"$m4>$matxt{'4'}
    </select></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'746'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowpics" $allowpicschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'381'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification" $notifchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'723'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allow_hide_email" $ahmchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'689'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxsiglen" size="5" value="$MaxSigLen"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'408'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="timeout" size="5" value="$timeout"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'75'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numposts" size="5" value="$numposts"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'52'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=text name="imspam" size="5" value="$imspam" maxlength="2"></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'43'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_buddies" $enable_buddieschecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'30'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_mailsounds" $senablemailsounds></td>
 </tr><tr>~;
if($soundsdir && opendir(DIR, "$soundsdir")) {
		opendir(DIR, "$soundsdir") || fatal_error("$txt{'230'} ($soundsdir)!<BR>$imtxt{'27'}");
		@contents = readdir(DIR);
		closedir(DIR);
		$sounds = "";
		if ($sound eq "blank.wav" || $sound eq "") { $sounds = qq~<option value="blank.wav"$checked selected>$imtxt{'28'}\n~; }
		else { $sounds = qq~<option value="blank.wav"$checked>$imtxt{'28'}\n~; }
		foreach $line (sort @contents) {
			chomp($line);
			($name, $extension) = split (/\./, $line);
			$checked = "";
			if ($line eq "$sound") { $checked = ' selected'; }
				if($extension =~ /wav/i) {
				$sounds .= qq~<option value="$line"$checked>$name\n~;
				}
			}
$yymain .= qq~
<bgsound id="sound">
<script language="JavaScript1.2" type="text/javascript">
<!--
function playSound() { document.all.sound.src = "$soundsurl/"+document.all.sounds_on.options[document.all.sounds_on.selectedIndex].value; }
//-->
</script>	
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2>$imtxt{'76'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="sounds_on" size="4" onChange="playSound()">$sounds</select>
</td></tr>
~;
} else {
$yymain .= qq~<script language="javascript"> alert("$imtxt{'77'}"); </script>~;
}
$yymain .= qq~
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'05'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_mailpopup" $senablemailpopup></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'44'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="popup_on" $popup_onchecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'06'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" width="50"><input type=checkbox name="enable_imlimit" $senableimlimit></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'03'} $txt{'320'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numobox" size="5" value="$numobox"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'03'} $txt{'316'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numibox" size="5" value="$numibox"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'03'} $imtxt{'46'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="numstore" size="5" value="$numstore"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'33'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="send_welcomeim" $send_welcomeimchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'34'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type "text" name="sendname" size="35" value="$sendname"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'36'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><textarea name="imsubject" cols="35" rows="1">$imsubject</textarea></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$imtxt{'35'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><textarea name="imtext" cols="35" rows="4">$imtext</textarea></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'476'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_width" size="5" value="$userpic_width"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'477'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_height" size="5" value="$userpic_height"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'478'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="userpic_limits" size="45" value="$userpic_limits"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="rul_users_display" size="3" value="$rul_users_display" maxlength="2"></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'15'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="rul_rowspan" size="3" value="$rul_rowspan" maxlength="2"></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'4'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="rul_show_avatars"$rul_show_avatars_checked></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'14'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="rul_show_time"$rul_show_time_checked></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'8'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><select name="rul_avatar_link">
	<option value="0"$rul_avatar_link_selected0>$rul_txt{'9'}</option>
	<option value="1"$rul_avatar_link_selected1>$rul_txt{'10'}</option>
	<option value="2"$rul_avatar_link_selected2>$rul_txt{'11'}</option>
	</select></td>
  </tr><tr>
   <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'7'}</font></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'5'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="rul_avatar_width" size="3" value="$rul_avatar_width" maxlength="3"></td>
  </tr><tr>
   <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$rul_txt{'6'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="rul_avatar_height" size="3" value="$rul_avatar_height" maxlength="3"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amv_txt{'12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showallgroups"$showallgroupschecked></td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/guest.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>MemberGroups Options</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'35'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="oldskool" value="1"$disprealinfochecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod3'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allow_mod" value="1"$gmodchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'40'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="showgmod_info" value="1"$gmodshowstats></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'41'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_news" value="1"$gmodnews></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'39'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_censor" value="1"$gmodshowcensor></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod8'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_edittemp" value="1"$gmodedittemplate></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod9'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_editcat" value="1"$gmodeditcat></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod10'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_ban" value="1"$gmodban></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod11'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_maint" value="1"$gmodmaint></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'gmod12'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="allowgmod_editprof" value="1"$gmodeditprof></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'36'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="hideadmin" value="1"$hideadminchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'37'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="hidegmod" value="1"$hidegmodchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amgtxt{'38'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="hidemod" value="1"$hidemodchecked></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>AMM 1.5</I></b>&nbsp;</font></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'windowbg2'}" height="19">&nbsp;</td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/guest.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>$membtxt{'13'}</b></font></td>
  </tr><tr>
    <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <table width="100%" border="0" cellspacing="0" cellpadding="4" align="left">
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'54'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'45'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'46'}</b></font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'47'}</b></font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'56'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="checkbox" name="view_gendcolm" $sviewgendcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="radio" name="gendcol" value="pic" $sgendpic> <img src="$imagesdir/gender.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type="radio" name="gendcol" value="txt" $sgendtxt> <font size="2">$membtxt{'55'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'01'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mailcolm" $sviewmailcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="pic" $smailpic> <img src="$imagesdir/email.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="mailcol" value="txt" $smailtxt> <font size="2">$membtxt{'48'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'07'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_wwwcolm" $sviewwwwcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="wwwcol" value="pic" $swwwpic> <img src="$imagesdir/www.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="wwwcol" value="txt" $swwwtxt> <font size="2">$membtxt{'49'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'44'}</font></td>

      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_imcolm" $sviewimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="imcol" value="pic" $simpic> <img src="$imagesdir/message.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="imcol" value="txt" $simtxt> <font size="2">$membtxt{'50'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'06'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_icqcolm" $sviewicqcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="icqcol" value="pic" $sicqpic> <img src="$imagesdir/icqflow.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="icqcol" value="txt" $sicqtxt> <font size="2">$membtxt{'51'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'17'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_yimcolm" $sviewyimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="yimcol" value="pic" $syimpic> <img src="$imagesdir/yim.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="yimcol" value="txt" $syimtxt> <font size="2">$membtxt{'52'}</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'18'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_aimcolm" $sviewaimcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="aimcol" value="pic" $saimpic> <img src="$imagesdir/aim.gif" alt="" border="0" align="absmiddle"></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=radio name="aimcol" value="txt" $saimtxt> <font size="2">$membtxt{'53'}</font></td>
    </tr>
    ~;
    if(-e "$sourcedir/Msn.pl") {
    $yymain .= qq~
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'15'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_msncolm" $sviewmsncolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr>
    ~;
    }
    $yymain .= qq~
    <tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'08'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_regdate" $sviewregcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'22'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_numbcolm" $sviewnumbcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'31'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_ipcolm" $sviewipcolm></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'12'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="defaultml" size=1>
    <option value="0"$defml1>$membtxt{'09'}
    <option value="1"$defml2>$membtxt{'10'}
    <option value="2"$defml3>$membtxt{'14'}
    <option value="3"$defml4>$membtxt{'11'}
    </select>
    </td>
  </tr><tr>
    <td colspan="4" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2"><b>$membtxt{'39'}:</b></font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'02'} $membtxt{'02a'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	<input type=radio name="barmaxdepend" value="0" $bmd1> <font size="2">$membtxt{'03'} $membtxt{'05'}</font>
	<input type=radio name="barmaxdepend" value="1" $bmd2><input type=text name="barmaxnumb" size="5" value="$barmaxnumb"> <font size="2">$membtxt{'04'}</font>
    </td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'02'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="maxbar" size=1>
    <option value="$membtxt{'02b'}"$mxbar1>$membtxt{'02b'} $membtxt{'02e'}</option>
    <option value="$membtxt{'02c'}"$mxbar2>$membtxt{'02c'} $membtxt{'02e'}</option>
    <option value="$membtxt{'02d'}"$mxbar3>$membtxt{'02d'} $membtxt{'02e'}</option>
    </select>
    </td>
~;
	opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
	@contents = readdir(DIR);
	closedir(DIR);
	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $stfaultbar) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}
if(-e "$sourcedir/MemberGroups.pl") {
	$yymain .= qq~
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$MemStatNewbie</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	~;
}
else {
	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	chomp @membergroups;
	$yymain .= qq~
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[2]</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
	~;
}
$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar() {
   document.images.icons.src="$barsurl/"+document.modsettings.defbar.options[document.modsettings.defbar.selectedIndex].value+".gif";
}
//-->
</script>
        <select name="defbar" onChange="showbar()">$bars</select>
        <img src="$barsurl/$stfaultbar.gif" name="icons" border=0 hspace=15>
    </td>

~;

	@defaultbar=();

if(-e "$sourcedir/MemberGroups.pl") {

	if (!-e "$vardir/barcolor.dat") {

		fopen(FILE, ">$vardir/barcolor.dat", 1);
		$i = 0;
		while($MemStat[$i]) {
			print FILE "CylBlue\n";
			$i++
		}
		fclose(FILE);
	}

	fopen(FILE, "$vardir/barcolor.dat");
	@defaultbar=<FILE>;
	fclose(FILE);
	chomp(@defaultbar);

	$taller = 0;

	while($MemStat[$taller]) {

		if($MemPostNum[$taller] ne 'x') {

			opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
			@contents = readdir(DIR);
			closedir(DIR);
			$bars = "";
			foreach $line (sort @contents){
				($name, $extension) = split (/\./, $line);
				$checked = "";
				if ($name eq $defaultbar[$taller]) { $checked = ' selected'; }
				if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
			}

			$yymain .= qq~

			<script language="JavaScript1.2" type="text/javascript">
			<!--
			function showbar$taller() {
			   document.images.icons$taller.src="$barsurl/"+document.modsettings.barsel$taller.options[document.modsettings.barsel$taller.selectedIndex].value+".gif";
			}
			//-->
			</script>

		  </tr><tr>
		    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$MemStat[$taller]</font> <font size="1">($MemPostNum[$taller] $membtxt{'40'})</font></td>
		    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		        <select name="barsel$taller" onChange="showbar$taller()">$bars</select>
		        <img src="$barsurl/$defaultbar[$taller].gif" name="icons$taller" border=0 hspace=15>
		    </td>
			~;
		}
		$taller++;
	}
}
else {

	if (!-e "$vardir/barcolor.dat") {

		fopen(FILE, ">$vardir/barcolor.dat", 1);
		for($i=0;$i<4;$i++) {
			print FILE "CylBlue\n";
		}
		fclose(FILE);
	}

	fopen(FILE, "$vardir/barcolor.dat");
	@defaultbar=<FILE>;
	fclose(FILE);
	chomp(@defaultbar);

	opendir(DIR, "$barsdir") || fatal_error("$txt{'230'} ($barsdir)!<BR>$txt{'681'}");
	@contents = readdir(DIR);
	closedir(DIR);

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[0]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar1() {
   document.images.icons1.src="$barsurl/"+document.modsettings.defbar1.options[document.modsettings.defbar1.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[3]</font> <font size="1">($JrPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar1" onChange="showbar1()">$bars</select>
		<img src="$barsurl/$defaultbar[0].gif" name="icons1" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[1]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar2() {
   document.images.icons2.src="$barsurl/"+document.modsettings.defbar2.options[document.modsettings.defbar2.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[4]</font> <font size="1">($FullPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar2" onChange="showbar2()">$bars</select>
		<img src="$barsurl/$defaultbar[1].gif" name="icons2" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[2]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar3() {
   document.images.icons3.src="$barsurl/"+document.modsettings.defbar3.options[document.modsettings.defbar3.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[5]</font> <font size="1">($SrPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar3" onChange="showbar3()">$bars</select>
		<img src="$barsurl/$defaultbar[2].gif" name="icons3" border=0 hspace=15>
    </td>

~;

	$bars = "";
	foreach $line (sort @contents){
		($name, $extension) = split (/\./, $line);
		$checked = "";
		if ($name eq $defaultbar[3]) { $checked = ' selected'; }
		if ($extension =~ /gif/i) { $bars .= qq~<option value="$name"$checked>$name\n~; }
	}

$yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function showbar4() {
   document.images.icons4.src="$barsurl/"+document.modsettings.defbar4.options[document.modsettings.defbar4.selectedIndex].value+".gif";
}
//-->
</script>
	  </tr><tr>
	    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membergroups[6]</font> <font size="1">($GodPostNum $membtxt{'40'})</font></td>
	    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}">
		<select name="defbar4" onChange="showbar4()">$bars</select>
		<img src="$barsurl/$defaultbar[3].gif" name="icons4" border=0 hspace=15>
    </td>

~;

}

$yymain .= qq~
  </tr><tr>
    <td colspan="4" class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'37'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="guest_allow" $sguest_allow></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$membtxt{'38'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_numb" $sviewnumb></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
    </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$budtxt{'11'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_buddylist" $senablebuddy></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">&nbsp;</font></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'373'}</font></td>
    <td colspan="3" class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="MembersPerPage" size="5" value="$MembersPerPage"></td>
    </tr>
    </table></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>$yams_ver</I></b> &nbsp;</font><a href=http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl?board=;action=pgratinglink;editmode=new;itemlink=1050346688 target=_blank><img src="http://www.cd-profil.dk/yabb/yams13ver.gif" border="0" align="absmiddle"><br></a></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'374'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxdisplay" size="5" value="$maxdisplay"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'375'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="maxmessagedisplay" size="5" value="$maxmessagedisplay"></td>
 </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td colspan="2" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><img src="$imagesdir/map.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>$maptxt{'01'}</b></font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'27'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="req_location" $sreq_location></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'23'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_state" $sview_state></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'15'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mapsort_index" $smapsort_index></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'16'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		<input type=radio name="mapsort" value="name" $smapsort_name><font size="2">$maptxt{'17'} &nbsp;</font>
		<input type=radio name="mapsort" value="country" $smapsort_country><font size="2">$maptxt{'18'}</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'13'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mapguest_allow" $smapguest_allow></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'14'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_flag" $sview_flag><font size="2">$maptxt{'28'} </font> <input type=checkbox name="view_text" $sview_text><font size="2">$maptxt{'29'}</font></td>
  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'30'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="view_mapgender" $sview_mapgender></td>

  </tr><tr>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$maptxt{'31'}</font></td>
      <td class="windowbg2" bgcolor="$color{'windowbg2'}">
		<input type=radio name="mappin" value="rpin" $sred_pin> <img src="$imagesdir/rpin.gif" alt="" border="0" align="absmiddle"> &nbsp;
		<input type=radio name="mappin" value="gpin" $sgreen_pin> <img src="$imagesdir/gpin.gif" alt="" border="0" align="absmiddle"> &nbsp;
		<input type=radio name="mappin" value="bpin" $sblue_pin> <img src="$imagesdir/bpin.gif" alt="" border="0" align="absmiddle"></td>
  </tr><tr>
    <td colspan="2" align="right" bgcolor="$color{'titlebg'}" height="19" class="titlebg"><font size="1" color="$color{'titletext'}"><b><I>MemberMap 2.7</I></b> &nbsp;</font><a href=http://www.langaa-net.dk/cgi-bin/kayabb/YaBB.pl?board=;action=pgratinglink;editmode=new;itemlink=1050347017 target=_blank><img src="http://www.cd-profil.dk/yabb/mm13ver.gif" border="0" align="absmiddle"><br></a></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">&nbsp;</td>
 </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'690'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="clicklogtime" size="5" value="$ClickLogTime"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$amv_txt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="OnlineLogTime" size="5" value="$OnlineLogTime"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'376'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="max_log_days_old" size="5" value="$max_log_days_old"></td>
  </tr><tr>
    <td colspan=2 class="windowbg2" bgcolor="$color{'windowbg2'}">
    <HR size=1 width="100%" class="hr"></td>
<!--- Added for Notify Plus 2.2 --->
  </tr><tr>
<!-- ANFANG Ausgeblendet fr Serverversion
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'48'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="imagesurl" size="35" value="$imagesurl"></td>
 </tr><tr>
ENDE Ausgeblendet fr Serverversion -->
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'36'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification_board" $notifyboardchecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'37'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_mark_board" $markboardchecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'38'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_mark_thread" $markthreadchecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'13'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_notification_guest" $notifyguestchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'18'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="enable_mailinglist" $mailinglistchecked></td>
 </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'50'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
~;
	# Autosend Mailinglist 
	if ($autosend eq "Mailinglist") {
		$yymain .= qq~ 
	<input type="radio" name="autosend" value="Mailinglist" checked><font size="2">&nbsp;$notify_txt{'51'}</font>
	<input type="radio" name="autosend" value="EmailReminder"><font size="2">&nbsp;$notify_txt{'52'}</font>
~;
	}
	# Autosend Email Reminder
	else {
		$yymain .= qq~ 
	<input type="radio" name="autosend" value="Mailinglist"><font size="2">&nbsp;$notify_txt{'51'}</font>
	<input type="radio" name="autosend" value="EmailReminder" checked><font size="2">&nbsp;$notify_txt{'52'}</font>
~;



	}

	$yymain .= qq~
</tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'53'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
~;

	# Autosend Frequency: Never
	if ($autosend_frequency eq "Never") {
		$yymain .= qq~ 
	<input type="radio" name="autosend_frequency" value="Never" checked><font size="2">&nbsp;$notify_txt{'54'}</font>
	<input type="radio" name="autosend_frequency" value="Daily"><font size="2">&nbsp;$notify_txt{'55'}</font>
	<input type="radio" name="autosend_frequency" value="Weekly"><font size="2">&nbsp;$notify_txt{'56'}</font>
	<input type="radio" name="autosend_frequency" value="Monthly"><font size="2">&nbsp;$notify_txt{'61'}</font>
~;
	}

	# Autosend Frequency: Daily
	elsif ($autosend_frequency eq "Daily") {
		$yymain .= qq~ 
	<input type="radio" name="autosend_frequency" value="Never"><font size="2">&nbsp;$notify_txt{'54'}</font>
	<input type="radio" name="autosend_frequency" value="Daily" checked><font size="2">&nbsp;$notify_txt{'55'}</font>
	<input type="radio" name="autosend_frequency" value="Weekly"><font size="2">&nbsp;$notify_txt{'56'}</font>
	<input type="radio" name="autosend_frequency" value="Monthly"><font size="2">&nbsp;$notify_txt{'61'}</font>
~;
	}

	# Autosend Frequency: Weekly
	elsif ($autosend_frequency eq "Weekly") {
		$yymain .= qq~ 
	<input type="radio" name="autosend_frequency" value="Never"><font size="2">&nbsp;$notify_txt{'54'}</font>
	<input type="radio" name="autosend_frequency" value="Daily"><font size="2">&nbsp;$notify_txt{'55'}</font>
	<input type="radio" name="autosend_frequency" value="Weekly" checked><font size="2">&nbsp;$notify_txt{'56'}</font>
	<input type="radio" name="autosend_frequency" value="Monthly"><font size="2">&nbsp;$notify_txt{'61'}</font>
~;
	}

	# Autosend Frequency: Weekly
	elsif ($autosend_frequency eq "Monthly") {
		$yymain .= qq~ 
	<input type="radio" name="autosend_frequency" value="Never"><font size="2">&nbsp;$notify_txt{'54'}</font>
	<input type="radio" name="autosend_frequency" value="Daily"><font size="2">&nbsp;$notify_txt{'55'}</font>
	<input type="radio" name="autosend_frequency" value="Weekly"><font size="2">&nbsp;$notify_txt{'56'}</font>
	<input type="radio" name="autosend_frequency" value="Monthly checked"><font size="2">&nbsp;$notify_txt{'61'}</font>
~;
	}

	$yymain .= qq~




  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$notify_txt{'57'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="email_reminder_address" size="35" value="$email_reminder_address"></td>
 </tr><tr>
    <td colspan="2" class="windowbg2" bgcolor="$color{'windowbg2'}"><hr size=1 width="100%" color="$color{'windowbg3'}" class="windowbg3"></td>

<!--- /Added for Notify Plus 2.2 --->

  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'392'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_EX" size="5" value="$LOCK_EX"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'393'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_UN" size="5" value="$LOCK_UN"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'607'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="LOCK_SH" size="5" value="$LOCK_SH"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'391'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
    <select name="use_flock" size=1>
    <option value="0"$fls1>$txt{'401'}
    <option value="1"$fls2>$txt{'402'}
    <option value="2"$fls3>$txt{'403'}
    </select></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'615'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="usetempfile"$utfchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$txt{'630'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="faketruncation"$truncchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center" valign="middle">
    <BR><input type=submit value="$txt{'10'}">
    </td>
  </tr>
</table>
</td>
</tr>
</table>
</form>
~;
	$yytitle = $txt{'222'};
	&template;
	exit;
}

sub GetBoardURL {
	my $url = 'http://' . ($ENV{'HTTP_HOST'} ? $ENV{'HTTP_HOST'} : $ENV{'SERVER_NAME'}) .
	($ENV{'SERVER_PORT'} != 80 ? ":$ENV{'SERVER_PORT'}" : '') .
	$ENV{'SCRIPT_NAME'};
	$url =~ s~/[^/]+\Z~/~;
	return $url;
}

# Gets our current absolute path. Needed for error messages.
sub GetDirPath {
	eval 'use Cwd; $cwd = cwd();';
	unless( $cwd ) { $cwd = `pwd`; chomp $cwd; }
	unless($cwd) { $cwd = $0 || $ENV{'PWD'} || $ENV{'CWD'} || ( $ENV{'DOCUMENT_ROOT'} . '/' . $ENV{'SCRIPT_NAME'} || $ENV{'PATH_INFO'} ); }
	$cwd =~ tr~\\~/~;
	$cwd =~ s~\A(.+)/\Z~$1~;
	$cwd =~ s~\A(.+)/YaBB\.\w+\Z~$1~i;
	return $cwd;
}

sub is_exe {
    my ($cmd,$name);
    foreach $cmd (@_) {
	$name = ($cmd =~ /^(\S+)/)[0];	# remove any options
	return ($cmd) if (-x $name and ! -d $name and $name =~ m:/:);	# check for absolute or relative path
	if (defined $ENV{PATH}) {
	    my $dir;
	    foreach $dir (split(/:/, $ENV{PATH})) {
		return "$dir/$cmd" if (-x "$dir/$name" && ! -d "$dir/$name");
	    }
	}
    }
    0;
}

sub ModifySettings2 {
	&is_admin;
# Hotfix empty Form
if ( $FORM{'boardurl'} eq "" ) { &fatal_error($rul_txt{'17'}) };

	my @onoff = qw/
		allowpics showyabbcbutt showbdescrip maintenance guestaccess insert_original enable_ubbc enable_news enable_guestposting enable_notification showlatestmember showrecentbar showmarkread showmodify showuserpic showusertext showgenderimage shownewsfader MenuType curposlinks profilebutton autolinkurls emailpassword RegAgree emailwelcome allow_hide_email usetempfile faketruncation emailnewpass/;
     push(@onoff, "tsreverse");
# --- Added for Notify Plus 2.2 --- #
	push(@onoff, "enable_notification_board");
	push(@onoff, "enable_mark_board");
	push(@onoff, "enable_mark_thread");
	push(@onoff, "enable_notification_guest");
	push(@onoff, "enable_mailinglist");
# --- /Added for Notify Plus 2.2 --- #

     push(@onoff, "mdadmin", "mdglobal", "mdmod");
	push(@onoff, "useraddpoll", "ubbcpolls", "pollcomments");

	push(@onoff, "rul_show_avatars");
	push(@onoff, "rul_show_time");

	push(@onoff, "enable_mailsounds", "enable_mailpopup", "enable_imlimit", "numibox", "numobox", "send_welcomeim", "enable_buddies", "enable_rim", "numposts", "popup_on");
	## WHOSON MOD START ##
	push(@onoff, "showonlinebar", "showmostusers", "showwhoson", "onlopt", "adminwho");
	## WHOSON MOD END ##
	push(@onoff, "view_state", "mapsort_index", "mapsort", "mapguest_allow", "view_flag", "view_text", "req_location", "view_mapgender", "rpin", "gpin", "bpin");
	push(@onoff, "view_mailcolm", "view_wwwcolm", "view_imcolm", "view_icqcolm", "view_yimcolm", "view_aimcolm", "view_msncolm", "view_regdate", "barmaxdepend", "defaultml");
	push(@onoff, "view_numbcolm", "view_ipcolm", "guest_allow", "view_numb", "defbar", "mailcol", "wwwcol", "imcol", "icqcol", "yimcol", "aimcol");
	push(@onoff, "view_gendcolm", "gendcol", "barmaxnumb", "maxbar", "enable_buddylist");
	push(@onoff, "show_topposter" );
	# Set as 0 or 1 if box was checked or not
	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;
	$guestaccess = $guestaccess ? 0 : 1;
	$ss_advanced = $FORM{'ss_advanced'} ? 1 : 0;
fopen( FILE, ">$vardir/barcolor.dat", 1);
if(-e "$sourcedir/MemberGroups.pl") {
	$taller = 0;
	while($MemStat[$taller]) {
		if($MemPostNum[$taller] ne 'x') {
			$defaultbar[$taller] = $FORM{"barsel$taller"} || 'CylBlue';
			print FILE "$defaultbar[$taller]\n";
		}
		else { print FILE "CylBlue\n"; }
		$taller++
	}
}
else {
	$defaultbar[0] = $FORM{"defbar1"} || 'CylBlue';
	$defaultbar[1] = $FORM{"defbar2"} || 'CylBlue';
	$defaultbar[2] = $FORM{"defbar3"} || 'CylBlue';
	$defaultbar[3] = $FORM{"defbar4"} || 'CylBlue';
	print FILE "$defaultbar[0]\n";
	print FILE "$defaultbar[1]\n";
	print FILE "$defaultbar[2]\n";
	print FILE "$defaultbar[3]\n";
}
fclose(FILE);

	# If empty fields are submitted, set them to default-values to save yabb from crashing
	$show_topposter = $FORM{'show_topposter'} || 0;
	#recent users list settings
	$kategorie = $FORM{'kategorie'} || Internet;
	$rul_avatar_link = $FORM{'rul_avatar_link'} || 0;
	$rul_avatar_width = $FORM{'rul_avatar_width'} || 0;
	$rul_avatar_height = $FORM{'rul_avatar_height'} || 0;
	$rul_rowspan = $FORM{'rul_rowspan'} || 6;
	$rul_users_display = $FORM{'rul_users_display'} || 5;
	if ($rul_users_display > 99) { $rul_users_display = 99; }
	if ($rul_users_display =~ /\D/) { &fatal_error($rul_txt{'16'}); }
	if ($rul_rowspan =~ /\D/) { &fatal_error($rul_txt{'16'}); }
	if ($rul_avatar_width =~ /\D/) { &fatal_error($rul_txt{'16'}); }
	if ($rul_avatar_height =~ /\D/) { &fatal_error($rul_txt{'16'}); }
	$maintenancetext = $FORM{'maintenancetext'} || "";
	&ToHTML($maintenancetext);
	## WHOSON MOD START ##
	$whotime = $FORM{'whotime'} || 30;
	## WHOSON MOD END ##
	$allow_mod = $FORM{'allow_mod'} || 0;
	$disprealinfo = $FORM{'oldskool'} || 0;
	$hideadmin = $FORM{'hideadmin'} || 0;
	$hidegmod = $FORM{'hidegmod'} || 0;
	$hidemod = $FORM{'hidemod'} || 0;
	$showgmod_info = $FORM{'showgmod_info'} || 0;
	$allowgmod_censor = $FORM{'allowgmod_censor'} || 0;
	$allowgmod_edittemp = $FORM{'allowgmod_edittemp'} || 0;
	$allowgmod_editcat = $FORM{'allowgmod_editcat'} || 0;
	$allowgmod_ban = $FORM{'allowgmod_ban'} || 0;
	$allowgmod_news = $FORM{'allowgmod_news'} || 0;
	$allowgmod_maint = $FORM{'allowgmod_maint'} || 0;
	$allowgmod_editprof = $FORM{'allowgmod_editprof'} || 0;
	$mdadmin = $FORM{'mdadmin'} || 0;
	$mdglobal = $FORM{'mdglobal'} || 0;
	$mdmod = $FORM{'mdmod'} || 0;
	$FORM{'timeout'} =~ s/\D//g;
	$timeout = $FORM{'timeout'} || 5;
	$FORM{'fadertime'} =~ s/\D//g;
	$fadertime = $FORM{'fadertime'} || 5000;
	$FORM{'timeselect'} =~ s/\D//g;
	$timeselected = $FORM{'timeselect'} || 0;
	$gendcol = $FORM{'gendcol'} || 'pic';
	$mailcol = $FORM{'mailcol'} || 'pic';
	$wwwcol = $FORM{'wwwcol'} || 'pic';
	$imcol = $FORM{'imcol'} || 'pic';
	$icqcol = $FORM{'icqcol'} || 'pic';
	$yimcol = $FORM{'yimcol'} || 'pic';
	$aimcol = $FORM{'aimcol'} || 'pic';
	$barmaxdepend = $FORM{'barmaxdepend'} || 0;
	if ($FORM{'maxbar'} =~ /\d+/)  { $maxbar  = $FORM{'maxbar'};  } else { $maxbar = 100; }
	if ($FORM{'barmaxnumb'} =~ /\d+/)  { $barmaxnumb  = $FORM{'barmaxnumb'};  } else { $barmaxnumb = 500; }
	$defaultml = $FORM{'defaultml'} || 0;
	$stfaultbar = $FORM{'defbar'} || 'CylBlue';
	$mapsort = $FORM{'mapsort'} || 'name';
	$mappin = $FORM{'mappin'} || 'rpin';
	$FORM{'timeoffset'} =~ tr/,/./;
	$FORM{'timeoffset'} =~ s/[^\d\.\-]//g;
	$timeoffset = $FORM{'timeoffset'} || 0;
	$FORM{'TopAmmount'} =~ s/\D//g;
	$TopAmmount = $FORM{'TopAmmount'} || 25;
	$FORM{'MembersPerPage'} =~ s/\D//g;
	$MembersPerPage = $FORM{'MembersPerPage'} || 20;
	$FORM{'maxdisplay'} =~ s/\D//g;
	$maxdisplay = $FORM{'maxdisplay'} || 20;
	$FORM{'maxmessagedisplay'} =~ s/\D//g;
	$maxmessagedisplay = $FORM{'maxmessagedisplay'} || 20;
	$FORM{'max_log_days_old'} =~ s/\D//g;
	$max_log_days_old = $FORM{'max_log_days_old'} || 21;
	$FORM{'clicklogtime'} =~ s/\D//g;
	$clicklogtime = $FORM{'clicklogtime'} || 1440;
	if($clicklogtime >= 1440) { $clicklogtime = 1439; }
	$OnlineLogTime = $FORM{'OnlineLogTime'} || 15;
	if($OnlineLogTime >= 1440) { $OnlineLogTime = 1439; }
	$FORM{'use_flock'} =~ s/\D//g;
	$use_flock = $FORM{'use_flock'} || 0;
	$adminview = $FORM{'adminview'} || 0;
	$gmodview = $FORM{'gmodview'} || 0;
	$modview = $FORM{'modview'} || 0;
	$FORM{'LOCK_EX'} =~ s/\D//g;
	$LOCK_EX = $FORM{'LOCK_EX'} || 2;
	$FORM{'LOCK_UN'} =~ s/\D//g;
	$LOCK_UN = $FORM{'LOCK_UN'} || 8;
	$FORM{'LOCK_SH'} =~ s/\D//g;
	$LOCK_SH = $FORM{'LOCK_SH'} || 1;
	$FORM{'cookielength'} =~ s/\D//g;
	$Cookie_Length = $FORM{'cookielength'} || 60;
	$FORM{'cookieusername'} =~ s/\W//g;
	$cookieusername = $FORM{'cookieusername'} || 'YaBBusername';
	$FORM{'cookiepassword'} =~ s/\W//g;
	$cookiepassword = $FORM{'cookiepassword'} || 'YaBBpassword';
	if ($cookieusername eq $cookiepassword) {$cookieusername = 'YaBBusername'; $cookiepassword = 'YaBBpassword';}
	$FORM{'maxmesslen'} =~ s/\D//g;
	$maxmesslen = $FORM{'maxmesslen'} || 5000;
	$numpolloptions = $FORM{'numpolloptions'} || 8;
	$maxpq = $FORM{'maxpq'} || 60;
	$maxpo = $FORM{'maxpo'} || 50;
	$maxpc = $FORM{'maxpc'} || 0;
	$FORM{'maxsiglen'} =~ s/\D//g;
	$maxsiglen = $FORM{'maxsiglen'} || 200;
	$language = $FORM{'language'} || 'english.lng';
	if($language =~ /[^\w\-\.]/) {$language = 'english.lng';}
	$defaulttemplate = $FORM{'defaulttemplate'} || 'default.html';
	$showallgroups = $FORM{'showallgroups'} ? 1 : 0;
	$mbname = $FORM{'mbname'} || 'My YaBB 1 Gold - SP1';
	$mbname =~ s/\"/\'/g;
	$mbname =~ s/\^//g;
	$boardurl = $FORM{'boardurl'} || &GetBoardURL;
	$boardurl =~ s/\"/\'/g;
	$boarddir = $FORM{'boarddir'} || &GetDirPath;
	$boardsdir = $FORM{'boardsdir'} || "$boarddir/Boards";
	$boardsdir =~ s/\"/\'/g;
	$datadir = $FORM{'datadir'} || "$boarddir/Messages";
	$datadir =~ s/\"/\'/g;
	$memberdir = $FORM{'memberdir'} || "$boarddir/Members";
	$memberdir =~ s/\"/\'/g;
	$sourcedir = $FORM{'sourcedir'} || "$boarddir/Sources";
	$sourcedir =~ s/\"/\'/g;
	$vardir = $FORM{'vardir'} || "$boarddir/Variables";
	$vardir =~ s/\"/\'/g;
	$templatesdir = $FORM{'templatesdir'} || "$boarddir/Templates";
	$facesdir = $FORM{'facesdir'} || "$boarddir/YaBBImages/avatars";
	$facesdir =~ s/\"/\'/g;
	$facesurl = $FORM{'facesurl'} || "$boardurl/YaBBImages/avatars";
	$facesurl =~ s/\"/\'/g;
	$soundsdir = $FORM{'soundsdir'} || "$boarddir/sounds";
	$soundsurl = $FORM{'soundsurl'} || "$boardurl/sounds";
	$numposts = $FORM{'numposts'} || 0;
	$sounds_on = $FORM{'sounds_on'} || "blank.wav";
	$numibox = $FORM{'numibox'} || 20;
	$numobox = $FORM{'numobox'} || 20;
	$numstore = $FORM{'numstore'} || 20;
	$sendname = $FORM{'sendname'} || admin;
	$imspam = $FORM{'imspam'} || off;
	$FORM{'imtext'} =~ s~\n~\&\&~g;
	$imtext = $FORM{'imtext'} || "Welcome in our community";
		$imtext =~ s~\A\s+~~;
		$imtext =~ s~\s+\Z~~;
		$imtext =~ s~[\n\r]~~g;
		$imtext =~ s~"~\\"~g;
		$imtext =~ s~@~\\@~g;
	$imsubject = $FORM{'imsubject'} || "Welcome to $mbname";
		$imsubject =~ s~"~\\"~g;
		$imsubject =~ s~[\n\r]~~g;
		$imsubject =~ s~\<BR\>~~gi;
		$imsubject =~ s~\A\s+~~;
		$imsubject =~ s~\s+\Z~~;
	$smiliesdir = $FORM{'smiliesdir'} || "";
	$smiliesurl = $FORM{'smiliesurl'} || "$boardurl/YaBBImages/smilies";
	$show_smilie_block = $FORM{'show_smilie_block'} || 0;
	$imagesdir = $FORM{'imagesdir'} || "$boardurl/YaBBImages";
	$imagesdir =~ s/\"/\'/g;
# --- Added for Notify Plus 2.2 --- #
	$imagesurl = $FORM{'imagesurl'} || "$boarddir/YaBBImages";
	$autosend = $FORM{'autosend'};
	$autosend_frequency = $FORM{'autosend_frequency'};
	$email_reminder_address = $FORM{'email_reminder_address'};
# --- /Added for Notify Plus 2.2 --- #

	$barsdir = $FORM{'barsdir'} || "../../YaMSbars";
	$barsurl = $FORM{'barsurl'} || "$boardurl/YaMSbars";
	$helpfile = $FORM{'helpfile'} || "$boardurl/YaBBHelp/$help_xtc{'1'}/index.html";
	$helpfile =~ s/\"/\'/g;
	$mailprog = $FORM{'mailprog'} || &is_exe('/usr/lib/sendmail','/usr/sbin/sendmail','/usr/ucblib/sendmail','sendmail','mailx','Mail','mail');
	$mailprog =~ s/\"/\'/g;
	$smtp_server = $FORM{'smtp_server'} || '127.0.0.1';
	$webmaster_email = $FORM{'webmaster_email'} || 'webmaster@mysite.com';
	$webmaster_email =~ s/\^//g;
	$webmaster_email =~ s/\"/\'/g;
	$FORM{'mailtype'} =~ s/\D//g;
	$mailtype = $FORM{'mailtype'} || 0;
	$color{'titlebg'} = $FORM{'titlebg'} || '#6E94B7';
	$color{'titlebg'} =~ s/\"/\'/g;
	$color{'titletext'} = $FORM{'titletext'} || '#FFFFFF';
	$color{'titletext'} =~ s/\"/\'/g;
	$color{'windowbg'} = $FORM{'windowbg'} || '#AFC6DB';
	$color{'windowbg'} =~ s/\"/\'/g;
	$color{'windowbg2'} = $FORM{'windowbg2'} || '#F8F8F8';
	$color{'windowbg2'} =~ s/\"/\'/g;
	$color{'windowbg3'} = $FORM{'windowbg3'} || '#6394BD';
	$color{'windowbg3'} =~ s/\"/\'/g;
	$color{'catbg'} = $FORM{'catbg'} || '#DEE7EF';
	$color{'catbg'} =~ s/\"/\'/g;
	$color{'bordercolor'} = $FORM{'bordercolor'} || '#6394BD';
	$color{'bordercolor'} =~ s/\"/\'/g;
	$color{'fadertext'} = $FORM{'fadertext'} || '#D4AD00';
	$color{'fadertext'} =~ s/\"/\'/g;
	$tsreverse = $FORM{'tsreverse'} || 0;
	$cutamount = $FORM{'cutamount'} || '10';
	$faderpath = $FORM{'faderpath'} || "$boardurl/fader.js";
	$faderpath =~ s/\"/\'/g;
	$ubbcjspath = $FORM{'ubbcjspath'} || "$boardurl/ubbc.js";
	$ubbcjspath =~ s/\"/\'/g;
	if ($FORM{'userpic_width'} =~ /^\d+$/)  { $userpic_width  = $FORM{'userpic_width'};  }
	else { $userpic_width = 65; }
	if ($FORM{'userpic_height'} =~ /^\d+$/) {	$userpic_height = $FORM{'userpic_height'}; }
	else { $userpic_height = 65; }
	$userpic_limits = $FORM{'userpic_limits'} || 'Please note that your image has to be <b>gif</b> or <b>jpg</b> and that it will be resized!';
	$userpic_limits =~ s/\~//g;
	$userpic_limits =~ s/\"/\'/g;
	$userpic_limits =~ s/\"/\'/g;

	my $filler = q~                                                                               ~;
	my $setfile = << "EOF";
###############################################################################
# Settings.pl                                                                 #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.3.2                                      #
# Released:       December 2001; Updated August 17, 2004                      #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

########## Board Info ##########
# Note: these settings must be properly changed for YaBB to work
\$kategorie = "$kategorie";

\$maintenance = $maintenance;				# Set to 1 to enable Maintenance mode
\$guestaccess = $guestaccess;				# Set to 0 to disallow guests from doing anything but login or register

\$language = "$language";				# Change to language pack you wish to use
\$defaulttemplate = "$defaulttemplate";			# Change to Template you wish to use
\$mbname = q^$mbname^;					# The name of your YaBB forum
\$boardurl = "$boardurl";				# URL of your board's folder (without trailing '/')

\$Cookie_Length = $Cookie_Length;			# Default minutes to set login cookies to stay for
\$cookieusername = "$cookieusername";			# Name of the username cookie
\$cookiepassword = "$cookiepassword";			# Name of the password cookie

\$RegAgree = $RegAgree;					# Set to 1 to display the registration agreement when registering
\$emailpassword = $emailpassword;			# 0 - instant registration. 1 - password emailed to new members
\$emailnewpass = $emailnewpass;				# Set to 1 to email a new password to members if they change their email address
\$emailwelcome = $emailwelcome;				# Set to 1 to email a welcome message to users even when you have mail password turned off

\$mailprog = "$mailprog";				# Location of your sendmail program
\$smtp_server = "$smtp_server";				# Address of your SMTP-Server
\$webmaster_email = q^$webmaster_email^;		# Your email address. (eg: \$webmaster_email = q^admin\@host.com^;)
\$mailtype = $mailtype;					# Mail program to use: 0 = sendmail, 1 = SMTP, 2 = Net::SMTP


########## Directories/Files ##########
# Note: directories other than \$imagesdir do not have to be changed unless you move things

\$boarddir = "$boarddir"; 				# The server path to the board's folder (usually can be left as '.')
\$boardsdir = "$boardsdir";         			# Directory with board data files
\$datadir = "$datadir";         			# Directory with messages
\$memberdir = "$memberdir";        			# Directory with member files
\$sourcedir = "$sourcedir";        			# Directory with YaBB source files
\$vardir = "$vardir";         				# Directory with variable files
\$templatesdir = "$templatesdir";			# Directory with template files.
\$facesdir = "$facesdir";				# The server path to your avatars (userpics) folder
\$facesurl = "$facesurl";				# URL to your avatars folder
\$soundsdir = "$soundsdir";				# Absolute Path to your sounds folder
\$soundsurl = "$soundsurl";				# URL to your sounds folder

\$smiliesdir = "$smiliesdir";				# The server path to your smilies folder
\$smiliesurl = "$smiliesurl";				# URL to your smilies folder
\$imagesdir = "$imagesdir";				# URL to your images folder
\$barsdir = "$barsdir";					# Absolute Path to your YaMS bars folder
\$barsurl = "$barsurl";					# URL to your YaMS bars folder
\$ubbcjspath = "$ubbcjspath";	                        # URL to your 'ubbc.js' (REQUIRED for post/modify to work properly)
\$faderpath = "$faderpath";				# URL to your 'fader.js'
\$helpfile = "$helpfile";				# URL to your help file


########## Colors ##########
# Note: equivalent to colors in CSS tag of template.html, so set to same colors preferrably
# for browsers without CSS compatibility and for some items that don't use the CSS tag

\$color{'titlebg'} = "$color{'titlebg'}";		# Background color of the 'title-bar'
\$color{'titletext'} = "$color{'titletext'}";		# Color of text in the 'title-bar' (above each 'window')
\$color{'windowbg'} = "$color{'windowbg'}";		# Background color for messages/forms etc.
\$color{'windowbg2'} = "$color{'windowbg2'}";		# Background color for messages/forms etc.
\$color{'windowbg3'} = "$color{'windowbg3'}";		# Color of horizontal rules in posts
\$color{'catbg'} = "$color{'catbg'}";			# Background color for category (at Board Index)
\$color{'bordercolor'} = "$color{'bordercolor'}";	# Table Border color for some tables
\$color{'fadertext'}  = "$color{'fadertext'}";		# Color of text in the NewsFader (news color)
\$cutamount  = "$FORM{'cutamount'}";
\$tsreverse = $tsreverse;

########## Layout ##########

\$maintenancetext = "$maintenancetext";			# User-defined text for Maintenance mode (leave blank for default text)
\$MenuType = $MenuType;					# 1 for text menu or anything else for images menu
\$curposlinks = $curposlinks;				# 1 for links in navigation on current page, or 0 for text without link
\$profilebutton = $profilebutton;			# 1 to show view profile button under post, or 0 for blank
\$timeselected = $timeselected;				# Select your preferred output Format of Time and Date
\$allow_hide_email = $allow_hide_email;			# Allow users to hide their email from public. Set 0 to disable
\$view_gendcolm = $view_gendcolm;				# Set to 0 to hide Gender column in Memberlist
\$view_mailcolm = $view_mailcolm;	     			# Set to 0 to hide e-mail column in Memberlist
\$view_wwwcolm = $view_wwwcolm;	     			# Set to 0 to hide WWW column in Memberlist
\$view_imcolm = $view_imcolm;	   	  			# Set to 0 to hide IM column in Memberlist
\$view_icqcolm = $view_icqcolm;	     			# Set to 0 to hide ICQ column in Memberlist
\$view_yimcolm = $view_yimcolm;	     			# Set to 0 to hide YIM column in Memberlist
\$view_aimcolm = $view_aimcolm;	     			# Set to 0 to hide AIM column in Memberlist
\$gendcol = $gendcol;						# Set to txt for text in Gender column
\$mailcol = $mailcol;						# Set to txt for text in e-mail column
\$wwwcol = $wwwcol;						# Set to txt for text in WWW column
\$imcol = $imcol;							# Set to txt for text in IM column
\$icqcol = $icqcol;						# Set to txt for text in ICQ column
\$yimcol = $yimcol;						# Set to txt for text in YIM column
\$aimcol = $aimcol;						# Set to txt for text in AIM column
if(-e "$sourcedir/Msn.pl") {
	\$view_msncolm = $view_msncolm;	     		# Set to 0 to hide MSN column in Memberlist
}
\$view_regdate = $view_regdate;	     			# Set to 0 to hide registration-date column in Memberlist
\$view_numbcolm = $view_numbcolm;	     			# Set to 0 to hide member number column in Memberlist
\$view_ipcolm = $view_ipcolm;	     				# Set to 0 to hide IP number column in Memberlist
\$guest_allow = $guest_allow;	     				# Set to 0 to disallow guests to view Memberlist
\$view_numb = $view_numb;		     			# Set to 0 to hide member number in posts and profile
\$barmaxdepend = $barmaxdepend;				# Set to 0 to let bar-max-length depend on top poster or 1 to depend on a number of your choise
\$barmaxnumb = $barmaxnumb;					# Select number of post for max. bar-length in memberlist
\$maxbar = $maxbar;
\$defaultml = $defaultml;					# Select default sort-column
\$stfaultbar = "$stfaultbar";					# Select Standard Bar-color in memberlist
\$enable_buddylist = $enable_buddylist;  			# Set to 0 to disable buddylist
\$req_location = $req_location;	     			# Set to 1 to require location on registration
\$view_state = $view_state;		     			# Set to 0 to disallow State/Region selection in Member Map
\$mapsort_index = $mapsort_index;	     			# Set to 0 to hide index-headers in name-list in Member Map
\$mapsort = "$mapsort";			     			# Set to country or name to sort name-list in Member Map by Country or Name
\$mapguest_allow = $mapguest_allow;	     			# Set to 0 to disallow guests to view Member Map
\$view_flag = $view_flag;		     			# Set to 0 to hide flags in Posts and Profile
\$view_text = $view_text;		     			# Set to 0 to hide location in Posts and Profile
\$view_mapgender = $view_mapgender;	     			# Set to 0 to hide location in Posts and Profile
\$mappin = $mappin;			     			# Set to rpin for red pins, gpin for green pins or bpin for blue pins on Member Map
\$showlatestmember = $showlatestmember;			# Set to 1 to display "Welcome Newest Member" on the Board Index
\$show_topposter = $show_topposter;			# Set 1 to display "Topposter" on the Info Center
\$shownewsfader = $shownewsfader;			# 1 to allow or 0 to disallow NewsFader javascript on the Board Index
							# If 0, you'll have no news at all unless you put <yabb news> tag
							# back into template.html!!!
\$Show_RecentBar = $showrecentbar;			# Set to 1 to display the Recent Post on Board Index
## WHOSON MOD START ##
\$Show_OnlineBar = $showonlinebar;			# Set to 1 to display the Who's Online List table row on Board Index
\$Show_MostUsers = $showmostusers;			# Set to 1 to display the Line with Most Users Online in the Who's Online List
\$Show_WhosOn = $showwhoson;				# Set to 1 to add the text Who's Online to your YaBB menu
\$onlopt = $onlopt;					# Set to 1 to enable Online Overview for all
\$adminwho = $adminwho;					# Set to 1 to enable the actions display in the Online Overview
\$whotime = $whotime;					# Number of Seconds to refresh the Online table
## WHOSON MOD END ##
\$showmarkread = $showmarkread;				# Set to 1 to display and enable the mark as read buttons
\$ss_advanced = $ss_advanced;				# Set to 1 if you want to use the advanced split/splice function
\$showmodify = $showmodify;				# Set to 1 to display "Last modified: Realname - Date" under each message
\$ShowBDescrip = $showbdescrip;				# Set to 1 to display board descriptions on the topic (message) index for each board
\$showuserpic = $showuserpic;				# Set to 1 to display each member's picture in the message view (by the ICQ.. etc.)
\$showusertext = $showusertext;				# Set to 1 to display each member's personal text in the message view (by the ICQ.. etc.)
\$showgenderimage = $showgenderimage;			# Set to 1 to display each member's gender in the message view (by the ICQ.. etc.)
\$showyabbcbutt = $showyabbcbutt;                       # Set to 1 to display the yabbc buttons on Posting and IM Send Pages
\$enable_buddies = $enable_buddies;			# Set to 1 to enable the BuddyList for users
\$enable_mailsounds = $enable_mailsounds;		# Set to 1 to enable info-sounds on new private messages
\$sound = \"$sounds_on\";				# Set to 1 to enable Sound as default for new regged users
\$enable_mailpopup = $enable_mailpopup;			# Set to 1 to enable info-popup on new private messages
\$popup_on = $popup_on;					# Set to 1 to enable Popups as default for new regged users
\$enable_imlimit = $enable_imlimit;			# Set to 1 to enable limitation of incoming and outgoing im messages

########## Automated IM Settings ##########

\$imtext = qq~$imtext~;
\$sendname = "$sendname";
\$imsubject = "$imsubject";
\$send_welcomeim = $send_welcomeim;

######## AMM Feature Settings ########

\$disprealinfo = $disprealinfo;				# Set to 1 to use YaBBs original MemberGroup display in posts
\$hideadmin = $hideadmin;				# Set to 1 to disable showing Admin Status in Posts and IMs
\$hidegmod = $hidegmod;					# Set to 1 to disable showing Global Mod Status in Posts and IMs
\$hidemod = $hidemod;					# Set to 1 to disable showing Moderato Status in Posts
\$allow_mod = $allow_mod;  				# Set to 1 to activate a "Global Moderators - Center"
\$allowgmod_news = $allowgmod_news;			# Set to 1 to let Global Moderators edit the news
\$showgmod_info = $showgmod_info;	  		# Set to 1 to let Global Moderators see board statistics
\$allowgmod_censor = $allowgmod_censor;  		# Set to 1 to let Global Moderators edit censored words
\$allowgmod_edittemp = $allowgmod_edittemp;  		# Set to 1 to let Global Moderators edit the forum template
\$allowgmod_editcat = $allowgmod_editcat;  		# Set to 1 to let Global Moderators edit the forum boards and categories
\$allowgmod_ban = $allowgmod_ban;  			# Set to 1 to let Global Moderators edit the ban list
\$allowgmod_maint = $allowgmod_maint;  			# Set to 1 to let Global Moderators perform routine forum maintenance
\$allowgmod_editprof = $allowgmod_editprof;		# Set to 1 to let Global Moderators edit non-security related profile items
########## Feature Settings ##########

\$mdadmin = $mdadmin;
\$mdglobal = $mdglobal;
\$mdmod = $mdmod;
\$show_smilie_block = $show_smilie_block;		# Set to 1 if you want to display the smiley block
\$enable_ubbc = $enable_ubbc;				# Set to 1 if you want to enable UBBC (Uniform Bulletin Board Code)
\$enable_news = $enable_news;				# Set to 1 to turn news on, or 0 to set news off
\$allowpics = $allowpics;				# set to 1 to allow members to choose avatars in their profile
\$enable_guestposting = $enable_guestposting;		# Set to 0 if do not allow 1 is allow.
\$enable_notification = $enable_notification;		# Allow e-mail notification
\$autolinkurls = $autolinkurls;				# Set to 1 to turn URLs into links, or 0 for no auto-linking.

\$timeoffset = $timeoffset;				# Time Offset (so if your server is EST, this would be set to -1 for CST)
\$TopAmmount = $TopAmmount;				# No. of top posters to display on the top members list
\$MembersPerPage = $MembersPerPage;			# No. of members to display per page of Members List - All
\$maxdisplay = $maxdisplay;				# Maximum of topics to display
\$maxmessagedisplay = $maxmessagedisplay;		# Maximum of messages to display
\$MaxMessLen = $maxmesslen;  				# Maximum Allowed Characters in a Posts
\$numpolloptions = $numpolloptions;  			# Number of poll options
\$maxpq = $maxpq;  						# Maximum Allowed Characters in a Poll Qestion?
\$maxpo = $maxpo;  						# Maximum Allowed Characters in a Poll Option?
\$maxpc = $maxpc;  						# Maximum Allowed Characters in a Poll Comment?
\$useraddpoll = $useraddpoll;  				# Allow users to add polls to existing threads? (1 = yes)
\$ubbcpolls = $ubbcpolls;  					# Allow UBBC tags and smilies in polls? (1 = yes)

\$MaxSigLen = $maxsiglen;				# Maximum Allowed Characters in Signatures
\$ClickLogTime = $clicklogtime;				# Time in minutes to log every click to your forum (longer time means larger log file size)
\$OnlineLogTime = $OnlineLogTime;				# Time in minutes before users are removed from the online log
\$max_log_days_old = $max_log_days_old;			# If an entry in the user's log is older than ... days remove it
							# Set to 0 if you want it disabled
\$fadertime = $fadertime;				# Length in milliseconds to delay between each item in the news fader
\$timeout = $timeout;					# Minimum time between 2 postings from the same IP
\$numposts = $numposts;					# Number of posts required to send Instant Messages
\$imspam = $imspam;					# Percent of Users a user is a allowed to send a message at once
\$numibox = $numibox;					# Number of maximum Messages in the IM-Inbox
\$numobox = $numobox;					# Number of maximum Messages in the IM-Outbox
\$numstore = $numstore;					# Number of maximum Messages in the Storage box
#RECENT USERS LIST
\$rul_show_avatars = $rul_show_avatars;				# $rul_txt{'4'}
\$rul_show_time = $rul_show_time;				# $rul_txt{'14'}
\$rul_avatar_link = $rul_avatar_link;				# $rul_txt{'8'}
\$rul_avatar_width = $rul_avatar_width;				# $rul_txt{'5'}
\$rul_avatar_height = $rul_avatar_height;				# $rul_txt{'6'}
\$rul_users_display = $rul_users_display;				# $rul_txt{'3'}
\$rul_rowspan = $rul_rowspan;				# $rul_txt{'15'}


\$showallgroups = $showallgroups;					# Select membergroups to show in memberview (0 = assigned membergroups only , 1 = assigned and post dependant membergroups)

########## MemberPic Settings ##########

\$userpic_width = $userpic_width;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$userpic_height = $userpic_height;			# Set pixel size to which the selfselected userpics are resized, 0 disables this limit
\$userpic_limits = qq~$userpic_limits~;			# Text To Describe The Limits


# --- Added for Notify Plus 2.2 --- #

########## Notify Plus ##########

\$imagesurl = "$imagesurl";						# Directory of your images (Still an Error in original YaBB SP1 !!!)
\$enable_notification_board = $enable_notification_board;	# Allow e-mail notification on Board-level
\$enable_mark_board = $enable_mark_board;				# Enable mark of Boards
\$enable_mark_thread = $enable_mark_thread;			# Enable mark of Threads
\$enable_notification_guest = $enable_notification_guest;	# Allow e-mail notification for guests
\$enable_mailinglist = $enable_mailinglist;			# Allow use of Mailinglist
\$autosend = "$autosend";						# Autosend the Mailinglist or Email Reminder
\$autosend_frequency = "$autosend_frequency";			# Autosend frequency (Never, Daily, Weekly)	
\$email_reminder_address = q^$email_reminder_address^;	# Email Reminder Address
# --- /Added for Notify Plus 2.2 --- #

########## Multi-admin Settings ##########

\$adminview = $adminview;				# Multi-admin settings for Administrators: 0=none, 1=icons 2=single checkbox 3=multiple checkboxes
\$gmodview = $gmodview;					# Multi-admin settings for Global Moderators: 0=none, 1=icons 2=single checkbox 3=multiple checkboxes
\$modview = $modview;					# Multi-admin settings for Moderators: 0=none, 1=icons 2=single checkbox 3=multiple checkboxes

########## File Locking ##########

\$LOCK_EX = $LOCK_EX;					# You can probably keep this as it is set now.
\$LOCK_UN = $LOCK_UN;					# You can probably keep this as it is set now.
\$LOCK_SH = $LOCK_SH;					# You can probably keep this as it is set now.

\$use_flock = $use_flock;				# Set to 0 if your server doesn't support file locking,
							# 1 for Unix/Linux and WinNT, and 2 for Windows 95/98/ME

\$usetempfile = $usetempfile;				# Write to a temporary file when updating large files.
							# This can potentially save your board index files from
							# being corrupted if a process aborts unexpectedly.
							# 0 to disable, 1 to enable.

\$faketruncation = $faketruncation;			# Enable this option only if YaBB fails with the error:
							# "truncate() function not supported on this platform."
							# 0 to disable, 1 to enable.

1;
EOF

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(FILE, ">$boarddir/Settings.pl");
	print FILE $setfile;
	fclose(FILE);

	$password = crypt($settings[0],$pwseed);
	$Cookie_Exp_Date = 'Sunday, 17-Jan-2038 00:00:00 GMT';
	$yySetCookies1 = cookie(-name    =>   "$cookieusername",
				-value   =>   "$username",
				-path    =>   "/",
				-expires =>   "$Cookie_Exp_Date");
	$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
				-value   =>   "$password",
				-path    =>   "/",
				-expires =>   "$Cookie_Exp_Date");
	&LoadIMs;
	&LoadUserSettings;
	&WriteLog;
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}

1;