###############################################################################
# Load.pl                                                                     #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.4                                        #
# Released:       December 2001; Updated November 25, 2004                    #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

$loadplver = "1 Gold - SP 1.4";

sub LoadIMs {
	if ($maintenance && $settings[7] ne 'Administrator') {$username="Guest";}
	if($username ne "Guest" && $username ne '' && $action ne "logout") {
		open(IM, "$memberdir/$username.msg");
		@immessages = <IM>;
		close(IM);
		open(OM, "$memberdir/$username.outbox");
		@outmessages = <OM>;
		close(OM);
		open(SM, "$memberdir/$username.imstore");
		@storemessages = <SM>;
		close(SM);
		$moutnum=@outmessages;
		$storenum=@storemessages;
		foreach $curline (@immessages) {
		($imusername, $imsub, $imdate, $mmessage, $imessageid, $mip, $imnew) = split(/\|/,$curline);
		if($imnew == 1) { $imnewcount++; }
		}
		if($imnewcount eq "") { $imnewcount=0; }
		if($imnewcount == 1) { $imnewtext = qq~$imtxt{'16'}.~; } else { $imnewtext = qq~$imtxt{'17'}.~; }
		if($enable_mailsounds == 1) {
		if($imnewcount > 0 && $action eq "" && $INFO{'board'} eq "" || $imnewcount > 0 && $action eq "login2") { 
		if(-e("$memberdir/$username.imconfig")) {
		open(FILE, "$memberdir/$username.imconfig");
		@userimcfg = <FILE>;
		close(FILE);
		chomp($userimcfg[2]);
		chomp($userimcfg[5]);
		if($userimcfg[2] ne "blank.wav" && $userimcfg[2] ne "") {
		$imsound = qq~<BGSOUND SRC="$soundsurl/$userimcfg[2]" controls="none" loop="0" autostart="true">~; } } }		
		}
		$mnum = @immessages;
		$minnum = @immessages;
		if($mnum eq "1") { $yyim = qq~$txt{'152'} <a href="$scripturl?action=im">$mnum $txt{'471'}</a>, $imnewcount $imnewtext $imsound~; }
		else { $yyim = qq~$txt{'152'} <a href="$scripturl?action=im">$mnum $txt{'153'}</a>, $imnewcount $imnewtext $imsound~;}
		if(-e ("$datadir/$username.ymg") && $enable_buddylist) {
			fopen(FILE,"$datadir/$username.ymg");
			@qmess = <FILE>;
			$qmessnr = @qmess;
			fclose(FILE);
			if($qmessnr > 0) {
				$yyim .= qq~
					<script language="JavaScript1.2" type="text/javascript">
					<!--
					function QuickIMwin(FileName,WindowName) {
						WindowFeature="Resizable=No,ScrollBars=No,MenuBar=No,Directories=No,ToolBar=No,Location=No,Status=No,Width=340,Height=250,ScreenX=0,ScreenY=0,Top=30,Left=30"
						newWindow=open(FileName,WindowName,WindowFeature);
						if (newWindow.opener == null) { newWindow.opener = self; }
						if (newWindow.focus) { newWindow.focus(); }
					}

					//-->
					</script>
				<a href="#" onclick="QuickIMwin('$boardurl/QuickIM.pl')"><img src="$imagesdir/quickim1.gif" alt="$budtxt{'09'}" border="0" align="absmiddle"></a>
				~;
			}
		}
		if($maintenance && $settings[7] eq 'Administrator') { $yyim .= qq~<BR><B>$txt{'616'}</B>~; }
		if (!$user_ip && ($settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator')) { $yyim .= qq~<br><b>$txt{'773'}</b>~; }
	}
}

### Add More Smilies 3.0 - Load Smilies ###
sub LoadSmilies {
	undef %Smilies;
	my (@tmp_smilies);

	if ($smiliesurl ne "") {
		fopen(FILE, "$vardir/Smilies.txt",1);
		@tmp_smilies = <FILE>;
		fclose(FILE);
		my $i = 0;
		foreach $line (@tmp_smilies){ 
			chomp $line;
			my ($tmpa, $tmpb, $tmpc, $tmpd) = split (/\|/, $line);
			if ($tmpa eq "" || ($tmpa !~ /\//i && $smiliesdir ne "" && !-e ("$smiliesdir/$tmpa"))) {next;} 
			$SmilieURL[$i] = $tmpa;
			$SmilieCode[$i] = $tmpb;
			$SmilieDescription[$i] = $tmpc;
			$SmilieOption[$i] = $tmpd;
			$Smilies{$SmilieURL[$i]} = $SmilieCode[$i]; 
			$i++;
		}

		if ($smiliesdir ne "") {
			opendir(DIR, "$smiliesdir");
			@tmp_smilies = readdir(DIR);
			closedir(DIR);
			foreach $line (sort {uc($a) cmp uc($b)} @tmp_smilies){ 
				($name, $extension) = split (/\./, $line);
				$extension = lc $extension;
				if ($extension eq "gif" || $extension eq "jpg" || $extension eq "jpeg" || $extension eq "png" || $extension eq "bmp" ){
					if ($line !~ /banner/i && !exists $Smilies{$line}) {
						$Smilies{$line} = "[smiley=$line]";
						push (@SmilieURL, $line);
						push (@SmilieCode, "[smiley=$line]");
						push (@SmilieDescription, $name);
						push (@SmilieOption, "6");
					}
				}
			}
		}
	}
	undef %Smilies;
}
### Add More Smilies 3.0 - Load Smilies ###

sub LoadBoard {
	my $threadid = $INFO{'num'} || $INFO{'thread'} || $FORM{'threadid'};
	if( $threadid =~ /\D/ ) { &fatal_error($txt{'337'}); }
	if($currentboard ne '') {
		unless( &BoardAccessGet($currentboard) ) { &fatal_error( $txt{'1'} ); }

		fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("400 $txt{'106'}: $txt{'23'} $currentboard.dat");
		@yyBoardInfo =<FILE>;
		fclose(FILE);

		chomp @yyBoardInfo;
		$boardname = $yyBoardInfo[0];

		# Create Hash %moderators with all Moderators of the current board
		foreach(split(/\|/,$yyBoardInfo[2])) {
			fopen(MODERATOR, "$memberdir/$_.dat");
			@modprop = <MODERATOR>;
			fclose(MODERATOR);
			$modprop[1] =~ s/[\n\r]//g;
			$moderators{$_} = $modprop[1];
		}
		####	
		unless ($settings[7] eq "Administrator") {
			my $accesstype = "";
			my $cookiename = "$cookiepassword$currentboard";
			my $crypass = crypt($boardpw{$currentboard},$pwseed);
			if ($boardpw{$currentboard} && $yyCookies{$cookiename} ne $crypass && !$FORM{'boardpw'} ) { require "$sourcedir/MBCoptions.pl"; &askforboardpw("$currentboard"); }
			if ($action eq "post") {
				$polltxt{'1a'} =~ tr/+/ /;
				$polltxt{'2a'} =~ tr/+/ /;
				if ($INFO{'title'} eq $polltxt{'1a'} || $INFO{'title'} eq $polltxt{'2a'}) { $accesstype = 3; } # Post Poll
				elsif ($INFO{'num'}) { $accesstype = 2; } # Post Reply
				else { $accesstype = 1; } # Post Thread
			}
			my $access = &AccessCheck($currentboard, $accesstype);
			if ($access ne "granted"){ &fatal_error($txt{'1'});}
		}
		####


		if ($threadid ne '' && ! $FORM{'caller'} && $action ne 'imsend') {
			$yyThreadPosition = -1;
			my $found;
			fopen(BOARDFILE, "$boardsdir/$currentboard.txt") || &fatal_error("401 $txt{'106'}: $txt{'23'} $currentboard.txt");
			while( $yyThreadLine = <BOARDFILE> ) {
				++$yyThreadPosition;
				if( $yyThreadLine =~ m~\A$threadid\|~o ) { $found = 1; last; }
			}
			fclose(BOARDFILE);
			unless( $found ) { &fatal_error("$txt{'472'} $threadid : $yyThreadPosition."); }
			chomp $yyThreadLine;
		}
	}
	elsif( $threadid ne '' && $action ne "imsend" ) { &fatal_error("$txt{'472'}"); }
}

sub LoadCensorList {
	fopen(FILE,"$vardir/censor.txt") || &fatal_error("205 $txt{'106'}: $txt{'23'} censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);
}

sub LoadUserSettings {
	if($username ne 'Guest') {
		if( fopen(FILE, "$memberdir/$username.dat") ) {
			@settings=<FILE>;
			fclose(FILE);
			for( $_ = 0; $_ < @settings; $_++ ) {
				$settings[$_] =~ s~[\n\r]~~g;
			}
			$spass = crypt($settings[0],$pwseed);
			if($spass ne $password && $action ne 'logout') { $username = ''; }
			else {
				$realname = $settings[1];
				$realemail = $settings[2];
			}
		       ### User Templates ###
		       fopen(TMPL, "$memberdir/$username.tmpl");
		       @templ = <TMPL>;
		       fclose(TMPL);
		       $tmplfile = @templ[0];
		       if(!-e("$templatesdir/$tmplfile")) { $tmplfile = "default.html"; }
		       ###/User Templates ###
		}
		else { $username = ''; }
	}
	unless($username) {
		$yySetCookies1 = cookie(-name    =>   "$cookieusername",
					-value   =>   "",
					-path    =>   "/",
					-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
		$yySetCookies2 = cookie(-name    =>   "$cookiepassword",
					-value   =>   "",
					-path    =>   "/",
					-expires =>   "Thursday, 01-Jan-1970 00:00:00 GMT");
		$username = 'Guest';
		$password = '';
		@settings = ();
		$realname = '';
		$realemail = '';
		$ENV{'HTTP_COOKIE'} = '';
	}
	&FormatUserName($username);
}

sub FormatUserName {
	my $user = $_[0];
	if( $useraccount{$user} ) { return; }
	$useraccount{$user} = $user;
	$useraccount{$user} =~ s~\%~%25~g;
	$useraccount{$user} =~ s~\#~%23~g;
	$useraccount{$user} =~ s~\+~%2B~g;
	$useraccount{$user} =~ s~\,~%2C~g;
	$useraccount{$user} =~ s~\-~%2D~g;
	$useraccount{$user} =~ s~\.~%2E~g;
	$useraccount{$user} =~ s~\@~%40~g;
	$useraccount{$user} =~ s~\^~%5E~g;
}

sub LoadUser {
	my $user = $_[0];
	unless( exists $userprofile{$user} ) {
		fopen(FILEAUSER, "$memberdir/$user.dat") || return 0;
		@{$userprofile{$user}} = <FILEAUSER>;
		fclose(FILEAUSER);
		for( $_ = 0; $_ < @{$userprofile{$user}}; $_++ ) {
			chomp $userprofile{$user}->[$_];
		}
		&FormatUserName($user);
	}
	return 1;
}


sub LoadUserDisplay {
	my $user= $_[0];
	if(exists $userprofile{$user}) { if($yyUDLoaded{$user}) { return 1; } }
	else {
		&LoadUser($user);
		unless(exists $userprofile{$user}) { return 0 ; }
	}
	&LoadCensorList;	# Load censor list

	$userpic_tmpwidth ||= $userpic_width ? qq~ width="$userpic_width"~ : '';
	$userpic_tmpheight ||= $userpic_height ? qq~ height="$userpic_height"~ : '';

	if($userprofile{$user}->[4] !~ m~\Ahttp://~) { $userprofile{$user}->[4] = "http://$userprofile{$user}->[4]"; }
	if($sm) { $userprofile{$user}->[4] = $userprofile{$user}->[4] && $userprofile{$user}->[4] ne q~http://~ ? qq~ <a href="$userprofile{$user}->[4]" target="_blank">$img{'website_sm'}</a>$menusep~ : ''; }
	else { $userprofile{$user}->[4] = $userprofile{$user}->[4] && $userprofile{$user}->[4] ne q~http://~ ? qq~<a href="$userprofile{$user}->[4]" target="_blank">$img{'website'}</a>$menusep~ : ''; }

	$userprofile{$user}->[5] =~ s~\&\&~<br>~g;
	$userprofile{$user}->[5] = $userprofile{$user}->[5] ? qq~<hr width="100%" size="1" class="hr"><font size="1">$userprofile{$user}->[5]</font>~ : '';
	# do some ubbc on the signature
	$message = $userprofile{$user}->[5];
	$displayname = $userprofile{$user}->[1];
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	$userprofile{$user}->[5] = $message;

	if($userprofile{$user}->[8] ne "" && $userprofile{$user}->[8] !~ m~\D~) {
		$icqad{$user} = qq~<a href="http://web.icq.com/whitepages/add_me?uin=$userprofile{$user}->[8]&action=add" target="_blank"><img src="$imagesdir/icqadd.gif" alt="$userprofile{$user}->[8]" BORDER=0></a>~;
		$userprofile{$user}->[8] = qq~<a href="$cgi;action=icqpager;UIN=$userprofile{$user}->[8]" target="_blank"><img src="http://web.icq.com/whitepages/online?icq=$userprofile{$user}->[8]&img=5" alt="$userprofile{$user}->[8]" border="0"></a>~;
	}
	else {
		$icqad{$user} = '';
		$userprofile{$user}->[8] = '';
	}

	$userprofile{$user}->[9] = $userprofile{$user}->[9] ? qq~<a href="aim:goim?screenname=$userprofile{$user}->[9]&message=Hi.+Are+you+there?"><img src="$imagesdir/aim.gif" alt="$userprofile{$user}->[9]" border="0"></a>~ : '';

	if($userprofile{$user}->[10] ne "") {
		$yimon{$user} = qq~<img SRC="http://opi.yahoo.com/online?u=$userprofile{$user}->[10]&m=g&t=0" BORDER=0 alt="">~;
		$userprofile{$user}->[10] = $userprofile{$user}->[10] ? qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$userprofile{$user}->[10]" target="_blank"><img src="$imagesdir/yim.gif" alt="$userprofile{$user}->[10]" border="0"></a>~ : '';
	}

	if($showgenderimage && $userprofile{$user}->[11]) {
		$userprofile{$user}->[11] = $userprofile{$user}->[11] =~ m~Female~i ? 'female' : 'male';
		$userprofile{$user}->[11] = $userprofile{$user}->[11] ? qq~<font size="1">$txt{'231'}: <img src="$imagesdir/$userprofile{$user}->[11].gif" border="0" alt="$userprofile{$user}->[11]"><br></font>~ : '';
	}
	else { $userprofile{$user}->[11] = ''; }

	$userprofile{$user}->[12] = $showusertext ? qq~$userprofile{$user}->[12]<br>~ : '';

	if($showuserpic && $allowpics) {
		$userprofile{$user}->[13] ||= 'blank.gif';
		$userprofile{$user}->[13] = $userprofile{$user}->[13] =~ m~\A[\s\n]*http://~i ? qq~<br><img src="$userprofile{$user}->[13]"$userpic_tmpwidth$userpic_tmpheight border="0" alt=""><br><br>~ : qq~<br><img src="$facesurl/$userprofile{$user}->[13]" border="0" alt=""><br>~;
	}
	else { $userprofile{$user}->[13] = '<BR>'; }

	### Censor it ###
	foreach (@censored) {
		($tmpa,$tmpb) = @{$_};
		$userprofile{$user}->[5] =~ s~\Q$tmpa\E~$tmpb~gi;
		$userprofile{$user}->[12] =~ s~\Q$tmpa\E~$tmpb~gi;
	}
	
	if( $userprofile{$user}->[7] eq 'Administrator' && $hideadmin != 1) {
		if ($MemTypeAdmin == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColAdmin, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeAdmin == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColAdmin, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColAdmin><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$memberinfo{$user} = "<B>$MemStatAdmin</B>";
		$starnum = "0";
		if ($MemStarNumAdmin eq "") { $MemStarNumAdmin = "0"; }
		$memberstartemp ='';
		while($MemStarNumAdmin ne "$starnum") {
################# XTC BEGIN ##################
if ($MemStarPicAdmin =~ /^http:/) {
		$memberstartemp .= qq(<img src="$MemStarPicAdmin" border="0" alt="*">);
} else {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicAdmin" border="0" alt="*">);
}
################# XTC END ##################
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	}

	elsif ( $userprofile{$user}->[7] eq 'Global Moderator' && $hidegmod != 1) {
		if ($MemTypeGMod == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColGMod, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeGMod == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColGMod, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColGMod><b>$userprofile{$user}->[1]</b></font></a><br>~; }  
		$memberinfo{$user} = "<B>$MemStatGMod</B>";
		$starnum = "0";
		if ($MemStarNumGMod eq "") { $MemStarNumGMod = "0"; }
		$memberstartemp ='';
		while($MemStarNumGMod ne "$starnum") {
################# XTC BEGIN ##################
if ($MemStarPicGMod =~ /^http:/) {
		$memberstartemp .= qq(<img src="$MemStarPicGMod" border="0" alt="*">);
} else {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicGMod" border="0" alt="*">);
}
################# XTC END ##################
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	}

	else {
	if ($MemStarNumNewbie eq "") { $MemStarNumNewbie = "0"; }
	$starnum = "0";
	if( $userprofile{$user}->[6] >= $MemPostNewbie) {
		if ($MemTypeNewbie == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColNewbie, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeNewbie == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColNewbie, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColNewbie><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$memberinfo{$user} = "$MemStatNewbie";
		$memberstartemp ='';
		  while($MemStarNumNewbie ne "$starnum") {
################# XTC BEGIN ##################
if ($MemStarPicNewbie =~ /^http:/) {
		$memberstartemp .= qq(<img src="$MemStarPicNewbie" border="0" alt="*">);
} else {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicNewbie" border="0" alt="*">);
}
################# XTC END ##################
	    ++$starnum; 
	    }
                  $memberstar{$user} = $memberstartemp;
	          $starnum = "0";
	


	$msstatcount = "0";
	$starnum = "0";
	while($MemStat[$msstatcount]) {
	if( $userprofile{$user}->[6] >= $MemPostNum[$msstatcount] && $MemPostNum[$msstatcount] ne "x") {
		if ($MemType[$msstatcount] == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeCol[$msstatcount], direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemType[$msstatcount] == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeCol[$msstatcount], strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeCol[$msstatcount]><b>$userprofile{$user}->[1]</b></font></a><br>~; }

		$memberinfo{$user} = "$MemStat[$msstatcount]";

		if ($MemStarNum[$msstatcount] eq "") { $MemStarNum[$msstatcount] = "0"; }
		$memberstartemp ='';
		while($MemStarNum[$msstatcount] ne "$starnum") {
################# XTC BEGIN ##################
if ($MemStarPic[$msstatcount] =~ /^http:/) {
		$memberstartemp .= qq(<img src="$MemStarPic[$msstatcount]" border="0" alt="*">);
} else {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPic[$msstatcount]" border="0" alt="*">);
}
################# XTC END ##################
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
	$starnum = "0";
	}
	++$msstatcount;
	}
}

	if( exists $moderators{$user} && $sender ne "im" && $hidemod != 1) {
		if ($MemTypeMod == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeColMod, direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemTypeMod == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeColMod, strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeColMod><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$modinfo{$user} = "<i>$MemStatMod</i>";
		$starnum = "0";
		if ($MemStarNumMod eq "") { $MemStarNumMod = "0"; }
		$memberstartemp ='';
		while($MemStarNumMod ne "$starnum") {
################# XTC BEGIN ##################
if ($MemStarPicMod =~ /^http:/) {
		$memberstartemp .= qq(<img src="$MemStarPicMod" border="0" alt="*">);
} else {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPicMod" border="0" alt="*">);
}
################# XTC END ##################
           ++$starnum;
           }
           $memberstar{$user} = $memberstartemp;
		$starnum = "0";
	}

  if ($disprealinfo == 1) {
	if( $userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Administrator' && $userprofile{$user}->[7] ne 'Global Moderator') {
		$memberinfo{$user} = "$userprofile{$user}->[7]<BR>$memberinfo{$user}";
		if ($modinfo{$user}) { $memberinfo{$user} = "$modinfo{$user}<br>$memberinfo{$user}" }
	}
  } else {

    if( $userprofile{$user}->[7] && $userprofile{$user}->[7] ne 'Administrator' && $userprofile{$user}->[7] ne 'Global Moderator'&& !$modinfo{$user}) {
	$msstatcount = "0";
	$starnum = "0";
	while($MemStat[$msstatcount] && $MemStat[$msstatcount] ne "$userprofile{$user}->[7]") { $msstatcount++; }
	   if($MemStat[$msstatcount] eq "$userprofile{$user}->[7]") {
		if ($MemType[$msstatcount] == 1)    {	$link{$user} = qq~<table style="filter:shadow(color=$MemTypeCol[$msstatcount], direction=left)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		elsif ($MemType[$msstatcount] == 2) {	$link{$user} = qq~<table style=filter:glow(color=$MemTypeCol[$msstatcount], strength=5)"><a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$color{'fadertext2'}><b>$userprofile{$user}->[1]</b></font></a></table>~; }
		else 			   {	$link{$user} = qq~<a href="$cgi;action=viewprofile;username=$user"><font size="2" color=$MemTypeCol[$msstatcount]><b>$userprofile{$user}->[1]</b></font></a><br>~; }
		$memberinfo{$user} = "$MemStat[$msstatcount]";
		if ($MemStarNum[$msstatcount] eq "") { $MemStarNum[$msstatcount] = "0"; }
		$memberstartemp ='';
		while($MemStarNum[$msstatcount] ne "$starnum") {
################# XTC BEGIN ##################
if ($MemStarPic[$msstatcount] =~ /^http:/) {
		$memberstartemp .= qq(<img src="$MemStarPic[$msstatcount]" border="0" alt="*">);
} else {
		$memberstartemp .= qq(<img src="$imagesdir/$MemStarPic[$msstatcount]" border="0" alt="*">);
}
################# XTC END ##################
                  $starnum++;
                }
           $memberstar{$user} = $memberstartemp;
	   $starnum = "0";
	   }
	}
		if ($modinfo{$user}) { $memberinfo{$user} = "$modinfo{$user}<br>$memberinfo{$user}"; }
    }
  }

	if($userprofile{$user}->[6] > 100000) { $userprofile{$user}->[6] = "$txt{'683'}"; }

	$yyUDLoaded{$user} = 1;
	return 1;
}

sub LoadCookie {
	foreach (split(/; /,$ENV{'HTTP_COOKIE'})) {
		$_ =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
		($cookie,$value) = split(/=/);
		$yyCookies{$cookie} = $value;
	}
	if($yyCookies{$cookiepassword}) {
		$password = $yyCookies{$cookiepassword};
		$username = $yyCookies{$cookieusername} || 'Guest';
	} else {
		$password = '';
		$username = 'Guest';
	}
}

sub LoadAdmins {
	&is_admin;
	my (@members, $curentry);

	$administrators = '';
	fopen(FILE, "$memberdir/memberlist.txt");
	@members = <FILE>;
	fclose(FILE);
	foreach $curentry (@members) {
		chomp $curentry;
		&LoadUser($curentry);
		if($userprofile{$curentry}->[7] eq 'Administrator') {
			$administrators .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$curentry}">$userprofile{$curentry}->[1]</a><font size="1">,</font> \n~;
		}
	}
	$administrators =~ s~<font size="1">,</font> \n\Z~~;
}

sub LoadGMods {
	&is_admin_or_gmod;
	my (@members, $curentry);

	$gmoderators = '';
	fopen(FILE, "$memberdir/memberlist.txt");
	@members = <FILE>;
	fclose(FILE);
	foreach $curentry (@members) {
		chomp $curentry;
		&LoadUser($curentry);
		if($userprofile{$curentry}->[7] eq 'Global Moderator') {
			$gmoderators .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$curentry}">$userprofile{$curentry}->[1]</a><font size="1">,</font> \n~;
		}
	}
	$gmoderators =~ s~<font size="1">,</font> \n\Z~~;
}

sub LoadLogCount {
	&is_admin_or_gmod;
	if ($settings[7] eq 'Global Moderator'  && $showgmod_info != 1 ) { &fatal_error("$txt{'1'}"); }
	my(@log);
	fopen(LOG, "$vardir/clicklog.txt");
	@log = <LOG>;
	fclose(LOG);
	$yyclicks = @log;
}

sub loadfiles {
	require "$yabb_fullpath/language/$language";
	require "$sourcedir/AdminEdit.pl";
	require "$sourcedir/BoardIndex.pl";
	require "$sourcedir/Display.pl";
	require "$sourcedir/ICQPager.pl";
	require "$sourcedir/InstantMessage.pl";
	require "$sourcedir/LockThread.pl";
	require "$sourcedir/LogInOut.pl";
	require "$sourcedir/Maintenance.pl";
	require "$sourcedir/ManageBoards.pl";
	require "$sourcedir/ManageCats.pl";
	require "$sourcedir/Memberlist.pl";
	require "$sourcedir/MessageIndex.pl";
	require "$sourcedir/ModifyMessage.pl";
	require "$sourcedir/MoveThread.pl";
	require "$sourcedir/Notify.pl";
	require "$sourcedir/Post.pl";
	require "$sourcedir/Printpage.pl";
	require "$sourcedir/Profile.pl";
	require "$sourcedir/Recent.pl";
	require "$sourcedir/Register.pl";
	require "$sourcedir/RemoveOldThreads.pl";
	require "$sourcedir/RemoveThread.pl";
	require "$sourcedir/Search.pl";
	require "$sourcedir/Security.pl";
	require "$sourcedir/SendTopic.pl";
	require "$sourcedir/YaBBC.pl";
}

1;