###############################################################################
# Memberlist.pl                                                               #
###############################################################################
#                                                                             #
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
#                                                                             #
# Version:        YaBB 1 Gold - SP 1.4                                        #
# Released:       December 2001; Updated November 25, 2004                    #
# Distributed by: http://www.yabbforum.com                                    #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2000-2004 YaBB (www.yabbforum.com) - All Rights Reserved.     #
#                                                                             #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
#                                                                             #
###############################################################################

$memberlistplver = "1 Gold - SP 1.4 - $yams_ver";

if($username eq "Guest" && !$guest_allow) { &fatal_error("$txt{'223'}"); }

$buddycount = 0;
if(-e "$memberdir/$username.bud" && $enable_buddylist) {
	fopen(FILE, "$memberdir/$username.bud");
	@buddylist = <FILE>;
	$buddycount = @buddylist;
	fclose(FILE);
	chomp(@buddylist);
	for($i=0;$i<$buddycount;$i++) {
		if(!-e "$memberdir/$buddylist[$i].dat") { &DelBuddy($buddylist[$i]) }
	}
}

# Load the membergroups list.
fopen(FILE, "$vardir/membergroups.txt") || &fatal_error("100 $txt{'106'}: $txt{'23'} membergroups.txt");
@membergroups = <FILE>;
fclose(FILE);

$avm_inst = 0;
opendir(DIR, "$memberdir");
@contents = readdir(DIR);
closedir(DIR);
foreach $line (@contents){
	($oname, $oextension) = split (/\./, $line);
	if ($oextension eq "ll"){
		$avm_inst = 1;
	}
}

if($gendcol eq "pic") { $gendhdr .= qq(<IMG SRC="$imagesdir/gender.gif" border="0" align="absmiddle" alt="$membtxt{'56'}">); } else { $gendhdr = "$membtxt{'56'}" }
if($mailcol eq "pic") { $mailhdr .= qq(<IMG SRC="$imagesdir/email.gif" border="0" align="absmiddle" alt="$txt{'307'}">); } else { $mailhdr = "$txt{'307'}" }
if($wwwcol eq "pic") { $wwwhdr .= qq(<IMG SRC="$imagesdir/www.gif" border="0" align="absmiddle" alt="$txt{'515'}">); } else { $wwwhdr = "$txt{'515'}" }
if($imcol eq "pic") { $imhdr .= qq(<IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'321'}">); } else { $imhdr = "$txt{'321'}" }
if($icqcol eq "pic") { $icqhdr .= qq(<IMG SRC="$imagesdir/icqflow.gif" border="0" align="absmiddle" alt="$txt{'513'}">); } else { $icqhdr = "$txt{'513'}" }
if($yimcol eq "pic") { $yimhdr .= qq(<IMG SRC="$imagesdir/yim.gif" border="0" align="absmiddle" alt="$txt{'604'}">); } else { $yimhdr = "$txt{'604'}" }
if($aimcol eq "pic") { $aimhdr .= qq(<IMG SRC="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$txt{'603'}">); } else { $aimhdr = "$txt{'603'}" }

if($avm_inst && $settings[7] eq "Administrator") {
	if($FORM{'sort_date'} eq $amv_txt{'9'}) { $action = "mlonall"; }
	elsif($FORM{'sort_date'} eq $amv_txt{'10'}) { $action = "mlpostall"; }
	elsif($FORM{'sort_date'} eq $amv_txt{'11'}) { $action = "mlimall"; }
}
else {
	$reglink	.= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center"><input type="button" value="$membtxt{'57'}" style="border-width: 2px; border-style: outset; padding: 1px; width: 100%; font-size: 13px; height: 25px; cursor: hand" onClick="window.location='$cgi;action=mlall';"></td>);
	if($action eq "mlall") { 
		$sortorder = 0; 
		$smb1 = ' selected'; 
		$mlcall = "mlall";
		$reglink = "";
		$reglink .= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><b><font size=2>$membtxt{'57'} <a href="$cgi;action=mlalldes"><IMG SRC="$imagesdir/des.gif" border="0" align="absmiddle"></a></font></b></td>);
	}
	if($action eq "mlalldes") { 
		$sortorder = 1; 
		$smb1 = ' selected'; 
		$mlcall = "mlalldes";
		$reglink = "";
		$reglink .= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><b><font size=2>$membtxt{'57'} <a href="$cgi;action=mlall"><IMG SRC="$imagesdir/ass.gif" border="0" align="absmiddle"></a></font></b></td>);
	}
}

$alfalink	.= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center"><input type="button" value="$txt{'68'}" style="border-width: 2px; border-style: outset; padding: 1px; width: 100%; font-size: 13px; height: 25px; cursor: hand" onClick="window.location='$cgi;action=mlalfa';"></td>);
$grplink	.= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center"><input type="button" value="$txt{'87'}" style="border-width: 2px; border-style: outset; padding: 1px; width: 100%; font-size: 13px; height: 25px; cursor: hand" onClick="window.location='$cgi;action=mlgrp';"></td>);
$postlink	.= qq(<td class="catbg" bgcolor="$color{'catbg'}" colspan="2" align="center"><input type="button" value="$txt{'86'}" style="border-width: 2px; border-style: outset; padding: 1px; width: 100%; font-size: 13px; height: 25px; cursor: hand" onClick="window.location='$cgi;action=mlpost';"></td>);
$iplink	.= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center"><input type="button" value="$membtxt{'30'}" style="border-width: 2px; border-style: outset; padding: 1px; width: 100%; font-size: 13px; height: 25px; cursor: hand" onClick="window.location='$cgi;action=mlipnum';"></td>);
$emaillink	.= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><nobr><IMG SRC=$imagesdir/sort.gif><a href="$cgi;action=mlemail">$mailhdr</a><IMG SRC=$imagesdir/fill.gif></nobr></td>);

if($action eq "mlalfa") { 
	$smb4 = ' selected'; 
	$mlcall = "mlalfa";
	$alfalink = "";
	$alfalink .= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><b><font size=2>$txt{'68'}</font></b></td>); 
}
if($action eq "mlletter") { 
	$smb4 = ' selected'; 
	$mlcall = "mlalfa"; 
}
if($action eq "mlgrp") { 
	$smb3 = ' selected'; 
	$mlcall = "mlgrp";
	$grplink = "";
	$grplink .= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><b><font size=2>$txt{'87'}</font></b></td>);
}
if($action eq "mlpost") { 
	$smb2 = ' selected'; 
	$mlcall = "mlpost";
	$postlink = "";
	$postlink .= qq(<td class="catbg" bgcolor="$color{'catbg'}" colspan="2" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><b><font size=2>$txt{'86'}</font></b></td>);
}
if($action eq "mlipnum") { 
	$smb5 = ' selected'; 
	$mlcall = "mlipnum";
	$iplink = "";
	$iplink .= qq(<td class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px"><b><font size=2>$membtxt{'30'}</font></b></td>);
}
if($action eq "mlipsearch") { 
	$smb5 = ' selected'; 
	$mlcall = "mlipsearch"; 
}
if($action eq "mlemail") { 
	$smb6 = ' selected'; 
	$mlcall = "mlemail";
	$emaillink = "";
	$emaillink .= qq(<td colspan="3" class="catbg" bgcolor="$color{'catbg'}" align="center" style="border-width: 2px; border-style: outset; padding: 1px">$txt{'307'}</td>); 
}

if($avm_inst && $settings[7] eq "Administrator") {
	$mlimg = "fill";
	if($action eq "mlonall") { 
		$sortorder = 0; 
		$smb7 = ' selected'; 
		$mlcall = "mlonall";
		$mcall = "mlonalldes";
		$mlimg = "des";
	}
	if($action eq "mlonalldes") { 
		$sortorder = 1; 
		$smb7 = ' selected'; 
		$mlcall = "mlonalldes";
		$mcall = "mlonall";
		$mlimg = "ass";
	}
	if($action eq "mlpostall") { 
		$sortorder = 0; 
		$smb8 = ' selected'; 
		$mlcall = "mlpostall";
		$mcall = "mlpostalldes";
		$mlimg = "des";
	}
	if($action eq "mlpostalldes") { 
		$sortorder = 1; 
		$smb8 = ' selected'; 
		$mlcall = "mlpostalldes";
		$mcall = "mlpostall";
		$mlimg = "ass";
	}
	if($action eq "mlimall") { 
		$sortorder = 0; 
		$smb9 = ' selected'; 
		$mlcall = "mlimall";
		$mcall = "mlimalldes";
		$mlimg = "des";
	}
	if($action eq "mlimalldes") { 
		$sortorder = 1; 
		$smb9 = ' selected'; 
		$mlcall = "mlimalldes";
		$mcall = "mlimall";
		$mlimg = "ass";
	}
	if($action eq "mlall") {
		$sortorder = 0; 
		$smb1 = ' selected';
		$mlcall = "mlall";
		$mcall = "mlalldes";
		$mlimg = "des";
	}
	if($action eq "mlalldes") {
		$sortorder = 1; 
		$smb1 = ' selected'; 
		$mlcall = "mlalldes";
		$mcall = "mlall";
		$mlimg = "ass";
	}

	$reglink = "";
	$reglink .= qq~
		<form method="post" action="$cgi;action=mlall">
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center"><nobr>
		<IMG SRC="$imagesdir/fill.gif" border="0" align="absmiddle">
		<select name="sort_date" style="font-size: 11px;" onChange="if(this.options[this.selectedIndex].value) submit(); return true">
			<option>$membtxt{'58'}</option>
			<option value="$membtxt{'57'}" $smb1>$membtxt{'57'}</option>
			<option value="$amv_txt{'9'}" $smb7>$amv_txt{'9'}</option>
			<option value="$amv_txt{'10'}" $smb8>$amv_txt{'10'}</option>
			<option value="$amv_txt{'11'}" $smb9>$amv_txt{'11'}</option>
		</select>
		<a href="$cgi;action=$mcall"><IMG SRC="$imagesdir/$mlimg.gif" border="0" align="absmiddle"></a>
		</nobr></td>
		</form>
	~;
}

if($settings[7] ne 'Global Moderator' ) { $allow_mod = 0; }

if($barmaxdepend == 0)	{
	$barmax = 0;
	fopen(MEMBERLISTREAD,"$memberdir/memberlist.txt");
	@member = ();
	while(chomp($membername=<MEMBERLISTREAD>)) {
		fopen(MEMBERFILE,"$memberdir/$membername.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		chomp @member;
		if($member[6] > $barmax) { $barmax = $member[6]; }
	}
	fclose(MEMBERLISTREAD);
	if($barmax == 0) { $barmax = 1; }
}
else	{
	$barmax = $barmaxnumb;
}

if($smb4) {
	$page = "a"; $showpage = "A";
	while($page ne "z") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$page">$showpage&nbsp;</a> );
		$page++; $showpage++;
	}
	$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=z">Z&nbsp;</a> );
	if($lngtxt{'01uc'} ne "") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$lngtxt{'01lc'}">$lngtxt{'01uc'}&nbsp;</a> );
	}
	if($lngtxt{'02uc'} ne "") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$lngtxt{'02lc'}">$lngtxt{'02uc'}&nbsp;</a> );
	}
	if($lngtxt{'03uc'} ne "") {
		$LetterLinks .= qq(<a href="$scripturl?action=mlletter;letter=$lngtxt{'03lc'}">$lngtxt{'03uc'}</a> );
	}
	$LetterLinks .= qq( <a href="$scripturl?action=mlletter;letter=other">$txt{'800'}</a>);
}


$membspan = "5";
if ($mlcall ne "mlemail") {
	if ($view_mailcolm)	{ $membspan++; }
	if ($view_wwwcolm)	{ $membspan++; }
	if ($view_imcolm)		{ $membspan++; }
	if ($view_icqcolm)	{ $membspan++; }
	if ($view_yimcolm)	{ $membspan++; }
	if ($view_aimcolm)	{ $membspan++; }
	if ($view_msncolm)	{ $membspan++; }
	if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{ $membspan++; }
}
else {
	$membspan++;
	$membspan++;
	$membspan++;
 }
if ($view_gendcolm) { 
	$membspan++;
}
if ($view_regdate) {
	$membspan++;
}
if ($view_numbcolm) {
	$membspan++;
}
if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
	$membspan++;
}
if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{ $membspan++; }


if(-e "$sourcedir/Msn.pl") {
	$TableHeader .= qq(
	<object classid="clsid:F3A614DC-ABE0-11d2-A441-00C04F795683" codebase="#Version=2,0,0,83" codetype=application/x-oleobject id=MsgrObj width=0 height=0>
	</object>
	<OBJECT classid="clsid:FB7199AB-79BF-11d2-8D94-0000F875C541" codeType=application/x-oleobject id=MsgrApp width=0 height=0></OBJECT>
	<SCRIPT LANGUAGE="JavaScript">           
	<!--            
	function stopError() {             return true;           }            
	window.onerror = stopError;            
	// -->
	</script>
	);
}

$TableHeader .= qq(
<table border=0 width=100% cellspacing=0 cellpadding="0">

<tr>
	<td colspan=$membspan bgcolor="$color{'titlebg'}" class="titlebg" style="border: $color{'bordercolor'} 1px solid; padding: 3px;">
		<img src="$imagesdir/guest.gif" alt="" border="0" align="absmiddle"> <font size="2" color="$color{'titletext'}"><b>$membtxt{'13'}</b></font>
	</td>
</tr>
);

if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
	$TableHeader .= qq(<tr>
		<td class="windowbg" style="border: $color{'bordercolor'} 1px solid;" bgcolor="$color{'windowbg'}" align="right" valign="middle" colspan=$membspan>
			<form action="$scripturl?action=mlipsearch" method="post" name="searchipform">
			<table align=right border=0 cellspacing=0 cellpadding=4>
			<tr>
			<td align="right">
				<font size=2>$membtxt{'33'}&nbsp;</font>
			</td>
			<td>
				<input type=text size=15 name="searchip" style="font-size: 11px">
			</td>
			<td>
				<input type="submit" name="submit" value="$txt{'462'}" style="border-width: 2px; border-style: outset; font-size: 11px">
			</td>
			</tr>
			</table>
			</form>
			<script language="JavaScript"> <!--
			document.searchipform.searchip.focus();
			//--> </script>
		</td>
	</tr>
	);
}

if($LetterLinks ne "") {
	$TableHeader .= qq(<tr>
		<td class="catbg" style="border: $color{'bordercolor'} 1px solid; padding: 1px" bgcolor="$color{'catbg'}" colspan=$membspan><b><font size=2>$LetterLinks</b></font></td>
	</tr>
	);
}

$TableHeader .= qq(<tr>
	<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center" width="25"><IMG SRC="$imagesdir/login.gif" border="0" alt="$txt{'686'} \- $txt{'687'}" align="absmiddle"></td>
	$alfalink
	$grplink
	$postlink
	);
	if ($view_regdate)	{
	$TableHeader .= qq(
		$reglink
	);
	}
	if ($view_numbcolm)	{
	$TableHeader .= qq(
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center"><b><font size=2>$membtxt{'23'}</font></b></td>
	);
	}
	if ($view_gendcolm)	{
	$TableHeader .= qq(
	<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$gendhdr&nbsp;</td>
	);
	}
	if ($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
		if ($view_mailcolm && $mlcall ne "mlemail")	{
		$TableHeader .= qq(
			$emaillink
		);
		}
	
		if ($mlcall eq "mlemail")	{
		$TableHeader .= qq(
			$emaillink
		);
		}
	}
	else {
		if ($view_mailcolm)	{
		$TableHeader .= qq(
			<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$mailhdr&nbsp;</td>
		);
		}
	}

	if ($view_wwwcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
	<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$wwwhdr&nbsp;</td>
	);
	}
	if ($view_imcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$imhdr&nbsp;</td>
	);
	}
	if ($view_icqcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$icqhdr&nbsp;</td>
	);
	}
	if ($view_yimcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$yimhdr&nbsp;</td>
	);
	}
	if ($view_aimcolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;$aimhdr&nbsp;</td>
	);
	}
	if ($view_msncolm && $mlcall ne "mlemail")	{
	$TableHeader .= qq(
		<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">&nbsp;<IMG SRC="$imagesdir/msn.gif" border="0" align="absmiddle" alt="$membtxt{'16'}">&nbsp;</td>
	);
	}
	if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
	$TableHeader .= qq(
		$iplink
	);
	}
	if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{
		if($buddycount) {
			$TableHeader .= qq(
				<td class="catbg" bgcolor="$color{'catbg'}" align="center"><input type="button" value="$budtxt{'01'}" style="border-width: 2px; border-style: outset; padding: 1px; width: 100%; font-size: 13px; height: 25px; cursor: hand" onClick="window.location='$scripturl?action=mlbuddy';"></td>
			);
		}
		else {
			$TableHeader .= qq(
				<td class="catbg" style="border-width: 2px; border-style: outset; padding: 1px" bgcolor="$color{'catbg'}" align="center">$budtxt{'01'}</td>
			);
		}
	}

$TableHeader .= qq(
</tr>
);

$TableFooter = qq~</table>~;

sub MLAll {
	if($username eq "Guest" && !$guest_allow) { &fatal_error("$txt{'223'}"); }
	# Get the number of members
	fopen(FILE, "$memberdir/memberlist.txt");
	@memberlist = <FILE>;
	$memcount = @memberlist;
	@membername = @memberlist;
	fclose(FILE);
	if($smb1)	{
		&SortMemb;
		if($sortorder == 1) { 
			@membername = reverse @sortmembername;
		}
		else {
			@membername = @sortmembername;
		}
	}
	elsif($smb3)	{
		&SortGrpMemb;
		@membername = @grpmemberlist;
	}
	elsif($smb7 || $smb8 || $smb9) {
		&SortMemb;
		if($sortorder == 1) { 
			@membername = reverse @sortmembername;
		}
		else {
			@membername = @sortmembername;
		}
	}
	else	{
		&SortMemb;
		@membername = @sortmembername;
	}

	$stopflag = 0;
	$firstgrp= "";
	$firstlett = "";

	if($INFO{'start'} eq "") { $start=0; } else { $start="$INFO{'start'}"; }
	$numshown=0;
	$numbegin = ($start + 1);
	$numend = ($start + $MembersPerPage);
	if($numend > $memcount) { $numend = $memcount; }
	$b = $start;

	$yymain .= qq~
		<center><font size="2" class="nav"><B>$txt{'308'} $numbegin $txt{'311'} $numend ($txt{'309'} $memcount $txt{'310'})</B></font></center><BR>
	~;
	$yymain .= qq~$TableHeader~;

	while(($numshown < $MembersPerPage)) {
		$numshown++;
		$c=0;
		$pages="";
		chomp(@membername);
		$tempname = $membername[$b];
		$membername[$b] =~ s/ //gi;
		$membername[$b] =~ s/\n//gi;
		$name = $membername[$b];
		$tname = $membername[$b];
		$b++;
		$hjsite = "";
		@entries = ();

		@member = ();
		$Bar = "";
		$ICQ = "";
		fopen(MEMBERFILEREAD,"$memberdir/$name.dat");
		@member = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @member;
		if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{
			$buddyimg = qq~<img src="$imagesdir/buddyunchek.gif" border="0" alt="$budtxt{'02'}">~; 
			if(-e "$memberdir/$username.bud") {
				fopen(FILE, "$memberdir/$username.bud");
				@buddylist = <FILE>;
				$buddycount = @buddylist;
				fclose(FILE);
				chomp(@buddylist);
				for($i=0;$i<$buddycount;$i++) {
					if($buddylist[$i] eq $name) { $buddyimg = qq~<img src="$imagesdir/buddychek.gif" border="0" alt="$budtxt{'03'}">~; }
				}
			}
		}

		$viewipnumb = "";
		fopen(NUMBERFILEREAD,"$memberdir/$name.yam");
		@number = <NUMBERFILEREAD>;
		fclose(NUMBERFILEREAD);
		chomp @number;
		if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
			($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
			if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
			else {
				$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
				if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
				if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
			}
		}
		if ($number[0] == 0) { $number[0] = "&nbsp;"; }
		($e_name, $e_dom) = split(/\@/, $member[2]);
		&FormatUserName($name);
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
		chomp @membergroups;
		if(!-e "$sourcedir/MemberGroups.pl") {
			if($member[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
			elsif($member[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
			elsif($member[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
			elsif($member[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
			else { $memberinfo = "$membergroups[2]"; }
		}
		else {
			$memstatcount = "0";
			if( $member[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
			while($MemStat[$memstatcount]) {
				if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
					$memberinfo = "$MemStat[$memstatcount]"; 
				}
				$memstatcount++;
			}
		}
		$memberinfo =~ s/\n//gi;
		$Bargif = "";
		$barchart = ($member[6]);
		$bartemp = ($member[6] * $maxbar);
		$barwidth = ($bartemp / $barmax);
		$barwidth = ($barwidth + 0.5);
		$barwidth = int($barwidth);
		if($barwidth > $maxbar) {$barwidth = $maxbar}
		
		fopen(FILE, "$vardir/barcolor.dat");
		@grpbar=<FILE>;
		fclose(FILE);
		chomp(@grpbar);

		if(!-e "$sourcedir/MemberGroups.pl") {
			if ($barchart >= $GodPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[3].gif'";
			}
			elsif ($barchart >= $SrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[2].gif'";
			}
			elsif ($barchart >= $FullPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[1].gif'";
			}
			elsif ($barchart >= $JrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[0].gif'";
			}
			else {
				$Bargif = "img src='$barsurl/$stfaultbar.gif'";
			}
		}
		else {
			$membarcount = 0;
			$Bargif .= qq(img src="$barsurl/$stfaultbar.gif");
			while($MemStat[$membarcount]) {
				if($barchart >= $MemPostNum[$membarcount] && $MemPostNum[$membarcount] ne 'x') {
					$Bargif = "";
					$Bargif .= qq(img src="$barsurl/$grpbar[$membarcount].gif");
				}
				$membarcount++;
			}
		}
		
		if ($barwidth < 1) {$Bar = "$Bar";}
		else {
			$Bar = qq~<$Bargif width=$barwidth height=10 alt="$memberinfo" border="0">~;
		}

		if ($Bar eq "") { $Bar="&nbsp;"; }
		if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

		if(-e "$sourcedir/MemberGroups.pl") {
			if($member[7] eq "Administrator") { $member[7] = "$MemStatAdmin"; }
			if($member[7] eq "Global Moderator") { $member[7] = "$MemStatGMod"; }
		}
		else {
		if($member[7] eq "Administrator") { $member[7] = "$membergroups[0]"; }
		}

		if($member[7] eq "") { $member[7] = "$memberinfo"; }

			$dispgend = "&nbsp;";
			if($gendcol eq "pic") {
				if ($member[11] eq "Male") { $dispgend = qq~<img src="$imagesdir/male.gif" border="0">~; }
				if ($member[11] eq "Female") { $dispgend = qq~<img src="$imagesdir/female.gif" border="0">~; }
				$gendjust = "center";
			}
			else {
				if ($member[11] eq "Male") { $dispgend = qq~$txt{'238'}~; }
				if ($member[11] eq "Female") { $dispgend = qq~$txt{'239'}~; }
				$gendjust = "left";
			}

			if ($username eq "Guest" && $guest_allow) {
				if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
								  $mailjust = "center"; }
				else				{ $mailpic = "$txt{'722'}";
								  $mailjust = "left"; }
			}
			else {
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_mod == 0 && $allow_hide_email eq 1) {
					if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
									  $mailjust = "center"; }
					else				{ $mailpic = "$txt{'722'}";
									  $mailjust = "left"; }
				}
				else {
					if($mailcol eq "pic")	{ $mailpic = qq~<a href="mailto:$member[2]"><IMG SRC="$imagesdir/email.gif" border="0" alt="$member[2]"></a>~;
									  $mailjust = "center"; }
					else				{ $mailpic = qq~<a href="mailto:$member[2]">$member[2]</a>~;
									  $mailjust = "left"; }
				}
			}



		if($member[4] eq "")	{ $hjsite = "&nbsp;"; }
		elsif($wwwcol eq "pic")	{ if($member[4] !~ m~\Ahttp://\S*~) { $member4 = "<a href=\"http://$member[4]\" target=\"_blank\">"; }
						  else { $member4 = "<a href=\"$member[4]\" target=\"_blank\">"; }
						  $hjsite = qq~$member4<img src="$imagesdir/www.gif" border="0" align="absmiddle" alt="$member[3]"></a>~;
						  $wwwjust = "center"; }
		else				{ if($member[4] !~ m~\Ahttp://\S*~) { $member4 = "<a href=\"http://$member[4]\" target=\"_blank\">"; }
						  else { $member4 = "<a href=\"$member[4]\" target=\"_blank\">"; }
						  $hjsite = qq~$member4$member[3]</a>~;
						  $wwwjust = "left"; }

		if($imcol eq "pic")	{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}"><IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'148'} $txt{'311'} $member[1]"></a>~;
						  $imjust = "center"; }
		else				{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}">$membtxt{'43'} $member[1]</a>~;
						  $imjust = "left"; }

		if( $member[8] ne "" && $member[8] !~ m~\D~ ) {
		$ICQ = $member[8];
		if($icqcol eq "pic")	{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> </a>~;
						  $icqjust = "center"; }
		else				{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> $member[8]</a>~;
						  $icqjust = "left"; }
		}
		else				{ $icqimg = "&nbsp;" }

            if ($member[10] eq '')	{ $yimimg = "&nbsp"; }
		elsif($yimcol eq "pic")	{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"></a>~;
						  $yimjust = "center"; }
		else				{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"> $member[10]</a>~;
						  $yimjust = "left"; }

            if ($member[9] eq '')	{ $aimimg = "&nbsp"; }
		elsif($aimcol eq "pic")	{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"></a>~;
						  $aimjust = "center"; }
		else				{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"> $member[9]</a>~;
						  $aimjust = "left"; }

		if(-e "$sourcedir/Msn.pl") {
			fopen(FILE, "$memberdir/$name.om");
			@msnsettings = <FILE>;
			fclose <FILE>;
			chomp @msnsettings;
		}

		$dr = "";
		if ($member[14] eq "") { $dr = "$txt{'470'}"; }
		else { $dr = "$member[14]"; $dr = &timeformat($dr); }
		if ($number[0] eq "&nbsp;") { $dr = "$membtxt{'32'}"; }

		if($avm_inst && $settings[7] eq "Administrator") {
				fopen(FILE, "$memberdir/$tname.ll");
					my ($lastlogin, $lastpost, $lastim) = <FILE>;
				fclose(FILE);
				$lastlogin =~ s/\n//g; $lastlogin = &timeformat($lastlogin);
				$lastpost =~ s/\n//g; $lastpost = &timeformat($lastpost);
				$lastim =~ s/\n//g; $lastim = &timeformat($lastim);
				if ($lastlogin eq "") { $lastlogin = "$txt{'470'}"; }
				if ($lastpost eq "") { $lastpost = "$txt{'470'}"; }
				if ($lastim eq "") { $lastim = "$txt{'470'}"; }
			if($smb7) { $dr = $lastlogin }
			if($smb8) { $dr = $lastpost }
			if($smb9) { $dr = $lastim; }
		}

		$onlinemem = $img{'mem_offline'};
		fopen(FILE, "$vardir/log.txt");
		@entries = <FILE>;
		fclose(FILE);
		foreach $curentry (@entries) {
			chomp $curentry;
			($onname, $onvalue) = split(/\|/, $curentry);
			if(lc $onname eq lc $name) { $onlinemem = $img{'mem_online'}; }
		}

		if($tempname)
		{
			if($smb3) {
				if($member[7] ne "") {
					$startgrp = $member[7];
					if($startgrp ne $firstgrp) {
						$firstgrp = $startgrp;
						$yymain .= qq~ 
						<tr>
							<td class="catbg" style="border-left: $color{'bordercolor'} 1px solid; border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'catbg'}" colspan=$membspan><font size=1>&nbsp; $startgrp</font></td>
						</tr>
								~;
					}
				}
				elsif($stopflag == 0) {
					$yymain .= qq~ 
					<tr>
						<td class="catbg" style="border-left: $color{'bordercolor'} 1px solid; border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'catbg'}" colspan=$membspan><font size=1>&nbsp;</font></td>
					</tr>
							~;
					$stopflag = 1;
				}
			}

			if($smb4) {
				$startlett = substr $member[1],0,1;
				if($startlett eq "$lngtxt{'01lc'}") {$startlett = "$lngtxt{'01uc'}";}
				if($startlett eq "$lngtxt{'02lc'}") {$startlett = "$lngtxt{'02uc'}";}
				if($startlett eq "$lngtxt{'03lc'}") {$startlett = "$lngtxt{'03uc'}";}
				$startlett = uc $startlett;
				if($startlett ne $firstlett) {
					$firstlett = $startlett;
					$yymain .= qq~ 
					<tr>
						<td class="catbg" style="border-left: $color{'bordercolor'} 1px solid; border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'catbg'}" colspan=$membspan><font size=1>&nbsp; $startlett</font></td>
					</tr>
					~;
				}
			}
			$yymain .= qq~
			<tr>
				<td class="windowbg2" style="border-left: $color{'bordercolor'} 1px solid; border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$onlinemem</td>
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$name}">$member[1]</a></font></td>
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$member[7]</font>&nbsp;</td>
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="right" valign="middle"><font size=1>$member[6]</font></td>
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="left">$Bar</td>
				~;
				if ($view_regdate)	{
					$yymain .= qq~
					<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$dr</font></td>
					~;
				}
				if ($view_numbcolm)	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
					~;
				}
				if ($view_gendcolm)	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$gendjust" valign="middle"><font size="2">$dispgend</font></td>
					~;
				}
				if ($view_mailcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
					~;
				}
				if ($mlcall eq "mlemail")	{
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] ne 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
						<td colspan="3" class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$txt{'722'}</td>
					~; } else { $yymain .= qq~
						<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="right" valign="middle">
							<font size=1><nobr><a href="mailto:$member[2]">$e_name</a></nobr></font>
						</td>
						<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
							<font size=1><nobr><a href="mailto:$member[2]">@</a></nobr></font>
						</td>
						<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="left" valign="middle">
							<font size=1><nobr><a href="mailto:$member[2]">$e_dom</a></nobr></font>
						</td>
					~; }
				}

				if ($view_wwwcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
					~;
				}
				if ($view_imcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
					~;
				}
				if ($view_icqcolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
					~;
				}
				if ($view_yimcolm && $mlcall ne "mlemail")	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$yimjust" valign="middle"><font size=2>$yimimg</font></td>
				~;
				}
				if ($view_aimcolm && $mlcall ne "mlemail")	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$aimjust" valign="middle"><font size=2>$aimimg</font></td>
				~;
				}
				if (-e "$sourcedir/Msn.pl" && $view_msncolm && $mlcall ne "mlemail")	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
					~;
					if ($msnsettings[0] ne '') {
						$yymain .= qq~
						<nobr>
						<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
						<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
						</nobr>
						~;
					}
					else { 
						$yymain .= qq~
						&nbsp;
					~;
					}

					$yymain .= qq~
					</td>
					~;
				}
				if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
					$yymain .= qq~
					<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$viewipnumb</font></td>
					~;
				}
				if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{
					$yymain .= qq~
					<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="center" valign="middle"><font size="2"><a href="$scripturl?action=mlbuddy2;listname=$name;thesort=$mlcall;thestart=$start">$buddyimg</a></font></td>
					~;
				}
			$yymain .= qq~
			</tr>
			~;
		}
	}
	$yymain .= qq~$TableFooter~;

	# Build the page links list.
	$postdisplaynum = 8;	# max number of pages to display
	$max = $memcount;
	$start = $INFO{'start'} || 0;
	$start = ( int( $start / $MembersPerPage ) ) * $MembersPerPage;
	$tmpa = 1;
	$tmpx = int( $max / $MembersPerPage );
	if ($start >= (($postdisplaynum-1) * $MembersPerPage)) { $startpage = $start - (($postdisplaynum-1) * $MembersPerPage); $tmpa = int( $startpage /$MembersPerPage ) + 1; }
	if ($max >= $start + ($postdisplaynum * $MembersPerPage)) { $endpage = $start + ($postdisplaynum * $MembersPerPage); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=$mlcall;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=$mlcall;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=$mlcall;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage) + 0;
	$lastpn = int($memcount / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $max - ($MembersPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=$mlcall;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	$yymain .= qq~
	<table border="0" width="100%" cellspacing="0" cellpadding="2" bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr>
		<td class="catbg" style="border: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'catbg'}"><font size=2><b> $txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
	~;

	$yytitle = "$txt{'308'} $numbegin $txt{'311'} $numend";
	&template;
	exit;
}

sub MLByLetter {
	if($username eq "Guest" && !$guest_allow) { &fatal_error("$txt{'223'}"); }
	$yymain .= qq~$TableHeader~;
	fopen(FILE, "$memberdir/memberlist.txt");
	@memberlist = <FILE>;
	$memcount = @memberlist;
	@membername = @memberlist;
	fclose(FILE);


	for($i=0;$i<$memcount;$i++) {
		chomp(@membername);
		$membname = $membername[$i];
		fopen(MEMBERFILE,"$memberdir/$membname.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		chomp(@member);
		$templist[$i] .= qq($member[1] | $membname);
	}
	@SortAList = sort{lc($a) cmp lc($b)} (@templist);
	for($i=0;$i<$memcount;$i++) {
		chomp(@SortAList);
		($indxname[$i], $SortList[$i]) = split(/\|/, $SortAList[$i]);
	}
	chomp(@SortList);
	@lmemberfile = @SortList;

	$letter = $INFO{'letter'};
	if($INFO{'start'} eq "") { $start=0; } else { $start="$INFO{'start'}"; }

	unless(!$letter)
	{
		for($i=0;$i<$memcount;$i++) {
			chomp(@lmemberfile);
			$lmemberfile[$i] =~ s/ //gi;
			$lmemberfile[$i] =~ s/\n//gi;
			$memberfile = $lmemberfile[$i];
			fopen(MEMBERFILEREAD,"$memberdir/$memberfile.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;

			$SearchName = $member[1];
			$SearchName = substr $SearchName,0,1;
			if($SearchName eq "$lngtxt{'01uc'}") {$SearchName = "$lngtxt{'01lc'}";}
			if($SearchName eq "$lngtxt{'02uc'}") {$SearchName = "$lngtxt{'02lc'}";}
			if($SearchName eq "$lngtxt{'03uc'}") {$SearchName = "$lngtxt{'03lc'}";}
			$SearchName = lc $SearchName;
			if($letter eq "other" && (($SearchName lt "a") || ($SearchName gt "z"))) {
				push(@ToShow,$memberfile);
			} elsif($SearchName eq $letter) {
				push(@ToShow,$memberfile);
			}
		}
		$memcount=@ToShow;
		$numshown=0; $b=$start;

		unless ($memcount == 0)	{
		while(($numshown < $MembersPerPage))
		{
			$membername=@ToShow[$b];
			if ($membername ne "")
			{
			@member = ();
			$Bar = "";
			$ICQ = "";
			$hjsite = "";
			fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
			@member = <MEMBERFILEREAD>;
			fclose(MEMBERFILEREAD);
			chomp @member;
			if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{
				$buddyimg = qq~<img src="$imagesdir/buddyunchek.gif" border="0" alt="$budtxt{'02'}">~; 
				if(-e "$memberdir/$username.bud") {
					fopen(FILE, "$memberdir/$username.bud");
					@buddylist = <FILE>;
					$buddycount = @buddylist;
					fclose(FILE);
					chomp(@buddylist);
					for($i=0;$i<$buddycount;$i++) {
						if($buddylist[$i] eq $membername) { $buddyimg = qq~<img src="$imagesdir/buddychek.gif" border="0" alt="$budtxt{'03'}">~; }
					}
				}
			}

			$viewipnumb = "";
			fopen(NUMBERFILEREAD,"$memberdir/$membername.yam");
			@number = <NUMBERFILEREAD>;
			fclose(NUMBERFILEREAD);
			chomp @number;
			if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
				($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
				if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
				else {
					$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
					if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
					if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
				}
			}
			if ($number[0] == 0) { $number[0] = "&nbsp;"; }
			&FormatUserName($membername);
		fopen(FILE, "$vardir/membergroups.txt");
		@membergroups = <FILE>;
		fclose(FILE);
		chomp @membergroups;
		if(!-e "$sourcedir/MemberGroups.pl") {
			if($member[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
			elsif($member[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
			elsif($member[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
			elsif($member[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
			else { $memberinfo = "$membergroups[2]"; }
		}
		else {
			$memstatcount = "0";
			if( $member[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
			while($MemStat[$memstatcount]) {
				if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
					$memberinfo = "$MemStat[$memstatcount]"; 
				}
				$memstatcount++;
			}
		}
		$memberinfo =~ s/\n//gi;
		$Bargif = "";
		$barchart = ($member[6]);
		$bartemp = ($member[6] * $maxbar);
		$barwidth = ($bartemp / $barmax);
		$barwidth = ($barwidth + 0.5);
		$barwidth = int($barwidth);
		if($barwidth > $maxbar) {$barwidth = $maxbar}
		
		fopen(FILE, "$vardir/barcolor.dat");
		@grpbar=<FILE>;
		fclose(FILE);
		chomp(@grpbar);

		if(!-e "$sourcedir/MemberGroups.pl") {
			if ($barchart >= $GodPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[3].gif'";
			}
			elsif ($barchart >= $SrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[2].gif'";
			}
			elsif ($barchart >= $FullPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[1].gif'";
			}
			elsif ($barchart >= $JrPostNum) {
				$Bargif = "img src='$barsurl/$grpbar[0].gif'";
			}
			else {
				$Bargif = "img src='$barsurl/$stfaultbar.gif'";
			}
		}
		else {
			$membarcount = 0;
			$Bargif .= qq(img src="$barsurl/$stfaultbar.gif");
			while($MemStat[$membarcount]) {
				if($barchart >= $MemPostNum[$membarcount] && $MemPostNum[$membarcount] ne 'x') {
					$Bargif = "";
					$Bargif .= qq(img src="$barsurl/$grpbar[$membarcount].gif");
				}
				$membarcount++;
			}
		}
		
		if ($barwidth < 1) {$Bar = "$Bar";}
		else {
			$Bar = qq~<$Bargif width=$barwidth height=10 alt="$memberinfo" border="0">~;
		}
			$member[8] =~ s/[\n\r]//g;
			if ($Bar eq "") { $Bar="&nbsp;"; }

			if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

			if(-e "$sourcedir/MemberGroups.pl") {
				if($member[7] eq "Administrator") { $member[7] = "$MemStatAdmin"; }
				if($member[7] eq "Global Moderator") { $member[7] = "$MemStatGMod"; }
			}
			else {
				if($member[7] eq "Administrator") { $member[7] = "$membergroups[0]"; }
			}
			if($member[7] eq "") { $member[7] = "$memberinfo"; }

			$dispgend = "&nbsp;";
			if($gendcol eq "pic") {
				if ($member[11] eq "Male") { $dispgend = qq~<img src="$imagesdir/male.gif" border="0">~; }
				if ($member[11] eq "Female") { $dispgend = qq~<img src="$imagesdir/female.gif" border="0">~; }
				$gendjust = "center";
			}
			else {
				if ($member[11] eq "Male") { $dispgend = qq~$txt{'238'}~; }
				if ($member[11] eq "Female") { $dispgend = qq~$txt{'239'}~; }
				$gendjust = "left";
			}

			if ($username eq "Guest" && $guest_allow) {
				if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~; 
								  $mailjust = "center"; }
				else				{ $mailpic = "$txt{'722'}";
								  $mailjust = "left"; }
			}
			else {
				if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_mod == 0 && $allow_hide_email eq 1) {
					if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
									  $mailjust = "center"; }
					else				{ $mailpic = "$txt{'722'}";
									  $mailjust = "left"; }
				}
				else {
					if($mailcol eq "pic")	{ $mailpic = qq~<a href="mailto:$member[2]"><IMG SRC="$imagesdir/email.gif" border="0" alt="$member[2]"></a>~;
									  $mailjust = "center"; }
					else				{ $mailpic = qq~<a href="mailto:$member[2]">$member[2]</a>~;
									  $mailjust = "left"; }
				}
			}

			if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] ne 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
			~; }

		if($member[4] eq "")	{ $hjsite = "&nbsp;"; }
		elsif($wwwcol eq "pic")	{ if($member[4] !~ m~\Ahttp://\S*~) { $member4 = "<a href=\"http://$member[4]\" target=\"_blank\">"; }
						  else { $member4 = "<a href=\"$member[4]\" target=\"_blank\">"; }
						  $hjsite = qq~$member4<img src="$imagesdir/www.gif" border="0" align="absmiddle" alt="$member[3]"></a>~;
						  $wwwjust = "center"; }
		else				{ if($member[4] !~ m~\Ahttp://\S*~) { $member4 = "<a href=\"http://$member[4]\" target=\"_blank\">"; }
						  else { $member4 = "<a href=\"$member[4]\" target=\"_blank\">"; }
						  $hjsite = qq~$member4$member[3]</a>~;
						  $wwwjust = "left"; }

		if($imcol eq "pic")	{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$membername}"><IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'148'} $txt{'311'} $member[1]"></a>~;
						  $imjust = "center"; }
		else				{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$membername}">$membtxt{'43'} $member[1]</a>~;
						  $imjust = "left"; }

		if( $member[8] ne "" && $member[8] !~ m~\D~ ) {
		$ICQ = $member[8];
		if($icqcol eq "pic")	{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> </a>~;
						  $icqjust = "center"; }
		else				{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> $member[8]</a>~;
						  $icqjust = "left"; }
		}
		else				{ $icqimg = "&nbsp;" }

            if ($member[10] eq '')	{ $yimimg = "&nbsp"; }
		elsif($yimcol eq "pic")	{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"></a>~;
						  $yimjust = "center"; }
		else				{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"> $member[10]</a>~;
						  $yimjust = "left"; }

            if ($member[9] eq '')	{ $aimimg = "&nbsp"; }
		elsif($aimcol eq "pic")	{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"></a>~;
						  $aimjust = "center"; }
		else				{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"> $member[9]</a>~;
						  $aimjust = "left"; }


			if(-e "$sourcedir/Msn.pl") {
				fopen(FILE, "$memberdir/$membername.om"); 
				@msnsettings = <FILE>;
				fclose <FILE>;
				chomp @msnsettings;
			}

			$dr = "";
			if ($member[14] eq "") { $dr = "$txt{'470'}"; }
			else { $dr = "$member[14]"; $dr = &timeformat($dr); }
			if ($number[0] eq "&nbsp;") { $dr = "$membtxt{'32'}"; }

			$onlinemem = $img{'mem_offline'};
			fopen(FILE, "$vardir/log.txt");
			@entries = <FILE>;
			fclose(FILE);
			foreach $curentry (@entries) {
				chomp $curentry;
				($onname, $onvalue) = split(/\|/, $curentry);
				if(lc $onname eq lc $membername) { $onlinemem = $img{'mem_online'}; }
			}

			$yymain .= qq~
				<tr>
					<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
			~;
			if ($member[19] eq "checked" && $settings[7] ne "Administrator" &&  $settings[7] ne 'Global Moderator' && $allow_hide_email eq 1) { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><i>$txt{'722'}</i></font></td>
			~; } else { $yymain .= qq~
				<td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=2><a href="mailto:$member[2]">$member[2]</a></font></td>
			~; }
			$yymain .= qq~
			<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>$member[4]</font>&nbsp;</td>
			<td class="windowbg2" bgcolor="$color{'windowbg2'}" align="center"><font size=2>$member[6]</font>&nbsp;</td>
			<td class="windowbg" bgcolor="$color{'windowbg'}"><font size=2>$member[7]</font>&nbsp;</td>
			<td class="windowbg" bgcolor="$color{'windowbg'}">$Bar</td>
			</tr>
			~;
			}
			$numshown++;
			$b++;
		}
		}
	}
	if(!$letter) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$txt{'759'}</b><br><br></td>~;}
	if($memcount == 0 && $letter) {$yymain .= qq~ <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$txt{'760'}</b><br><br></td>~;}
	$yymain .= qq~$TableFooter~;

unless ($memcount == 0)
{
	# Build the page links list.
	$postdisplaynum = 4;	# max number of pages to display
	$max = $memcount;
	$start = $INFO{'start'} || 0;
	$start = ( int( $start / $MembersPerPage ) ) * $MembersPerPage;
	$tmpa = 1;
	$tmpx = int( $max / $MembersPerPage );
	if ($start >= (($postdisplaynum-1) * $MembersPerPage)) { $startpage = $start - (($postdisplaynum-1) * $MembersPerPage); $tmpa = int( $startpage /$MembersPerPage ) + 1; }
	if ($max >= $start + ($postdisplaynum * $MembersPerPage)) { $endpage = $start + ($postdisplaynum * $MembersPerPage); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=mlletter;letter=$letter;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=mlletter;letter=$letter;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=mlletter;letter=$letter;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage) + 0;
	$lastpn = int($memcount / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $max - ($MembersPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=mlletter;letter=$letter;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	$yymain .= qq~
	<table border="0" width="100%" cellspacing="0" cellpadding="2">
	<tr>
		<td class="catbg" style="border: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'catbg'}"><font size=2><b> $txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
	~;
}
	$yytitle = "$txt{'312'}";
	&template;
	exit;
}

sub MLByIP {
if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
$yymain .= qq~$TableHeader~;
fopen(FILE, "$memberdir/memberlist.txt");
@memberlist = <FILE>;
$memcount = @memberlist;
@imemberfile = @memberlist;
fclose(FILE);

if ($FORM{'searchip'} ne "") { $ipaddr = $FORM{'searchip'}; }
else { $ipaddr = $INFO{'searchip'}; }

$ipaddr =~ s/ //gi;
$ipaddr =~ s/\n//gi;

if($INFO{'start'} eq "") { $start=0; } 
else { $start="$INFO{'start'}"; }

unless(!$ipaddr)
{
	for($i=0;$i<$memcount;$i++) {
		chomp(@imemberfile);
		$imemberfile[$i] =~ s/ //gi;
		$imemberfile[$i] =~ s/\n//gi;
		$memberfile = $imemberfile[$i];
		fopen(MEMBERFILEREAD,"$memberdir/$memberfile.yam");
		@member = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @member;

		($SearchName1, $SearchName2, $SearchName3) = split(/\|/, $member[1]);

		if ($SearchName1 eq $ipaddr) {push(@ToShow,$memberfile);}
		elsif ($SearchName2 eq $ipaddr) {push(@ToShow,$memberfile);}
		elsif ($SearchName3 eq $ipaddr) {push(@ToShow,$memberfile);}
	}
	$memcount=@ToShow;
	$numshown=0; $b=$start;

	unless ($memcount == 0)	{
	while(($numshown < $MembersPerPage))
	{
		$membername=@ToShow[$b];
		if ($membername ne "")
		{
		@member = ();
		$Bar = "";
		$ICQ = "";
		$hjsite = "";
		fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
		@member = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		chomp @member;
		$viewipnumb = "";
		fopen(NUMBERFILEREAD,"$memberdir/$membername.yam");
		@number = <NUMBERFILEREAD>;
		fclose(NUMBERFILEREAD);
		chomp @number;
		if($settings[7] eq "Administrator" || $settings[7] eq 'Global Moderator' && $allow_mod == 1) {
			($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
			if ($ipnumb1 == 0) { $viewipnumb = "&nbsp;"; }
			else {
				$viewipnumb .= qq~<a href="$cgi;action=mlipsearch;searchip=$ipnumb1"><b>$ipnumb1</b></a>~;
				if ($ipnumb2 != 0 && $ipnumb2 ne $ipnumb1) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb2">$ipnumb2</a>~; }
				if ($ipnumb3 != 0 && $ipnumb3 ne $ipnumb1 && $ipnumb3 ne $ipnumb2) { $viewipnumb .= qq~<br><a href="$cgi;action=mlipsearch;searchip=$ipnumb3">$ipnumb3</a>~; }
			}
		}
		if ($number[0] == 0) { $number[0] = "&nbsp;"; }
		&FormatUserName($membername);
	fopen(FILE, "$vardir/membergroups.txt");
	@membergroups = <FILE>;
	fclose(FILE);
	chomp @membergroups;
	if(!-e "$sourcedir/MemberGroups.pl") {
		if($member[6] >= $GodPostNum) { $memberinfo = "$membergroups[6]"; }
		elsif($member[6] >= $SrPostNum) { $memberinfo = "$membergroups[5]"; }
		elsif($member[6] >= $FullPostNum) { $memberinfo = "$membergroups[4]"; }
		elsif($member[6] >= $JrPostNum) { $memberinfo = "$membergroups[3]"; }
		else { $memberinfo = "$membergroups[2]"; }
	}
	else {
		$memstatcount = "0";
		if( $member[6] >= $MemPostNewbie) { $memberinfo = "$MemStatNewbie"; }
		while($MemStat[$memstatcount]) {
			if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
				$memberinfo = "$MemStat[$memstatcount]"; 
			}
			$memstatcount++;
		}
	}
	$memberinfo =~ s/\n//gi;
	$Bargif = "";
	$barchart = ($member[6]);
	$bartemp = ($member[6] * $maxbar);
	$barwidth = ($bartemp / $barmax);
	$barwidth = ($barwidth + 0.5);
	$barwidth = int($barwidth);
	if($barwidth > $maxbar) {$barwidth = $maxbar}
		
	fopen(FILE, "$vardir/barcolor.dat");
	@grpbar=<FILE>;
	fclose(FILE);
	chomp(@grpbar);

	if(!-e "$sourcedir/MemberGroups.pl") {
		if ($barchart >= $GodPostNum) {
			$Bargif = "img src='$barsurl/$grpbar[3].gif'";
		}
		elsif ($barchart >= $SrPostNum) {
			$Bargif = "img src='$barsurl/$grpbar[2].gif'";
		}
		elsif ($barchart >= $FullPostNum) {
			$Bargif = "img src='$barsurl/$grpbar[1].gif'";
		}
		elsif ($barchart >= $JrPostNum) {
			$Bargif = "img src='$barsurl/$grpbar[0].gif'";
		}
		else {
			$Bargif = "img src='$barsurl/$stfaultbar.gif'";
		}
	}
	else {
		$membarcount = 0;
		$Bargif .= qq(img src="$barsurl/$stfaultbar.gif");
		while($MemStat[$membarcount]) {
			if($barchart >= $MemPostNum[$membarcount] && $MemPostNum[$membarcount] ne 'x') {
				$Bargif = "";
				$Bargif .= qq(img src="$barsurl/$grpbar[$membarcount].gif");
			}
			$membarcount++;
		}
	}
		
	if ($barwidth < 1) {$Bar = "$Bar";}
	else {
		$Bar = qq~<$Bargif width=$barwidth height=10 alt="$memberinfo" border="0">~;
	}
	$member[8] =~ s/[\n\r]//g;
	if ($Bar eq "") { $Bar="&nbsp;"; }

	if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

	if(-e "$sourcedir/MemberGroups.pl") {
		if($member[7] eq "Administrator") { $member[7] = "$MemStatAdmin"; }
		if($member[7] eq "Global Moderator") { $member[7] = "$MemStatGMod"; }
	}
	else {
		if($member[7] eq "Administrator") { $member[7] = "$membergroups[0]"; }
	}

	if($member[7] eq "") { $member[7] = "$memberinfo"; }

		$dispgend = "&nbsp;";
		if($gendcol eq "pic") {
			if ($member[11] eq "Male") { $dispgend = qq~<img src="$imagesdir/male.gif" border="0">~; }
			if ($member[11] eq "Female") { $dispgend = qq~<img src="$imagesdir/female.gif" border="0">~; }
			$gendjust = "center";
		}
		else {
			if ($member[11] eq "Male") { $dispgend = qq~$txt{'238'}~; }
			if ($member[11] eq "Female") { $dispgend = qq~$txt{'239'}~; }
			$gendjust = "left";
		}

		if ($username eq "Guest" && $guest_allow) {
			if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~; 
							  $mailjust = "center"; }
			else				{ $mailpic = "$txt{'722'}";
							  $mailjust = "left"; }
		}
		else {

		if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $allow_mod == 0 && $allow_hide_email eq 1) {
				if($mailcol eq "pic")	{ $mailpic = qq~<IMG SRC="$imagesdir/lockmail.gif" border="0" alt="$txt{'722'}">~;
								  $mailjust = "center"; }
				else				{ $mailpic = "$txt{'722'}";
								  $mailjust = "left"; }
			}
			else {
				if($mailcol eq "pic")	{ $mailpic = qq~<a href="mailto:$member[2]"><IMG SRC="$imagesdir/email.gif" border="0" alt="$member[2]"></a>~;
								  $mailjust = "center"; }
				else				{ $mailpic = qq~<a href="mailto:$member[2]">$member[2]</a>~;
								  $mailjust = "left"; }
			}
		}

		if ($member[19] eq "checked" && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator" && $allow_hide_email eq 1) { $yymain .= qq~
		~; }

	if($member[4] eq "")	{ $hjsite = "&nbsp;"; }
	elsif($wwwcol eq "pic")	{ if($member[4] !~ m~\Ahttp://\S*~) { $member4 = "<a href=\"http://$member[4]\" target=\"_blank\">"; }
					  else { $member4 = "<a href=\"$member[4]\" target=\"_blank\">"; }
					  $hjsite = qq~$member4<img src="$imagesdir/www.gif" border="0" align="absmiddle" alt="$member[3]"></a>~;
					  $wwwjust = "center"; }
	else				{ if($member[4] !~ m~\Ahttp://\S*~) { $member4 = "<a href=\"http://$member[4]\" target=\"_blank\">"; }
					  else { $member4 = "<a href=\"$member[4]\" target=\"_blank\">"; }
					  $hjsite = qq~$member4$member[3]</a>~;
					  $wwwjust = "left"; }

	if($imcol eq "pic")	{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}"><IMG SRC="$imagesdir/message.gif" border="0" align="absmiddle" alt="$txt{'148'} $txt{'311'} $member[1]"></a>~;
					  $imjust = "center"; }
	else				{ $imimg = qq~<a href="$cgi;action=imsend;to=$useraccount{$name}">$membtxt{'43'} $member[1]</a>~;
					  $imjust = "left"; }

	if( $member[8] ne "" && $member[8] !~ m~\D~ ) {
	$ICQ = $member[8];
	if($icqcol eq "pic")	{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> </a>~;
					  $icqjust = "center"; }
	else				{ $icqimg = qq~<a href="$cgi;action=icqpager;UIN=$ICQ" target=_blank> <img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt="$member[8]" border="0" align="absmiddle"> $member[8]</a>~;
					  $icqjust = "left"; }
	}
	else				{ $icqimg = "&nbsp;" }

	if ($member[10] eq '')	{ $yimimg = "&nbsp"; }
	elsif($yimcol eq "pic")	{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"></a>~;
					  $yimjust = "center"; }
	else				{ $yimimg = qq~<a href="http://edit.yahoo.com/config/send_webmesg?.target=$member[10]"><img SRC="http://opi.yahoo.com/online?u=$member[10]&m=g&t=0" NOSAVE BORDER=0 alt="$member[10]"> $member[10]</a>~;
					  $yimjust = "left"; }

	if ($member[9] eq '')	{ $aimimg = "&nbsp"; }
	elsif($aimcol eq "pic")	{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"></a>~;
					  $aimjust = "center"; }
	else				{ $aimimg = qq~<a href="aim:goim?screenname=$member[9]&message=Hi,+are+you+there?"><img src="$imagesdir/aim.gif" border="0" align="absmiddle" alt="$member[9]"> $member[9]</a>~;
					  $aimjust = "left"; }


		if(-e "$sourcedir/Msn.pl") {
			fopen(FILE, "$memberdir/$membername.om"); 
			@msnsettings = <FILE>;
			fclose <FILE>;
			chomp @msnsettings;
		}

		$dr = "";
		if ($member[14] eq "") { $dr = "$txt{'470'}"; }
		else { $dr = "$member[14]"; $dr = &timeformat($dr); }
		if ($number[0] eq "&nbsp;") { $dr = "$membtxt{'32'}"; }

		$onlinemem = $img{'mem_offline'};
		fopen(FILE, "$vardir/log.txt");
		@entries = <FILE>;
		fclose(FILE);
		foreach $curentry (@entries) {
			chomp $curentry;
			($onname, $onvalue) = split(/\|/, $curentry);
			if(lc $onname eq lc $membername) { $onlinemem = $img{'mem_online'}; }
		}

		$yymain .= qq~
		<tr>
		<td class="windowbg2" style="border-left: $color{'bordercolor'} 1px solid; border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$onlinemem</td>
		<td valign="middle" class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
		<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$member[7]</font>&nbsp;</td>
		<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="right" valign="middle"><font size=1>$member[6]</font></td>
		<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="left">$Bar</td>
		~;
		if ($view_regdate)	{
			$yymain .= qq~
			<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$dr</font></td>
			~;
		}
		if ($view_numbcolm)	{
			$yymain .= qq~
			<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
			~;
		}
	if ($view_gendcolm)	{
		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$gendjust" valign="middle"><font size="2">$dispgend</font></td>
		~;
	}
	if ($view_mailcolm)	{
		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
		~;
	}
	if ($view_wwwcolm)	{
		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
		~;
	}
	if ($view_imcolm)	{

		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
		~;
	}
	if ($view_icqcolm)	{
		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
		~;
	}
	if ($view_yimcolm)	{
		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$yimimg</font></td>
		~;
	}
	if ($view_aimcolm)	{
		$yymain .= qq~
		<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle"><font size=2>$aimimg</font></td>
		~;
	}
		if (-e "$sourcedir/Msn.pl" && $view_msncolm)	{
			$yymain .= qq~
			<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
			~;
			if ($msnsettings[0] ne '') {
				$yymain .= qq~
				<nobr>
				<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
				<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
				</nobr>
				~;
			}
			else { 
				$yymain .= qq~
				&nbsp;
			~;
			}

			$yymain .= qq~
			</td>
			~;
		}
		if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
			$yymain .= qq~
			<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$viewipnumb</font></td>
			~;
		}
		$yymain .= qq~
		</tr>
		~;
		}
		$numshown++;
		$b++;
	}
	}
}
if(!$ipaddr) {$yymain .= qq~ <td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$membtxt{'34'}</b><br><br></td>~;}
if($memcount == 0 && $ipaddr) {$yymain .= qq~ <td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" colspan=$membspan align="center"><br><b>$membtxt{'35'}</b><br><br></td>~;}
$yymain .= qq~$TableFooter~;

unless ($memcount == 0) {
	# Build the page links list.
	$postdisplaynum = 4;	# max number of pages to display
	$max = $memcount;
	$start = $INFO{'start'} || 0;
	$start = ( int( $start / $MembersPerPage ) ) * $MembersPerPage;
	$tmpa = 1;
	$tmpx = int( $max / $MembersPerPage );
	if ($start >= (($postdisplaynum-1) * $MembersPerPage)) { $startpage = $start - (($postdisplaynum-1) * $MembersPerPage); $tmpa = int( $startpage /$MembersPerPage ) + 1; }
	if ($max >= $start + ($postdisplaynum * $MembersPerPage)) { $endpage = $start + ($postdisplaynum * $MembersPerPage); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $MembersPerPage) { $pageindex = qq~<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $MembersPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $MembersPerPage;
	$outerpn = int($tmpx / $MembersPerPage) + 0;
	$lastpn = int($memcount / $MembersPerPage) + 1;
	$lastptn = ($lastpn - 1) * $MembersPerPage;
	if ($endpage < $max - ($MembersPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$cgi;action=mlipsearch;searchip=$ipaddr;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

	$yymain .= qq~
	<table border=0 width=100% cellspacing="0" cellpadding="2">
	<tr>
		<td class="catbg" style="border: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'catbg'}"><font size=2><b> $txt{'139'}:</b>
			$pageindex
		</td>
	</tr>
	</table>
	~;
}
	$yytitle = "$membtxt{'36'}";
	&template;
	exit;
}
sub MLTop {
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
	$yymain .= qq~$TableHeader~;
	%TopMembers = ();
	fopen(MEMBERLISTREAD,"$memberdir/memberlist.txt");
		@member = ();
		while(chomp($membername=<MEMBERLISTREAD>)) {
			fopen(MEMBERFILE,"$memberdir/$membername.dat");
				@member = <MEMBERFILE>;
			fclose(MEMBERFILE);
			chomp @member;

			$TopMembers{$membername} = $member[6];
		}
	fclose(MEMBERLISTREAD);

	my @toplist = sort {$TopMembers{$a} <=> $TopMembers{$b}} keys %TopMembers;
	@toplist = reverse @toplist;
	$TopListNum = $TopAmmount - 1;

for ($i=0;$i<=$TopListNum;$i++) {
		@member = ();
		$Bar = "";
		$ICQ = "";
		$membername = @toplist[$i];
		fopen(MEMBERFILEREAD,"$memberdir/$membername.dat");
			@member = <MEMBERFILEREAD>;
		fclose(MEMBERFILEREAD);
		&FormatUserName($membername);
		if($member[4] ne "" && $member[4] !~ m~\Ahttp://\S*~) { $member[4] = "<a href=\"http://$member[4]\" target=\"_blank\">$member[3]</a>"; }
		elsif($member[4] ne "") { $member[4] = "<a href=\"$member[4]\" target=\"_blank\">$member[3]</a>"; }
		chomp @member;
		if($member[1] ne "") {
			$barchart = ($member[6] / 5);
			if ($barchart < 1) {$Bar = "$Bar";}
			elsif ($barchart > 100) {$Bar = qq~<img src="$imagesdir/bar.gif" width=100 height=15 alt="" border="0">~;}
			else {
			$Bar = qq~<img src="$imagesdir/bar.gif" width=$barchart height=15 alt="" border="0">~;
			}
			$member[8] =~ s/[\n\r]//g;

			if($member[8] ne "") { $ICQ = qq~<a href="$cgi;action=icqpager;UIN=$memset[8]" target="_blank"><img src="http://web.icq.com/whitepages/online?icq=$member[8]&img=5" alt ="$member[8]" border=0></a>~; }
			if ($Bar eq "") { $Bar="&nbsp;"; }
			if($member[6] > 100000) { $member[6] = "$txt{'683'}"; }

			if($member[7] eq "Administrator") { $member[7] = "$membergroups[0]"; }

			$yymain .= qq~
			<tr>
			<td class="windowbg2" style="border-left: $color{'bordercolor'} 1px solid; border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">$onlinemem</td>
			<td valign="middle" class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}"><font size=2><a href="$cgi;action=viewprofile;username=$useraccount{$membername}">$member[1]</a></font></td>
			<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$member[7]</font>&nbsp;</td>
			<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="right" valign="middle"><font size=1>$member[6]</font></td>
			<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="left">$Bar</td>
			~;
			if ($view_regdate)	{
				$yymain .= qq~
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$dr</font></td>
				~;
			}
			if ($view_numbcolm)	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="right" valign="middle"><font size=1>$number[0]</font></td>
				~;
			}
			if ($view_gendcolm)	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$gendjust" valign="middle"><font size="2">$dispgend</font></td>
				~;
			}
			if ($view_mailcolm)	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$mailjust" valign="middle"><font size="2">$mailpic</font></td>
				~;
			}

			if ($view_wwwcolm)	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$wwwjust" valign="middle"><font size=2>$hjsite</font></td>
				~;
			}
				if ($view_imcolm)	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$imjust" valign="middle"><font size=2>$imimg</font></td>
					~;
				}
				if ($view_icqcolm)	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$icqjust" valign="middle"><font size=2>$icqimg</font></td>
					~;
				}
				if ($view_yimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="$yimjust" valign="middle"><font size=2>$yimimg</font></td>
				~;
				}
				if ($view_aimcolm)	{
				$yymain .= qq~
				<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="aimjust" valign="middle"><font size=2>$aimimg</font></td>
				~;
				}
				if (-e "$sourcedir/Msn.pl" && $view_msncolm)	{
					$yymain .= qq~
					<td class="windowbg2" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg2'}" align="center" valign="middle">
					~;
					if ($msnsettings[0] ne '') {
						$yymain .= qq~
						<nobr>
						<a href=javascript:MsgrApp.LaunchAddContactUI("$msnsettings[0]")><img src="$imagesdir/msnadd.gif" alt="$membtxt{'19'} $msnsettings[0] $membtxt{'20'}" border=0 align="absmiddle"></a>
						<a id="lll" href=javascript:MsgrApp.LaunchIMUI("$msnsettings[0]")><img src="$imagesdir/msntalk.gif" alt="$membtxt{'21'} $msnsettings[0]" border=0 align="absmiddle"></a>
						</nobr>
						~;
					}
					else { 
						$yymain .= qq~
						&nbsp;
					~;
					}

					$yymain .= qq~
					</td>
					~;
				}
			if ($settings[7] eq "Administrator" && $view_ipcolm || $settings[7] eq 'Global Moderator' && $allow_mod == 1 && $view_ipcolm) {
				$yymain .= qq~
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" valign="middle"><font size=1>$viewipnumb</font></td>
				~;
			}
			if ($enable_buddylist && $username ne "Guest" && $mlcall ne "mlipsearch")	{
				$yymain .= qq~
				<td class="windowbg" style="border-top: $color{'bordercolor'} 1px solid; border-right: $color{'bordercolor'} 1px solid; padding: 2px" bgcolor="$color{'windowbg'}" align="center" valign="middle"><font size="2"><a href="$scripturl?action=mlbuddy2;listname=$membername;thesort=mlletter;theletter=$letter;thestart=$start">$buddyimg</a></font></td>
				~;
			}
			$yymain .= qq~
			</tr>
			~;
		}
	}
	$yymain .= qq~$TableFooter~;
	$yytitle = "$txt{'313'} $TopAmmount $txt{'314'}";
	&template;
	exit;
}
sub SortGrpMemb	{
	if(!-e "$sourcedir/MemberGroups.pl") {
		fopen(GRPFILE, "$vardir/membergroups.txt");
		@membergroup = <GRPFILE>;
		$grpcount = @membergroup;
		fclose(GRPFILE);
		foreach (@membergroup) { $_ =~ s~[\n\r]~~g; }
		$grpcount = $grpcount + 2;
	}
	else {
		$membergroup[0] = "$MemStatAdmin";
		$membergroup[1] = "$MemStatGMod";
		$membergroup[2] = "$MemStatNewbie";
		$grpcount = "0";
		while($MemStat[$grpcount]) { 
			$membergroup[$grpcount + 3] = $MemStat[$grpcount];
			$grpcount++;
		}
		$grpcount = $grpcount + 5;
	}
	for($i=0;$i<$memcount;$i++) {
		chomp(@membername);
		$membername[$i] =~ s/ //gi;
		$membername[$i] =~ s/\n//gi;
		$membname = $membername[$i];
		@member = ();
		fopen(MEMBERFILE,"$memberdir/$membname.dat");
		@member = <MEMBERFILE>;
		fclose(MEMBERFILE);
		foreach (@member) { $_ =~ s~[\n\r]~~g; }
		$realmembname = lc $member[1];
		$memberinf = $member[7];
		if($memberinf eq "") { 
			if(!-e "$sourcedir/MemberGroups.pl") {
				if($member[6] >= $GodPostNum) { $memberinf = "$membergroup[6]"; }
				elsif($member[6] >= $SrPostNum) { $memberinf = "$membergroup[5]"; }
				elsif($member[6] >= $FullPostNum) { $memberinf = "$membergroup[4]"; }
				elsif($member[6] >= $JrPostNum) { $memberinf = "$membergroup[3]"; }
				else { $memberinf = "$membergroup[2]"; }
			}
			else {
				$memstatcount = "0";
				if( $member[6] >= $MemPostNewbie) { $memberinf = "$MemStatNewbie"; }
				while($MemStat[$memstatcount]) {
					if( $member[6] >= $MemPostNum[$memstatcount] && $MemPostNum[$memstatcount] ne "x") { 
						$memberinf = "$MemStat[$memstatcount]";
					}
					$memstatcount++;
				}
			}
		} 
		$amember = lc $memberinf;
		for($grp=0;$grp<$grpcount;$grp++) {
			$agroup = lc $membergroup[$grp];
			if($agroup eq $amember) { $grpnr = $grpcount - $grp; }
		}
		if($member[7] eq "Administrator") { $grpnr = 0; }
		if($member[7] eq "Global Moderator") { $grpnr = 1; }
		$SortNumm = ($grpnr + 100);
		$GrpMembers[$i] .= qq($SortNumm | $realmembname | $membname);
	}
	@grplist = sort{ $a cmp $b } (@GrpMembers);
	for($i=0;$i<$memcount;$i++) {
		chomp(@grplist);
		($dummynum[$i], $dummyname[$i], $SortList[$i]) = split(/\|/, $grplist[$i]);
	}
	chomp(@SortList);
	@grpmemberlist = @SortList;
}

sub SortMemb	{
		for($i=0;$i<$memcount;$i++) {
			chomp(@membername);
			$membname = $membername[$i];
			fopen(MEMBERFILE,"$memberdir/$membname.dat");
			@member = <MEMBERFILE>;
			fclose(MEMBERFILE);
			chomp(@member);
			if($smb1) {
				$date1 = $member[14];
				if ($membname eq "admin") { $date1 = qq~01/01/01 $txt{'107'} 00:00:00~; }
				&calcdaystime;
				$templist[$i] .= qq($result | $membname);
			}
			if($smb2)	{
				$templist[$i] .= qq($member[6] | $membname);
			}
			if($smb4)	{
				$templist[$i] .= qq($member[1] | $membname);
			}
			if($smb5)	{
				fopen(NUMBERFILEREAD,"$memberdir/$membname.yam");
				@number = <NUMBERFILEREAD>;
				fclose(NUMBERFILEREAD);
				chomp @number;
				($ipnumb1, $ipnumb2, $ipnumb3) = split(/\|/, $number[1]);
				if ($ipnumb1 == 0) { $ipnumb1 = 999.999.999.999; }
				else {
					@ippart = ();
					($ippart[0], $ippart[1], $ippart[2], $ippart[3]) = split(/\./, $ipnumb1);
					for($x=0;$x<4;$x++) {
						if($ippart[$x] < 10) { $ippart[$x] = "00$ippart[$x]"; }
						elsif($ippart[$x] < 100) { $ippart[$x] = "0$ippart[$x]"; }
					}
					$ipnumb1 = "$ippart[0]\.$ippart[1]\.$ippart[2]\.$ippart[3]";
				}
				$templist[$i] .= qq($ipnumb1 | $membname);
			}
			if($smb6)	{
				($ename, $edom) = split(/\@/, $member[2]);
				$templist[$i] .= qq($edom $ename | $membname);
			}
			if($smb7)	{
				if(-e "$memberdir/$membname.ll") {
					fopen(FILEREAD,"$memberdir/$membname.ll");
					@sordate = <FILEREAD>;
					fclose(FILEREAD);
					chomp @sordate;
					$st_date = stringtotime($sordate[0]);
				}
				else { $st_date = "0000000000" }
				$templist[$i] .= qq($st_date|$membname);
			}
			if($smb8)	{
				if(-e "$memberdir/$membname.ll") {
					fopen(FILEREAD,"$memberdir/$membname.ll");
					@sordate = <FILEREAD>;
					fclose(FILEREAD);
					chomp @sordate;
					$st_date = stringtotime($sordate[1]);
				}
				else { $st_date = "0000000000" }
				$templist[$i] .= qq($st_date|$membname);
			}
			if($smb9)	{
				if(-e "$memberdir/$membname.ll") {
					fopen(FILEREAD,"$memberdir/$membname.ll");
					@sordate = <FILEREAD>;
					fclose(FILEREAD);
					chomp @sordate;
					$st_date = stringtotime($sordate[2]);
				}
				else { $st_date = "0000000000" }
				$templist[$i] .= qq($st_date|$membname);
			}
		}
		if($smb4 || $smb5 || $smb6) { @SortAList = sort{lc($a) cmp lc($b)} (@templist); }
		else { @SortAList = sort{$b<=>$a} (@templist); }
		for($i=0;$i<$memcount;$i++) {
			chomp(@SortAList);
			($indxname[$i], $SortList[$i]) = split(/\|/, $SortAList[$i]);
		}
		chomp(@SortList);
		@sortmembername = @SortList;
}

sub MLBuddy2 {
	if($username eq "Guest") { &fatal_error("$txt{'223'}"); }
	my($thisbuddy, $thisstart, $thissort, $thisletter);
	$thisbuddy = $INFO{'listname'};
	$thisstart = $INFO{'thestart'};
	$thissort = $INFO{'thesort'};
	if($thissort eq "mlletter") {
		$thisletter = $INFO{'theletter'};
	}
	fopen(FILE, "$memberdir/$username.bud");
	@buddylist = <FILE>;
	$buddycount = @buddylist;
	fclose(FILE);
	chomp (@buddylist);
	$buddydel = 0;
	for($i=0;$i<$buddycount;$i++) {
		if($thisbuddy eq $buddylist[$i]) { $buddydel = 1; }
	}
	unlink("$memberdir/$username.bud");

	fopen(FILE, ">$memberdir/$username.bud");
	if($buddydel == 1) {
		for($i=0;$i<$buddycount;$i++) {
			if($buddylist[$i] ne $thisbuddy) { print FILE "$buddylist[$i]\n" }
		}
	}		
	elsif($buddydel == 0) {
		for($i=0;$i<$buddycount;$i++) { print FILE "$buddylist[$i]\n" }
		print FILE "$thisbuddy\n";
	}
	fclose(FILE);

	if($thissort eq "mlletter") {
		$yySetLocation = qq~$cgi;action=$thissort;letter=$thisletter;start=$thisstart~;
	}
	else {
		$yySetLocation = qq~$cgi;action=$thissort;start=$thisstart~;
	}
	&redirectexit;
}

sub DelBuddy {
	my($thisbudd);
	$thisbudd = $_[0];
	fopen(FILE, "$memberdir/$username.bud");
	@buddlist = <FILE>;
	$buddcount = @buddlist;
	fclose(FILE);
	chomp (@buddlist);
	unlink("$memberdir/$username.bud");

	fopen(FILE, ">$memberdir/$username.bud");
	for($z=0;$z<$buddcount;$z++) {
		if($buddlist[$z] ne $thisbudd) { print FILE "$buddlist[$z]\n" }
	}
	fclose(FILE);
}


1;