###############################################################################
# SplitSplice.pl                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
# =========================================================================== #
# Mod Name:    Split/Splice for SP1-1.3 - version 1.0.1                       #
# Written by:  BHRA Webmaster (http://www.bhra.org.uk)                        #
###############################################################################

$SplitSplicemod = "Split/Splice v1.0.1";

sub Split_Splice {

	if ($FORM{'ss_submit'} eq $sstxt{'215'} || $FORM{'ss_submit'} eq "" && $FORM{'mode'} ne ""){
			$mode = $FORM{'mode'}; # 0 = Split, 1 = Splice, 2 = Split/Slice (Advanced Mode)
			$postid = $FORM{'postid'};			
			$cat = $FORM{'catid'};
			$oldboard = $INFO{'board'};
			if ($FORM{'boardid'} eq ""){$newboard = $INFO{'board'};} else {$newboard = $FORM{'boardid'};}
			$leave = $FORM{'moved_to'};
			$oldthreadid = $INFO{'thread'};
			$newthreadid = $FORM{'threadid'};
			$newsubject = $FORM{'new_subject'};
			&Split_Splice2($mode,$posts,$cat,$oldboard,$newboard,$leave,$oldthreadid,$newthreadid,$newsubject);}

	if ($action eq "split") {
		$mode = 0;
		$postlist = qq~                    <option value="">\n~;
	} elsif ($action eq "splice") {
		$mode = 1;
		$threadlist = qq~                    <option value="">\n~;
	} elsif ($action eq "split_splice") { 
		if($ss_advanced ne "1") { &fatal_error("$sstxt{'202'}"); }
		if ($FORM{'postid'} =~ m/all/i) {$selectall = "selected";}
		$postlist = qq~                    <option value="all" $selectall>$sstxt{'204'}\n~;
		$threadlist = qq~                    <option value="new">$sstxt{'211'}\n~;
		$mode = 2;
	}

	if ((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error($txt{100 * $mode + 2}); }
	$yytitle = $sstxt{eval {100 * $mode + 1}};

	$curthread = $INFO{'thread'};
	&LoadCensorList;	# Load Censor List

	if($action ne "splice") { 
		fopen(FILE,"$datadir/$curthread.txt") || &fatal_error("$txt{'23'} $curthread.txt - line 109");
		@messages = <FILE>;
		fclose(FILE);
		if ($mode != 2 && $#messages == 0) {&fatal_error("$sstxt{'11'}");}
		for($counter = 0; $counter <= $#messages; $counter++) {
			if ($counter == 0 && $mode != 2) {next;}
			my $t = "0";
			chomp $messages[$counter];
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $messages[$counter]);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$postmessage =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if (length($postmessage) > 40) { $postmessage = substr($postmessage, 0, 40) . qq~ ...~; }
			@selposts = split (/\, /, $FORM{'postid'});
			foreach (@selposts) {
				if ($_ eq $counter){$postlist .= qq~<option value="$counter" selected>$sstxt{'209'} $counter: $postmessage\n~; $t = 1; last;}}
			unless ($t eq "1") {$postlist .= qq~<option value="$counter">$sstxt{'209'} $counter: $postmessage\n~;}
			}
	}

	if($action ne "split" && $action ne "split_splice") { 
		fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt - line 131");
		@oldthreads = <FILE>;
		fclose(FILE);
		foreach $thread_data (@oldthreads) {
			chomp $thread_data;
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$thread_data);
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$msub =~ s~\Q$tmpa\E~$tmpb~gi;
			}
			if (length($msub) > 40) { $msub = substr($msub, 0, 40) . qq~ ...~; }
			if ($mnum ne $curthread) { $threadlist .= qq~                    <option value="$mnum">$msub\n~; }
		}
	}
	
	if($action eq "split_splice") {
		my (@catinfo, @cats, $i, $t, $tmpb, @boards, $k, $v, $category);		
		if ($FORM{'ss_submit'} eq $sstxt{'219'}) {
			$checked = $FORM{'moved_to'};
			$category = $FORM{'catid'};
			$currentboard = "";
			$threadlist = "";}
		elsif ($FORM{'ss_submit'} eq $sstxt{'222'}){
			$checked = $FORM{'moved_to'};
			$category = $FORM{'catid'};
			$currentboard = $FORM{'boardid'};}
		else {$category = $INFO{'cat'};
			$currentboard = $currentboard;}
		fopen (FILE, "$boardsdir/$category.cat", 1);
		@catinfo = <FILE>;
		fclose (FILE);
		shift (@catinfo); shift (@catinfo);
		foreach $tmpb (@catinfo){
			$i == 0;
			chomp ($tmpb);
			fopen (FILE, "$boardsdir/$tmpb.dat", 1);
			while (<FILE>){
				chomp ($_);
				if ($i == 0){$pushit = "$tmpb|$_"; push (@boards,$pushit); last;}
				$i++;}
			fclose (FILE);}
              	foreach (@boards) {
              		($k, $v) = split(/\|/, $_);
              		if ($currentboard eq $k) {$boards .= qq(<option value="$k" selected>$v</option>);}
              		else {$boards .= qq(<option value="$k">$v</option>);}
              		}
              	fopen(FILE, "$vardir/cat.txt");
		@categories = <FILE>;
		fclose(FILE);
		foreach $file (@categories) {
			$t == 0;
			chomp ($file);
			fopen (FILE, "$boardsdir/$file.cat", 1);
			while (<FILE>) {
				chomp ($_);
				if ($t == 0){push (@cats, "$file|$_"); last;}
				$t++;}
			fclose (FILE);}			
		foreach (@cats) {
              	($k, $v) = split(/\|/, $_);
              	if ($category eq $k) {$cats .= qq(<option value="$k" selected>$v</option>);}
              	else {$cats .= qq(<option value="$k">$v</option>);}
		}
		if ($currentboard ne ""){
			fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("$txt{'23'} $currentboard.txt - line 195");
			@oldthreads = <FILE>;
			fclose(FILE);
			foreach $thread_data (@oldthreads) {
				chomp $thread_data;
				($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/,$thread_data);
				foreach (@censored) {
					($tmpa,$tmpb) = @{$_};
					$msub =~ s~\Q$tmpa\E~$tmpb~gi;
				}
				if (length($msub) > 40) { $msub = substr($msub, 0, 40) . qq~ ...~; }
				if ($mnum ne $curthread) { $threadlist .= qq~                    <option value="$mnum">$msub\n~; }}
		}
		$moved_to_radios = qq~<table cellpadding="0" cellspacing="0" border="0"><tr>~;
		for (my $i = 1; $i < 4; $i++) {
			$movetxt = $i + 225;
			if ($checked eq $i) {$moved_to_radios .= qq~<td width="38%"><font size="2"><b>$sstxt{$movetxt}</b></font>&nbsp<input type="radio" name="moved_to" value="$i" checked></td>~;}
			else {$moved_to_radios .= qq~<td width="38%"><font size="2"><b>$sstxt{$movetxt}</b></font>&nbsp<input type="radio" name="moved_to" value="$i"></td>~;}}
		$moved_to_radios .= qq~</tr></table>~;
	}
	if ($mode == 2) {$js = "this.ss_submit.disabled=true;this.ss_reset.disabled=true;";} else {$js = "this.ss_submit.disabled=true;";}

	$yymain .= qq~
<form action="$scripturl?board=$INFO{'board'};action=split_splice;cat=$INFO{'cat'};thread=$INFO{'thread'}" method="POST" name="split" onSubmit="$js"><br>
<input type="hidden" name="mode" value="$mode">
<table border="0" width="80%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>~;

	if ($action eq "split") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_split.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'1'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'4'}</font><br><br>
            <b>$sstxt{'3'}:</b> <select name="postid">
$postlist
            </select><input type="hidden" name="threadid" value="new"><input type="hidden" name="moved_to" value="1"><input type="hidden" name="new_subject" value=""><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'1'}"></font></td>
        </tr>~;

	} elsif ($action eq "splice") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_splice.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'101'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br><font size="1">$sstxt{'104'}</font><br><br>
            <b>$sstxt{'103'}:</b> <select name="threadid">
$threadlist
            </select><input type="hidden" name="postid" value="all"><input type="hidden" name="moved_to" value="1"><input type="hidden" name="new_subject" value=""><br><br>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'101'}"></font></td>
        </tr>~;

	} elsif ($action eq "split_splice") { 

	$yymain .= qq~
          <td class="titlebg" bgcolor="$color{'titlebg'}"><img src="$imagesdir/admin_split_splice.gif" align="absmiddle"> <font size="2" class="text1" color="$color{'titletext'}"><b>$sstxt{'201'}</b></font></td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td valign="top" width="30%"><font size="2"><b>$sstxt{'203'}:</b></font></td>
                <td valign="top">
                  <select name="postid" multiple size="5" style="width:100%">
$postlist
                  </select>
                </td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'205'}<br><br></font></td>
              </tr><tr>
                <td colspan="2">$moved_to_radios</td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'207'}<br><br></font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><br>
            <table cellpadding="0" cellspacing="0" border="0" width="100%">
              <tr>
                <td width="30%"><font size="2"><b>$sstxt{'210'}:</b></font><br><br></td>
              </tr><tr>
              	<td><font size="2"><b>$sstxt{'220'}</b></font>&nbsp</td><td><select name="catid">
$cats
              				 </select>&nbsp<input type="submit" name="ss_submit" value="$sstxt{'219'}">
              </tr><tr>
              	<td><font size="1">$sstxt{'221'}<br><br></font></td><td></td>
              </tr><tr>
              	<td><font size="2"><b>$sstxt{'223'}</b></font>&nbsp</td><td><select name="boardid">
$boards
              				 </select>&nbsp<input type="submit" name="ss_submit" value="$sstxt{'222'}">
              </tr><tr>
              	<td><font size="1">$sstxt{'224'}<br><br></font></td><td></td>
              </tr><tr>
               	<td><font size="2"><b>$sstxt{'225'}</b></font>&nbsp</td><td><select name="threadid" style="width:100%">
$threadlist
                  </select>
                </td>
              </tr><tr>
                <td><font size="1">$sstxt{'212'}<br><br></font></td><td colspan="2"></td>
              </tr><tr>             
               <td><br><br></td><td colspan="2"></td>
              </tr><tr>
                <td width="30%"><font size="2"><b>$sstxt{'213'}</b></font></td>
                <td><input type="text" name="new_subject" size="40" maxlength="50" style="width:100%"></td>
              </tr><tr>
                <td colspan="2"><font size="1">$sstxt{'214'}<br><br></font></td>
              </tr>
            </table>
          </td>
        </tr><tr>
          <td class="windowbg" bgcolor="$color{'windowbg'}" align="center"><font size="2"><input type="submit" name="ss_submit" value="$sstxt{'215'}"> &nbsp; <input type="reset" name="ss_reset" value="$sstxt{'216'}"></font></td>
        </tr>~;

	}

	$yymain .= qq~
      </table>
    </td>
  </tr>
</table>
</form>
<br>~;

	&template;
	exit;
}

###############################################################################

sub Split_Splice2 {
	if ((!exists $moderators{$username}) && $settings[7] ne "Administrator" && $settings[7] ne "Global Moderator") { &fatal_error($txt{100 * $mode + 2}); }
	if ($FORM{'ss_submit'} eq $sstxt{'101'}) {&fatal_error("$sstxt{'228'}");}

	if ($newthreadid eq "") { &fatal_error("$sstxt{'217'}"); }
	if ($postid eq "") { &fatal_error("$sstxt{'208'}"); }
	if ($FORM{'postid'} =~ /all/) {$postid = "0";} else {$postid = $FORM{'postid'};}
	&fatal_error($txt{'77'}) unless(!$FORM{'new_subject'} || $FORM{'new_subject'} !~ m~\A[\s_.,]+\Z~);

	# Read existing threads.
	fopen(FILE, "$datadir/$oldthreadid.txt") || &fatal_error("$txt{'23'} $oldthreadid.txt - line 341");
	@old_messages = <FILE>;
	fclose(FILE);
	fopen(FILE, "$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data - line 344");
	@old_thread_data = <FILE>;
	fclose(FILE);

	if ($mode != 2 || $FORM{'postid'} =~ /all/) { 
		for(my $i = $postid + 1; $i < @old_messages; $i++) { $postid .= ", $i"; }
	}

	# Find a valid random ID for new thread.
	if ($newthreadid eq "new") { # Thread doesn't exist, find valid ID
		$new_thread = 1;
		$newthreadid = time;
		$i=0;
		if (-e "$datadir/$newthreadid.txt") {
			while (-e "$datadir/$newthreadid$i.txt") { ++$i; }
			$newthreadid = "$newthreadid$i";
		}
		@new_messages = ""; #The actual posts of a thread
		@new_thread_data = ""; #Number of views and Last poster - Used by MessageIndex.pl
	} else { # Thread exists, load existing messages
		$new_thread = 0;
		fopen(FILE, "$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt - line 365");
		@new_messages = <FILE>;
		fclose(FILE);
		fopen(FILE, "$datadir/$newthreadid.data") || &fatal_error("$txt{'23'} $newthreadid.data - line 368");
		@new_thread_data = <FILE>;
		fclose(FILE);
	}

#$yymain .= qq~Post id: $postid<br>Thread id: $newthreadid<br>Moved notice: $FORM{'moved_to'}<br>Date Order: $FORM{'date_order'}<br>New Subject: $FORM{'new_subject'}<br>~;
#&template;
#exit;

	# Update current thread.
	$tmp_threadcount = 0;
	$tmp_oldthreadcount = 0;
	$tmp_postcount = 0;
	@reply_ids = split(/\, /, $postid);
	foreach $id (@reply_ids) {
		push (@mobile_messages, $old_messages[$id]);
		if ($leave ne "2"){$old_messages[$id] = ""};
	}
	
	$mobilemessno = @mobile_messages;
	$mmno = $#mobile_messages; 
	$omno = $#old_messages;
	
	if ($leave eq "1") {	# leave "moved to..." notice
		($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $tmpstuff) = split(/[\|]/, $mobile_messages[0], 13);
	 	if ($#mobile_messages == $#old_messages) {
			$moved_notice = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|0|$tmpip|$sstxt{'105'} \[link=$scripturl?board=$newboard;action=display;num=$newthreadid\]$sstxt{'106'}\[/link\] $sstxt{'107'} $settings[1].||$date|$username|\n~;
		} else {
			$moved_notice = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|0|$tmpip|$sstxt{'5'} \[link=$scripturl?board=$newboard;action=display;num=$newthreadid\]$sstxt{'6'}\[/link\] $sstxt{'7'} $settings[1].||$date|$username|\n~;
		}
		push (@old_messages, $moved_notice);
		$tmp_postcount++;
	} 
	if ($leave eq "2" || $leave eq "3") {($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $tmpstuff) = split(/[\|]/, $mobile_messages[0], 13);}
	fopen(FILE, ">$datadir/$oldthreadid.txt") || &fatal_error("$txt{'23'} $oldthreadid.txt - line 409");
	print FILE @old_messages;
	fclose(FILE);
	if ($leave eq "1" || $leave eq "3") {
		chomp $old_thread_data[0];
		@tmp_data = split(/\|/, $old_thread_data[0]);
		$tmp_data[1] = $username;
		$old_thread_data[0] = join("|", @tmp_data);
		if ($old_thread_data[1] ne "") {$old_thread_data[0] .= "\n";}
		fopen(FILE, "+>$datadir/$oldthreadid.data") || &fatal_error("$txt{'23'} $oldthreadid.data - line 418");
		print FILE @old_thread_data;
		fclose(FILE);}
	if ($mmno == $omno && $leave eq "3") {# kill old thread
		opendir (DIR, "$datadir");
		while ($file = readdir(DIR)) {
			if ($file =~ m/^$oldthreadid\./){unlink ("$datadir/$file");}}
		closedir(DIR);
		if ($newboard eq $oldbaord){$tmp_threadcount--;} else {$tmp_oldthreadcount--;}}
	# Save new thread.
	if ($new_thread) {$tmp_threadcount++;}
	if ($FORM{'new_subject'} && $new_thread) {
		&ToHTML($FORM{'new_subject'});
		($tmpsub, $stuff) = split(/[\|]/, $mobile_messages[0], 2);
		$mobile_messages[0] = qq~$FORM{'new_subject'}|$stuff~;;
		
	}
	push (@new_messages, @mobile_messages);
	fopen(FILE, ">$datadir/$newthreadid.txt") || &fatal_error("$txt{'23'} $newthreadid.txt - line 432");
	print FILE @new_messages;
	fclose(FILE);
	($dm1,$newlastposter_name,$dm2,$newlastposttime,$newlastposter) = split(/\|/, $new_messages[$#new_messages]);
	if ($newlastposter eq 'Guest') {$newlastposter = "$newlastposter-$newlastposter_name";}
	chomp $new_thread_data[0];
	@tmp_data = split(/\|/, $new_thread_data[0]);
	$tmp_data[1] = $newlastposter;
	$new_thread_data[0] = join("|", @tmp_data);
	if ($new_thread_data[1] ne "") {$new_thread_data[0] .= "\n";}
	fopen(FILE, "+>$datadir/$newthreadid.data") || &fatal_error("$txt{'23'} $newthreadid.txt - line 441");
	print FILE @new_thread_data;
	fclose(FILE);

	# Update message index.
	fopen(FILE2, "$boardsdir/$oldboard.txt") || &fatal_error("$txt{'23'} $oldboard.txt - line 446");
	@oldbthreads = <FILE2>;
	fclose(FILE2);
	if ($newboard ne $oldboard){
		fopen(FILE, "$boardsdir/$newboard.txt") || &fatal_error("$txt{'23'} $newboard.txt - line 450");
		@newbthreads = <FILE>;
		fclose(FILE);
		}
	@oldnewthreads = (oldbthreads, newbthreads);
	foreach (@oldnewthreads){
		@threads = @{$_};
		for(my $i = 0; $i < @threads; $i++) {
			if( $threads[$i] =~ m~\A$newthreadid\|~o ) { $NewThreadLine = $threads[$i]; $NewThreadPosition = $i;}
			if( $threads[$i] =~ m~\A$oldthreadid\|~o ) { $OldThreadLine = $threads[$i]; $OldThreadPosition = $i;}
			if( $newboard eq $oldboard ) {last;}
		}}

	@tmp_messages = split(/\n/, join('', @old_messages));
	$oldmessno = @tmp_messages;
	chomp $OldThreadLine;
	($oldsub, $oldname, $oldemail, $dummy, $oldusername, $oldicon, $oldattach, $oldip, $oldmessage, $oldns, $oldlm, $oldlmb, $dummy) = split(/[\|]/, $tmp_messages[0], 13);
	($dummy, $dummy, $dummy, $olddate, $dummy) = split(/[\|]/, $tmp_messages[$#tmp_messages]);
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $mstuff) = split(/\|/, $OldThreadLine, 10);
	$moreplies = $oldmessno - 1;
	if ($mstuff ne "") {$mstuff = "|".$mstuff;}
	if ($mmno == $omno && $leave eq "3") {
		$OldThreadLine = qq~~;
	} elsif ($mmno == $omno && $leave eq "1") {
		$OldThreadLine = qq~$oldthreadid|$sstxt{'108'}: $oldsub|$oldname|$oldemail|$olddate|0|$oldusername|$oldicon|1$mstuff\n~;
	} else {
		$OldThreadLine = qq~$oldthreadid|$oldsub|$oldname|$oldemail|$olddate|$moreplies|$oldusername|$oldicon|$mstate$mstuff\n~;
	}

	@tmp_messages = split(/\n/, join('', @new_messages));
	$newmessno = @tmp_messages;
	chomp $NewThreadLine;
	($newsub, $newname, $newemail, $dummy, $newusername, $newicon, $newattach, $newip, $newmessage, $newns, $newlm, $newlmb, $dummy) = split(/[\|]/, $tmp_messages[0], 13);
	($dummy, $dummy, $dummy, $newdate, $dummy) = split(/[\|]/, $tmp_messages[$#tmp_messages]);
	($dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $dummy, $tmpstate, $tmpstuff) = split(/\|/, $NewThreadLine, 10);
	$mnreplies = $newmessno - 1;
	if ($tmpstate eq "") {$tmpstate = $mstate;}
	if ($tmpstuff ne "") {$tmpstuff = "|".$tmpstuff;}
	$NewThreadLine = qq~$newthreadid|$newsub|$newname|$newemail|$newdate|$mnreplies|$newusername|$newicon|$tmpstate$tmpstuff\n~;

	my @threadfiles = ($oldboard, $newboard);
	
	foreach (@threadfiles) {
		fopen(FILE2, "+<$boardsdir/$_.txt", 1) || &fatal_error("211 $txt{'106'}: $txt{'23'} $_.txt - line 493");
			seek FILE2, 0, 0;
			my @buffer = <FILE2>;
			truncate FILE2, 0;
			for ($a = 0; $a < @buffer; $a++) {
				if ( $buffer[$a] =~ m/$newthreadid/ ) { $buffer[$a] = "";}
				if ( $buffer[$a] =~ m/$oldthreadid/ ) { $buffer[$a] = "$OldThreadLine";}
			}
			seek FILE2, 0, 0;
			if ($_ eq $newboard) {print FILE2 qq~$NewThreadLine~;}
			print FILE2 @buffer;
		fclose(FILE2);
		if( $newboard eq $oldboard ) {last;}
		}

	# Update totals for this board.
	@oldnewboards = ($newboard, $oldboard);
	foreach (@oldnewboards){
		$currentboard = $_;
		fopen(FILEBOARDGET, "$boardsdir/$currentboard.ttl");
		$tmpa = <FILEBOARDGET>;
		fclose(FILEBOARDGET);
		chomp $tmpa;
		( $threadcount, $messagecount, $lastposttime, $lastposter, $lastthreadid ) = split( /\|/, $tmpa, 5 );
		if ($newboard eq $oldbaord){
			$threadcount = $threadcount + $tmp_threadcount;
			if ($leave eq "2") {$messagecount = $messagecount + $mobilemessno;} 
			else {$messagecount = $messagecount + $tmp_postcount;}}
		else {
			if ($_ eq $newboard){
				if ($leave eq "2" || $leave eq "3") {$messagecount = $messagecount + $mobilemessno;}
				else {$messagecount = $messagecount + $mobilemessno;}
				$threadcount = $threadcount + $tmp_threadcount;}
			if ($_ eq $oldboard){
				if ($leave eq "1") {$messagecount = $messagecount - $mobilemessno + 1;}
				if ($leave eq "3") {$threadcount = $threadcount + $tmp_oldthreadcount;
				$messagecount = $messagecount - $mobilemessno;}}
					}
		if ($NewThreadPosition == 0 && $_ eq $newboard) {
			$lastposttime = $newlastposttime;
			$lastposter = $newlastposter;
			$tmpthreadid = $newthreadid;
		} elsif ($OldThreadPosition == 0 && $_ eq $oldboard) {
			$lastposttime = $tmpdate;
			$lastposter = $tmpusername;
			$tmpthreadid = $oldthreadid;
		} else {
			$tmpthreadid = $lastthreadid;
		}
		fopen(FILE, "+>$boardsdir/$currentboard.poster");
		print FILE $lastposter;
		fclose(FILE);

		$tmpa = qq~$threadcount|$messagecount|$lastposttime|$lastposter~;
		if ($lastthreadid) { $tmpa .= qq~|$tmpthreadid~; }
		fopen(FILEBOARDSET, "+>$boardsdir/$currentboard.ttl");
		print FILEBOARDSET $tmpa;
		fclose(FILEBOARDSET);
		if( $newboard eq $oldboard ) {last;}
	}

	# Update file attachments.
	fopen(AMV, "$vardir/attachments.txt");
	my @attachments = <AMV>;
	fclose(AMV);
	fopen(AMV, ">$vardir/attachments.txt");
	foreach $row(@attachments) {
		chomp $row;
		my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/,$row);
		if($amthreadid eq $oldthreadid) {
			$tmpreplies = $amreplies;
			$tmpthreadid = $amthreadid;
			for(my $i = 0; $i < @reply_ids; $i++) {
				if ($reply_ids[$i] == $amreplies) {$tmpreplies = $oldmessno - $mobilemessno + $i; $tmpthreadid = $newthreadid; last;}
				if ($reply_ids[$i] < $amreplies) {$tmpreplies--;}				
			}
			print AMV qq~$tmpthreadid|$tmpreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		} else {
			print AMV qq~$amthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
		}
	}
	fclose(AMV);

	$yySetLocation = qq~$scripturl?board=$newboard;action=display;num=$newthreadid~;
	&redirectexit;
}

1;