#################################################################
# Who.pl                                                        #
#################################################################
# This file has been written by: DaddyCool                      #
# Rewritten & edited by: dOCda S! & Gobalopper                  #
#################################################################
#                                                               #
# Edit: 22.01.2002 (dOCda S!)                                   #
#  - small fixes for bugs and formatting                        #
#                                                               #
# Edit: 28.12.2001 (dOCda S!)                                   #
#  - added page refresh on Online Table                         #
#                                                               #
# Edit: 25.12.2001 (Gobalopper)                                 #
#  - rewritten for YaBB 1 Gold - SP1                            #
#  - added a fast find similar to what is in YaBB.pl            #
#  - code uses fclose/fopen now                                 #
#  - fixed some grammar errors in the english.lng file          #
#  - fixed a few layout problems                                #
#  - added code to show users browsing the website              #
#                                                               #
# Edit: 29.07.2001 (dOCda S!)                                   #
#  - converted to YaBB 1 Gold                                   #
#  - reordered all strings like in YaBB.pl                      #
#  - strings for existing mods implemented                      #
#  - option to enable it just for admins                        #
#  - actions can be hidden for users                            #
#################################################################

$recentplver = "1 Gold - SP1";

$websiteurl = "http\://www.dune2k.com/";

#################################################################
# Who:                                                          #
#  Used for displaying the people that are online in more       #
#  detail. Usually found at YaBB.pl?action=who.                 #
#################################################################
sub who {
	$yytitle = "$who{'2'}";

	if ( $onlopt == 0 || $onlopt eq "" ) {
		&is_admin;
	}

	$yymain .= qq~
	<table border=0 width=100% cellspacing=1 cellpadding=1 bgcolor="$color{'bordercolor'}" class="bordercolor">
	<tr>
	 <td bgcolor="$color{'titlebg'}" class="titlebg" width="25%"><b><font color="$color{'titletext'}" size="2" face="Verdana,Arial">$who{'1'}</font></b></td>
	 <td bgcolor="$color{'titlebg'}" class="titlebg" width="20%"><b><font color="$color{'titletext'}" size="2" face="Verdana,Arial">$who{'3'}</font></b></td>
	 <td bgcolor="$color{'titlebg'}" class="titlebg" width="55%"><b><font color="$color{'titletext'}" size="2" face="Verdana,Arial">$who{'4'}</font></b></td>
	</tr>
	~;

	fopen( LOG, "$vardir/log.txt" );
	@log = <LOG>;
	fclose( LOG );

	foreach $log ( @log ) {
		$log =~ s/[\n\r]//g;
		( $name, $value, $datewho, $usernamewho, $boardwho, $actionwho, $username1who, $numwho, $ipinfo ) = split( /\|/, $log );
		$showusername = "";
		if ( $usernamewho eq "Guest" ) {
			$showusername = "$who{'105'}";
		} else {
			fopen( FILE, "$memberdir/$usernamewho.dat" );
			@memdata = <FILE>;
			fclose( FILE );
			$showusername = "<a href=\"$cgi;action=viewprofile;username=$usernamewho\">$memdata[1]</a>";
		}

		fopen( FILE, "$memberdir/$username1who.dat" );
		@mem_data = <FILE>;
		fclose( FILE );
		$showuser1name = "<a href=\"$cgi;action=viewprofile;username=$username1who\">$mem_data[1]</a>";
		$datewho = &timeformat( $datewho );

		if ( $boardwho ne "" ) {
			if ( $numwho ne "" ) {
				fopen( FILE, "$datadir/$numwho.txt" );
				@messages = <FILE>;
				fclose( FILE );
				( $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $mmessage, $mns ) = split( /\|/, $messages[0] );
				$msub =~ s/[\n\r]//g;
		        }
			fopen( BOARD, "$boardsdir/$boardwho.dat" );
			@boardinfo = <BOARD>;
			fclose( BOARD );
			$curboardname="$boardinfo[0]";
			$curboardname =~ s/[\n\r]//g;

			fopen( FILE, "$vardir/cat.txt" );
			@categories = <FILE>;
			fclose( FILE );

			foreach $curcat ( @categories ) {
				$curcat =~ s/[\n\r]//g;
				fopen( CAT, "$boardsdir/$curcat.cat" );
				@catinfo = <CAT>;
				fclose( CAT );
				foreach $catinfo ( @catinfo ) {
					$catinfo =~ s/[\n\r]//g;
					if ( $catinfo eq "$boardwho" ) {
						$catinfo[1] =~ s/[\n\r]//g;
						if ( %membergroups > 0 ) {
							undef %membergroups;
						}
						foreach( split( /,/, $catinfo[1] ) ) {
							if ( $_ ne "" ) {
								$membergroups{$_} = "OK";
							}
						}
				                if ( exists $membergroups{$settings[7]} || $settings[7] eq "Administrator" || %membergroups==0 ) {
							$boardname = "<a href=\"$cgi$boardwho\">$curboardname</a>";
							$threadname = "<a href=\"$cgi$boardwho;action=display;num=$numwho\">$msub</a>";
						} else {
							$boardname = "**$who{'107'}**";
							$threadname = "**$who{'107'}**";
						}
					}
				}
			}
		}

		$whatis = "";

		if ( $actionwho eq "" ) {
			if ( $boardwho eq "" ) {
				if ( $guestaccess == 0 && $usernamewho eq "Guest" ) {
					if ($regop == 1 || $regop == 2) {
						$whatis = "$showusername $who{'97'}";
					} else {
						$whatis = "$showusername $who{'96'}";
					}
				} else {
					$whatis = "$showusername $who{'5'} <a href=\"$scripturl\">$who{'6'}</a>$who{'7'}";
				}
			} elsif ($boardwho ne "") {
				$whatis = "$showusername $who{'8'} $boardname$who{'7'}";
			}
		}

		$fastfind = substr( $actionwho, 0, 1 );

		## W ACTIONS ##
		if ( $fastfind eq 'w' ) {
			   if ($actionwho eq "who") { $whatis = "$showusername $who{'9'} <a href=\"$cgi;action=who\">$who{'10'}</a>$who{'11'}"; }
			elsif ($actionwho eq "website" ) { $whatis = "$showusername $who{'5'} <a href=\"$websiteurl\">$who{'111'}</a>."; }
		}

		## L ACTIONS ##
		elsif ( $fastfind eq 'l' ) {
			   if ( $actionwho eq "login" || $actionwho eq "login2" ) { $whatis = "$showusername $who{'36'}"; }
			elsif ( $actionwho eq "logout" ) { $whatis = "$showusername $who{'37'}"; }
			elsif ( $actionwho eq "lock" ) { $whatis = "$showusername $who{'30'} \"$threadname\" $who{'18'} \"$boardname\"."; }
		}

		## D ACTIONS ##
		elsif ( $fastfind eq 'd' ) {
			   if ( $actionwho eq "display" ) { $whatis = "$showusername $who{'19'} \"$threadname\" $who{'18'} \"$boardname\"$who{'7'}"; }
			elsif ( $actionwho eq "detailedversion" ) { $whatis = "$showusername $who{'69'}"; }
			elsif ( $actionwho eq "deletemultimembers" ) { $whatis = "$showusername $who{'70'}"; }
			elsif ( $actionwho eq "do_clean_log" ) { $whatis = "$showusername $who{'71'}"; }
			elsif ( $actionwho eq "deletelog" || $actionwho eq "deletelog2" ) { $whatis = "$showusername $who{'89'}"; }
		}

		## M ACTIONS ##
		elsif ( $fastfind eq 'm' ) {
			   if ( $actionwho eq "moderate" ) { $whatis = "$showusername $who{'72'}"; }
			elsif ( $actionwho eq "modify" || $actionwho eq "modify2" ) { $whatis = "$showusername $who{'39'} \"$threadname\" $who{'18'} \"$boardname\"."; }
			elsif ( $actionwho eq "modtemp" || $actionwho eq "modtemp2" ) { $whatis = "$showusername $who{'15'}"; }
			elsif ( $actionwho eq "modsettings" || $actionwho eq "modsettings2" ) { $whatis = "$showusername $who{'73'}"; }
			elsif ( $actionwho eq "modmemgr" || $actionwho eq "modmemgr2" ) { $whatis = "$showusername $who{'55'}"; }
			elsif ( $actionwho eq "movethread" || $actionwho eq "movethread2" ) { $whatis = "$showusername $who{'26'}"; }
			elsif ( $actionwho eq "modifycatorder" ) {	$whatis = "$showusername $who{'46'}"; }
			elsif ( $actionwho eq "modifycat" ) { $whatis = "$showusername $who{'45'}"; }
			elsif ( $actionwho eq "manageboards" || $actionwho eq "modifyboard" ) { $whatis = "$showusername $who{'49'}"; }
			elsif ( $actionwho eq "markasread" ) { $whatis = "$showusername $who{'67'}"; }
			elsif ( $actionwho eq "markallasread" ) { $whatis = "$showusername $who{'74'}"; }
			elsif ( $actionwho eq "managecats" ) { $whatis = "$showusername $who{'45'}"; }
			elsif ( $actionwho eq "mailing" ) { $whatis = "$showusername $who{'54'}"; }
			elsif ( $actionwho eq "membershiprecount" ) { $whatis = "$showusername $who{'75'}"; }
			elsif ( $actionwho eq "mlall" ) { $whatis = "$showusername $who{'62'}"; }
			elsif ( $actionwho eq "mlletter" ) { $whatis = "$showusername $who{'63'}"; }
			elsif ( $actionwho eq "mltop" ) { $whatis = "$showusername $who{'64'}"; }
			elsif ( $actionwho eq "ml" ) { $whatis = "$showusername $who{'54'}"; }
			elsif ( $actionwho eq "messageindex" ) { $whatis = "$showusername $who{'93'} \"$boardname\"$who{'07'}"; }
		}

		## P ACTIONS ##
		elsif ( $fastfind eq 'p' ) {
			   if ( $actionwho eq "post" || $actionwho eq "post2" ) {
				   if ( $numwho eq "" ) { $whatis = "$showusername $who{'16'} \"$boardname\"."; }
				 else { $whatis = "$showusername $who{'17'} \"$threadname\" $who{'18'} \"$boardname\"."; }
			}
			elsif ( $actionwho eq "profile" || $actionwho eq "profile2" ) {
				   if ( $username1who eq "$usernamewho" ) { $whatis = "$showusername $who{'40'}"; }
				elsif ( $username1who != $usernamewho && $settings[7] ne "Administrator" ) { $whatis = "$showusername $who{'42'} <a href=\"$cgi;action=viewprofile;username=$username1who\">$username1who</a>$who{'43'}"; }
				 else { $whatis = "$showusername $who{'41'} <a href=\"$cgi;action=viewprofile;username=$username1who\">$username1who</a>."; }
			}
		}

		## R ACTIONS ##
		elsif ( $fastfind eq 'r' ) {
			   if ( $actionwho eq "register" || $actionwho eq "register2" ) {
				   if ( $regop == 1 ) { $whatis = "$showusername $who{'94'}"; }
				elsif ( $regop == 2 ) { $whatis = "$showusername $who{'95'}"; }
				 else { $whatis = "$showusername $who{'31'}"; }
			}
			elsif ( $actionwho eq "removethread" || $actionwho eq "removethread2" ) { $whatis = "$showusername $who{'38'}"; }
			elsif ( $actionwho eq "recent" ) { $whatis = "$showusername $who{'76'}"; }
			elsif ( $actionwho eq "RemoveOldThreads" ) { $whatis = "$showusername $who{'29'}"; }
			elsif ( $actionwho eq "reorderboards" || $actionwho eq "reorderboards2" ) { $whatis = "$showusername $who{'50'}"; }
			elsif ( $actionwho eq "repairboards" ) { $whatis = "$showusername $who{'77'}"; }
			elsif ( $actionwho eq "rebuildmemlist" ) { $whatis = "$showusername $who{'78'}"; }
			elsif ( $actionwho eq "ratetopic" ) { $whatis = "$showusername $who{'91'} \"$threadname\" $who{'18'} \"$boardname\"."; }
		}

		## I ACTIONS ##
		elsif ( $fastfind eq 'i' ) {
			   if ( $actionwho eq "im" ) { $whatis = "$showusername $who{'56'}"; }
			elsif ( $actionwho eq "imprefs" || $actionwho eq "imprefs2" ) { $whatis = "$showusername $who{'57'}"; }
			elsif ( $actionwho eq "imoutbox" ) { $whatis = "$showusername $who{'58'}"; }
			elsif ( $actionwho eq "imremove" ) { $whatis = "$showusername $who{'59'}"; }
			elsif ( $actionwho eq "imsend" ) { $whatis = "$showusername $who{'60'}"; }
			elsif ( $actionwho eq "imsend2" ) { $whatis = "$showusername $who{'61'}"; }
			elsif ( $actionwho eq "imremoveall" || $actionwho eq "imremoveall2" ) { $whatis = "$showusername $who{'79'}"; }
			elsif ( $actionwho eq "icqpager" ) { $whatis = "$showusername $who{'12'}"; }
			elsif ( $actionwho eq "ipban" || $actionwho eq "ipban2" || $actionwho eq "ipbangm" || $actionwho eq "ipban2gm" ) { $whatis = "$showusername $who{'80'}"; }
		}

		## C ACTIONS ##
		elsif ( $fastfind eq 'c' ) {
			   if ( $actionwho eq "createcat" ) { $whatis = "$showusername $who{'48'}"; }
			elsif ( $actionwho eq "clean_log" ) { $whatis = "$showusername $who{'71'}"; }
			elsif ( $actionwho eq "cefmemgr" || $actionwho eq "cefmemgr2" ) { $whatis = "$showusername $who{'81'}"; }
		}

		## S ACTIONS ##
		elsif ( $fastfind eq 's' ) {
			   if ( $actionwho eq "sendtopic" || $actionwho eq "sendtopic2" ) { $whatis = "$showusername $who{'82'} \"$threadname\" $who{'18'} \"$boardname\"."; }
			elsif ( $actionwho eq "setcensor" ) { $whatis = "$showusername $who{'22'}"; }
			elsif ( $actionwho eq "setcensor2" ) { $whatis = "$showusername $who{'23'}"; }
			elsif ( $actionwho eq "search" || $actionwho eq "search2" ) { $whatis = "$showusername $who{'68'}"; }
			elsif ( $actionwho eq "setreserve" ) { $whatis = "$showusername $who{'65'}"; }
			elsif ( $actionwho eq "setreserve2" ) { $whatis = "$showusername $who{'66'}"; }
			elsif ( $actionwho eq "showclicks" ) { $whatis = "$showusername $who{'83'}"; }
			elsif ( $actionwho eq "shownotify" ) { $whatis = "$showusername $who{'84'}"; }
			elsif ( $actionwho eq "smilies" || $actionwho eq "addsmilies" ) { $whatis = "$showusername $who{'88'}"; }
			elsif ( $actionwho eq "showadminlog" ) { $whatis = "$showusername $who{'90'}"; }
			elsif ( $actionwho eq "showftpinfo" ) { $whatis = "$showusername $who{'92'} \"$threadname\" $who{'18'} \"$boardname\"$who{'7'}"; }
		}

		## S ACTIONS ##
		elsif ( $fastfind eq 'a' ) {
			   if ( $actionwho eq "addboard" ) { $whatis = "$showusername $who{'51'}"; }
			elsif ( $actionwho eq "admin" ) { $whatis = "$showusername $who{'52'}"; }
			elsif ( $actionwho eq "assigned" || $actionwho eq "assigned2" ) { $whatis = "$showusername $who{'85'}"; }
		}

		## V ACTIONS ##
		elsif ( $fastfind eq 'v' ) {
			   if ( $actionwho eq "viewprofile" ) { $whatis = "$showusername $who{'44'} $showuser1name$who{'7'}"; }
			elsif ( $actionwho eq "viewmembers" ) { $whatis = "$showusername $who{'53'}"; }
		}

		## OTHER ACTIONS ##
		else {
			   if ( $actionwho eq "notify" || $actionwho eq "notify2" || $actionwho eq "notify3" || $actionwho eq "notify4" ) { $whatis = "$showusername $who{'27'} \"$threadname\" $who{'18'} \"$boardname\"$who{'28'}"; }
			elsif ( $actionwho eq "editnews" || $actionwho eq "editnews2" || $actionwho eq "editnewsgm" || $actionwho eq "editnews2gm" ) { $whatis = "$showusername $who{'25'}"; }
			elsif ( $actionwho eq "boardrecount" ) { $whatis = "$showusername $who{'86'}"; }
			elsif ( $actionwho eq "usersrecentposts" ) { $whatis = "$showusername $who{'87'} <a href=\"$cgi;action=viewprofile;username=$username1who\">$username1who</a>$who{'7'}"; }
		}

		if ( $settings[7] eq "Administrator" ) {
			$showusername = qq~$showusername ( $ipinfo )~;
		}

		chomp( $memdata[7] );
		$yymain .= qq~<!--$memdata[7]-->~;
		if ( $settings[7] ne "Administrator" && $adminwho == 0 && $memdata[7] eq "Administrator" && $usernamewho ne "Guest" ) {
			$whatis = qq(<i>$who{'106'}</i>);
		}
		$yymain .= qq~
		<tr>
		 <td bgcolor=$color{'windowbg2'} class="windowbg2"><font size=2 face="Verdana,Arial">$showusername</font></td>
		 <td bgcolor=$color{'windowbg2'} class="windowbg2"><font size=2 face="Verdana,Arial">$datewho</font></td>
		 <td bgcolor=$color{'windowbg2'} class="windowbg2"><font size=2 face="Verdana,Arial">$whatis</font></td>
		</tr>
		~;
	}

	if ( $Show_MostUsers == 1 ) {
		fopen( FILE, "$vardir/mostuser.txt" );
		@onlcount = <FILE>;
		fclose( FILE );
		$onlcount[1] = &timeformat( $onlcount[1] );
		$uonline .= qq~$mosttxt{'01'} $onlcount[1] $mosttxt{'02'} $onlcount[0] $mosttxt{'03'}~;
		$yymain .= qq~<tr><td class="windowbg" bgcolor=$color{'windowbg'} colspan=3 align=center><font face="Verdana,Arial" size="2">$uonline</font></td></tr>~;
	}

	if ( !$whotime ) {
		$whotime = 30;
	}
	$yymain .= qq~
	</table>
	<br><font face="Verdana,Arial" size="1"><center><b>$who{'108'} $whotime $who{'109'}.</b></center></font>
	<meta http-equiv="refresh" content="$whotime; url="$cgi;action=who">
	~;

	&template;
	exit;
}

1;
